<?php

class Admin extends Controller {

    function Admin() {
        parent :: Controller();
        if ($this->session->userdata('admin') !== 'yes') {
            redirect('adminlogin/login', 'location');
        }
        $this->load->model('adminmodel');
    }

    function index() {
        redirect('adminlogin/login');
    }
    function login() {
        redirect('adminlogin/login');
    }

    function menu() {
        $data['formTable'] = $this->_generatemenu();
        $data['formOpen'] = "";
        $data['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
        $data['contentTitle'] = 'Admin Menu';
        $this->load->view('admin/mainform', $data);
    }

    function _generatemenu() {
        $formTableA = array(array(), array('Please select an option from Admin Menu.'));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function manageplot() {
        $formTableA = array(array(''), array(anchor('/admin/viewplots', 'View Plots', array('title' =>
                           'View/Delete Plot', 'class' => 'forward'))), array(anchor('/admin/addplot', 'Add Plot', array
                           ('title' => 'Add a Plot', 'class' => 'forward'))));
        $data['formTable'] = $this->table->generate($formTableA);
        $data['formOpen'] = form_open('admin/addplotform');
        $data['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
        $data['contentTitle'] = 'Manage Plots';
        $this->load->view('admin/mainform', $data);
    }

    function viewplots() {
        $getPlotInfo = $this->adminmodel->viewPlots();
        if ($getPlotInfo->num_rows() > 0) {
            $this->table->set_heading('No.', 'Plot', 'Database Group', 'Database Version', 'Action');
            $plotResult = $getPlotInfo->result();
            $i = 1;
            foreach ($plotResult as $plotRow) {
                $plotID = $plotRow->Plots_ID;
                $plotName = $plotRow->PlotName;
                $dbGroup = $plotRow->DatabaseName;
                $dbVersion = $plotRow->DatabaseVersion;
                $this->table->add_row($i++, $plotName, $dbGroup, $dbVersion, anchor('admin/deleteplot/'.$plotID,
                                     'delete', array('class' => 'delete', 'onclick' =>
                                     "return confirm('Are you sure, you want to delete this plot?')")));
            }
        }
        else {
            $this->table->add_row('No Plots Added Yet. Please Click "Add Plot".');
        }
        $data['formTable'] = '<div class="data">'.$this->table->generate().'</div>';
        $data['formOpen'] = form_open('admin/addplotform');
        $data['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
        $data['contentTitle'] = 'View Plots';
        $this->load->view('admin/mainform', $data);
    }

    function deleteplot($plotID) {
        $this->adminmodel->deletePlot($plotID);
        redirect('admin/viewplots');
    }

    function addplot() {
        $data['formTable'] = $this->_generateaddplot();
        $data['formOpen'] = form_open('admin/addplotform');
        $data['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
        $data['contentTitle'] = 'Add Plot';
        $this->load->view('admin/mainform', $data);
    }

    function addplotform() {
        $this->_validateaddplotform();
        if ($this->form_validation->run() == FALSE) {
            $data['formTable'] = $this->_generateaddplot();
            $data['formOpen'] = form_open('admin/addplotform');
            $data['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
            $data['contentTitle'] = 'Add Plot';
            $this->load->view('admin/mainform', $data);
        }
        else {
            $plotName = $this->input->post('plotName');
            $databaseName = $this->input->post('databaseName');
            $databaseVersion = $this->input->post('databaseVersion');
            $insertArray = array('PlotName' => $plotName, 'DatabaseName' => $databaseName, 'DatabaseVersion' => $databaseVersion
                                );
            $status = $this->adminmodel->insertPlot($insertArray);
            if ($status = 'success') {
                $data['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
                $data['contentTitle'] = 'Add Plot';
                $data['message1'] = "<div class='success'>Plot Added.</div>";
                $data['message2'] = anchor('admin/addplot', 'Add More Plot', 'class="add"');
                $this->load->view('admin/message', $data);
            }
            else {
                $data['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
                $data['contentTitle'] = 'Add Plot';
                $data['message1'] = "<div class='error'>Error Adding Plot</div>";
                $data['message2'] = anchor('admin/addplot', 'Try Again', 'class="update"');
                $this->load->view('admin/message', $data);
            }
        }
    }

    function _generateaddplot() {
        $plotName = set_value('plotName');
        $databaseName = set_value('databaseName');
        $databaseVersion = set_value('databaseVersion');
        $plotNameA = array('name' => 'plotName', 'id' => 'plotName', 'size' => '16', 'value' => $plotName);
        $databaseNameA = array('name' => 'databaseName', 'id' => 'databaseName', 'size' => '16', 'value' => $databaseName
                              );
        $databaseVersionA = array('default' => 'Select', 'new' => 'New', 'old' => 'Old');
        $plotNameTbx = form_input($plotNameA);
        $databaseNameTbx = form_input($databaseNameA);
        $databaseVersionDD = form_dropdown('databaseVersion', $databaseVersionA);
        $plotNameErr = form_error('plotName');
        $databaseNameErr = form_error('databaseName');
        $databaseVersionErr = form_error('databaseVersion');
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $resetButtonA = array('name' => 'resetButton', 'id' => 'button', 'type' => 'reset', 'content' => 'Reset');
        $submitButton = form_button($submitButtonA);
        $resetButton = form_button($resetButtonA);
        $formTableA = array(array(), array('Plot Name : ', $plotNameTbx, $plotNameErr), array('Database Group : ', $databaseNameTbx,
                           $databaseNameErr), array('Database Version : ', $databaseVersionDD, $databaseVersionErr),
                           array('<br />'),
                           array('',$submitButton."\t".$resetButton));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function _validateaddplotform() {
        $this->form_validation->set_rules('plotName', 'Plot Name', 'required');
        $this->form_validation->set_rules('databaseName', 'Database Name', 'required');
        $this->form_validation->set_rules('databaseVersion', 'Database Version', 'callback_dropdown_check');
        $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    function manageuser() {
        $formTableA = array(array(''), array(anchor('/admin/viewusers', 'View Users', array('title' =>
                           'View/Delete Users', 'class' => 'forward'))), array(anchor('/admin/adduser', 'Add User',
                           array('title' => 'Add a User', 'class' => 'forward'))));
        $data['formTable'] = $this->table->generate($formTableA);
        $data['formOpen'] = form_open('admin/addplotform');
        $data['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
        $data['contentTitle'] = 'Manage Users';
        $this->load->view('admin/mainform', $data);
    }

    function viewusers() {
        $getUserInfo = $this->adminmodel->viewUsers();
        if ($getUserInfo->num_rows() > 0) {
            $this->table->set_heading('No.', 'User', 'Database Group', 'Action');
            $userResult = $getUserInfo->result();
            $i = 1;
            foreach ($userResult as $userRow) {
                $userID = $userRow->UserID;
                $userName = $userRow->UserName;
                $dbGroup = $userRow->DatabaseName;
                $this->table->add_row($i++, $userName, $dbGroup, anchor('admin/deleteuser/'.$userID, 'delete', array(
                                     'class' => 'delete', 'onclick' =>
                                     "return confirm('Are you sure, you want to delete this user?')"))
                                     .'&nbsp;&nbsp;'. anchor('admin/updateuser/'.$userID, 'update', array(
                                     'class' => 'update'))
                                     );
            }
        }
        else {
            $this->table->add_row('No User Added Yet. Please Click "Add User".');
        }
        $data['formTable'] = '<div class="data">'.$this->table->generate().'</div>';
        $data['formOpen'] = form_open('admin/addplotform');
        $data['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
        $data['contentTitle'] = 'View Users';
        $this->load->view('admin/mainform', $data);
    }

    function deleteuser($userID) {
        $this->adminmodel->deleteUser($userID);
        redirect('admin/viewusers');
    }

    function updateuser($userID) {
       $data['formTable'] = $this->_generateupdateuser($userID);
       $data['formOpen'] = form_open('admin/updateuserform/'.$userID);
       $data['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
       $data['contentTitle'] = 'Update User Password';
       $this->load->view('admin/mainform', $data);
    }

    function updateuserform($userID) {
       $this->_validateupdateuserform();
        if ($this->form_validation->run() == FALSE) {
            $data['formTable'] = $this->_generateupdateuser($userID);
            $data['formOpen'] = form_open('admin/updateuserform/'.$userID);
            $data['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
            $data['contentTitle'] = 'Update User Password';
            $this->load->view('admin/mainform', $data);
        }
        else {
            $userID = $this->input->post('userID');
            $password = $this->input->post('password');
            $password = $this->adminmodel->convertPassword($password);
            $updateArray = array('Pwd' => $password);
            $status = $this->adminmodel->updateUser($userID, $updateArray);
            if ($status = 'success') {
                $data['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
                $data['contentTitle'] = 'Update User';
                $data['message1'] = "<br /><div class='success'>User Updated.</div><br />";
                $data['message2'] = anchor('admin/viewusers', 'View User', 'class="view"');
                $this->load->view('admin/message', $data);
            }
            else {
                $data['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
                $data['contentTitle'] = 'Update User';
                $data['message1'] = "<div class='error'>Error Updating User</div>";
                $data['message2'] = anchor('admin/updateuser', 'Try Again', 'class="update"');
                $this->load->view('admin/message', $data);
            }
        }
    }

    function _generateupdateuser($userID) {

        $userName = $this->adminmodel->getUserByID($userID);
        $password = set_value('password');

        $userNameA = array('name' => 'userName', 'id' => 'userName', 'size' => '16', 'value' => $userName, 'readonly'=>'readonly', 'style' => 'background:#CCCCCC;');
        $passwordA = array('name' => 'password', 'id' => 'password', 'size' => '16', 'value' => $password);

        $userNameTbx = form_input($userNameA);
        $passwordTbx = form_input($passwordA);
        $userIDHid = form_hidden('userID',$userID);

        $userNameErr = form_error('userName');
        $passwordErr = form_error('password');

        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $resetButtonA = array('name' => 'resetButton', 'id' => 'button', 'type' => 'reset', 'content' => 'Reset');
        $submitButton = form_button($submitButtonA);
        $resetButton = form_button($resetButtonA);
        $formTableA = array(array(), array('Username : ', $userNameTbx, $userNameErr), array('Password : ', $passwordTbx,
                           $passwordErr), array('<br />'.$userIDHid),
                            array('',$submitButton."\t".$resetButton));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function _validateupdateuserform() {
        $this->form_validation->set_rules('password', 'Password', 'trim|required');
        $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    function adduser() {
        $data['formTable'] = $this->_generateadduser();
        $data['formOpen'] = form_open('admin/adduserform');
        $data['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
        $data['contentTitle'] = 'Add User';
        $this->load->view('admin/mainform', $data);
    }

    function adduserform() {
        $this->_validateadduserform();
        if ($this->form_validation->run() == FALSE) {
            $data['formTable'] = $this->_generateadduser();
            $data['formOpen'] = form_open('admin/adduserform');
            $data['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
            $data['contentTitle'] = 'Add User';
            $this->load->view('admin/mainform', $data);
        }
        else {
            $userName = $this->input->post('userName');
            $password = $this->input->post('password');
            $databaseName = $this->input->post('databaseName');
            $password = $this->adminmodel->convertPassword($password);
            $insertArray = array('UserName' => $userName, 'Pwd' => $password, 'databaseName' => $databaseName);
            $status = $this->adminmodel->insertUser($insertArray);
            if ($status = 'success') {
                $data['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
                $data['contentTitle'] = 'Add User';
                $data['message1'] = "<div class='success'>User Added.</div>";
                $data['message2'] = anchor('admin/adduser', 'Add More User', 'class="add"');
                $this->load->view('admin/message', $data);
            }
            else {
                $data['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
                $data['contentTitle'] = 'Add User';
                $data['message1'] = "<div class='error'>Error Adding User</div>";
                $data['message2'] = anchor('admin/adduser', 'Try Again', 'class="update"');
                $this->load->view('admin/message', $data);
            }
        }
    }

    function _generateadduser() {
        $userName = set_value('userName');
        $password = set_value('password');
        $databaseName = set_value('databaseName');
        $userNameA = array('name' => 'userName', 'id' => 'userName', 'size' => '16', 'value' => $userName);
        $passwordA = array('name' => 'password', 'id' => 'password', 'size' => '16', 'value' => $password);
        $databaseNameA = $this->adminmodel->databaseNamesDD();
        $userNameTbx = form_input($userNameA);
        $passwordTbx = form_input($passwordA);
        $databaseNameDD = form_dropdown('databaseName', $databaseNameA, $databaseName);
        $userNameErr = form_error('userName');
        $passwordErr = form_error('password');
        $databaseNameErr = form_error('databaseName');
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $resetButtonA = array('name' => 'resetButton', 'id' => 'button', 'type' => 'reset', 'content' => 'Reset');
        $submitButton = form_button($submitButtonA);
        $resetButton = form_button($resetButtonA);
        $formTableA = array(array(), array('Username : ', $userNameTbx, $userNameErr), array('Password : ', $passwordTbx,
                           $passwordErr), array('Database Group : ', $databaseNameDD, $databaseNameErr), array('<br />'),
                            array('',$submitButton."\t".$resetButton));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function _validateadduserform() {
        $this->form_validation->set_rules('userName', 'Username', 'trim|required');
        $this->form_validation->set_rules('password', 'Password', 'trim|required');
        $this->form_validation->set_rules('databaseName', 'Database Name', 'callback_dropdown_check');
        $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    function managetable() {
        if(isset($this->session->userdata['adminDBGroup']))
        {
          $this->session->unset_userdata('adminDBGroup');
        }
        $data['formTable'] = $this->_managetableform();
        $data['formOpen'] = form_open('admin/managetableval');
        $data['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
        $data['contentTitle'] = 'Manage Tables';
        $this->load->view('admin/mainform', $data);
    }

    function managetableval() {
        if(isset($this->session->userdata['adminDBGroup']))
        {
          $this->session->unset_userdata('adminDBGroup');
        }
        $this->_validatemanagetable();
        if ($this->form_validation->run() == FALSE) {
            $data['formTable'] = $this->_managetableform();
            $data['formOpen'] = form_open('admin/managetableval');
            $data['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
            $data['contentTitle'] = 'Manage Tables';
            $this->load->view('admin/mainform', $data);
        }
        else {
            $databaseName = $this->input->post('databaseName');
            $this->session->set_userdata('adminDBGroup', $databaseName);
            redirect('basetables/menu');
        }
    }

    function _managetableform() {
        $databaseNameA = $this->adminmodel->databaseNamesDD();
        $databaseNameDD = form_dropdown('databaseName', $databaseNameA);
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $submitButton = form_button($submitButtonA);
        $databaseNameErr = form_error('databaseName');
        $formTableA = array(array('<br />'), array('Select Database Group : ', $databaseNameDD, $databaseNameErr), array('<br />'),
                            array('',$submitButton));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function _validatemanagetable() {
        $this->form_validation->set_rules('databaseName', 'Database Name', 'callback_dropdown_check');
        $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    function addlink() {
        $data['formTable'] = $this->_generateaddlink();
        $data['formOpen'] = form_open('admin/addlinkform');
        $data['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
        $data['contentTitle'] = 'Add Download Link';
        $this->load->view('admin/mainform2', $data);
    }

    function addlinkform() {
        $this->_validateaddlinkform();
        if ($this->form_validation->run() == FALSE) {
            $data['formTable'] = $this->_generateaddlink();
            $data['formOpen'] = form_open('admin/addlinkform');
            $data['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
            $data['contentTitle'] = 'Add Download Link';
            $this->load->view('admin/mainform2', $data);
        }
        else {
            $title = $this->input->post('title');
            $path = $this->input->post('path');
            $date = $this->input->post('date');
            $databaseName = $this->input->post('databaseName');
            $linkType = $this->input->post('linkType');
            $insertArray = array('Title' => $title, 'Path' => $path, 'Date' => $date, 'DatabaseName' => $databaseName,
                                'LinkType' => $linkType);
            $status = $this->adminmodel->insertlink($insertArray);
            if ($status = 'success') {
                $data['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
                $data['contentTitle'] = 'Add Download Link';
                $data['message1'] = "<div class='success'>Link Added.</div>";
                $data['message2'] = anchor('admin/addlink', 'Add More Link', 'class="add"');
                $this->load->view('admin/message', $data);
            }
            else {
                $data['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
                $data['contentTitle'] = 'Add Download Link';
                $data['message1'] = "<div class='error'>Error Adding Link</div>";
                $data['message2'] = anchor('admin/addlink', 'Try Again', 'class="update"');
                $this->load->view('admin/message', $data);
            }
        }
    }

    function _generateaddlink() {
        $title = set_value('title');
        $path = set_value('path');
        $date = set_value('date');
        $databaseName = set_value('databaseName');
        $linkType = set_value('linkType');
        $titleA = array('name' => 'title', 'id' => 'title', 'size' => '20', 'value' => $title);
        $pathA = array('name' => 'path', 'id' => 'path', 'size' => '20', 'value' => $path);
        $dateA = array('name' => 'date', 'id' => 'date', 'size' => '20', 'value' => $date);
        $databaseNameA = $this->adminmodel->databaseNamesDD();
        $linkTypeA = array('default' => 'Select', 'PlotData' => 'PlotData', 'Taxonomy' => 'Taxonomy', 'Archive' =>
                          'Archive');
        $titleTbx = form_input($titleA);
        $pathTbx = form_input($pathA);
        $dateTbx = form_input($dateA);
        $databaseNameDD = form_dropdown('databaseName', $databaseNameA, $databaseName);
        $linkTypeDD = form_dropdown('linkType', $linkTypeA, $linkType);
        $titleErr = form_error('title');
        $pathErr = form_error('path');
        $dateErr = form_error('date');
        $databaseNameErr = form_error('databaseName');
        $linkTypeErr = form_error('linkType');
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $resetButtonA = array('name' => 'resetButton', 'id' => 'button', 'type' => 'reset', 'content' => 'Reset');
        $submitButton = form_button($submitButtonA);
        $resetButton = form_button($resetButtonA);
        $formTableA = array(array(), array('Title: ', $titleTbx, $titleErr), array('Path : ', $pathTbx, $pathErr), array
                           ('Date(mm-dd-yyyy) :', $dateTbx, $dateErr), array('Database Name : ', $databaseNameDD, $databaseNameErr
                           ), array('Link Type : ', $linkTypeDD, $linkTypeErr), array('', $submitButton."\t".$resetButton));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function _validateaddlinkform() {
        $this->form_validation->set_rules('title', 'Title', 'trim|required');
        $this->form_validation->set_rules('path', 'Path', 'trim|required');
        $this->form_validation->set_rules('date', 'Date', 'trim|required');
        $this->form_validation->set_rules('databaseName', 'Database Name', 'callback_dropdown_check');
        $this->form_validation->set_rules('linkType', 'Link Type', 'callback_dropdown_check');
        $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    function logout() {
        $this->session->unset_userdata('admin');
        redirect('adminlogin/login', 'location');
    }

    function dropdown_check($str) {
        if ($str == 'default') {
            $this->form_validation->set_message('dropdown_check', '%s need to be Selected');
            return FALSE;
        }
        else {
            return True;
        }
    }

}
