<?php

class Appgenerateoldfiles extends Controller {

  function Appgenerateoldfiles()
  {
    parent::Controller();
    if($this->session->userdata('loggedin') !== '1')
    {
      redirect('main','location');
    }
    $this->load->model('formmodel');
  }

  function index()
  {
    if(!isset($this->session->userdata['plotCensusArray']))
    {
         redirect('dataentry/plotcensus','location');
    }
    //redirect('appolddatafile/createform');
  }

  function selectquadrats()
  {
    $plotCensusArray = $this->session->userdata('plotCensusArray');
    $plotName = $plotCensusArray['plotName'];
    $censusNumber = $plotCensusArray['censusNumber'];
    $plotActualName = $plotCensusArray['plotActualName'];

    $quadratNameArray = $this->formmodel->getQuadratNames($plotName);
    $data['formOpen'] = form_open("appgenerateoldfiles/createfiles");
    $data['formTable'] = $this->_selectQuadratsTable($quadratNameArray);
    $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
    $data['contentTitle'] = 'Android App Files - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
    $data['backLink'] = anchor('/dataentry/androidapp', 'Back', array('title'=>'Back to Android App Menu', 'class'=>'back'));
    $this->load->view('user/dataentry/simpleform',$data);
  }

  function _selectQuadratsTable($quadratNameArray)
  {

    $quadratName1DD = form_dropdown('quadratName1',$quadratNameArray);
    $quadratName2DD = form_dropdown('quadratName2',$quadratNameArray);
    $quadratNameHd = form_hidden('quadratNameArray',$quadratNameArray);


    $quadratName1Err = form_error('quadratName1');
    $quadratName2Err = form_error('quadratName2');

   $submitButtonA = array('name'=>'submitButton','id'=>'button','type'=>'submit','content'=>'Generate','onclick'=>"return confirm('Are you sure quadrat range is correct and you want to generate the files?')");
   $submitButton = form_button($submitButtonA);

    $formTableA = array(array(),
                        array('Select Starting Quadrat : ',$quadratName1DD,$quadratName1Err),
                        array('Select Ending Quadrat : ',$quadratName2DD,$quadratName2Err),
                        array('',$quadratNameHd),
                        array('',$submitButton)
                        );

    $this->table->set_empty("");
    $formTable = $this->table->generate($formTableA);

    return $formTable;
  }

  function createfiles()
  {
     $plotCensusArray = $this->session->userdata('plotCensusArray');
     $plotID = $plotCensusArray['plotName'];
     $censusNumber = $plotCensusArray['censusNumber'];
     $plotActualName = $plotCensusArray['plotActualName'];

     $plotName = $this->formmodel->getPlotNameByID($plotID);

     $selectedPlotName = $this->session->userdata('selectedPlotName');
     $formType = 'oldform';
     $fileLinkJoin = "";

     $quadratName1 = $this->input->post('quadratName1');
     $quadratName2 = $this->input->post('quadratName2');

     $quadratListQ = $this->formmodel->getQuadratRange($quadratName1,$quadratName2,$plotID);

     foreach($quadratListQ->result() as $quadratListRow)
     {
        $quadratName = $quadratListRow->QuadratName;

        $this->load->library('formlibrary');
        $fileName = base_url()."files/configfiles/".$formType."_".$selectedPlotName."_".$plotName."_".$plotID.".txt";
        $fileName = str_replace(" ","",$fileName);
        $formDetailResult = $this->formlibrary->readConfigFile($fileName);

        if($formDetailResult == "Not Found")
        {
           $data['formTable'] = '<br /><br /><div class="error"> Configuration File Not Found</div>';

           $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
           $data['contentTitle'] = 'Data Entry - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
           $this->load->view('user/dataentry/mainmenu',$data);
        }

        else //rest all code of this function
        {
          foreach($formDetailResult as $formDetailRow)
          {
            if($formDetailRow->ColumnType == 'oldcolumn')
            {
              $attributes = $formDetailRow->Attributes;
              $columnNumber = $formDetailRow->ColumnNumber;
              $attributesArray = $this->_sortOldFormData($attributes);
              $columnName = $attributesArray['columnName'];
              if($columnName == 'subquadrat')
              {
                $maxX = $attributesArray['maxX'];
                $maxY = $attributesArray['maxY'];
                $orderBy = 'subquadrat';
              }
              elseif($columnName == 'nosubTag')
              {
                $maxX = $attributesArray['maxX'];
                $maxY = $attributesArray['maxY'];
                $orderBy = 'treetag';
              }
            }
          }
          $subquadQuery = "SELECT QDimX as DimX, QDimY as DimY FROM Site WHERE PlotID = ".$plotID;
          $subquadReturnQuery = $this->formmodel->subquadDDQuery($subquadQuery);
          $subquadRow = $subquadReturnQuery->row();
          $dimX = $subquadRow->DimX;
          $dimY = $subquadRow->DimY;

          $lastCensusID = $censusNumber - 1;
          if($lastCensusID == 0)
          {
             $data['formTable'] = '<br /><br /><div class="error">Old data does not exist for Census 1.</div>';

             $plotCensusArray = $this->session->userdata('plotCensusArray');
             $plotName = $plotCensusArray['plotName'];
             $censusNumber = $plotCensusArray['censusNumber'];
             $plotActualName = $plotCensusArray['plotActualName'];
             $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
             $data['contentTitle'] = 'Data Entry - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
             $this->load->view('user/dataentry/mainmenu',$data);
          }
          else
          {
            $this->load->model('formmodel');
            $oldDataExtractQuery = $this->formmodel->olddataextract($lastCensusID,$plotID,$quadratName,$maxX,$maxY,$dimX,$dimY,$orderBy);

            if($oldDataExtractQuery->num_rows > 0)
            {
              $rowNumber = 1;
              $totalRows = $oldDataExtractQuery->num_rows();
              foreach($oldDataExtractQuery->result() as $oldExtractRow)
              {
                /*if($formDetailQuery->num_rows() > 0)
                {*/
                  foreach($formDetailResult as $formDetailRow)
                  {
                    if($formDetailRow->ColumnType == 'oldcolumn')
                    {
                      $attributes = $formDetailRow->Attributes;
                      $columnNumber = $formDetailRow->ColumnNumber;

                      $attributesArray = $this->_sortOldFormData($attributes);
                      $columnHeader = $attributesArray['columnHeader'];
                      $headerListA[$columnNumber] = $columnHeader;
                      $columnName = $attributesArray['columnName'];
                      $columnNameA[$columnNumber] = $columnName;
                      $columnSize = $attributesArray['columnSize'];
                      if($columnName == 'subquadrat')
                      {
                        $startsWith = $attributesArray['startsWith'];
                        $maxX = $attributesArray['maxX'];
                        $maxY = $attributesArray['maxY'];

                        if($startsWith == 0)
                        {
                          $in = 0;
                        }
                        else
                        {
                          $in = 1;
                        }
                        $qX = $oldExtractRow->QX;
                        $qY = $oldExtractRow->QY;
                        if($qX != "")
                        {
                          $qX = $in + intval(($qX-$dimX*intval($qX/$dimX))/$maxX);
                        }
                        if($qY != "")
                        {
                          $qY = $in + intval(($qY-$dimY*intval($qY/$dimY))/$maxY);
                        }
                        $subquadrat = $qX.$qY;
                        $columnListA[$columnNumber] = $subquadrat;
                       }
                       elseif($columnName == 'tag')
                       {
                         $treeTag = $oldExtractRow->Tag;
                         $columnListA[$columnNumber] = $treeTag;
                       }
                       elseif($columnName == 'nosubTag')
                       {
                         $treeTag = $oldExtractRow->Tag;
                         $columnListA[$columnNumber] = $treeTag;
                       }
                       elseif($columnName == 'stemTag')
                       {
                         $stemTag = $oldExtractRow->StemTag;
                         $columnListA[$columnNumber] = $stemTag;
                       }
                       elseif($columnName == 'species')
                       {
                         $species = $oldExtractRow->Mnemonic;
                         $columnListA[$columnNumber] = $species;
                       }
                       elseif($columnName == 'olddbh')
                       {
                         $dbh = $oldExtractRow->DBH;
                         $columnListA[$columnNumber] = $dbh;
                       }
                       elseif($columnName == 'oldcodes')
                       {
                         $code = $oldExtractRow->ListOfTSM;
                         $columnListA[$columnNumber] = $code;
                       }
                       elseif($columnName == 'oldhom')
                       {
                         $hom = $oldExtractRow->HOM;
                         $columnListA[$columnNumber] = $hom;
                       }
                       elseif($columnName == 'x')
                       {
                         $qx = $oldExtractRow->QX;
                         $columnListA[$columnNumber] = $qx;
                       }
                       elseif($columnName == 'y')
                       {
                         $qy = $oldExtractRow->QY;
                         $columnListA[$columnNumber] = $qy;
                       }
                     }
                     elseif($formDetailRow->ColumnType == 'text')
                     {
                       $attributes = $formDetailRow->Attributes;
                       $columnNumber = $formDetailRow->ColumnNumber;
                       $columnDetailA = $this->_textAttributes($attributes);
                       $columnName = $columnDetailA['columnName'];
                       $columnNameA[$columnNumber] = $columnName;
                       $headerListA[$columnNumber] = $columnDetailA['columnHeader'];
                       $columnDetailA['columnType'] = $formDetailRow->ColumnType;
                       $defaultValue = $columnDetailA['defaultValue'];
                       $columnListA[$formDetailRow->ColumnNumber] = $defaultValue;
                     }
                     elseif($formDetailRow->ColumnType == "limit")
                     {
                       $attributes = $formDetailRow->Attributes;
                       $columnNumber = $formDetailRow->ColumnNumber;
                       $columnDetailA = $this->_limitAttributes($attributes);
                       $columnName = $columnDetailA['columnName'];
                       $columnNameA[$columnNumber] = $columnName;
                       $headerListA[$columnNumber] = $columnDetailA['columnHeader'];
                       $columnDetailA['columnType'] = $formDetailRow->ColumnType;
                       $defaultValue = $columnDetailA['defaultValue'];
                       $columnListA[$formDetailRow->ColumnNumber] = $defaultValue;
                     }
                   }
                   //$checkTabA[] = "no";
                /*}
                else
                {
                  echo "Add Columns First!!";
                  die();
                }*/
                $headerListRow = implode("\t",$headerListA);
                $columnListRow = implode("\t",$columnListA);

                ////////Write the file//////////////////
                $linetab = "\t";
                $nextline = "\r\n";
                $mainFolderName = $plotName;
                $fileFolderName = 'oldform_data';
                $filename = 'OldTreeForm_'.$plotName.'_'.$censusNumber.'_'.$quadratName;

                if (!file_exists('appfiles/'.$mainFolderName))
                {
                   mkdir('appfiles/'.$mainFolderName, 0777, true);
                }
                if (!file_exists('appfiles/'.$mainFolderName.'/'.$fileFolderName))
                {
                  mkdir('appfiles/'.$mainFolderName.'/'.$fileFolderName, 0777, true);
                }

                $this->load->helper('file');
                if($rowNumber == '1')
                {
                  write_file('./appfiles/'.$mainFolderName.'/'.$fileFolderName.'/'.$filename.'.txt', $headerListRow,'w');
                  write_file('./appfiles/'.$mainFolderName.'/'.$fileFolderName.'/'.$filename.'.txt', $nextline,'a');
                }
                write_file('./appfiles/'.$mainFolderName.'/'.$fileFolderName.'/'.$filename.'.txt', $columnListRow,'a');
                if($rowNumber !== $totalRows)
                {
                  write_file('./appfiles/'.$mainFolderName.'/'.$fileFolderName.'/'.$filename.'.txt', $nextline,'a');
                }
                ////////////Write file end//////////////

                $rowNumber++;
              } ////foreach row ends/////
            }
            else
            {
               $data['formTable'] = '<br /><br /><div class="error">Unable to extract old data.</div>';
               $plotCensusArray = $this->session->userdata('plotCensusArray');
               $plotName = $plotCensusArray['plotName'];
               $censusNumber = $plotCensusArray['censusNumber'];
               $plotActualName = $plotCensusArray['plotActualName'];
               $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
               $data['contentTitle'] = 'Data Entry - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
               $this->load->view('user/dataentry/mainmenu',$data);
            }
          }
        }
        $filepath = base_url().'appfiles/'.$mainFolderName.'/'.$fileFolderName.'/'.$filename.'.txt';
        if($this->fileExists($filepath))
        {
          chmod('./appfiles/'.$mainFolderName.'/'.$fileFolderName.'/'.$filename.'.txt', 0777);
          $fileLink = anchor($filepath, $filename.'.txt' , array('title'=>'View Text File', 'target'=>'_blank'));
        }
        else
        {
          $fileLink =  '<span style="font-size:10pt; color:#FF0000;">Error - '.$filename.'.txt</span>';
        }
        $fileLinkJoin = $fileLinkJoin.'<br />'.$fileLink;
        /////foreach quadrat ends//////
     }
     $backLink = anchor('appgenerateoldfiles/selectquadrats', 'Back To Select Quadrat', array('title'=>'Back To Select Quadrat', 'class'=>'back'));
     $data['formTable'] = '<div class="success">List of Files Created: '.$fileLinkJoin.'</div>';

     $data['formOpen'] = "";
     $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
     $data['contentTitle'] = 'Data Entry - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
     $data['backLink'] = '<br />'.$backLink;
     $this->load->view('user/dataentry/simpleform',$data);
  }

  function _sortOldFormData($attributes)
  {
    $attributesList = explode("\t",$attributes);
    $attributesArray['columnHeader'] = $attributesList[0];
    $attributesArray['columnName'] = $attributesList[1];
    $attributesArray['columnSize'] = $attributesList[2];
    if($attributesArray['columnName'] == 'subquadrat')
    {
      $attributesArray['startsWith'] = $attributesList[3];
      $attributesArray['maxX'] = $attributesList[4];
      $attributesArray['maxY'] = $attributesList[5];
    }
    elseif($attributesArray['columnName'] == 'nosubTag')
    {
      $attributesArray['maxX'] = $attributesList[3];
      $attributesArray['maxY'] = $attributesList[4];
    }
    elseif($attributesArray['columnName'] == 'stemTag')
    {
      $attributesArray['readOnly'] = $attributesList[3];
    }
    return $attributesArray;
  }

  function _textAttributes($attributes)
  {
    $attributeA = explode("\t",$attributes);
    $array['columnHeader'] = $attributeA[0];
    $array['columnName'] = $attributeA[1];
    $array['dataType'] = $attributeA[2];
    $array['defaultValue'] = $attributeA[3];
    $array['columnSize'] = $attributeA[4];
    $array['allowNull'] = $attributeA[5];

    return $array;
  }

  function _limitAttributes($attributes)
  {
    $attributeA = explode("\t",$attributes);
    $array['columnHeader'] = $attributeA[0];
    $array['columnName'] = $attributeA[1];
    $array['dataType'] = $attributeA[2];
    $array['upperLimit'] = $attributeA[3];
    $array['lowerLimit'] = $attributeA[4];
    $array['defaultValue'] = $attributeA[5];
    $array['columnSize'] = $attributeA[6];
    $array['allowNull'] = $attributeA[7];

    return $array;
  }

  function fileExists($path)
  {
    return (@fopen($path,"r")==true);
  }

  function removeAccents($str)
  {
    $a = array('', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', 'A', 'a', 'A', 'a', 'A', 'a', 'C', 'c', 'C', 'c', 'C', 'c', 'C', 'c', 'D', 'd', '', 'd', 'E', 'e', 'E', 'e', 'E', 'e', 'E', 'e', 'E', 'e', 'G', 'g', 'G', 'g', 'G', 'g', 'G', 'g', 'H', 'h', 'H', 'h', 'I', 'i', 'I', 'i', 'I', 'i', 'I', 'i', 'I', 'i', '?', '?', 'J', 'j', 'K', 'k', 'L', 'l', 'L', 'l', 'L', 'l', '?', '?', 'L', 'l', 'N', 'n', 'N', 'n', 'N', 'n', '?', 'O', 'o', 'O', 'o', 'O', 'o', '', '', 'R', 'r', 'R', 'r', 'R', 'r', 'S', 's', 'S', 's', 'S', 's', '', '', 'T', 't', 'T', 't', 'T', 't', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'W', 'w', 'Y', 'y', '', 'Z', 'z', 'Z', 'z', '', '', '?', '', 'O', 'o', 'U', 'u', 'A', 'a', 'I', 'i', 'O', 'o', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', '?', '?', '?', '?', '?', '?');
    $b = array('A', 'A', 'A', 'A', 'A', 'A', 'AE', 'C', 'E', 'E', 'E', 'E', 'I', 'I', 'I', 'I', 'D', 'N', 'O', 'O', 'O', 'O', 'O', 'O', 'U', 'U', 'U', 'U', 'Y', 's', 'a', 'a', 'a', 'a', 'a', 'a', 'ae', 'c', 'e', 'e', 'e', 'e', 'i', 'i', 'i', 'i', 'n', 'o', 'o', 'o', 'o', 'o', 'o', 'u', 'u', 'u', 'u', 'y', 'y', 'A', 'a', 'A', 'a', 'A', 'a', 'C', 'c', 'C', 'c', 'C', 'c', 'C', 'c', 'D', 'd', 'D', 'd', 'E', 'e', 'E', 'e', 'E', 'e', 'E', 'e', 'E', 'e', 'G', 'g', 'G', 'g', 'G', 'g', 'G', 'g', 'H', 'h', 'H', 'h', 'I', 'i', 'I', 'i', 'I', 'i', 'I', 'i', 'I', 'i', 'IJ', 'ij', 'J', 'j', 'K', 'k', 'L', 'l', 'L', 'l', 'L', 'l', 'L', 'l', 'l', 'l', 'N', 'n', 'N', 'n', 'N', 'n', 'n', 'O', 'o', 'O', 'o', 'O', 'o', 'OE', 'oe', 'R', 'r', 'R', 'r', 'R', 'r', 'S', 's', 'S', 's', 'S', 's', 'S', 's', 'T', 't', 'T', 't', 'T', 't', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'W', 'w', 'Y', 'y', 'Y', 'Z', 'z', 'Z', 'z', 'Z', 'z', 's', 'f', 'O', 'o', 'U', 'u', 'A', 'a', 'I', 'i', 'O', 'o', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'A', 'a', 'AE', 'ae', 'O', 'o');
    $str = str_replace($a, $b, $str);
    return $str;
  }



}