<?php

class Basetables extends Controller {

    function Basetables() {
        parent :: Controller();
        if ($this->session->userdata('admin') !== 'yes') {
            redirect('admin/login', 'location');
        }
        if(!isset($this->session->userdata['adminDBGroup']))
        {
          redirect('admin/managetable');
        }
        $this->load->model('basemodel');
        $this->load->library('filereader');
    }

    function menu() {
        $dbGroup = $this->session->userdata('adminDBGroup');
        $formTableA = array(array(''), array(anchor('/basetables/createtables/', 'Create All Blank Tables', array('title' =>
                           'Create Database Tables', 'class' => 'forward', 'onclick' => "return confirm('This will run SQL script to create all tables, if they do not exist. Are you sure you want to run it?')"))),
                           array(anchor('/basetables/populatemenu', 'Populate Base Tables', array('title' => 'Populate the base tables', 'class' => 'forward'))));
        $data['formTable'] = $this->table->generate($formTableA);
        $data['formOpen'] = "";
        $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
        $data['contentTitle'] = 'Manage Tables - '.$dbGroup;
        $this->load->view('admin/mainform', $data);
    }

    function createtables() {

        $status = $this->basemodel->createAllTables();
        if($status == 'Success') {
          $message = '<div class="success">Tables were created successfully.</div>';
        }
        elseif ($status == 'Error') {
          $message = '<div class="error">An issue occured during transaction. Please try again.</div>';
        }
        else {
          $message = '<div class="error">The database contain tables. To run this script the database should be empty.</div>';
        }

        $data['formTable'] = $message;
        $data['formOpen'] = '';
        $data['backLink'] = anchor('basetables/menu/', 'Back', array('title'=>'Back to Menu', 'class'=>'back'));
        $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
        $dbGroup = $this->session->userdata('adminDBGroup');
        $data['contentTitle'] = 'Manage Tables - '.$dbGroup;
        $this->load->view('admin/mainform1', $data);
    }

    function populatemenu() {
        $dbGroup = $this->session->userdata('adminDBGroup');
        $formTableA = array(array(''),
                            array(anchor('/basetables/csv', 'Upload Data Using CSV File', array('title' => 'Populate table using CSV file', 'class' => 'forward'))),
                            array(anchor('/basetables/xls', 'Upload Data Using XLS File', array('title' => 'Populate table using XLS file', 'class' => 'forward'))),
                            array(anchor('/basetables/tab', 'Upload Data Using Tab File', array('title' => 'Populate table using tab-delimited text file', 'class' => 'forward')))
                            );
        $data['formTable'] = $this->table->generate($formTableA);
        $data['formOpen'] = "";
        $data['backLink'] = anchor('basetables/menu/', 'Back', array('title'=>'Back to Menu', 'class'=>'back'));
        $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
        $data['contentTitle'] = 'Populate Base Tables- '.$dbGroup;
        $this->load->view('admin/mainform1', $data);
    }

    function csv() {
        if (isset ($this->session->userdata['fileUploadInfo'])) {
            $this->session->unset_userdata('fileUploadInfo');
        }
        $fileUploadErr = "";
        $data['title'] = "Upload Data File";
        $data['contentTitle'] = "Upload CSV File";
        $data['formHeading'] = "";
        $data['formOpen'] = form_open_multipart('basetables/csvvalidate');
        $data['formTable'] = $this->_csvForm($fileUploadErr);
        $data['backLink'] = anchor('basetables/populatemenu/', 'Back - Menu', array('class' => 'back'));
        $this->load->view('admin/mainform1', $data);
    }

    function csvvalidate() {
        if (isset ($this->session->userdata['fileUploadInfo'])) {
            $this->session->unset_userdata('fileUploadInfo');
        }
        $config['upload_path'] = './files/uploadfiles/';
        $config['allowed_types'] = 'csv';
        $config['max_size'] = '10240';
        $config['overwrite'] = 'TRUE';
        $this->load->library('upload', $config);
        $this->_validateCSV();
        if (($this->form_validation->run() == FALSE) && (!$this->upload->do_upload()) || ($this->form_validation->run()
           == FALSE) || (!$this->upload->do_upload())) {
            $fileUploadErr = $this->upload->display_errors('<p class="errorblock">', '</p>');
            $data['title'] = "Upload Data File";
            $data['contentTitle'] = "Upload CSV File";
            $data['formHeading'] = "";
            $data['formOpen'] = form_open_multipart('basetables/csvvalidate');
            $data['formTable'] = $this->_csvForm($fileUploadErr);
            $data['backLink'] = anchor('basetables/populatemenu/', 'Back - Menu', array('class' => 'back'));
            $this->load->view('admin/mainform1', $data);
        }
        else {
            $tableName = $this->input->post('tableNameDD');
            $hasHeader = $this->input->post('headerIncDD');
            $delimiter = $this->input->post('delimiter');
            $enclosure = "";
            $fileInfo = array('upload_file' => $this->upload->data());
            $fileName = $fileInfo['upload_file']['orig_name'];
            $filePath = "./files/uploadfiles/".$fileName;
            $headers = $this->filereader->csvHeader($filePath, $hasHeader, $delimiter, $enclosure);
            $fileUploadInfo['filePath'] = $filePath;
            $fileUploadInfo['tableName'] = $tableName;
            $fileUploadInfo['hasHeader'] = $hasHeader;
            $fileUploadInfo['delimiter'] = $delimiter;
            $fileUploadInfo['headers'] = $headers;
            $this->session->set_userdata('fileUploadInfo', $fileUploadInfo);
            redirect('basetables/csvpair');
        }
    }

    function _csvForm($fileUploadErr) {
        $tableNameDDA = $this->basemodel->getTableList("");
        $headerIncDDA = array('default' => 'Select', 'yes' => 'Yes', 'no' => 'No');
        $delimiterTbxA = array('name' => 'delimiter', 'id' => 'delimiter', 'size' => '10', 'value' => ',');
        $fileUploadA = array('name' => 'userfile', 'id' => 'userfile', 'size' => '20');
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $tableNameDD = form_dropdown('tableNameDD', $tableNameDDA);
        $headerIncDD = form_dropdown('headerIncDD', $headerIncDDA);
        $delimiterTbx = form_input($delimiterTbxA);
        $fileUpload = form_upload($fileUploadA);
        $submitButton = form_button($submitButtonA);
        $tableNameDDErr = form_error('tableNameDD');
        $headerIncDDErr = form_error('headerIncDD');
        $delimiterErr = form_error('delimiterTbx');
        $formTableA = array(array(''), array('Select Table : ', $tableNameDD, $tableNameDDErr), array(
                           'Header Included : ', $headerIncDD, $headerIncDDErr), array('Delimiter :', $delimiterTbx, $delimiterErr
                           ), array('File :', $fileUpload, $fileUploadErr), array('', '<p style="text-align:center;">'.$submitButton
                           .'</p>'));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function _validateCSV() {
        $this->form_validation->set_rules('tableNameDD', 'Table', 'callback_dropdown_check');
        $this->form_validation->set_rules('headerIncDD', 'Header Info', 'callback_dropdown_check');
        $this->form_validation->set_rules('delimiter', 'Delimiter', 'required');
        $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    function csvpair() {
        if (!isset ($this->session->userdata['fileUploadInfo'])) {
            redirect('basetables/csv');
        }
        $fileUploadInfo = $this->session->userdata('fileUploadInfo');
        $tableName = $fileUploadInfo['tableName'];
        $headers = $fileUploadInfo['headers'];
        $data['formTable'] = $this->_csvpairForm($tableName, $headers);
        $data['title'] = "Upload Data File";
        $data['contentTitle'] = "Pair Columns";
        $data['formHeading'] = "";
        $data['formOpen'] = form_open('basetables/uploadcsv');
        $data['backLink'] = anchor('basetables/csv/', 'Back - Menu', array('class' => 'back'));
        $this->load->view('admin/mainform1', $data);
    }

    function _csvpairForm($tableName, $headers) {
        $tableColumnA = $this->basemodel->getTableColumns($tableName);
        $keepDefault = array("keepDefault" => "Keep Default");
        $headerDDA['keepDefault'] = "Keep Default";
        foreach ($headers as $id => $val) {
            $headerDDA[$id] = $val;
        }
        $this->table->set_empty("");
        $this->table->set_heading('<u>Table Columns</u>', '<u>File Headers</u>');
        foreach ($tableColumnA as $key => $value) {
            $headerDD = form_dropdown($key, $headerDDA);
            $this->table->add_row($key." : ", $headerDD);
        }
        $this->table->add_row("<br />");
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $submitButton = form_button($submitButtonA);
        $this->table->add_row("", $submitButton);
        $formTable = $this->table->generate();
        return $formTable;
    }

    function uploadcsv() {
        $fileUploadInfo = $this->session->userdata('fileUploadInfo');
        $tableName = $fileUploadInfo['tableName'];
        $headers = $fileUploadInfo['headers'];
        $filePath = $fileUploadInfo['filePath'];
        $hasHeader = $fileUploadInfo['hasHeader'];
        $delimiter = $fileUploadInfo['delimiter'];
        $tableColumnA = $this->basemodel->getTableColumns($tableName);
        foreach ($tableColumnA as $key => $value) {
            $columns[$key] = $this->input->post($key);
        }
        $readData = $this->filereader->csvReader($filePath, $hasHeader, $delimiter, $columns);
        $uploadStatus = $this->basemodel->uploadToTable($tableName, $readData);
        if ($uploadStatus == "Done") {
            $data['formTable'] = '<div class="success">Data Uploaded Successfully.</div>';
        }
        else {
            $data['formTable'] = '<div class="error">Error Occured while Uploading.</div>';
        }
        $data['title'] = "Upload Data File";
        $data['contentTitle'] = "CSV Upload";
        $data['formHeading'] = "";
        $data['formOpen'] = "";
        $data['backLink'] = anchor('basetables/populatemenu/', 'Back - Menu', array('class' => 'back'));
        $this->load->view('admin/mainform1', $data);
    }

    function xls() {
        if (isset ($this->session->userdata['fileUploadInfo'])) {
            $this->session->unset_userdata('fileUploadInfo');
        }
        $fileUploadErr = "";
        $data['title'] = "Upload Data File";
        $data['contentTitle'] = "Upload XLS File";
        $data['formHeading'] = "";
        $data['formOpen'] = form_open_multipart('basetables/xlsvalidate');
        $data['formTable'] = $this->_xlsForm($fileUploadErr);
        $data['backLink'] = anchor('basetables/populatemenu/', 'Back - Menu', array('class' => 'back'));
        $this->load->view('admin/mainform1', $data);
    }

    function xlsvalidate() {
        if (isset ($this->session->userdata['fileUploadInfo'])) {
            $this->session->unset_userdata('fileUploadInfo');
        }
        $config['upload_path'] = './files/uploadfiles/';
        $config['allowed_types'] = 'xls';
        $config['max_size'] = '10240';
        $config['overwrite'] = 'TRUE';
        $this->load->library('upload', $config);
        $this->_validateTab();
        if (($this->form_validation->run() == FALSE) && (!$this->upload->do_upload()) || ($this->form_validation->run()
           == FALSE) || (!$this->upload->do_upload())) {
            $fileUploadErr = $this->upload->display_errors('<p class="errorblock">', '</p>');
            $data['title'] = "Upload Data File";
            $data['contentTitle'] = "Upload XLS Data File";
            $data['formHeading'] = "";
            $data['formOpen'] = form_open_multipart('basetables/xlsvalidate');
            $data['formTable'] = $this->_xlsForm($fileUploadErr);
            $data['backLink'] = anchor('basetables/populatemenu/', 'Back - Menu', array('class' => 'back'));
            $this->load->view('admin/mainform1', $data);
        }
        else {
            $hasHeader = $this->input->post('headerIncDD');
            $tableName = $this->input->post('tableNameDD');
            $sheet = $this->input->post('sheet');
            $fileInfo = array('upload_file' => $this->upload->data());
            $fileName = $fileInfo['upload_file']['orig_name'];
            $filePath = "./files/uploadfiles/".$fileName;
            $this->load->library('filereader');
            $headers = $this->filereader->xlsHeader($filePath, $hasHeader, $sheet);
            $fileUploadInfo['filePath'] = $filePath;
            $fileUploadInfo['tableName'] = $tableName;
            $fileUploadInfo['hasHeader'] = $hasHeader;
            $fileUploadInfo['headers'] = $headers;
            $fileUploadInfo['sheet'] = $sheet;
            $this->session->set_userdata('fileUploadInfo', $fileUploadInfo);
            redirect('basetables/xlspair');
        }
    }

    function _xlsForm() {
        $tableNameDDA = $this->basemodel->getTableList("");
        $headerIncDDA = array('default' => 'Select', 'yes' => 'Yes', 'no' => 'No');
        $sheetTbxA = array('name' => 'sheet', 'id' => 'sheet', 'size' => '10', 'value' => 'All');
        $fileUploadA = array('name' => 'userfile', 'id' => 'userfile', 'size' => '20');
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $tableNameDD = form_dropdown('tableNameDD', $tableNameDDA);
        $headerIncDD = form_dropdown('headerIncDD', $headerIncDDA);
        $sheetTbx = form_input($sheetTbxA);
        $fileUpload = form_upload($fileUploadA);
        $submitButton = form_button($submitButtonA);
        $tableNameDDErr = form_error('tableNameDD');
        $headerIncDDErr = form_error('headerIncDD');
        $sheetTbxErr = form_error('sheet');
        $formTableA = array(array(''), array('Select Table : ', $tableNameDD, $tableNameDDErr), array(
                           'Header Included : ', $headerIncDD, $headerIncDDErr), array(
                           'Sheets(All or Sheet No.) : ', $sheetTbx, $sheetTbxErr), array('File :', $fileUpload), array('',
                           '<p style="text-align:center;">'.$submitButton.'</p>'));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function _validateXLS() {
        $this->form_validation->set_rules('tableNameDD', 'Table', 'callback_dropdown_check');
        $this->form_validation->set_rules('headerIncDD', 'Header Info', 'callback_dropdown_check');
        $this->form_validation->set_rules('sheet', 'Sheet', 'required|trim');
        $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    function xlspair() {
        if (!isset ($this->session->userdata['fileUploadInfo'])) {
            redirect('basetables/xls');
        }
        $fileUploadInfo = $this->session->userdata('fileUploadInfo');
        $tableName = $fileUploadInfo['tableName'];
        $headers = $fileUploadInfo['headers'];
        $data['formTable'] = $this->_xlspairForm($tableName, $headers);
        $data['title'] = "Upload Data File";
        $data['contentTitle'] = "Pair Columns";
        $data['formHeading'] = "";
        $data['formOpen'] = form_open('basetables/uploadxls');
        $data['backLink'] = anchor('basetables/xls/', 'Back - Upload XLS File', array('class' => 'back'));
        $this->load->view('admin/mainform1', $data);
    }

    function _xlspairForm($tableName, $headers) {
        $tableColumnA = $this->basemodel->getTableColumns($tableName);
        $keepDefault = array("keepDefault" => "Keep Default");
        $headerDDA['keepDefault'] = "Keep Default";
        foreach ($headers as $id => $val) {
            $headerDDA[$id] = $val;
        }
        $this->table->set_empty("");
        $this->table->set_heading('<u>Table Columns</u>', '<u>File Headers</u>');
        foreach ($tableColumnA as $key => $value) {
            $headerDD = form_dropdown($key, $headerDDA);
            $this->table->add_row($key." : ", $headerDD);
        }
        $this->table->add_row("<br />");
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $submitButton = form_button($submitButtonA);
        $this->table->add_row("", $submitButton);
        $formTable = $this->table->generate();
        return $formTable;
    }

    function uploadxls() {
        $fileUploadInfo = $this->session->userdata('fileUploadInfo');
        $tableName = $fileUploadInfo['tableName'];
        $headers = $fileUploadInfo['headers'];
        $filePath = $fileUploadInfo['filePath'];
        $hasHeader = $fileUploadInfo['hasHeader'];
        $sheet = $fileUploadInfo['sheet'];
        $tableColumnA = $this->basemodel->getTableColumns($tableName);
        foreach ($tableColumnA as $key => $value) {
            $columns[$key] = $this->input->post($key);
        }
        $readData = $this->filereader->xlsReader($filePath, $hasHeader, $columns, $sheet);
        $uploadStatus = $this->basemodel->uploadToTable($tableName, $readData);
        if ($uploadStatus == "Done") {
            $data['formTable'] = '<div class="success">Data Uploaded Successfully.</div>';
        }
        else {
            $data['formTable'] = '<div class="error">Error Occured while Uploading.</div>';
        }
        $data['title'] = "Upload Data File";
        $data['contentTitle'] = "CSV Upload";
        $data['formHeading'] = "";
        $data['formOpen'] = "";
        $data['backLink'] = anchor('basetables/populatemenu/', 'Back - Menu', array('class' => 'back'));
        $this->load->view('admin/mainform1', $data);
    }

    function tab() {
        if (isset ($this->session->userdata['fileUploadInfo'])) {
            $this->session->unset_userdata('fileUploadInfo');
        }
        $fileUploadErr = "";
        $data['title'] = "Upload Data File";
        $data['contentTitle'] = "Upload Tab File";
        $data['formHeading'] = "";
        $data['formOpen'] = form_open_multipart('basetables/tabvalidate');
        $data['formTable'] = $this->_tabForm($fileUploadErr);
        $data['backLink'] = anchor('basetables/populatemenu/', 'Back - Menu', array('class' => 'back'));
        $this->load->view('admin/mainform1', $data);
    }

    function tabvalidate() {
        if (isset ($this->session->userdata['fileUploadInfo'])) {
            $this->session->unset_userdata('fileUploadInfo');
        }
        $config['upload_path'] = './files/uploadfiles/';
        $config['allowed_types'] = 'txt';
        $config['max_size'] = '10240';
        $config['overwrite'] = 'TRUE';
        $this->load->library('upload', $config);
        $this->_validateTab();
        if (($this->form_validation->run() == FALSE) && (!$this->upload->do_upload()) || ($this->form_validation->run()
           == FALSE) || (!$this->upload->do_upload())) {
            $fileUploadErr = $this->upload->display_errors('<p class="errorblock">', '</p>');
            $data['title'] = "Upload Data File";
            $data['contentTitle'] = "Upload Tab File";
            $data['formHeading'] = "";
            $data['formOpen'] = form_open_multipart('basetables/tabvalidate');
            $data['formTable'] = $this->_tabForm($fileUploadErr);
            $data['backLink'] = anchor('basetables/populatemenu/', 'Back - Menu', array('class' => 'back'));
            $this->load->view('admin/mainform1', $data);
        }
        else {
            $tableName = $this->input->post('tableNameDD');
            $hasHeader = $this->input->post('headerIncDD');
            $delimiter = "\t";
            $enclosure = "";
            $fileInfo = array('upload_file' => $this->upload->data());
            $fileName = $fileInfo['upload_file']['orig_name'];
            $filePath = "./files/uploadfiles/".$fileName;
            $headers = $this->filereader->csvHeader($filePath, $hasHeader, $delimiter, $enclosure);
            $fileUploadInfo['filePath'] = $filePath;
            $fileUploadInfo['tableName'] = $tableName;
            $fileUploadInfo['hasHeader'] = $hasHeader;
            $fileUploadInfo['delimiter'] = $delimiter;
            $fileUploadInfo['headers'] = $headers;
            $this->session->set_userdata('fileUploadInfo', $fileUploadInfo);
            redirect('basetables/tabpair');
        }
    }

    function _tabForm($fileUploadErr) {
        $tableNameDDA = $this->basemodel->getTableList("");
        $headerIncDDA = array('default' => 'Select', 'yes' => 'Yes', 'no' => 'No');
        $fileUploadA = array('name' => 'userfile', 'id' => 'userfile', 'size' => '20');
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $tableNameDD = form_dropdown('tableNameDD', $tableNameDDA);
        $headerIncDD = form_dropdown('headerIncDD', $headerIncDDA);
        $fileUpload = form_upload($fileUploadA);
        $submitButton = form_button($submitButtonA);
        $tableNameDDErr = form_error('tableNameDD');
        $headerIncDDErr = form_error('headerIncDD');
        $formTableA = array(array(''), array('Select Table : ', $tableNameDD, $tableNameDDErr), array(
                           'Header Included : ', $headerIncDD, $headerIncDDErr), array('File :', $fileUpload, $fileUploadErr
                           ), array('', '<p style="text-align:center;">'.$submitButton.'</p>'));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function _validateTab() {
        $this->form_validation->set_rules('tableNameDD', 'Table', 'callback_dropdown_check');
        $this->form_validation->set_rules('headerIncDD', 'Header Info', 'callback_dropdown_check');
        $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    function tabpair() {
        if (!isset ($this->session->userdata['fileUploadInfo'])) {
            redirect('basetables/tab');
        }
        $fileUploadInfo = $this->session->userdata('fileUploadInfo');
        $tableName = $fileUploadInfo['tableName'];
        $headers = $fileUploadInfo['headers'];
        $data['formTable'] = $this->_csvpairForm($tableName, $headers);
        $data['title'] = "Upload Data File";
        $data['contentTitle'] = "Pair Columns";
        $data['formHeading'] = "";
        $data['formOpen'] = form_open('basetables/uploadtab');
        $data['backLink'] = anchor('basetables/tab/', 'Back - Menu', array('class' => 'back'));
        $this->load->view('admin/mainform1', $data);
    }

    function _tabpairForm($tableName, $headers) {
        $tableColumnA = $this->basemodel->getTableColumns($tableName);
        $keepDefault = array("keepDefault" => "Keep Default");
        $headerDDA['keepDefault'] = "Keep Default";
        foreach ($headers as $id => $val) {
            $headerDDA[$id] = $val;
        }
        $this->table->set_empty("");
        $this->table->set_heading('<u>Table Columns</u>', '<u>File Headers</u>');
        foreach ($tableColumnA as $key => $value) {
            $headerDD = form_dropdown($key, $headerDDA);
            $this->table->add_row($key." : ", $headerDD);
        }
        $this->table->add_row("<br />");
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $submitButton = form_button($submitButtonA);
        $this->table->add_row("", $submitButton);
        $formTable = $this->table->generate();
        return $formTable;
    }

    function uploadtab() {
        $fileUploadInfo = $this->session->userdata('fileUploadInfo');
        $tableName = $fileUploadInfo['tableName'];
        $headers = $fileUploadInfo['headers'];
        $filePath = $fileUploadInfo['filePath'];
        $hasHeader = $fileUploadInfo['hasHeader'];
        $delimiter = $fileUploadInfo['delimiter'];
        $tableColumnA = $this->basemodel->getTableColumns($tableName);
        foreach ($tableColumnA as $key => $value) {
            $columns[$key] = $this->input->post($key);
        }
        $readData = $this->filereader->csvReader($filePath, $hasHeader, $delimiter, $columns);
        $uploadStatus = $this->basemodel->uploadToTable($tableName, $readData);
        if ($uploadStatus == "Done") {
            $data['formTable'] = '<div class="success">Data Uploaded Successfully.</div>';
        }
        else {
            $data['formTable'] = '<div class="error">Error Occured while Uploading.</div>';
        }
        $data['title'] = "Upload Data File";
        $data['contentTitle'] = "Tab Upload";
        $data['formHeading'] = "";
        $data['formOpen'] = "";
        $data['backLink'] = anchor('basetables/populatemenu/', 'Back - Menu', array('class' => 'back'));
        $this->load->view('admin/mainform1', $data);
    }

    function dropdown_check($str) {
        if ($str == 'default') {
            $this->form_validation->set_message('dropdown_check', '%s need to be Selected');
            return FALSE;
        }
        else {
            return True;
        }
    }



}