<?php

class Createview extends Controller{

    function Createview()
    {
      parent::Controller();
      if($this->session->userdata('loggedin') !== '1')
      {
        redirect('main','location');
      }
      $this->load->library(array('table','pagination'));
      $this->load->model('createviewmodel');

      set_time_limit(0);
      ini_set('memory_limit', '-1');
    }

    function create()
    {
      set_time_limit(0);

      $data['buttonText12'] = 'Populate PX and PY';
      $data['ajaxStep12'] = site_url('createview/PopPXPY');

      $data['buttonText1'] = 'Create SGFtemp';
      $data['ajaxStep1'] = site_url('createview/SGFtemp');

      $data['buttonText2'] = 'Create MPQTtemp';
      $data['ajaxStep2'] = site_url('createview/MPQTtemp');

      $data['buttonText3'] = 'Create ViewFullTable';
      $data['ajaxStep3'] = site_url('createview/ViewFullTable');

      $data['buttonText4'] = 'Update ListOfTSM';
      $data['ajaxStep4'] = site_url('createview/updListOfTSM');

      $data['buttonText5'] = 'Update Status';
      $data['ajaxStep5'] = site_url('createview/updStatus');

      $data['buttonText6'] = 'Create ViewTaxonomy';
      $data['ajaxStep6'] = site_url('createview/TAX1temp');

      $data['buttonText7'] = 'Create TAX2temp';
      $data['ajaxStep7'] = site_url('createview/TAX2temp');

      $data['buttonText8'] = 'Create TAX3temp';
      $data['ajaxStep8'] = site_url('createview/TAX3temp');

      $data['buttonText9'] = 'Update ViewTaxonomy - ListOfHerbarium';
      $data['ajaxStep9'] = site_url('createview/concatspecies1');

      $data['buttonText10'] = 'Update ViewTaxonomy - Old Names';
      $data['ajaxStep10'] = site_url('createview/concatspecies2');

      $data['buttonText11'] = 'Update TAX2temp - Old Genus Name';
      $data['ajaxStep11'] = site_url('createview/concattemp2');

      $data['loadingImage'] = img("images/ajax-loader.gif");
      $plotCensusArray = $this->session->userdata('plotCensusArray');
      $plotName = $plotCensusArray['plotName'];
      $censusNumber = $plotCensusArray['censusNumber'];
      $plotActualName = $plotCensusArray['plotActualName'];
      $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
      $data['contentTitle'] = 'Create View - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';

      $this->load->view('upload/createview',$data);
    }

////////////Populate PX and PY///////////////////////
    function PopPXPY()
    {
      // zero the quadrat QX,QY fields in the Coordinates table
      // zero the plot PX,PY fields in the Coordinates table
      $this->createviewmodel->PopPXPY1();

      // calculating plot-local points (in Stem table) from quadrat points (in Coordinates table)
      // calculating plot-local points for features (in Coordinates table) from quadrat points (in Coordinates table)
      $this->createviewmodel->PopPXPY2();

      echo '<span class="smallsuccess">PX and PY Populated.</span>';
    }
/////////End - Populate PX and PY///////////////////

/////////Steps to create ViewFullTable///////////////

    function SGFtemp()
    {
      // Plot Records
      // Table structure for table `SGFtemp`

      $this->createviewmodel->SGFTemp();
      echo '<span class="smallsuccess">SGFtemp Created.</span>';
    }

    function MPQTtemp()
    {
      // Plot Records report
      // Table structure for table MPQTtemp

      $this->createviewmodel->MPQTtemp();
      echo '<span class="smallsuccess">MPQTtemp Created.</span>';
    }

    function ViewFullTable()
    {
      // Table structure for table ViewFullTable: the primary temporary table housing all measurements of every stem in every census, joined to species name,
      // plot name, and census number (ie, all in one table). It is built using the previous 2 tables, which are now (Oct 2008) dropped after this table is
      // finished

      $this->createviewmodel->viewFullTable();
      //$this->createviewmodel->viewFullTable2();
      echo '<span class="smallsuccess">ViewFullTable Created.</span>';
    }
    function updListOfTSM()
    {
       // The following restrict the query to measurements where there is an attribute. This is often well below half of measurements
      $dbhQuery = $this->createviewmodel->getDBHData();

      if($dbhQuery->num_rows() > 0)
      {
        foreach($dbhQuery->result_array() as $dbhRow)
        {
          $dbhID = trim($dbhRow['DBHID']);
          //$censusID = trim($dbhRow['CensusID']);

          $tsmQuery = $this->createviewmodel->getTSMData($dbhID);

          $listOfTSM = '';
          $firstTime = 0;

          if($tsmQuery->num_rows() > 0)
          {
            foreach($tsmQuery->result_array() as $tsmRow)
            {
              $tsmCode = trim($tsmRow['TSMCode']);
              if($firstTime == 0)
              {
            	$listOfTSM = $tsmCode;
                $firstTime = 1;
              }
              else
              {
            	$listOfTSM = $listOfTSM.",".$tsmCode;
              }
            }

            $this->createviewmodel->updVFTListOfTSM($dbhID,$listOfTSM);
          }
        }
      }
      echo '<span class="smallsuccess">ListOfTSM Updated in ViewFullTable.</span>';
    }
    function updStatus()
    {
      //Calculate status field for each ViewFullTable record
      $this->createviewmodel->updStatus();
      echo '<span class="smallsuccess">Status Updated in ViewFullTable.</span>';
    }
/////////////End - Steps to create ViewFullTable ////////////////


/////////////Steps to Create Taxonomy Views//////////////////

    function TAX1temp()
    {
      // This creates a table called TAX1temp which has all species in CurrentTaxonomyTable, collecting subspecies and
      // adding a variable for all old names
      // Table structure for table `TAX1temp`
      $this->createviewmodel->tax1temp();
      echo '<span class="smallsuccess">ViewTaxonomy Created.</span>';
    }

    function TAX2temp()
    {
      // This creates a table called TAX2temp with all obsolete species names along with the current name of each
      // Table structure for table `TAX2temp`
      $this->createviewmodel->tax2temp();
      echo '<span class="smallsuccess">TAX2temp Created.</span>';
    }

    function TAX3temp()
    {
      // This creates a table called TAX3temp which collects every current species name with every plot
      // or inventory the species is known from. It queries both PlotInventory and TreeTaxonomy tables.
      // Table structure for table `TAX3temp`
      $this->createviewmodel->tax3temp();
      echo '<span class="smallsuccess">TAX3temp Created.</span>';
    }

    function concatspecies1()
    {
      $getSpecies = $this->createviewmodel->getSpeciesIDs();
      if($getSpecies->num_rows() > 0)
      {
        foreach($getSpecies->result_array() as $speciesRow)
        {
          $speciesID = trim($speciesRow['SpeciesID']);
          $numberOfHerbarium = 0;
      	  $listOfHerbarium = '';
      	  $firstTime = 0;

          $getHerbarium = $this->createviewmodel->getHerbarium($speciesID);
          $numberOfHerbarium = $getHerbarium->num_rows();
          if($numberOfHerbarium > 0)
          {
            foreach($getHerbarium->result_array() as $herbariumRow)
            {
              $herbarium = trim($herbariumRow['Herbarium']);
              if($firstTime == 0)
              {
                $listOfHerbarium = $herbarium;
               	$firstTime = 1;
              }
              else
              {
                $listOfHerbarium = $listOfHerbarium.",".$herbarium;
              }
            }
            $this->createviewmodel->updListOfHerbarium($speciesID,$numberOfHerbarium,$listOfHerbarium);
          }
        }
      }
      echo '<span class="smallsuccess">List Of Herbarium Updated in ViewTaxonomy.</span>';
    }

    function concatspecies2()
    {
      $getSpecies = $this->createviewmodel->getSpeciesIDs();
      if($getSpecies->num_rows() > 0)
      {
        foreach($getSpecies->result_array() as $speciesRow)
        {
          $speciesID = trim($speciesRow['SpeciesID']);
          $startingSpeciesID = $speciesID;
      	  $listOfOldNames = '';
      	  $firstTime = 0;
      	  $head = 0;
      	  $tail = 0;
      	  $queue = '';

          //ExpandSpecie
          $getSpeciesData = $this->createviewmodel->getSpeciesData($speciesID);
          if($getSpeciesData->num_rows() > 0)
          {
            $rowSpecies['SpeciesName'] = '';
            foreach($getSpeciesData->result_array() as $rowSpecies)
            {
              $speciesName = trim($rowSpecies['SpeciesName'],"'");
			  $rowSpecies['SpeciesName'] = '';
			  $genusID = trim($rowSpecies['GenusID'],"'");

              $getGenus = $this->createviewmodel->getGenus($genusID);
              $rowGenus = $getGenus->row_array();
              $genusName = trim($rowGenus['Genus'],"'");

              if($firstTime == 0)
              {
                $listOfOldNames = $genusName." ".$speciesName;
                $firstTime = 1;
              }
              else
              {
                $listOfOldNames = $listOfOldNames.",".$genusName." ".$speciesName;
              }
              // Build Queue
			  $obsoleteSpeciesID = trim($rowSpecies['ObsoleteSpeciesID'],"'");
			  $queue[$tail] = $obsoleteSpeciesID;
			  $tail = $tail + 1;
            }
          }
          /////////////////////
          while (($head < $tail) AND ($tail != 0))
	      {
	        // pop top ObsoleteSpeciesID and make CO.SpeciesID
		    $speciesID = $queue[$head];
		    $head = $head + 1;

            //ExpandSpecie
            $getSpeciesData = $this->createviewmodel->getSpeciesData($speciesID);
            if($getSpeciesData->num_rows() > 0)
            {
              $rowSpecies['SpeciesName'] = '';
              foreach($getSpeciesData->result_array() as $rowSpecies)
              {
                $speciesName = trim($rowSpecies['SpeciesName'],"'");
  			  $rowSpecies['SpeciesName'] = '';
  			  $genusID = trim($rowSpecies['GenusID'],"'");

                $getGenus = $this->createviewmodel->getGenus($genusID);
                $rowGenus = $getGenus->row_array();
                $genusName = trim($rowGenus['Genus'],"'");

                if($firstTime == 0)
                {
                  $listOfOldNames = $genusName." ".$speciesName;
                  $firstTime = 1;
                }
                else
                {
                  $listOfOldNames = $listOfOldNames.",".$genusName." ".$speciesName;
                }
                // Build Queue
  			  $obsoleteSpeciesID = trim($rowSpecies['ObsoleteSpeciesID'],"'");
  			  $queue[$tail] = $obsoleteSpeciesID;
  			  $tail = $tail + 1;
              }
            }
            /////////////////////
          }
          //update the ViewTaxonomy table with ListOfOldNames
          $this->createviewmodel->updTax1temp($listOfOldNames,$startingSpeciesID);
        }
      }
      echo '<span class="smallsuccess">Old Names Updated in ViewTaxonomy.</span>';
    }

    function concattemp2()
    {
      $getTAX2temp = $this->createviewmodel->getTAX2temp();

      if($getTAX2temp->num_rows() > 0)
      {
        foreach($getTAX2temp->result_array() as $rowTAX2temp)
        {
          $speciesID = $rowTAX2temp['SpeciesID'];
	      $obsoleteSpeciesID = $rowTAX2temp['ObsoleteSpeciesID'];
	      $obsoleteSpeciesName = trim($rowTAX2temp['ObsoleteSpeciesName']);
	      $obsoleteSpeciesName = addslashes($obsoleteSpeciesName);

          $getGenus = $this->createviewmodel->getGenusName($obsoleteSpeciesID);
          $rowGenus = $getGenus->row_array();
          $oldGenusName = trim($rowGenus['Genus']);
          $oldGenusName = addslashes($oldGenusName);

          // update the TAX2temp table with Old Genus Name
          $this->createviewmodel->updTax2temp($oldGenusName,$obsoleteSpeciesName,$speciesID,$obsoleteSpeciesID);
        }
      }
      echo '<span class="smallsuccess">Old Genus Names Updated in ViewTaxonomy.</span>';
    }

/////////////END - Steps to Create Taxonomy Views//////////////////
    function test()
    {
      echo "hello";
    }
}