<?php

class Dataentry extends Controller{

    function Dataentry()
    {
      parent::Controller();
      if($this->session->userdata('loggedin') !== '1')
      {
        redirect('main','location');
      }
      $this->load->model('dataentrymodel');
      global $databaseName;
      $databaseName = $this->session->userdata('databaseName');

      set_time_limit(0);
      ini_set('memory_limit', '-1');
    }

    function plotcensus()
    {
      if(isset($this->session->userdata['plotCensusArray']))
      {
        $this->session->unset_userdata('plotCensusArray');
      }
      if(isset($this->session->userdata['plotArray']))
      {
        $this->session->unset_userdata('plotArray');
      }

      $data['formTable'] = $this->_generateplotcensusform();
      $data['formOpen'] = form_open('dataentry/plotcensusform');

      $data['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
      $data['contentTitle'] = 'Select Plot';
      $this->load->view('user/dataentry/plotcensusform',$data);
    }

    function plotcensusform()
    {
      $this->_validationplotcensusform();

      if($this->form_validation->run() == FALSE)
      {
        $data['formTable'] = $this->_generateplotcensusform();
        $data['formOpen'] = form_open('dataentry/plotcensusform');

        $data['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
        $data['contentTitle'] = 'Select Plot';
        $this->load->view('user/dataentry/plotcensusform',$data);
      }
      else
      {
        $plotArray['plotName'] = $this->input->post('plotName');

        $plotID = $plotArray['plotName'];
        //Just to make it clear that plotID is being passed
        //get PlotName as PlotID is being passed
        $plotQuery = $this->dataentrymodel->getPlotByID($plotID);
        $plotRow = $plotQuery->row();
        $plotArray['plotActualName'] = $plotRow->PlotName;

        $this->session->set_userdata('plotArray',$plotArray);
        $this->census();
      }
    }

    function _generateplotcensusform()
    {
      $plotName = set_value('plotName');

      $plotNameA = $this->dataentrymodel->getPlotName();
      $submitButtonA = array('name'=>'submitButton','id'=>'button','type'=>'submit','content'=>'Submit');
      //$resetButtonA = array('name'=>'resetButton','id'=>'button','type'=>'reset','content'=>'Reset');

      $plotNameDD = form_dropdown('plotName',$plotNameA,$plotName);
      $submitButton = form_button($submitButtonA);
      //$resetButton = form_button($resetButtonA);

      $plotNameErr = form_error('plotName');

      $formTableA = array(array(''),
                          array('Name of the Plot: ',$plotNameDD,$plotNameErr),
                          array('','<p style="text-align:center;">'.$submitButton.'</p>')
                         );
      $this->table->set_empty("");
      $formTable = $this->table->generate($formTableA);

      return $formTable;
    }

    function _validationplotcensusform()
    {
      $this->form_validation->set_rules('plotName','Plot Name', 'callback_dropdown_check');

      $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');

    }

    function census()
    {
      if(!isset($this->session->userdata['plotArray']))
      {
         $this->plotcensus();
      }
      else
      {
        $plotArray = $this->session->userdata('plotArray');
        $plotID = $plotArray['plotName'];

        $data['formTable'] = $this->_generatecensusform($plotID);
        $data['formOpen'] = form_open('dataentry/censusform');

        $data['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
        $data['contentTitle'] = 'Select Census';
        $this->load->view('user/dataentry/plotcensusform',$data);
      }
    }

    function censusform()
    {
      if(!isset($this->session->userdata['plotArray']))
      {
         $this->plotcensus();
      }
      else
      {
        $plotArray = $this->session->userdata('plotArray');
        $plotID = $plotArray['plotName'];
        $this->_validationcensusform();

        if($this->form_validation->run() == FALSE)
        {
          $data['formTable'] = $this->_generatecensusform($plotID);
          $data['formOpen'] = form_open('dataentry/censusform');

          $data['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
          $data['contentTitle'] = 'Select Census';
          $this->load->view('user/dataentry/plotcensusform',$data);
        }
        else
        {
          $plotCensusArray['censusNumber'] = $this->input->post('censusNumber');
          $plotArray = $this->session->userdata('plotArray');
          $plotCensusArray['plotName'] = $plotArray['plotName'];
          $plotCensusArray['plotActualName'] = $plotArray['plotActualName'];

          $this->session->set_userdata('plotCensusArray',$plotCensusArray);
          $this->session->unset_userdata('plotArray');
          redirect('dataentry/mainmenu','location');
        }
      }
    }

    function _generatecensusform($plotID)
    {
      $censusNumber = set_value('censusNumber');

      $censusNumberA = $this->dataentrymodel->getCensusList($plotID);
      $submitButtonA = array('name'=>'submitButton','id'=>'button','type'=>'submit','content'=>'Submit');
      //$resetButtonA = array('name'=>'resetButton','id'=>'button','type'=>'reset','content'=>'Reset');

      $censusNumberDD = form_dropdown('censusNumber',$censusNumberA,$censusNumber);
      $submitButton = form_button($submitButtonA);
      //$resetButton = form_button($resetButtonA);

      $censusNumberErr = form_error('censusNumber');

      $formTableA = array(array(''),
                          array('Census Number: ',$censusNumberDD,$censusNumberErr),
                          array('','<p style="text-align:center;">'.$submitButton.'</p>')
                         );
      $this->table->set_empty("");
      $formTable = $this->table->generate($formTableA);

      return $formTable;
    }

    function _validationcensusform()
    {
      $this->form_validation->set_rules('censusNumber','Census Number','callback_dropdown_check');

      $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    function dropdown_check($str)
    {
      if($str == 'default')
      {
          $this->form_validation->set_message('dropdown_check', '%s need to be Selected');
          return FALSE;
      }
      else
      {
          return True;
      }
    }

    function createcensus()
    {
      if(isset($this->session->userdata['plotCensusArray']))
      {
        $this->session->unset_userdata('plotCensusArray');
      }
      if(isset($this->session->userdata['plotArray']))
      {
        $this->session->unset_userdata('plotArray');
      }

      $data['formTable'] = $this->_generatecreatecensusform();
      $data['formOpen'] = form_open('dataentry/createcensusform');

      $data['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
      $data['contentTitle'] = 'Create New Census';
      $this->load->view('user/dataentry/plotcensusform',$data);
    }

    function createcensusform()
    {
      $this->_validationcreatecensusform();

      if($this->form_validation->run() == FALSE)
      {
        $data['formTable'] = $this->_generatecreatecensusform();
        $data['formOpen'] = form_open('dataentry/createcensusform');

        $data['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
        $data['contentTitle'] = 'Create New Census';
        $this->load->view('user/dataentry/plotcensusform',$data);
      }
      else
      {
        $plotName = $this->input->post('plotName');
        $censusNumber = $this->input->post('censusNumber');
        $startDate = $this->input->post('startDate');
        $endDate = $this->input->post('endDate');
        $description = $this->input->post('description');

        $insertArray = array('PlotID'=>$plotName,'PlotCensusNumber'=>$censusNumber,'StartDate'=>$startDate,'EndDate'=>$endDate,'Description'=>$description);
        $tableName = 'Census';
        $status = $this->dataentrymodel->insertRowIntoTable($tableName,$insertArray);
        if($status == 'TRUE')
        {
          $data['formTable'] = "<br /><div class='success'>Census Created!!</div>";
          $data['formOpen'] = "";

          $data['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
          $data['contentTitle'] = 'Create New Census';
          $this->load->view('user/dataentry/plotcensusform',$data);
        }
        else
        {
          $data['formTable'] = "<br /><div class='error'>Error Creating New Census.</div>";
          $data['formOpen'] = "";

          $data['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
          $data['contentTitle'] = 'Create New Census';
          $this->load->view('user/dataentry/plotcensusform',$data);
        }
      }
    }

    function _generatecreatecensusform()
    {
      $plotName = set_value('plotName');
      $censusNumber = set_value('censusNumber');
      $startDate = set_value('startDate');
      $endDate = set_value('endDate');
      $description = set_value('description');

      $plotNameA = $this->dataentrymodel->getPlotName();
      $censusNumberA = array('name'=>'censusNumber','id'=>'censusNumber','size'=>'16','value'=>$censusNumber);
      $startDateA = array('name'=>'startDate','id'=>'startDate','size'=>'16','value'=>$startDate);
      $endDateA = array('name'=>'endDate','id'=>'endDate','size'=>'16','value'=>$endDate);
      $descriptionA = array('name'=>'description','id'=>'description','value'=>$description,'rows'=>'5','cols'=>'20','class'=>'textarea2');

      $submitButtonA = array('name'=>'submitButton','id'=>'button','type'=>'submit','content'=>'Submit');
      $resetButtonA = array('name'=>'resetButton','id'=>'button','type'=>'reset','content'=>'Reset');

      $plotNameDD = form_dropdown('plotName',$plotNameA,$plotName);
      $censusNumberTbx = form_input($censusNumberA);
      $startDateTbx = form_input($startDateA);
      $endDateTbx = form_input($endDateA);
      $descriptionTarea = form_textarea($descriptionA);

      $submitButton = form_button($submitButtonA);
      $resetButton = form_button($resetButtonA);

      $plotNameErr = form_error('plotName');
      $censusNumberErr = form_error('censusNumber');
      $startDateErr = form_error('startDate');
      $endDateErr = form_error('endDate');

      $formTableA = array(array(''),
                          array('Name of the Plot: ',$plotNameDD,$plotNameErr),
                          array('Census Number: ',$censusNumberTbx,$censusNumberErr),
                          array('Start Date(yyyy-mm-dd): ',$startDateTbx,$startDateErr),
                          array('End Date(yyyy-mm-dd): ',$endDateTbx,$endDateErr),
                          array('Description: ',$descriptionTarea),
                          array('',$submitButton.'&nbsp;&nbsp;&nbsp;'.$resetButton)
                          );
      $this->table->set_empty("");
      $formTable = $this->table->generate($formTableA);

      return $formTable;
    }

    function _validationcreatecensusform()
    {
      $this->form_validation->set_rules('plotName','Plot Name', 'callback_dropdown_check');
      $this->form_validation->set_rules('censusNumber','Census Number','required|integer');
      $this->form_validation->set_rules('startDate','Start Date','required');
      $this->form_validation->set_rules('endDate','End Date','required');

      $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }


    function mainmenu()
    {
      if(!isset($this->session->userdata['plotCensusArray']))
      {
         $this->plotcensus();
      }
      $plotCensusArray = $this->session->userdata('plotCensusArray');
      $plotName = $plotCensusArray['plotName'];
      $censusNumber = $plotCensusArray['censusNumber'];
      $plotActualName = $plotCensusArray['plotActualName'];

      //get the default config files if user did not created any...
      /*$selectedPlotName = $this->session->userdata('selectedPlotName');
      $formTypeArray = array('newform','multiform','oldform');
      foreach($formTypeArray as $key=>$value)
      {
        $formType = $value;
        $fileName = base_url()."files/configfiles/".$formType."_".$selectedPlotName."_".$plotName."_".$plotID.".txt";
        if(!$this->fileExists($fileName))
        {
          $fileDefault = base_url()."files/defaultconfigfiles/".$formtype.".txt";
          copy($fileDefault,$fileName); //copy file
        }
      }*/

      $formTableA = array(array(''),
                          array(anchor('/oldplantform', 'Old Trees Form', array('title'=>'Old Trees Form', 'class'=>'forward'))),
                          array(anchor('/multistemform', 'Multiple Stem Form', array('title'=>'Multiple Stem Form', 'class'=>'forward'))),
                          array(anchor('/newplantform', 'New Plants Form', array('title'=>'New Plants Form', 'class'=>'forward'))),
                          array(anchor('/bigtreeform', 'Big Trees Form', array('title'=>'Big Trees Form', 'class'=>'forward'))),
                          array(anchor('/selectmergefile/selectformtype', 'Add More Data Into Existing File', array('title'=>'Add More Data Into Existing File', 'class'=>'forward'))),
                          //array(anchor('/buttress/dataentry', 'Buttressed Trees Form', array('title'=>'Buttressed Trees Form', 'class'=>'forward'))),
                          //array(anchor('/treeloc/dataentry', 'Tree Location Form', array('title'=>'Tree Location Form', 'class'=>'forward')))
                         );
      $this->table->set_empty("");
      $data['formTable'] = $this->table->generate($formTableA);


      $data['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
      $data['contentTitle'] = 'Data Entry - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
      $this->load->view('user/dataentry/mainmenu',$data);
    }

    function datascreening()
    {
      if(!isset($this->session->userdata['plotCensusArray']))
      {
         $this->plotcensus();
      }
      $plotCensusArray = $this->session->userdata('plotCensusArray');

      $formTableA = array(array(''),
                          array(anchor('/dataentry/selectentrytype', 'Copy Text Files into Temporary Tables', array('title'=>'Copy Text Files into Temporary Tables', 'class'=>'forward'))),
                          array(anchor('/screening/screencheck', 'Screen Data in Temporary Tables', array('title'=>'Screen Data in Temporary Tables', 'class'=>'forward')))
                         );
      $this->table->set_empty("");
      $data['formTable'] = $this->table->generate($formTableA);

      $plotName = $plotCensusArray['plotName'];
      $censusNumber = $plotCensusArray['censusNumber'];
      $plotActualName = $plotCensusArray['plotActualName'];
      $data['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
      $data['contentTitle'] = 'Data Screening - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
      $this->load->view('user/dataentry/mainmenu',$data);
    }

    function viewdata()
    {
      if(!isset($this->session->userdata['plotCensusArray']))
      {
         $this->plotcensus();
      }
      $plotCensusArray = $this->session->userdata('plotCensusArray');
      $formTableA = array(array(''),
                          array(anchor('/dataentry/viewalldata', 'View Data From Temp Table', array('title'=>'View Data From Temp Table', 'class'=>'forward'))),
                          array(anchor('/dataview/viewerrorsselectform', 'View Data With Errors', array('title'=>'View Data With Errors', 'class'=>'forward')))
                         );
      $this->table->set_empty("");
      $data['formTable'] = $this->table->generate($formTableA);

      $plotName = $plotCensusArray['plotName'];
      $censusNumber = $plotCensusArray['censusNumber'];
      $plotActualName = $plotCensusArray['plotActualName'];
      $data['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
      $data['contentTitle'] = 'View Screened Data - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
      $this->load->view('user/dataentry/mainmenu',$data);
    }

    function dataediting()
    {
      if(!isset($this->session->userdata['plotCensusArray']))
      {
         $this->plotcensus();
      }
      $plotCensusArray = $this->session->userdata('plotCensusArray');
      $formTableA = array(array(''),
                          array(anchor('/oldtree/dataediting', 'Old Trees Form', array('title'=>'Old Trees Form', 'class'=>'forward'))),
                          array(anchor('/multistem/dataediting', 'Multiple Stem Form', array('title'=>'Multiple Stem Form', 'class'=>'forward'))),
                          array(anchor('/newplant/dataediting', 'New Plants Form', array('title'=>'New Plants Form', 'class'=>'forward'))),
                          //array(anchor('/treeloc/dataediting', 'Tree Location Form', array('title'=>'Tree Location Form', 'class'=>'forward'))),
                          //array(anchor('/temp/dataediting', 'Edit All Temp Tables', array('title'=>'Edit All Temp Tables', 'class'=>'forward')))
                         );
      $this->table->set_empty("");
      $data['formTable'] = $this->table->generate($formTableA);

      $plotName = $plotCensusArray['plotName'];
      $censusNumber = $plotCensusArray['censusNumber'];
      $plotActualName = $plotCensusArray['plotActualName'];
      $data['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
      $data['contentTitle'] = 'Data Editing - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
      $this->load->view('user/dataentry/mainmenu',$data);
    }

    function uploaddata()
    {
      if(!isset($this->session->userdata['plotCensusArray']))
      {
         $this->plotcensus();
      }
      $plotCensusArray = $this->session->userdata('plotCensusArray');
      $formTableA = array(array('<span style="color:#CC3300;">*Please Select These Options Only After All The Data Has Been Entered and Screened*</span>'),
                          array('<span style="color:#CC3300; font-weight:bold;">*Upload In Order*</span>'),
                          array(anchor('/dataupload/oldandmulti', 'Old Trees and Multiple Stems Data', array('title'=>'Old Trees and Multiple Stem Form', 'class'=>'forward'))),
                          array(anchor('/dataupload/newplants', 'New Plants Data', array('title'=>'New Plants Form', 'class'=>'forward'))),
                          array(anchor('/dataupload/bigtrees', 'Big Trees Data', array('title'=>'Big Trees Form', 'class'=>'forward')))
                         );
      $this->table->set_empty("");
      $data['formTable'] = $this->table->generate($formTableA);

      $plotName = $plotCensusArray['plotName'];
      $censusNumber = $plotCensusArray['censusNumber'];
      $plotActualName = $plotCensusArray['plotActualName'];
      $data['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
      $data['contentTitle'] = 'Data Uploading - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
      $this->load->view('user/dataentry/mainmenu',$data);
    }

    function finishup()
    {
      if(!isset($this->session->userdata['plotCensusArray']))
      {
         $this->plotcensus();
      }
      $plotCensusArray = $this->session->userdata('plotCensusArray');
      $formTableA = array(array('<span style="color:#CC3300;">*Please Select These Options Only After All The Data Has Been Entered, Screened, and Uploaded*</span>'),
                          array(anchor('/createview/create', 'Create Report Tables', array('title'=>'Old Create Report Tables', 'class'=>'forward'))),
                          array(anchor('/finishup/removetemp', 'Erase Temporary Data Tables After Uploading', array('title'=>'Erase All Temporary Data Tables After Uploading', 'class'=>'forward'))),
                          //array(anchor('/postscreening/screen', 'Screen Uploaded Data', array('title'=>'Screen Uploaded Data', 'class'=>'forward', 'onclick'=>"return confirm('Do you want to generate the error report? This might take a while.')")))
                         );
      $this->table->set_empty("");
      $data['formTable'] = $this->table->generate($formTableA);

      $plotName = $plotCensusArray['plotName'];
      $censusNumber = $plotCensusArray['censusNumber'];
      $plotActualName = $plotCensusArray['plotActualName'];
      $data['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
      $data['contentTitle'] = 'Finishing Up - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
      $this->load->view('user/dataentry/mainmenu',$data);
    }

    function postscreening()
    {
      if(!isset($this->session->userdata['plotCensusArray']))
      {
         $this->plotcensus();
      }
      $plotCensusArray = $this->session->userdata('plotCensusArray');
      $formTableA = array(array('<span style="color:#CC3300;">*Please Select These Options Only After All The Data Has Been Entered, Pre-Screened, and Uploaded*</span>'),
                          array(anchor('/postscreening/screen', 'Screen Uploaded Data', array('title'=>'Screen Uploaded Data', 'class'=>'forward', 'onclick'=>"return confirm('Do you want to generate the error report? This might take a while.')")))
                         );
      $this->table->set_empty("");
      $data['formTable'] = $this->table->generate($formTableA);

      $plotName = $plotCensusArray['plotName'];
      $censusNumber = $plotCensusArray['censusNumber'];
      $plotActualName = $plotCensusArray['plotActualName'];
      $data['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
      $data['contentTitle'] = 'Post Screening - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
      $this->load->view('user/dataentry/mainmenu',$data);
    }

    function selectentrytype()
    {
      if(!isset($this->session->userdata['plotCensusArray']))
      {
         $this->plotcensus();
      }
      $plotCensusArray = $this->session->userdata('plotCensusArray');
      $formTableA = array(array(''),
                          array(anchor('/dataentry/singledataentry', 'Single Data Entry', array('title'=>'Single Data Entry', 'class'=>'forward'))),
                          array(anchor('/dataentry/doubledataentry', 'Double Data Entry', array('title'=>'Double Data Entry', 'class'=>'forward'))),
                          array(anchor('/screening/screencheck', 'Screen Data in Temporary Tables', array('title'=>'Screen Data in Temporary Tables', 'class'=>'forward'))),
                          array(anchor('/dataview/selectformtype', 'View all the Screened Records in Temporary Tables', array('title'=>'View all the Records in Temporary Tables', 'class'=>'forward'))),
                          array(anchor('/dataview/selectformtype/errors', 'View all the Screened Records with Errors', array('title'=>'View all the Screened Records with Errors', 'class'=>'forward'))),
                          array(anchor('/dataentry/summary','View Error Summary',array('title'=>'View Error Summary','class'=>'forward')))
                         );
      $this->table->set_empty("");
      $data['formTable'] = $this->table->generate($formTableA);

      $plotName = $plotCensusArray['plotName'];
      $censusNumber = $plotCensusArray['censusNumber'];
      $plotActualName = $plotCensusArray['plotActualName'];
      $data['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
      $data['contentTitle'] = 'Select Data Screening Type - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
      $this->load->view('user/dataentry/mainmenu',$data);
    }

    function singledataentry()
    {
      if(!isset($this->session->userdata['plotCensusArray']))
      {
         $this->plotcensus();
      }
      $plotCensusArray = $this->session->userdata('plotCensusArray');
      $formTableA = array(array(''),
                          array(anchor('/singledataentry/selectformtype', 'Copy Text Files into Temporary Tables', array('title'=>'Copy Text Files into Temporary Tables', 'class'=>'forward'))),
                          //array(anchor('/screening/screencheck', 'Screen Data in Temporary Tables', array('title'=>'Screen Data in Temporary Tables', 'class'=>'forward'))),
                          //array(anchor('/dataview/selectformtype', 'View all the Screened Records in Temporary Tables', array('title'=>'View all the Records in Temporary Tables', 'class'=>'forward'))),
                          //array(anchor('/dataview/selectformtype/errors', 'View all the Screened Records with Errors', array('title'=>'View all the Screened Records with Errors', 'class'=>'forward')))
                         );
      $this->table->set_empty("");
      $data['formTable'] = $this->table->generate($formTableA);

      $plotName = $plotCensusArray['plotName'];
      $censusNumber = $plotCensusArray['censusNumber'];
      $plotActualName = $plotCensusArray['plotActualName'];
      $data['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
      $data['contentTitle'] = 'Single Data Entry - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
      $this->load->view('user/dataentry/mainmenu',$data);
    }

    function doubledataentry()
    {
      if(!isset($this->session->userdata['plotCensusArray']))
      {
         $this->plotcensus();
      }
      $plotCensusArray = $this->session->userdata('plotCensusArray');
      $formTableA = array(array(''),
                          array(anchor('/doubledataentry/selectformtype', 'Copy Text Files into Temporary Tables', array('title'=>'Copy Text Files into Temporary Tables', 'class'=>'forward'))),
                          array(anchor('/doublescreening/selectformtype', 'Compare Data in Temporary Tables', array('title'=>'Compare Data in Temporary Tables', 'class'=>'forward'))),
                          array(anchor('/doublescreening/cleanscreeningtemp', 'Drop All Screened Temporary Tables with no data', array('title'=>'Drop Screened Temporary Tables with no data', 'class'=>'forward', 'onclick'=>"return confirm('Are you sure, you want to drop all empty screening temp tables?')")))
                         );
      $this->table->set_empty("");
      $data['formTable'] = $this->table->generate($formTableA);

      $plotName = $plotCensusArray['plotName'];
      $censusNumber = $plotCensusArray['censusNumber'];
      $plotActualName = $plotCensusArray['plotActualName'];
      $data['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
      $data['contentTitle'] = 'Double Data Entry - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
      $this->load->view('user/dataentry/mainmenu',$data);
    }

    function summary()
    {
      if(!isset($this->session->userdata['plotCensusArray']))
      {
         $this->plotcensus();
      }
      $plotCensusArray = $this->session->userdata('plotCensusArray');
      $formTableA = array(array(''),
                          array(anchor('/dataview/errorsummary/TempNewPlants', 'Error Summary for TempNewPlants', array('title'=>'Error Summary for TempNewPlants', 'class'=>'forward'))),
                          array(anchor('/dataview/errorsummary/TempOldTrees', 'Error Summary for TempOldTrees', array('title'=>'Error Summary for TempOldTrees', 'class'=>'forward'))),
                          array(anchor('/dataview/errorsummary/TempMultiStems', 'Error Summary for TempMultiStems', array('title'=>'Error Summary for TempMultiStems', 'class'=>'forward'))),
                          array(anchor('/dataview/errorsummary/TempBigTrees', 'Error Summary for TempBigTrees', array('title'=>'Error Summary for TempMultiStems', 'class'=>'forward'))),
                          array(anchor('/dataview/errorsummary/TempLocations', 'Error Summary for TempLocations', array('title'=>'Error Summary for TempLocations', 'class'=>'forward')))
                         );
      $this->table->set_empty("");
      $data['formTable'] = $this->table->generate($formTableA);

      $plotName = $plotCensusArray['plotName'];
      $censusNumber = $plotCensusArray['censusNumber'];
      $plotActualName = $plotCensusArray['plotActualName'];
      $data['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
      $data['contentTitle'] = 'Error Summary - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
      $this->load->view('user/dataentry/mainmenu',$data);
    }

    function androidapp()
    {
       if(!isset($this->session->userdata['plotCensusArray']))
      {
         $this->plotcensus();
      }
      $plotCensusArray = $this->session->userdata('plotCensusArray');
      $formTableA = array(array(''),
                          array(anchor('/appgenerateoldfiles/selectquadrats', 'Generate Old Data Files - Select Quadrat Range', array('title'=>'Select Quadrat Range', 'class'=>'forward'))),
                          array(anchor('/appfiles/generateallfiles', 'Generate Plot Info Files', array('title'=>'Generate Plot Info Files', 'class'=>'forward', 'onclick'=>"return confirm('Confirm to generate the files?')"))),
                         );
      $this->table->set_empty("");
      $data['formTable'] = $this->table->generate($formTableA);

      $plotName = $plotCensusArray['plotName'];
      $censusNumber = $plotCensusArray['censusNumber'];
      $plotActualName = $plotCensusArray['plotActualName'];
      $data['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
      $data['contentTitle'] = 'Android App Files - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
      $this->load->view('user/dataentry/mainmenu',$data);
    }

    function fileExists($path)
    {
      return (@fopen($path,"r")==true);
    }
    /*function uploaddata()
    {
      if(!isset($this->session->userdata['plotCensusArray']))
      {
         $this->plotcensus();
      }
      $plotCensusArray = $this->session->userdata('plotCensusArray');
      $formTableA = array(array(''),
                          array(anchor('/dataupload/oldandmulti', 'Upload Old Trees and Multi Stems Data', array('title'=>'Upload Old Trees and Multi Stems Data', 'class'=>'forward'))),
                          array(anchor('/dataupload/newplants', 'Upload New Plants Data', array('title'=>'Upload New Plants Data', 'class'=>'forward')))
                         );
      $this->table->set_empty("");
      $data['formTable'] = $this->table->generate($formTableA);

      $plotName = $plotCensusArray['plotName'];
      $censusNumber = $plotCensusArray['censusNumber'];
      $plotActualName = $plotCensusArray['plotActualName'];
      $data['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
      $data['contentTitle'] = 'Upload Data Into Production - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
      $this->load->view('user/dataentry/mainmenu',$data);
    }*/

    /*function screeneddata()
    {
      if(!isset($this->session->userdata['plotCensusArray']))
      {
         $this->plotcensus();
      }
      $plotCensusArray = $this->session->userdata('plotCensusArray');
      $formTableA = array(array(''),
                          array(anchor('/screeneddata/viewallrecords', 'View all the Screened Records in Temporary Table', array('title'=>'Copy Text Files into Temporary Tables', 'class'=>'forward'))),
                          array(anchor('/screeneddata/viewerrorrecords', 'View Records withScreen Data in Temporary Tables', array('title'=>'Screen Data in Temporary Tables', 'class'=>'forward')))
                         );
      $this->table->set_empty("");
      $data['formTable'] = $this->table->generate($formTableA);

      $plotName = $plotCensusArray['plotName'];
      $censusNumber = $plotCensusArray['censusNumber'];
      $plotActualName = $plotCensusArray['plotActualName'];
      $data['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
      $data['contentTitle'] = 'Double Data Entry - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
      $this->load->view('user/dataentry/mainmenu',$data);
    }*/

}