<?php

class Doubledataentry extends Controller{

    function Doubledataentry()
    {
      parent::Controller();
      if($this->session->userdata('loggedin') !== '1')
      {
        redirect('main','location');
      }
      $this->load->model('dataentrymodel');
      global $databaseName;
      $databaseName = $this->session->userdata('databaseName');

      set_time_limit(0);
      ini_set('memory_limit', '-1');
    }

    function selectformtype()
    {
      if(isset($this->session->userdata['formType']))
      {
        $this->session->unset_userdata('formType');
      }

      $data['formOpen'] = form_open("doubledataentry/selectformtypevalidate");
      $data['formTable'] = $this->_selectFormTypeTable();

      $plotCensusArray = $this->session->userdata('plotCensusArray');
      $plotName = $plotCensusArray['plotName'];
      $censusNumber = $plotCensusArray['censusNumber'];
      $plotActualName = $plotCensusArray['plotActualName'];
      $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
      $data['contentTitle'] = 'Double Data Entry - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
      $data['backLink'] = anchor('/dataentry/doubledataentry', 'Back', array('title'=>'Back to Select Entry Type', 'class'=>'back'));
      $this->load->view('user/dataentry/simpleform',$data);
    }

    function selectformtypevalidate()
    {
      $this->_validateselectformtype();

      if($this->form_validation->run() == FALSE)
      {
        $data['formOpen'] = form_open("doubledataentry/selectformtypevalidate");
        $data['formTable'] = $this->_selectFormTypeTable();

        $plotCensusArray = $this->session->userdata('plotCensusArray');
        $plotName = $plotCensusArray['plotName'];
        $censusNumber = $plotCensusArray['censusNumber'];
        $plotActualName = $plotCensusArray['plotActualName'];
        $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
        $data['contentTitle'] = 'Double Data Entry - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
        $data['backLink'] = anchor('/dataentry/doubledataentry', 'Back', array('title'=>'Back to Select Entry Type', 'class'=>'back'));
        $this->load->view('user/dataentry/simpleform',$data);
      }
      else
      {
        $plotCensusArray = $this->session->userdata('plotCensusArray');
        $plotName = $plotCensusArray['plotName'];
        $censusNumber = $plotCensusArray['censusNumber'];
        $plotActualName = $plotCensusArray['plotActualName'];
        $plotActualNameNoSpace = str_replace(" ","",$plotActualName);

        $formType = $this->input->post('formType');
        //$this->session->set_userdata('formType',$formType);

        if($formType == 'newform')
        {
          $dir = "./files/datafiles/newplant/";
        }
        elseif($formType == 'multiform')
        {
          $dir = "./files/datafiles/multistem/";
        }
        elseif($formType == 'oldform')
        {
          $dir = "./files/datafiles/oldtree/";
        }
        elseif($formType == 'bigform')
        {
          $dir = "./files/datafiles/bigtree/";
        }


        //form with drop down - listing files in the selected form type folder
        if(is_dir($dir))
        {
          if ($dh = opendir($dir))
          {
            $fileNameArray = array();
            //$fileNameArray['default'] = 'No Files In Folder';
            while (($file = readdir($dh)) !== false)
            {
              if($file !== "." && $file !== "..")
              {
                $fileSplit = explode(".",$file);
                $file = $fileSplit[0]; // Remove .txt from the end - need to remove for dropdown
                $fileSplit1 = explode("_",$file);
                if($fileSplit1[1] == $plotActualNameNoSpace)
                {
                  $fileNameArray[$file] = $file;
                }
                $fileNameArray['default'] = 'Select';
              }
            }
            natcasesort($fileNameArray);
            $defaultArray = array('default'=>'Select');
            $fileNameArray = array_merge($defaultArray,$fileNameArray);
            closedir($dh);
          }
        }
        $data['formTable'] = $this->_selectFileTable($fileNameArray,$formType);
        $data['formOpen'] = form_open("doubledataentry/twofileupload");

        $plotCensusArray = $this->session->userdata('plotCensusArray');
        $plotName = $plotCensusArray['plotName'];
        $censusNumber = $plotCensusArray['censusNumber'];
        $plotActualName = $plotCensusArray['plotActualName'];
        $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
        $data['contentTitle'] = 'Double Data Entry - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
        $data['backLink'] = anchor('/doubledataentry/selectformtype', 'Back', array('title'=>'Back to Select Form Type', 'class'=>'back'));
        $this->load->view('user/dataentry/simpleform',$data);
      }
    }

    function _selectFormTypeTable()
    {
      $formType = set_value('formType');

      $formTypeA = array('default'=>'Select','newform'=>'New Plants','oldform'=>'Old Trees','multiform'=>'Multi Stem','bigform'=>'Big Trees');
      //$formTypeA = array('default'=>'Select','newform'=>'New Plants','oldform'=>'Old Trees','multiform'=>'Multi Stem');
      $formTypeDD = form_dropdown('formType',$formTypeA);

      $formTypeErr = form_error('formType');

      $submitButtonA = array('name'=>'submitButton','id'=>'button','type'=>'submit','content'=>'Submit');
      $submitButton = form_button($submitButtonA);

      $formTableA = array(array(),
                          array('Form Type : ',$formTypeDD,$formTypeErr),
                          array('',$submitButton)
                          );

      $this->table->set_empty("");
      $formTable = $this->table->generate($formTableA);

      return $formTable;
    }

    function _validateselectformtype()
    {
      $this->form_validation->set_rules('formType', 'Form Type', 'callback_dropdown_check');

      $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    function _selectFileTable($fileNameArray,$formType)
    {
      $fileName1 = set_value('fileName1');
      $fileName2 = set_value('fileName2');

      $fileName1DD = form_dropdown('fileName1',$fileNameArray,$fileName1);
      $fileName2DD = form_dropdown('fileName2',$fileNameArray,$fileName2);
      $fileNameHd = form_hidden('fileNameArray',$fileNameArray);
      $formTypeHd = form_hidden('formType',$formType);

      $fileName1Err = form_error('fileName1');
      $fileName2Err = form_error('fileName2');

      $submitButtonA = array('name'=>'submitButton','id'=>'button','type'=>'submit','content'=>'Submit');
      $submitButton = form_button($submitButtonA);

      $formTableA = array(array(),
                          array('Select File 1 : ',$fileName1DD,$fileName1Err),
                          array('Select File 2 : ',$fileName2DD,$fileName2Err),
                          array('',$fileNameHd.$formTypeHd),
                          array('',$submitButton)
                          );

      $this->table->set_empty("");
      $formTable = $this->table->generate($formTableA);

      return $formTable;
    }

    function twofileupload()
    {
      $this->_validatetwofileupload();
      $fileNameArray = $this->input->post('fileNameArray');
      $formType = $this->input->post('formType');

      if($this->form_validation->run() == FALSE)
      {
        $data['formTable'] = $this->_selectFileTable($fileNameArray,$formType);
        $data['formOpen'] = form_open("doubledataentry/twofileupload");

        $plotCensusArray = $this->session->userdata('plotCensusArray');
        $plotName = $plotCensusArray['plotName'];
        $censusNumber = $plotCensusArray['censusNumber'];
        $plotActualName = $plotCensusArray['plotActualName'];
        $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
        $data['contentTitle'] = 'Double Data Entry - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
        $data['backLink'] = anchor('/doubledataentry/selectformtype', 'Back', array('title'=>'Back to Select Form Type', 'class'=>'back'));
        $this->load->view('user/dataentry/simpleform',$data);
      }

      else
      {
        //upload the file into temp table.
        $this->dataentrymodel->startTransaction(); // Transaction Starts Here

        $fileName1 = $this->input->post('fileName1');
        $fileName2 = $this->input->post('fileName2');
        if($formType == 'bigform')
        {
          $this->_uploadFileBig($formType,$fileName1,$fileName2);
        }
        else
        {
          $this->_uploadFile($formType,$fileName1,$fileName2);
        }
        $transactionStatus = $this->dataentrymodel->completeTransaction(); // Transaction Ends Here
        if($transactionStatus == 'Success')
        {
          //if Success move file to different folder;
           if($formType == 'newform')
          {
            $dir = "./files/datafiles/newplant/";
            $dirMove = "./files/datafiles/uploaded/newplant/";
          }
          elseif($formType == 'multiform')
          {
            $dir = "./files/datafiles/multistem/";
            $dirMove = "./files/datafiles/uploaded/multistem/";
          }
          elseif($formType == 'oldform')
          {
            $dir = "./files/datafiles/oldtree/";
            $dirMove = "./files/datafiles/uploaded/oldtree/";
          }
          elseif($formType == 'bigform')
          {
            $dir = "./files/datafiles/bigtree/";
            $dirMove = "./files/datafiles/uploaded/bigtree/";
          }

          $fileNameMove1 = $fileName1;
          $fileNameMove2 = $fileName2;
          $fileName1 = $dir.$fileName1.".txt";  //complete path to file
          $fileName2 = $dir.$fileName2.".txt";  //complete path to file
          $fileNameMove1 = $dirMove.$fileNameMove1.".txt";
          $fileNameMove2 = $dirMove.$fileNameMove2.".txt";
          copy($fileName1,$fileNameMove1); //copy file
          copy($fileName2,$fileNameMove2); //copy file
          $this->fileExists($fileNameMove1); //to make sure file is copied to other folder
          {
            unlink($fileName1);//delete file
          }
          $this->fileExists($fileNameMove2); //to make sure file is copied to other folder
          {
            unlink($fileName2);//delete file
          }

          $data['formTable'] = '<div class="success">The Data Uploaded Successfully.</div>';
        }
        else
        {
          $data['formTable'] = '<div class="error">Error Occured while uploading.</div>';
        }

        $data['formOpen'] = form_open("doubledataentry/twofileupload");

        $plotCensusArray = $this->session->userdata('plotCensusArray');
        $plotName = $plotCensusArray['plotName'];
        $censusNumber = $plotCensusArray['censusNumber'];
        $plotActualName = $plotCensusArray['plotActualName'];
        $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
        $data['contentTitle'] = 'Double Data Entry - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
        $data['backLink'] = anchor('/doubledataentry/selectformtype', 'Back', array('title'=>'Back to Select Form Type', 'class'=>'back'));
        $this->load->view('user/dataentry/simpleform',$data);
      }

    }

    function _validatetwofileupload()
    {
      $this->form_validation->set_rules('fileName1', 'File 1', 'callback_dropdown_check');
      $this->form_validation->set_rules('fileName2', 'File 2', 'callback_dropdown_check');

      $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    function dropdown_check($str)
    {
      if($str == 'default')
      {
          $this->form_validation->set_message('dropdown_check', '%s need to be Selected');
          return FALSE;
      }
      else
      {
          return True;
      }
    }

    function _uploadFileBig($formType,$fileName1,$fileName2)
    {
      $dir = "./files/datafiles/bigtree/";
      $tempTableName1 = 'TempBigTrees_1';
      $tempTableName2 = 'TempBigTrees_2';
      $tempTableNameFinal = 'TempBigTrees';
      $tempTableNameFinalErr = 'TempBigTreesError';

      $fileName1 = $dir.$fileName1.".txt";  //complete path to file
      $fileName2 = $dir.$fileName2.".txt";  //complete path to file

      $this->load->library('formlibrary');

      //////////////////File 1//////////////////////////////
      $fileContent1 = $this->formlibrary->readDataFileBig($fileName1);

      $fileInfoA = $fileContent1['fileInfo'];
      $censusNumber = $fileInfoA['censusNumber'];
      $plotName = $fileInfoA['plotName'];
      $collected1A = $fileContent1['collected'];
      $checked1A = $fileContent1['checked'];
      $entered1A = $fileContent1['entered'];
      $content1A = $fileContent1['content'];

      $plotCensusArray = $this->session->userdata('plotCensusArray');
      $plotID = $plotCensusArray['plotName'];

      $censusID = $this->dataentrymodel->getCensusIDByCensusNumber($censusNumber,$plotID);

      //Create personnel temp table and form temp table
      $createTempPersonnel = $this->dataentrymodel->createPersonnelTempTable();

      $createTempForm1 = $this->dataentrymodel->createFormTempTable($tempTableName1);

      //upload form data into form temp table
      $tempTableColumns = $this->_tempTableColumnArray();
      $contentInsertArray = array();
      $quadratNameArray = array();

      foreach($content1A as $contentRow)
      {
        //$contentInsertArray['QuadratName'] = $quadratName;
        $contentInsertArray['PlotCensusNumber'] = $censusNumber;
        $contentInsertArray['CensusID'] = $censusID;
        $contentInsertArray['PlotID'] = $plotID;

        $collectedCount = count($collected1A) - 1; //Last record is date
        $dateWorked = $collected1A[$collectedCount]; //array starts from 0
        $exactDate = $dateWorked; //This is ExactDate for collection column in Temp Tables

        $contentInsertArray['ExactDate'] = $exactDate;

        foreach($tempTableColumns as $key => $value)
        {
          if(isset($contentRow->$value))
          {
            $contentInsertArray[$key] = $contentRow->$value;
            //If Quadrat column exists in the big form
            if($key == 'QuadratName')
            {
              $quadratName = $contentRow->$value;
              if(!in_array($quadratName,$quadratNameArray))      //Do not enter Personnel information again if already entered once for a quadrat
              {
                  $quadratNameArray[$quadratName] = $quadratName;
                  //upload personnel info into personnel temp table
                  //Enter Collected Data
                  for($i=0;$i<$collectedCount;$i++)
                  {
                    $personnelID = $collected1A[$i];
                    $role = "field technician";
                    $roleID = $this->dataentrymodel->getRoleID($role);
                    $personnelInsertArray = array('QuadratName'=>$quadratName,'PersonnelID'=>$personnelID,'Form'=>$formType,'PlotID'=>$plotID,'CensusID'=>$censusID,'PlotCensusNumber'=>$censusNumber,'Role'=>$role,'RoleID'=>$roleID,'DateWorked'=>$dateWorked);
                    $tableName = 'TempPersonnelInfo';
                    $personnelInsert = $this->dataentrymodel->insertRowIntoTable($tableName,$personnelInsertArray);
                  }
                  //Enter Checked Data
                  $checkedCount = count($checked1A) - 1; //Last record is date
                  $dateWorked = $checked1A[$checkedCount]; //array starts from 0
                  for($i=0;$i<$checkedCount;$i++)
                  {
                    $personnelID = $checked1A[$i];
                    $role = "field supervisor";
                    $roleID = $this->dataentrymodel->getRoleID($role);
                    $personnelInsertArray = array('QuadratName'=>$quadratName,'PersonnelID'=>$personnelID,'Form'=>$formType,'PlotID'=>$plotID,'CensusID'=>$censusID,'PlotCensusNumber'=>$censusNumber,'Role'=>$role,'RoleID'=>$roleID,'DateWorked'=>$dateWorked);
                    $tableName = 'TempPersonnelInfo';
                    $personnelInsert = $this->dataentrymodel->insertRowIntoTable($tableName,$personnelInsertArray);
                  }
                  //Enter Entered Data
                  $enteredCount = count($entered1A) - 1; //Last record is date
                  $dateWorked = $entered1A[$enteredCount]; //array starts from 0
                  for($i=0;$i<$enteredCount;$i++)
                  {
                    $personnelID = $entered1A[$i];
                    $role = "data entry technician";
                    $roleID = $this->dataentrymodel->getRoleID($role);
                    $personnelInsertArray = array('QuadratName'=>$quadratName,'PersonnelID'=>$personnelID,'Form'=>$formType,'PlotID'=>$plotID,'CensusID'=>$censusID,'PlotCensusNumber'=>$censusNumber,'Role'=>$role,'RoleID'=>$roleID,'DateWorked'=>$dateWorked);
                    $tableName = 'TempPersonnelInfo';
                    $personnelInsert = $this->dataentrymodel->insertRowIntoTable($tableName,$personnelInsertArray);
                  }
              }
            }
          }
        }

        $this->dataentrymodel->insertRowIntoTable($tempTableName1,$contentInsertArray);
      }
      //////////////////End File 1///////////////////////////////

      //////////////////File 2//////////////////////////////////
      $fileContent2 = $this->formlibrary->readDataFileBig($fileName2);

      $fileInfoA = $fileContent2['fileInfo'];
      $censusNumber = $fileInfoA['censusNumber'];
      $plotName = $fileInfoA['plotName'];
      $collected2A = $fileContent2['collected'];
      $checked2A = $fileContent2['checked'];
      $entered2A = $fileContent2['entered'];
      $content2A = $fileContent2['content'];

      //Create form temp table
      $createTempForm2 = $this->dataentrymodel->createFormTempTable($tempTableName2);

      //Get ExactDate
      $collectedCount = count($collected2A) - 1; //Last record is date
      $dateWorked = $collected2A[$collectedCount]; //array starts from 0
      $exactDate = $dateWorked; //This is ExactDate for collection column in Temp Tables

      //upload form data into form temp table
      $tempTableColumns = $this->_tempTableColumnArray();
      $contentInsertArray = array();
      foreach($content2A as $contentRow)
      {
        //$contentInsertArray['QuadratName'] = $quadratName;
        $contentInsertArray['PlotCensusNumber'] = $censusNumber;
        $contentInsertArray['CensusID'] = $censusID;
        $contentInsertArray['PlotID'] = $plotID;
        $contentInsertArray['ExactDate'] = $exactDate;

        foreach($tempTableColumns as $key => $value)
        {
          if(isset($contentRow->$value))
          {
            $contentInsertArray[$key] = $contentRow->$value;
            //If Quadrat column exists in the big form
            if($key == 'QuadratName')
            {
              $quadratName = $contentRow->$value;
              //upload personnel info into personnel temp table

              //Don't Need to Enter Collected Data Again
              //Don't Need Enter Checked Data Again
              if(!in_array($quadratName,$quadratNameArray))      //Check if personnel information for a quadrat name already entered. Don't enter again.
              {
                $quadratNameArray[$quadratName] = $quadratName;
                //Enter Entered Data
                $enteredCount = count($entered2A) - 1; //Last record is date
                $dateWorked = $entered2A[$enteredCount]; //array starts from 0
                for($i=0;$i<$enteredCount;$i++)
                {
                  $personnelID = $entered2A[$i];
                  $role = "data entry technician";
                  $roleID = $this->dataentrymodel->getRoleID($role);
                  $personnelInsertArray = array('QuadratName'=>$quadratName,'PersonnelID'=>$personnelID,'Form'=>$formType,'PlotID'=>$plotID,'CensusID'=>$censusID,'PlotCensusNumber'=>$censusNumber,'Role'=>$role,'RoleID'=>$roleID,'DateWorked'=>$dateWorked);
                  $tableName = 'TempPersonnelInfo';
                  $personnelInsert = $this->dataentrymodel->insertRowIntoTable($tableName,$personnelInsertArray);
                }
              }
            }
          }
        }

        $this->dataentrymodel->insertRowIntoTable($tempTableName2,$contentInsertArray);
      }
      ////////////////////End File 2////////////////////////////////
      ////Create Final Temp Table///////
      $createTempForm3 = $this->dataentrymodel->createFormTempTable($tempTableNameFinal);
      $createTempForm4 = $this->dataentrymodel->createFormTempTable($tempTableNameFinalErr);
      ///////////////////////
    }


    function _uploadFile($formType,$fileName1,$fileName2)
    {
      $fileName1Split = explode('_',$fileName1);
      $quadrat1 = $fileName1Split[3];

      $fileName2Split = explode('_',$fileName2);
      $quadrat2 = $fileName2Split[3];

      if($formType == 'newform')
      {
        $dir = "./files/datafiles/newplant/";
        $tempTableName1 = 'TempNewPlants_1_'.$quadrat1;
        $tempTableName2 = 'TempNewPlants_2_'.$quadrat2;
        $tempTableNameFinal = 'TempNewPlants';
        $tempTableNameFinalErr = 'TempNewPlantsError';
      }
      elseif($formType == 'multiform')
      {
        $dir = "./files/datafiles/multistem/";
        $tempTableName1 = 'TempMultiStems_1_'.$quadrat1;
        $tempTableName2 = 'TempMultiStems_2_'.$quadrat2;
        $tempTableNameFinal = 'TempMultiStems';
        $tempTableNameFinalErr = 'TempMultiStemsError';

      }
      elseif($formType == 'oldform')
      {
        $dir = "./files/datafiles/oldtree/";
        $tempTableName1 = 'TempOldTrees_1_'.$quadrat1;
        $tempTableName2 = 'TempOldTrees_2_'.$quadrat2;
        $tempTableNameFinal = 'TempOldTrees';
        $tempTableNameFinalErr = 'TempOldTreesError';
      }

      $fileName1 = $dir.$fileName1.".txt";  //complete path to file
      $fileName2 = $dir.$fileName2.".txt";  //complete path to file

      $this->load->library('formlibrary');

      //////////////////File 1//////////////////////////////
      $fileContent1 = $this->formlibrary->readDataFile($fileName1);

      $fileInfoA = $fileContent1['fileInfo'];
      $quadratName = $fileInfoA['quadratName'];
      $censusNumber = $fileInfoA['censusNumber'];
      $plotName = $fileInfoA['plotName'];
      $collected1A = $fileContent1['collected'];
      $checked1A = $fileContent1['checked'];
      $entered1A = $fileContent1['entered'];
      $content1A = $fileContent1['content'];

      $plotCensusArray = $this->session->userdata('plotCensusArray');
      $plotID = $plotCensusArray['plotName'];

      $censusID = $this->dataentrymodel->getCensusIDByCensusNumber($censusNumber,$plotID);

      //Create personnel temp table and form temp table
      $createTempPersonnel = $this->dataentrymodel->createPersonnelTempTable();

      $createTempForm1 = $this->dataentrymodel->createFormTempTable($tempTableName1);

      //upload personnel info into personnel temp table

      //Enter Collected Data
      $collectedCount = count($collected1A) - 1; //Last record is date
      $dateWorked = $collected1A[$collectedCount]; //array starts from 0
      $exactDate = $dateWorked; //This is ExactDate for collection column in Temp Tables

      for($i=0;$i<$collectedCount;$i++)
      {
        $personnelID = $collected1A[$i];
        $role = "field technician";
        $roleID = $this->dataentrymodel->getRoleID($role);
        $personnelInsertArray = array('QuadratName'=>$quadratName,'PersonnelID'=>$personnelID,'Form'=>$formType,'PlotID'=>$plotID,'CensusID'=>$censusID,'PlotCensusNumber'=>$censusNumber,'Role'=>$role,'RoleID'=>$roleID,'DateWorked'=>$dateWorked);
        $tableName = 'TempPersonnelInfo';
        $personnelInsert = $this->dataentrymodel->insertRowIntoTable($tableName,$personnelInsertArray);
      }
      //Enter Checked Data
      $checkedCount = count($checked1A) - 1; //Last record is date
      $dateWorked = $checked1A[$checkedCount]; //array starts from 0
      for($i=0;$i<$checkedCount;$i++)
      {
        $personnelID = $checked1A[$i];
        $role = "field supervisor";
        $roleID = $this->dataentrymodel->getRoleID($role);
        $personnelInsertArray = array('QuadratName'=>$quadratName,'PersonnelID'=>$personnelID,'Form'=>$formType,'PlotID'=>$plotID,'CensusID'=>$censusID,'PlotCensusNumber'=>$censusNumber,'Role'=>$role,'RoleID'=>$roleID,'DateWorked'=>$dateWorked);
        $tableName = 'TempPersonnelInfo';
        $personnelInsert = $this->dataentrymodel->insertRowIntoTable($tableName,$personnelInsertArray);
      }
      //Enter Entered Data
      $enteredCount = count($entered1A) - 1; //Last record is date
      $dateWorked = $entered1A[$enteredCount]; //array starts from 0
      for($i=0;$i<$enteredCount;$i++)
      {
        $personnelID = $entered1A[$i];
        $role = "data entry technician";
        $roleID = $this->dataentrymodel->getRoleID($role);
        $personnelInsertArray = array('QuadratName'=>$quadratName,'PersonnelID'=>$personnelID,'Form'=>$formType,'PlotID'=>$plotID,'CensusID'=>$censusID,'PlotCensusNumber'=>$censusNumber,'Role'=>$role,'RoleID'=>$roleID,'DateWorked'=>$dateWorked);
        $tableName = 'TempPersonnelInfo';
        $personnelInsert = $this->dataentrymodel->insertRowIntoTable($tableName,$personnelInsertArray);
      }

      //upload form data into form temp table
      $tempTableColumns = $this->_tempTableColumnArray();
      $contentInsertArray = array();
      foreach($content1A as $contentRow)
      {
        $contentInsertArray['QuadratName'] = $quadratName;
        $contentInsertArray['PlotCensusNumber'] = $censusNumber;
        $contentInsertArray['CensusID'] = $censusID;
        $contentInsertArray['PlotID'] = $plotID;
        $contentInsertArray['ExactDate'] = $exactDate;

        foreach($tempTableColumns as $key => $value)
        {
          if(isset($contentRow->$value))
          {
            $insertValue = $contentRow->$value;
            if($insertValue == '')
            {
              $insertValue = NULL;    //set the value Null if the column is left blank
            }
            if($value == 'nosubTag')
            {
              $contentInsertArray['Tag'] = $insertValue;       // as tag and nosubTag ColumnName both goes to 'Tag' in temp table
            }
            else
            {
              $contentInsertArray[$key] = $insertValue;
            }
          }
        }

        $this->dataentrymodel->insertRowIntoTable($tempTableName1,$contentInsertArray);
      }
      ////////////////////////////////////////////////////

      //////////////////File 2///////////////////////////
      $fileContent2 = $this->formlibrary->readDataFile($fileName2);

      $fileInfoA = $fileContent2['fileInfo'];
      $quadratName = $fileInfoA['quadratName'];
      $censusNumber = $fileInfoA['censusNumber'];
      $plotName = $fileInfoA['plotName'];
      $collected2A = $fileContent2['collected'];
      $checked2A = $fileContent2['checked'];
      $entered2A = $fileContent2['entered'];
      $content2A = $fileContent2['content'];

      //Create form temp table
      $createTempForm2 = $this->dataentrymodel->createFormTempTable($tempTableName2);

      //upload personnel info into personnel temp table

      //Don't Need to Enter Collected Data Again
      //Don't Need Enter Checked Data Again

      //Get ExactDate
      $collectedCount = count($collected2A) - 1; //Last record is date
      $dateWorked = $collected2A[$collectedCount]; //array starts from 0
      $exactDate = $dateWorked; //This is ExactDate for collection column in Temp Tables

      //Enter Entered Data
      $enteredCount = count($entered2A) - 1; //Last record is date
      $dateWorked = $entered2A[$enteredCount]; //array starts from 0
      for($i=0;$i<$enteredCount;$i++)
      {
        $personnelID = $entered2A[$i];
        $role = "data entry technician";
        $roleID = $this->dataentrymodel->getRoleID($role);
        $personnelInsertArray = array('QuadratName'=>$quadratName,'PersonnelID'=>$personnelID,'Form'=>$formType,'PlotID'=>$plotID,'CensusID'=>$censusID,'PlotCensusNumber'=>$censusNumber,'Role'=>$role,'RoleID'=>$roleID,'DateWorked'=>$dateWorked);
        $tableName = 'TempPersonnelInfo';
        $personnelInsert = $this->dataentrymodel->insertRowIntoTable($tableName,$personnelInsertArray);
      }

      //upload form data into form temp table
      $tempTableColumns = $this->_tempTableColumnArray();
      $contentInsertArray = array();
      foreach($content2A as $contentRow)
      {
        $contentInsertArray['QuadratName'] = $quadratName;
        $contentInsertArray['PlotCensusNumber'] = $censusNumber;
        $contentInsertArray['CensusID'] = $censusID;
        $contentInsertArray['PlotID'] = $plotID;
        $contentInsertArray['ExactDate'] = $exactDate;

        foreach($tempTableColumns as $key => $value)
        {
          if(isset($contentRow->$value))
          {
            if(isset($contentRow->$value))
            {
              $insertValue = $contentRow->$value;
              if($insertValue == '')
              {
                $insertValue = NULL;    //set the value Null if the column is left blank
              }
              if($value == 'nosubTag')
              {
                $contentInsertArray['Tag'] = $insertValue;       // as tag and nosubTag ColumnName both goes to 'Tag' in temp table
              }
              else
              {
                $contentInsertArray[$key] = $insertValue;
              }
            }
          }
        }

        $this->dataentrymodel->insertRowIntoTable($tempTableName2,$contentInsertArray);
      }
      /////////////////////////////////////////////////////

      ////Create Final Temp Table///////
      $createTempForm3 = $this->dataentrymodel->createFormTempTable($tempTableNameFinal);
      $createTempForm4 = $this->dataentrymodel->createFormTempTable($tempTableNameFinalErr);
      ///////////////////////
    }

    function _tempTableColumnArray()
    {
      $tempTableArray['TreeID'] = 'treeID';
      $tempTableArray['Tag'] = 'tag';
      $tempTableArray['nosubTag'] = 'nosubTag';  // will be changed to 'Tag' while inserting records.
      $tempTableArray['StemID'] = 'stemID';
      $tempTableArray['StemTag'] = 'stemTag';
      $tempTableArray['QuadratID'] = 'quadratID';
      $tempTableArray['QuadratName'] = 'quadratName';
      $tempTableArray['Subquad'] = 'subquadrat';
      $tempTableArray['SpeciesID'] = 'speciesID';
      $tempTableArray['Mnemonic'] = 'species';
      $tempTableArray['SubSpeciesID'] = 'subSpeciesID';
      $tempTableArray['PlotID'] = 'plotID';
      $tempTableArray['CensusID'] = 'censusID';
      $tempTableArray['PlotCensusNumber'] = 'plotCensusNumber';
      $tempTableArray['PrimaryStem'] = 'primaryStem';
      $tempTableArray['X'] = 'x';
      $tempTableArray['Y'] = 'y';
      $tempTableArray['DBH'] = 'dbh';
      $tempTableArray['OldDBH'] = 'olddbh';
      $tempTableArray['HOM'] = 'hom';
      $tempTableArray['OldHOM'] = 'oldhom';
      $tempTableArray['Codes'] = 'codes';
      $tempTableArray['OldCodes'] = 'oldcodes';
      $tempTableArray['Comments'] = 'comments';
      $tempTableArray['ExactDate'] = 'exactDate';
      $tempTableArray['Errors'] = 'errors';
      $tempTableArray['OldTrees'] = 'oldTrees';
      $tempTableArray['BigTrees'] = 'bigTrees';
      $tempTableArray['Extra1'] = 'extra1';
      $tempTableArray['Extra2'] = 'extra2';
      $tempTableArray['Extra3'] = 'extra3';
      $tempTableArray['Extra4'] = 'extra4';
      $tempTableArray['Extra5'] = 'extra5';

      return $tempTableArray;
    }

    function fileExists($path)
    {
      return (@fopen($path,"r")==true);
    }
}