<?php

class Doublescreening extends Controller{

    function Doublescreening()
    {
      parent::Controller();
      if($this->session->userdata('loggedin') !== '1')
      {
        redirect('main','location');
      }
      $this->load->model('doublescreeningmodel');

      set_time_limit(0);
      ini_set('memory_limit', '-1');
    }

    function selectformtype()
    {
      if(isset($this->session->userdata['formType']))
      {
        $this->session->unset_userdata('formType');
      }
      if(isset($this->session->userdata['ordered']))
      {
        $this->session->unset_userdata('ordered');
      }

      $data['formOpen'] = form_open("doublescreening/selectformtypevalidate");
      $data['formTable'] = $this->_selectFormTypeTable();

      $plotCensusArray = $this->session->userdata('plotCensusArray');
      $plotActualName = $plotCensusArray['plotActualName'];
      $censusNumber = $plotCensusArray['censusNumber'];
      $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
      $data['contentTitle'] = 'Double Data Screening - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
      $data['backLink'] = anchor('/dataentry/doubledataentry', 'Back', array('title'=>'Back to Select Entry Type', 'class'=>'back'));
      $this->load->view('user/dataentry/simpleform',$data);
    }

    function selectformtypevalidate()
    {
      $this->_validateselectformtype();

      if($this->form_validation->run() == FALSE)
      {
        $data['formOpen'] = form_open("doublescreening/selectformtypevalidate");
        $data['formTable'] = $this->_selectFormTypeTable();

        $plotCensusArray = $this->session->userdata('plotCensusArray');
        $plotName = $plotCensusArray['plotName'];
        $censusNumber = $plotCensusArray['censusNumber'];
        $plotActualName = $plotCensusArray['plotActualName'];
        $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
        $data['contentTitle'] = 'Double Data Screening - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
        $data['backLink'] = anchor('/dataentry/doubledataentry', 'Back', array('title'=>'Back to Select Entry Type', 'class'=>'back'));
        $this->load->view('user/dataentry/simpleform',$data);
      }
      else
      {
        if(isset($this->session->userdata['tablesNames']))
        {
            $this->session->unset_userdata('tablesNames');
        }

        $formType = $this->input->post('formType');
        //$this->session->set_userdata('formType',$formType);

        if($formType == 'newform')
        {
          $like = 'TempNewPlants%';
        }
        elseif($formType == 'multiform')
        {
          $like = 'TempMultiStems%';
        }
        elseif($formType == 'oldform')
        {
          $like= 'TempOldTrees%';
        }
        elseif($formType == 'bigform')
        {
          $like = 'TempBigTrees%';
        }

        $tableNameArray = $this->doublescreeningmodel->tableNameList($like);

        //form with drop down - listing temp tables in the selected form type
        $data['formTable'] = $this->_selectFileTable($tableNameArray,$formType);
        $data['formOpen'] = form_open("doublescreening/selectfilesvalidate");

        $plotCensusArray = $this->session->userdata('plotCensusArray');
        $plotName = $plotCensusArray['plotName'];
        $censusNumber = $plotCensusArray['censusNumber'];
        $plotActualName = $plotCensusArray['plotActualName'];
        $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
        $data['contentTitle'] = 'Double Data Screening - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
        $data['backLink'] = anchor('/doublescreening/selectformtype', 'Back', array('title'=>'Back to Select Form Type', 'class'=>'back'));
        $this->load->view('user/dataentry/simpleform',$data);
      }
    }

    function _selectFormTypeTable()
    {
      $formType = set_value('formType');

      $formTypeA = array('default'=>'Select','newform'=>'New Plants','oldform'=>'Old Trees','multiform'=>'Multi Stem','bigform'=>'Big Trees');
      //$formTypeA = array('default'=>'Select','newform'=>'New Plants','oldform'=>'Old Trees','multiform'=>'Multi Stem');
      $formTypeDD = form_dropdown('formType',$formTypeA);

      $formTypeErr = form_error('formType');

      $submitButtonA = array('name'=>'submitButton','id'=>'button','type'=>'submit','content'=>'Submit');
      $submitButton = form_button($submitButtonA);

      $formTableA = array(array(),
                          array('Form Type : ',$formTypeDD,$formTypeErr),
                          array('',$submitButton)
                          );

      $this->table->set_empty("");
      $formTable = $this->table->generate($formTableA);

      return $formTable;
    }

    function _validateselectformtype()
    {
      $this->form_validation->set_rules('formType', 'Form Type', 'callback_dropdown_check');

      $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    function _selectFileTable($tableNameArray,$formType)
    {
      $tableName1 = set_value('tableName1');
      $tableName2 = set_value('tableName2');

      $tableName1DD = form_dropdown('tableName1',$tableNameArray,$tableName1);
      $tableName2DD = form_dropdown('tableName2',$tableNameArray,$tableName2);
      $tableNameHd = form_hidden('tableNameArray',$tableNameArray);
      $formTypeHd = form_hidden('formType',$formType);

      $tableName1Err = form_error('tableName1');
      $tableName2Err = form_error('tableName2');

      $submitButtonA = array('name'=>'submitButton','id'=>'button','type'=>'submit','content'=>'Submit');
      $submitButton = form_button($submitButtonA);

      $formTableA = array(array(),
                          array('Table 1 : ',$tableName1DD,$tableName1Err),
                          array('Table 2 : ',$tableName2DD,$tableName2Err),
                          array('',$tableNameHd.$formTypeHd),
                          array('',$submitButton)
                          );

      $this->table->set_empty("");
      $formTable = $this->table->generate($formTableA);

      return $formTable;
    }

    function _validatetwofileupload()
    {
      $this->form_validation->set_rules('tableName1', 'Table 1', 'callback_dropdown_check');
      $this->form_validation->set_rules('tableName2', 'Table 2', 'callback_dropdown_check');

      $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    function selectfilesvalidate()
    {
      $this->_validatetwofileupload();
      $tableNameArray = $this->input->post('tableNameArray');
      $formType = $this->input->post('formType');
      if($this->form_validation->run() == FALSE)
      {
        //form with drop down - listing temp tables in the selected form type
        $data['formTable'] = $this->_selectFileTable($tableNameArray,$formType);
        $data['formOpen'] = form_open("doublescreening/selectfilesvalidate");

        $plotCensusArray = $this->session->userdata('plotCensusArray');
        $plotName = $plotCensusArray['plotName'];
        $censusNumber = $plotCensusArray['censusNumber'];
        $plotActualName = $plotCensusArray['plotActualName'];
        $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
        $data['contentTitle'] = 'Double Data Screening - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
        $data['backLink'] = anchor('/doublescreening/selectformtype', 'Back', array('title'=>'Back to Select Form Type', 'class'=>'back'));
        $this->load->view('user/dataentry/simpleform',$data);
      }
      else
      {
        $tableName1 = $this->input->post('tableName1');
        $tableName2 = $this->input->post('tableName2');

        $tableNameSplit = explode('_',$tableName1);
        $tableNameFinal = $tableNameSplit[0];

        $tableNames['tableName1'] = $tableName1;
        $tableNames['tableName2'] = $tableName2;
        $tableNames['tableNameFinal'] = $tableNameFinal;

        $this->session->set_userdata('tableNames',$tableNames);

        if($formType == 'oldform') {

            $formTableA = array(array(''),
                          array(anchor('doublescreening/screentwotables', 'Compare Records Based On Tag and Stem Tag', array('title'=>'Compare Records Based On Tag and Stem Tag', 'class'=>'forward'))),
                          array(anchor('doublescreening/screentwotablesordered', 'Compare Records Based On Data Entry Order', array('title'=>'Compare Records Based On Data Entry Order', 'class'=>'forward')))
                         );
            $this->table->set_empty("");
            $data['formTable'] = $this->table->generate($formTableA);
            $data['formOpen'] = "";

            $plotCensusArray = $this->session->userdata('plotCensusArray');
            $plotName = $plotCensusArray['plotName'];
            $censusNumber = $plotCensusArray['censusNumber'];
            $plotActualName = $plotCensusArray['plotActualName'];
            $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
            $data['contentTitle'] = 'Double Data Screening - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
            $data['backLink'] = anchor('/doublescreening/selectformtype', 'Back', array('title'=>'Back to Select Form Type', 'class'=>'back'));
            $this->load->view('user/dataentry/simpleform',$data);
        }
        else {
          redirect('doublescreening/screentwotables');
        }
      }
    }

    function screentwotables()
    {
      if(!isset($this->session->userdata['tableNames']))
      {
        redirect('doublescreening/selectformtype');
      }
      $tableNames = $this->session->userdata('tableNames');
      $tableName1 = $tableNames['tableName1'];
      $tableName2 = $tableNames['tableName2'];
      $tableNameFinal = $tableNames['tableNameFinal'];

      $tableQuery1 = $this->doublescreeningmodel->fetchAllRecords($tableName1);
      if($tableQuery1->num_rows > 0)
      {
        $numRecords = $tableQuery1->num_rows;
        foreach($tableQuery1->result_array() as $tableRow1)
        {
          $tag = $tableRow1['Tag'];
          $stemTag = $tableRow1['StemTag'];

          $tableQuery2 = $this->doublescreeningmodel->fetchCompareRecord($tableName2,$tag,$stemTag);

          if($tableQuery2->num_rows > 0)
          {
             $status = $this->_compareRecords($tableRow1,$tableQuery2,$tableNames);
             if($status == 'diff')
             {
              $this->_displayRecords($tableRow1,$tableQuery2,$tableNames);
              break;
             }
          }
          else
          {
            //Records Missing in Table 2
            $tableQuery2Missing = "missing";
            $this->_displayRecords($tableRow1,$tableQuery2Missing,$tableNames);
            break;
          }
          $numRecords = $numRecords - 1;
        }
        if($numRecords == 0)
        {
          redirect('doublescreening/screentwotables');
        }
      }
      else
      {
        $tableQuery2 = $this->doublescreeningmodel->fetchAllRecords($tableName2);
        if($tableQuery2->num_rows > 0)
        {
          $data['title'] = "Data Entry";
          $data['contentTitle'] = "Data Screening - Choose Correct Record";
          $data['formOpen'] = "";
          $data['backLink'] = anchor('dataentry/selectentrytype','Back',array('class'=>'back'));
          $data['button1'] = "";
          $data['button2'] = "";
          $data['table'] = "<div class='success'>All Records in ".$tableName1." are screened. <br />But ".$tableName2." still have some data.<br /><br />Do you want to screen this table too.".anchor('doublescreening/screensecondtable/','Yes',array('class'=>'forward'))."</div>";
          $this->load->view('user/dataentry/screentwotable',$data);
        }
        else
        {
          $data['title'] = "Data Entry";
          $data['contentTitle'] = "Data Screening - Choose Correct Record";
          $data['formOpen'] = "";
          $data['backLink'] = anchor('dataentry/selectentrytype','Back',array('class'=>'back'));
          $data['button1'] = "";
          $data['button2'] = "";
          $data['table'] = "<div class='success'>All Records are screened. Table doesn't contain any more records.";
          $this->load->view('user/dataentry/screentwotable',$data);
        }
      }
    }

    function screentwotablesordered()
    {
      if(!isset($this->session->userdata['tableNames']))
      {
        redirect('doublescreening/selectformtype');
      }
      $this->session->set_userdata('ordered','ordered');

      $tableNames = $this->session->userdata('tableNames');
      $tableName1 = $tableNames['tableName1'];
      $tableName2 = $tableNames['tableName2'];
      $tableNameFinal = $tableNames['tableNameFinal'];

      $tableQuery1 = $this->doublescreeningmodel->fetchAllRecords($tableName1);
      if($tableQuery1->num_rows > 0)
      {
        $numRecords = $tableQuery1->num_rows;
        foreach($tableQuery1->result_array() as $tableRow1)
        {
          $tempID = $tableRow1['TempID'];
          //$stemTag = $tableRow1['StemTag'];

          $tableQuery2 = $this->doublescreeningmodel->fetchRecordByTempID($tableName2,$tempID);

          if($tableQuery2->num_rows > 0)
          {
             $status = $this->_compareRecords($tableRow1,$tableQuery2,$tableNames);
             if($status == 'diff')
             {
              $this->_displayRecords($tableRow1,$tableQuery2,$tableNames);
              break;
             }
          }
          else
          {
            //Records Missing in Table 2
            $tableQuery2Missing = "missing";
            $this->_displayRecords($tableRow1,$tableQuery2Missing,$tableNames);
            break;
          }
          $numRecords = $numRecords - 1;
        }
        if($numRecords == 0)
        {
          redirect('doublescreening/screentwotablesordered');
        }
      }
      else
      {
        $tableQuery2 = $this->doublescreeningmodel->fetchAllRecords($tableName2);
        if($tableQuery2->num_rows > 0)
        {
          $data['title'] = "Data Entry";
          $data['contentTitle'] = "Data Screening - Choose Correct Record";
          $data['formOpen'] = "";
          $data['backLink'] = anchor('dataentry/selectentrytype','Back',array('class'=>'back'));
          $data['button1'] = "";
          $data['button2'] = "";
          $data['table'] = "<div class='success'>All Records in ".$tableName1." are screened. <br />But ".$tableName2." still have some data.<br /><br />Do you want to screen this table too.".anchor('doublescreening/screensecondtable/ordered','Yes',array('class'=>'forward'))."</div>";
          $this->load->view('user/dataentry/screentwotable',$data);
        }
        else
        {
          $data['title'] = "Data Entry";
          $data['contentTitle'] = "Data Screening - Choose Correct Record";
          $data['formOpen'] = "";
          $data['backLink'] = anchor('dataentry/selectentrytype','Back',array('class'=>'back'));
          $data['button1'] = "";
          $data['button2'] = "";
          $data['table'] = "<div class='success'>All Records are screened. Table doesn't contain any more records.";
          $this->load->view('user/dataentry/screentwotable',$data);
        }
      }
    }

    function screensecondtable($ordered = 'ordered')
    {
      if(!isset($this->session->userdata['tableNames']))
      {
        redirect('doublescreening/selectformtype');
      }
      $tableNames = $this->session->userdata('tableNames');
      $tableName1 = $tableNames['tableName1'];
      $tableName2 = $tableNames['tableName2'];
      $tableNameFinal = $tableNames['tableNameFinal'];

      //Now switch table 1 and table 2
      $tableNames['tableName1'] = $tableName2;
      $tableNames['tableName2'] = $tableName1;
      $tableNames['tableNameFinal'] = $tableNameFinal;

      $this->session->set_userdata('tableNames',$tableNames);

      if($ordered == 'ordered') {
        redirect('doublescreening/screentwotablesordered');
      }
      else {
        redirect('doublescreening/screentwotables');
      }

    }

    function _compareRecords($tableRow1,$tableQuery2,$tableNames)
    {
      foreach($tableQuery2->result_array() as $tableRow2)
      {
        $tableRow1Compare = $tableRow1;
        $tableRow2Compare = $tableRow2;
        unset($tableRow1Compare['TempID']);
        unset($tableRow2Compare['TempID']);
        unset($tableRow1Compare['OldCodes']);
        unset($tableRow2Compare['OldCodes']);
        unset($tableRow1Compare['OldDBH']);
        unset($tableRow2Compare['OldDBH']);
        unset($tableRow1Compare['OldHOM']);
        unset($tableRow2Compare['OldHOM']);
        //$columnDiff = array_diff($tableRow1Compare,$tableRow2Compare);
        $columnDiff = $this->arraysDiff($tableRow1Compare,$tableRow2Compare);

        if($columnDiff == 0)
        {
          $status = 'same';
          //copy the record from table 1 to temp table final
          foreach($tableRow1 as $key => $value)
          {
            if($key !== 'TempID')
            {
             $insertRowArray[$key] = $tableRow1[$key];
            }
          }
          $this->doublescreeningmodel->insertRowIntoTable($tableNames['tableNameFinal'],$insertRowArray);
          //delete from table 1 and table 2
          $tempID1 = $tableRow1['TempID'];
          $this->doublescreeningmodel->deleteTempRecord($tableNames['tableName1'],$tempID1);
          $tempID2 = $tableRow2['TempID'];
          $this->doublescreeningmodel->deleteTempRecord($tableNames['tableName2'],$tempID2);
          //break
          break;
        }
        else
        {
          $status = 'diff';
        }
      }
      return $status;
    }

    function _displayRecords($tableRow1,$tableQuery2,$tableNames)
    {
      $tableName1 = $tableNames['tableName1'];
      $tableName2 = $tableNames['tableName2'];

      $plotCensusArray = $this->session->userdata('plotCensusArray');
      $plotID = $plotCensusArray['plotName'];
      $selectedPlotName = $this->session->userdata('selectedPlotName');
      $plotName = $this->doublescreeningmodel->getPlotNameByID($plotID);

      $this->load->library('formlibrary');

      $explodeTN1 = explode('_',$tableName1);
      if($explodeTN1[0] == 'TempNewPlants') //Process New Form Config File
      {
        $formType = 'newform';
        $fileName = base_url()."files/configfiles/".$formType."_".$selectedPlotName."_".$plotName."_".$plotID.".txt";
        $fileName = str_replace(" ","",$fileName);
        $formDetailResult = $this->formlibrary->readConfigFile($fileName);

        if($formDetailResult == "Not Found")
        {
          echo "Configuration File Not Found  :  ".$fileName;
          die();
        }
        $this->load->library('newplantlibrary');
        $processData = $this->newplantlibrary->processData($formDetailResult);
      }
      elseif($explodeTN1[0] == 'TempMultiStems') //Process Multi Form Config File
      {
        $formType = 'multiform';
        $fileName = base_url()."files/configfiles/".$formType."_".$selectedPlotName."_".$plotName."_".$plotID.".txt";
        $fileName = str_replace(" ","",$fileName);
        $formDetailResult = $this->formlibrary->readConfigFile($fileName);

        if($formDetailResult == "Not Found")
        {
          echo "Configuration File Not Found  :  ".$fileName;
          die();
        }
        $this->load->library('multistemlibrary');
        $processData = $this->multistemlibrary->processData($formDetailResult);
      }
      elseif($explodeTN1[0] == 'TempOldTrees') //Process Old Form Config File
      {
        $formType = 'oldform';
        $fileName = base_url()."files/configfiles/".$formType."_".$selectedPlotName."_".$plotName."_".$plotID.".txt";
        $fileName = str_replace(" ","",$fileName);
        $formDetailResult = $this->formlibrary->readConfigFile($fileName);

        if($formDetailResult == "Not Found")
        {
          echo "Configuration File Not Found  :  ".$fileName;
          die();
        }
        $this->load->library('oldplantlibrary');
        $processData = $this->oldplantlibrary->processData($formDetailResult);
      }
      elseif($explodeTN1[0] == "TempBigTrees")//Process Big Form Config file
      {
        $formType = 'bigform';
        $fileName = base_url()."files/configfiles/".$formType."_".$selectedPlotName."_".$plotName."_".$plotID.".txt";
        $fileName = str_replace(" ","",$fileName);
        $formDetailResult = $this->formlibrary->readConfigFile($fileName);

        if($formDetailResult == "Not Found")
        {
          echo "Configuration File Not Found  :   ".$fileName;
          die();
        }
        $this->load->library('bigtreelibrary');
        $processData = $this->bigtreelibrary->processData($formDetailResult);
      }
      $headerListA = $processData['headerListA'];
      $columnNameA = $processData['columnNameA'];

      //Added Exact Date as requested by Suzanne. Condition: In case the user select different collection date by mistake.
      $headerListA[] = "ExactDate";
      $columnNameA[] = "exactDate";


      $tempTableColumns = $this->_tempTableColumns();

      ////////////Table 1 Display Column///////////////
      $tempID1 = $tableRow1['TempID'];
      $radioData1 = array('name'=>'radioTable','id'=>'radioTable','value'=>"table1_".$tempID1,'checked'=>'TRUE');
      $radioTable1 = form_radio($radioData1);

      $textboxNamesA = array();//to get a list of names given to textboxes

      $allRecordsA = array(); //to get a list of records listed to delete it from table1 and table2
      $allRecordsA[] = "table1_".$tempID1;

      foreach($columnNameA as $key => $value)
      {
         $textboxType = 'same';
         $columnName = $tempTableColumns[$value]."_table1_".$tempID1;
         $textboxNamesA[] = $tempTableColumns[$value];
         $columnValue = $tableRow1[$tempTableColumns[$value]];
         $textbox = $this->_createTextbox($columnName,$columnValue,$textboxType);
         $tableArray1[$tempTableColumns[$value]] = $textbox;
      }

      $headerListShift = $headerListA;
      array_unshift($headerListShift," ");
      array_unshift($tableArray1,$radioTable1);

      //$tmpl = array ( 'table_open'  => '<table id="datatable">' );
      //$this->table->set_template($tmpl);

      $this->table->set_empty("&nbsp;");
      $this->table->set_heading($headerListShift);
      $this->table->add_row('<h3>Table1</h3>');
      $this->table->add_row($tableArray1);
      /////////////////////////////////////////////////////

      /////////////////Table 2 Display Column//////////////
      $this->table->add_row('<h3>Table2</h3>');

      if($tableQuery2 === 'missing')
      {
        $this->table->add_row("","<h5>Record Missing</h5>");
      }
      else
      {
        foreach($tableQuery2->result_array() as $tableRow2)
        {
          $tempID2 = $tableRow2['TempID'];

          $allRecordsA[] = "table2_".$tempID2;

          foreach($columnNameA as $key => $value)
          {
            $textboxType = 'same';
            $columnName = $tempTableColumns[$value]."_table2_".$tempID2;
            $columnValueTable1 = $tableRow1[$tempTableColumns[$value]];
            $columnValue = $tableRow2[$tempTableColumns[$value]];
            if($columnValueTable1 !== $columnValue)
            {
              $textboxType = 'diff';
            }
            $textbox = $this->_createTextbox($columnName,$columnValue,$textboxType);
            $tableArray2[$tempTableColumns[$value]] = $textbox;
          }
          $radioData2 = array('name'=>'radioTable','id'=>'radioTable','value'=>"table2_".$tempID2);
          $radioTable2 = form_radio($radioData2);
          $shiftTableArray2 = $tableArray2;
          array_unshift($shiftTableArray2,$radioTable2);
          $this->table->add_row($shiftTableArray2);
        }
      }
      $table = $this->table->generate();

      $submitButtonA = array('name'=>'submitButton','id'=>'button','type'=>'submit','content'=>'Submit >');
      $submitButton = form_button($submitButtonA);

      $textboxNamesHD = form_hidden('textboxNamesA',$textboxNamesA);
      $allRecordsHD = form_hidden('allRecordsA',$allRecordsA);

      $skipButton = anchor('doublescreening/skiprecord/'.$tempID1, 'Skip Record', array('title'=>'Skip This Record For Now', 'class'=>'next'));
      $deleteButton = '<p align="right" style="margin:-25px 0 10px 0;">'.anchor('doublescreening/deleterecord/'.$tempID1, 'Delete Record', array('title'=>'Record will be deleted from Table 1', 'class'=>'delete', 'onclick'=>"return confirm('Are you sure, you want to delete this record?')")).'</p>';
      $data['title'] = "Data Entry";
      $data['contentTitle'] = "Data Screening - Choose Correct Record";
      $data['formOpen'] = form_open("doublescreening/checkedrecord");
      $data['backLink'] = anchor('dataentry/selectentrytype','Back',array('class'=>'back'));
      $data['button1'] = $skipButton.$deleteButton;
      $data['button2'] = $submitButton;
      $data['table'] = $table.$textboxNamesHD.$allRecordsHD;
      $this->load->view('user/dataentry/screentwotable',$data);
    }

    function checkedrecord()
    {
      if(!isset($this->session->userdata['tableNames']))
      {
        redirect('doublescreening/selectformtype');
      }
      $tableNames = $this->session->userdata('tableNames');
      $tableName1 = $tableNames['tableName1'];
      $tableName2 = $tableNames['tableName2'];
      $tableNameFinal = $tableNames['tableNameFinal'];
      $radioTable = $this->input->post('radioTable');
      $textboxNamesA = $this->input->post('textboxNamesA');
      $allRecordsA = $this->input->post('allRecordsA');

      $splitRadioTable = explode("_",$radioTable);
      if($splitRadioTable[0] == 'table1')
      {
        $radioQuery = $this->doublescreeningmodel->fetchRecordByTempID($tableName1,$splitRadioTable[1]);
      }
      elseif($splitRadioTable[0] == 'table2')
      {
        $radioQuery = $this->doublescreeningmodel->fetchRecordByTempID($tableName2,$splitRadioTable[1]);
      }
      $rowArray = $radioQuery->row_array();
      foreach($rowArray as $rKey => $rValue)
      {
        if($rKey !== 'TempID')
        {
          $insertFinalArray[$rKey] = $rValue; //this will get additional columns like QuadratName etc to move to final temp table
        }
      }
      //now update the array with the new values from the screening form.
      foreach($textboxNamesA as $key => $value)
      {
        $insertFinalArray[$value] = $this->input->post($value."_".$radioTable);
      }
      $this->doublescreeningmodel->startTransaction(); // Transaction Starts Here
      //Insert Selected Record in final temp table
      $this->doublescreeningmodel->insertRowIntoTable($tableNameFinal,$insertFinalArray);
      //Delete records from temp table 1 and table 2
      foreach($allRecordsA as $key1 => $value1)
      {
        $splitValue1 = explode("_",$value1);
        if($splitValue1[0] == 'table1')
        {
          $tempID = $splitValue1[1];
          $this->doublescreeningmodel->deleteTempRecord($tableName1,$tempID);
        }
        elseif($splitValue1[0] == 'table2')
        {
          $tempID =$splitValue1[1];
          $this->doublescreeningmodel->deleteTempRecord($tableName2,$tempID);
        }

      }
      $this->doublescreeningmodel->completeTransaction(); // Transaction Ends Here

      if(isset($this->session->userdata['ordered'])) {
        redirect('doublescreening/screentwotablesordered');
      }
      else {
        redirect('doublescreening/screentwotables');
      }
    }

    function arraysDiff($array1,$array2)
    {
      $count = 0;
      foreach($array1 as $key=>$value)
      {
        if($array1[$key] !== $array2[$key])
        {
          $count++;
        }
      }
      return $count;
    }

    function skiprecord($tempID)
    {
      //move the first record to the last
      //change TempID
      //redirect back to screentwotables
      if(!isset($this->session->userdata['tableNames']))
      {
        redirect('doublescreening/selectformtype');
      }
      $tableNames = $this->session->userdata('tableNames');
      $nextTempID = $this->doublescreeningmodel->getNextTempID($tableNames['tableName1']);
      $this->doublescreeningmodel->updataTempID($tableNames['tableName1'],$tempID,$nextTempID);
      if(isset($this->session->userdata['ordered'])) {
        $this->doublescreeningmodel->updataTempID($tableNames['tableName2'],$tempID,$nextTempID);
        redirect('doublescreening/screentwotablesordered');
      }
      else {
        redirect('doublescreening/screentwotables');
      }
    }

    function deleterecord($tempID)
    {
      //delete record in table 1 with TempID
      //redirect back to screentwotables
      if(!isset($this->session->userdata['tableNames']))
      {
        redirect('doublescreening/selectformtype');
      }
      $tableNames = $this->session->userdata('tableNames');
      $this->doublescreeningmodel->deleteTempRecord($tableNames['tableName1'],$tempID);
      if(isset($this->session->userdata['ordered'])) {
        redirect('doublescreening/screentwotablesordered');
      }
      else {
        redirect('doublescreening/screentwotables');
      }

    }

    function _tempTableColumns()
    {
      $tempTableColumns['treeID']  = 'TreeID';
      $tempTableColumns['tag']  = 'Tag';
      $tempTableColumns['nosubTag']  = 'Tag';
      $tempTableColumns['stemID']  = 'StemID';
      $tempTableColumns['stemTag']  = 'StemTag';
      $tempTableColumns['quadratID']  = 'QuadratID';
      $tempTableColumns['quadratName']  = 'QuadratName';
      $tempTableColumns['subquadrat']  = 'Subquad';
      $tempTableColumns['speciesID']  = 'SpeciesID';
      $tempTableColumns['species']  = 'Mnemonic';
      $tempTableColumns['subSpeciesID']  = 'SubSpeciesID';
      $tempTableColumns['plotID']  = 'PlotID';
      $tempTableColumns['censusID']  = 'CensusID';
      $tempTableColumns['plotCensusNumber']  = 'PlotCensusNumber';
      $tempTableColumns['primaryStem']  = 'PrimaryStem';
      $tempTableColumns['x']  = 'X';
      $tempTableColumns['y']  = 'Y';
      $tempTableColumns['dbh']  = 'DBH';
      $tempTableColumns['olddbh']  = 'OldDBH';
      $tempTableColumns['hom']  = 'HOM';
      $tempTableColumns['oldhom']  = 'OldHOM';
      $tempTableColumns['codes']  = 'Codes';
      $tempTableColumns['oldcodes']  = 'OldCodes';
      $tempTableColumns['comments']  = 'Comments';
      $tempTableColumns['exactDate']  = 'ExactDate';
      $tempTableColumns['errors']  = 'Errors';
      $tempTableColumns['oldTrees']  = 'OldTrees';
      $tempTableColumns['bigTrees']  = 'BigTrees';
      $tempTableColumns['extra1']  = 'Extra1';
      $tempTableColumns['extra2']  = 'Extra2';
      $tempTableColumns['extra3']  = 'Extra3';
      $tempTableColumns['extra4']  = 'Extra4';
      $tempTableColumns['extra5']  = 'Extra5';

      return $tempTableColumns;
    }

    function _createTextbox($name,$value,$textboxType)
    {
      $size = strlen($value);
      if($size > 20)
      {
        $size = 20;
      }
      elseif($size < 6)
      {
        $size = 6;
      }
      if($textboxType == 'diff')
      {
        $textbxA = array('name'=>$name,'id'=>$name,'value'=>$value,'size'=>$size,'style'=>'background:#FFD2D3');
      }
      else
      {
        $textbxA = array('name'=>$name,'id'=>$name,'value'=>$value,'size'=>$size);
      }
      $textbx = form_input($textbxA);

      return $textbx;
    }

    function cleanscreeningtemp()
    {
      $this->doublescreeningmodel->startTransaction(); // Transaction Starts Here

      $like1 = 'TempNewPlants%';
      $list = $this->doublescreeningmodel->dropAllEmptyScreeningTables($like1);
      $like2 = 'TempMultiStems%';
      $this->doublescreeningmodel->dropAllEmptyScreeningTables($like2);
      $like3 = 'TempOldTrees%';
      $this->doublescreeningmodel->dropAllEmptyScreeningTables($like3);

      $transactionStatus = $this->doublescreeningmodel->completeTransaction(); // Transaction Ends Here

      if($transactionStatus == 'Success')
      {
        $data['formTable'] = '<div class="success">Temp Tables Dropped Successfully.</div>';
      }
      else
      {
        $data['formTable'] = '<div class="error">Error Occured.</div>';
      }

      $data['formOpen'] = "";

      $plotCensusArray = $this->session->userdata('plotCensusArray');
      $plotName = $plotCensusArray['plotName'];
      $censusNumber = $plotCensusArray['censusNumber'];
      $plotActualName = $plotCensusArray['plotActualName'];
      $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
      $data['contentTitle'] = 'Data Screening - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
      $data['backLink'] = anchor('/dataentry/doubledataentry', 'Back', array('title'=>'Back to Double Data Entry Menu', 'class'=>'back'));
      $this->load->view('user/dataentry/simpleform',$data);
    }

    /////////////Helper Function/////////////////
    function dropdown_check($str)
    {
      if($str == 'default')
      {
          $this->form_validation->set_message('dropdown_check', '%s need to be Selected');
          return FALSE;
      }
      else
      {
          return True;
      }
    }
    ////////////////////////////////////////

}