<?php
if (!defined('BASEPATH'))
  exit ('No direct script access allowed');
class Fieldform extends Controller {
  function Fieldform() {
    parent :: Controller();
    $this->load->library('pdflibrary');
    $this->load->model('formmodel');

    set_time_limit(0);
    ini_set('memory_limit', '-1');
  }
  function selectplot() {
    $data['table'] = $this->_generatePlotForm();
    $data['formOpen'] = form_open('fieldform/plotcensusform');
    $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
    $data['contentTitle'] = 'Select Plot - Create Field Form';
    $data['backLink'] = "";
    $this->load->view('forms/simpleform', $data);
  }
  function plotcensusform() {
    $this->_validationplotform();
    if ($this->form_validation->run() == FALSE) {
      $data['table'] = $this->_generateplotform();
      $data['formOpen'] = form_open('fieldform/plotcensusform');
      $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
      $data['contentTitle'] = 'Select Plot  - Create Field Form';
      $data['backLink'] = "";
      $this->load->view('forms/simpleform', $data);
    }
    else {
      $plotArray['plotName'] = $this->input->post('plotName');
      $plotID = $plotArray['plotName'];
//Just to make it clear that plotID is being passed
//get PlotName as PlotID is being passed
      $plotArray['plotActualName'] = $this->formmodel->getPlotNameByID($plotID);
      $this->session->set_userdata('plotArray', $plotArray);
      $this->census();
    }
  }
  function _generatePlotForm() {
    $plotName = set_value('plotName');
    $plotNameA = $this->formmodel->getPlotName();
    $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
    $plotNameDD = form_dropdown('plotName', $plotNameA, $plotName);
    $submitButton = form_button($submitButtonA);
    $plotNameErr = form_error('plotName');
    $formTableA = array(array(''), array('Name of the Plot: ', $plotNameDD, $plotNameErr), array('', '<p style="text-align:center;">' . $submitButton . '</p>'));
    $this->table->set_empty("");
    $formTable = $this->table->generate($formTableA);
    return $formTable;
  }
  function _validationplotform() {
    $this->form_validation->set_rules('plotName', 'Plot Name', 'callback_dropdown_check');
    $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
  }
  function census() {
    if (!isset ($this->session->userdata['plotArray'])) {
      $this->selectplot();
    }
    else {
      $plotArray = $this->session->userdata('plotArray');
      $plotID = $plotArray['plotName'];
      $data['table'] = $this->_generatecensusform($plotID);
      $data['formOpen'] = form_open('fieldform/censusform');
      $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
      $data['contentTitle'] = 'Select Census - Create Field Form';
      $data['backLink'] = anchor('fieldform/selectplot/', 'Back', array('class' => 'back'));
      $this->load->view('forms/simpleform', $data);
    }
  }
  function censusform() {
    if (!isset ($this->session->userdata['plotArray'])) {
      $this->selectplot();
    }
    else {
      $plotArray = $this->session->userdata('plotArray');
      $plotID = $plotArray['plotName'];
      $this->_validationcensusform();
      if ($this->form_validation->run() == FALSE) {
        $data['table'] = $this->_generatecensusform($plotID);
        $data['formOpen'] = form_open('dataentry/censusform');
        $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
        $data['contentTitle'] = 'Select Census - Create Field Form';
        $data['backLink'] = anchor('fieldform/selectplot/', 'Back', array('class' => 'back'));
        $this->load->view('forms/simpleform', $data);
      }
      else {
        $plotCensusArray['censusNumber'] = $this->input->post('censusNumber');
        $plotArray = $this->session->userdata('plotArray');
        $plotCensusArray['plotName'] = $plotArray['plotName'];
        $plotCensusArray['plotActualName'] = $plotArray['plotActualName'];
        $this->session->set_userdata('plotCensusArray', $plotCensusArray);
        $this->session->unset_userdata('plotArray');
        redirect('fieldform/menu', 'location');
      }
    }
  }
  function _generatecensusform($plotID) {
    $censusNumber = set_value('censusNumber');
    $censusNumberA = $this->formmodel->getCensusList($plotID);
    $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
    $censusNumberDD = form_dropdown('censusNumber', $censusNumberA, $censusNumber);
    $submitButton = form_button($submitButtonA);
    $censusNumberErr = form_error('censusNumber');
    $formTableA = array(array(''), array('Census Number: ', $censusNumberDD, $censusNumberErr), array('', '<p style="text-align:center;">' . $submitButton . '</p>'));
    $this->table->set_empty("");
    $formTable = $this->table->generate($formTableA);
    return $formTable;
  }
  function _validationcensusform() {
    $this->form_validation->set_rules('censusNumber', 'Census Number', 'callback_dropdown_check');
    $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
  }
  function dropdown_check($str) {
    if ($str == 'default') {
      $this->form_validation->set_message('dropdown_check', '%s need to be Selected');
      return FALSE;
    }
    else {
      return True;
    }
  }

  function menu()
  {
    if (!isset ($this->session->userdata['plotCensusArray']))
    {
      redirect('fieldform/selectplot', 'location');
    }

    $plotCensusArray = $this->session->userdata('plotCensusArray');
    $plotName = $plotCensusArray['plotName'];
    $censusNumber = $plotCensusArray['censusNumber'];
    $plotActualName = $plotCensusArray['plotActualName'];

    $tableA = array(array(''),
                        array(anchor('fieldform/viewfiles', 'View/Download Files', array('title'=>'View/Download Files', 'class'=>'forward'))),
                        array(anchor('fieldform/concatenate', 'Concatenate Individual Files', array('title'=>'Concatenate Individual Files', 'class'=>'forward')))
                         );
    $this->table->set_empty("");

    $data['table'] = $this->table->generate($tableA);
    $data['formOpen'] = "";
    $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
    $data['contentTitle'] = 'Create Field Forms - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
    $data['backLink'] = '';
    $this->load->view('pdf/simpleform', $data);
  }

  function concatenate()
  {
    if (!isset ($this->session->userdata['plotCensusArray']))
    {
      redirect('fieldform/selectplot', 'location');
    }

    $plotCensusArray = $this->session->userdata('plotCensusArray');
    $plotName = $plotCensusArray['plotName'];
    $censusNumber = $plotCensusArray['censusNumber'];
    $plotActualName = $plotCensusArray['plotActualName'];

    $tableA = array(array(''),
                        array(anchor('fieldform/concat/portrait', 'Concatenate Individual Files in Portrait', array('title'=>'Concatenate Individual Files in Portrait', 'class'=>'forward','onclick'=>"return confirm('Do you want to concatenate all PDFs for this plot?')"))),
                        array(anchor('fieldform/concat/landscape', 'Concatenate Individual Files in Lanscape', array('title'=>'Concatenate Individual Files in Landscape', 'class'=>'forward','onclick'=>"return confirm('Do you want to concatenate all PDFs for this plot?')")))
                         );
    $this->table->set_empty("");

    $data['table'] = $this->table->generate($tableA);
    $data['formOpen'] = "";
    $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
    $data['contentTitle'] = 'Create Field Forms - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
    $data['backLink'] = '';
    $this->load->view('pdf/simpleform', $data);
  }

  function viewfiles()
  {
    $fileLinkJoin = "";
    $plotCensusArray = $this->session->userdata('plotCensusArray');
    $plotID = $plotCensusArray['plotName'];
    $censusNumber = $plotCensusArray['censusNumber'];
    $plotActualName = $plotCensusArray['plotActualName'];
    $selectedPlotName = $this->session->userdata('selectedPlotName');
    $plotName = $this->formmodel->getPlotNameByID($plotID);
    $mainFolder =  $selectedPlotName."_".$plotName;
    $dirPath = "./files/printfieldforms/";
    $dir = $dirPath.$mainFolder;
    //$conCatFile = "conCatPDF.pdf";
    $files = array();
    if(is_dir($dir))
    {
      if ($dh = opendir($dir))
      {
        while (($file = readdir($dh)) !== false)
        {
          if($file !== "." && $file !== "..")
          {
            $files[] = $file;
          }
        }
        closedir($dh);
      }
    }
    if(count($files) > 0)
    {
      asort($files);
      $fileNumber = 1;
      foreach($files as $file)
      {
        $filepath = base_url() . $dir."/".$file;
        $fileLink = anchor($filepath, $file, array('title' => 'View PDF File', 'target' => '_blank'));
        $fileLinkJoin = $fileLinkJoin . '<br />' .$fileNumber.'. '.$fileLink;
        $fileNumber++;
      }
    }
    else
    {
       $fileLinkJoin = '<br /><br /> No PDFs were found in the directory!!';
    }
    $backLink = anchor('fieldform/menu', 'Back To Menu', array('title'=>'Back To Menu', 'class'=>'back'));
    $data['table'] = '<div class="success">List of PDF Files:<br /><span style="color:#8C0209; font-size:9pt;">(To download Individual Files - Right Click On File and Select `Save Link As`)</span> '.$fileLinkJoin.'</div>';

    $data['formOpen'] = "";
    $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
    $data['contentTitle'] = 'Create Field Forms - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
    $data['backLink'] = '<br />'.$backLink;
    $this->load->view('pdf/simpleform', $data);
  }

  function concat($orientation)
  {
    $this->load->library('concatpdflibrary');

    if($orientation == 'landscape')
    {
      $pageOrientation = 'L';
    }
    else
    {
      $pageOrientation = 'P';
    }

    $plotCensusArray = $this->session->userdata('plotCensusArray');
    $plotID = $plotCensusArray['plotName'];
    $censusNumber = $plotCensusArray['censusNumber'];
    $plotActualName = $plotCensusArray['plotActualName'];
    $selectedPlotName = $this->session->userdata('selectedPlotName');
    $plotName = $this->formmodel->getPlotNameByID($plotID);
    $mainFolder =  $selectedPlotName."_".$plotName;
    $dirPath = "./files/printfieldforms/";
    $dir = $dirPath.$mainFolder;
    $conCatFile = "conCatPDF.pdf";
    $files = array();
    if(is_dir($dir))
    {
      if ($dh = opendir($dir))
      {
        while (($file = readdir($dh)) !== false)
        {
          if($file !== "." && $file !== ".." && $file !== $conCatFile)
          {
            $files[] = $dir."/".$file;
          }
        }
        closedir($dh);
      }
    }
    if(count($files) > 0)
    {
      asort($files);
      $pdf = new concatpdflibrary();
      $pdf->setFiles($files);
      $pdf->concat($pageOrientation);
      $pdf->Output($dir."/".$conCatFile, "F");
      $filepath = base_url() . $dir."/".$conCatFile;
      if ($this->fileExists($filepath))
      {
        chmod($dir."/".$conCatFile, 0777);
        $fileLink = anchor($filepath, $conCatFile, array('title' => 'View/Download PDF', 'target' => '_blank'));
      }
      else {
        $fileLink = '<span style="font-size:10pt; color:#FF0000;">Error - ' . $conCatFile . '</span>';
      }
    }
    else
    {
      $fileLink = '<span style="font-size:10pt; color:#FF0000;"><br />Folder for this plot does not exist. Generate PDFs first.</span>';
    }

    $backLink = anchor('fieldform/menu', 'Back To Menu', array('title'=>'Back To Menu', 'class'=>'back'));
    $data['table'] = '<div class="success">File Created: '.$fileLink.'</div>';

    $data['formOpen'] = "";
    $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
    $data['contentTitle'] = 'Create Field Forms - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
    $data['backLink'] = '<br />'.$backLink;
    $this->load->view('pdf/simpleform', $data);
  }

  function selectquadrat() {
    $plotCensusArray = $this->session->userdata('plotCensusArray');
    $plotID = $plotCensusArray['plotName'];
    $censusNumber = $plotCensusArray['censusNumber'];
    $plotActualName = $plotCensusArray['plotActualName'];
    $selectedPlotName = $this->session->userdata('selectedPlotName');
    $formInstructions = '<br /><br /><span style="display:block; color:#8C0209; width:90%;"><b>Instructions</b>(Also check side menu for Sample PDF):<br />
                         1. Select a range of Quadrats to generate PDFs. Keeping both starting and ending quadrat same will generate one file.(At first generate a single quadrat file to check if the generated PDF is in desired format) <br />
                         2. <u>Top Header Line</u>: This text will be displayed on the top of every page. This can include information such as Plot Name, Census Information etc. <br />
                         3. <u>Top Field Instruction</u>: This text will be displayed on only on the first page of each Quadrat PDF. This can include information such as Instruction to fill the Top Table. <br />
                         4. <u>Top Table Headers</u>: This will generate a table on top of first page. Input 1;2;3;4 will generate a table with four columns with headers 1, 2, 3 and 4. This table can be used in the field for entering information such as personnel name. <br />
                         5. <u>No. of Rows in Table</u>: This will define the number of rows in the `Top Table`. <br />
                         6. <u>Page Size</u>: Different page sizes can be selected.<br />
                         7. <u>Page Orientation</u>: If a field form has greater number of columns, page orientation can be changed to `Landscape` to fit all columns.
                         </span>';
    $data['table'] = $this->_generateQuadratForm($plotID, $censusNumber) . $formInstructions;
    $data['formOpen'] = form_open('fieldform/oldform');
    $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
    $data['contentTitle'] = 'Generate Field Forms - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
    $data['backLink'] = anchor('fieldform/selectplot/', 'Back', array('class' => 'back'));
    $this->load->view('pdf/simpleform', $data);
  }
  function _generateQuadratForm($plotID, $censusNumber) {
//$quadratName = set_value('quadratName');
    $firstHeaderLine = set_value('firstHeaderLine');
    $table1Instruction = set_value('table1Instruction');
    $table1Headers = set_value('table1Headers');
    $table1RowNo = set_value('table1RowNo');
    $pageOrientation = set_value('pageOrientation');
    $pageSize = set_value('pageSize');
    $fontSize = set_value('fontSize');
    $includeDead = set_value('includeDead');
    //$excludeDead = set_value('excludeDead');

    $quadratNameA = $this->formmodel->getQuadratNames($plotID);
    $firstHeaderLineA = array('name' => 'firstHeaderLine', 'id' => 'firstHeaderLine', 'size' => '25', 'value' => $firstHeaderLine);
    $columnHeaderRepeatA = array('no'=>'No','yes'=>'Yes');
    $table1InstructionA = array('name' => 'table1Instruction', 'id' => 'table1Instruction', 'size' => '25', 'value' => $table1Instruction);
    $table1HeadersA = array('name' => 'table1Headers', 'id' => 'table1Headers', 'size' => '25', 'value' => $table1Headers);
    $table1RowNoA = array('name' => 'table1RowNo', 'id' => 'table1RowNo', 'size' => '5', 'value' => $table1RowNo);
    $pageSizeDDA = array('A4'=>'A4(8.27x11.69in)','LETTER'=>'Letter(8.50x11.00in)','LEGAL'=>'Legal(8.50x14.00in)');
    $pageOrientationDDA = array('P'=>'Portrait','L'=>'Landscape');
    $fontSizeA = array('8'=>'8','9'=>'9','10'=>'10','11'=>'11');
    $borderA = array('no'=>'No','yes'=>'Yes');
    $subQuadratA = array('name' => 'subQuadrat', 'id' => 'subQuadrat', 'size' => '25');
    $includeDeadA = array('no'=>'No','yes'=>'Yes');

    if($censusNumber == 2){
      $excludeDeadA['1'] = '1';
      $excludeDeadA['2'] = 'Don\'t Exclude';
    }
    elseif($censusNumber > 2){
        for($i=1;$i<$censusNumber;$i++){
          if($i == 2){
            $excludeDeadA[$i] = '2 (Default)';
          }
          else {
            $excludeDeadA[$i] = $i;
          }
        }
    }
    else{
        $excludeDeadA = array('2'=>'Not Available');
    }
    $excludeDead = '2';

    $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
    $resetButtonA = array('name' => 'resetButton', 'id' => 'button', 'type' => 'reset', 'content' => 'Reset');
    $quadratNameDD1 = form_dropdown('quadratName1', $quadratNameA);
    $quadratNameDD2 = form_dropdown('quadratName2', $quadratNameA);
    $firstHeaderLineTbx = form_input($firstHeaderLineA);
    $columnHeaderRepeatDD = form_dropdown('columnHeaderRepeat',$columnHeaderRepeatA);
    $table1InstructionTbx = form_input($table1InstructionA);
    $table1HeadersTbx = form_input($table1HeadersA);
    $table1RowNoTbx = form_input($table1RowNoA);
    $pageSizeDD = form_dropdown('pageSize',$pageSizeDDA,$pageSize);
    $pageOrientationDD = form_dropdown('pageOrientation',$pageOrientationDDA,$pageOrientation);
    $fontSizeDD = form_dropdown('fontSize',$fontSizeA,$fontSize);
    $borderDD = form_dropdown('border',$borderA);
    $subQuadratTbx = form_input($subQuadratA);
    $includeDeadDD = form_dropdown('includeDead',$includeDeadA, $includeDead);
    $excludeDeadDD = form_dropdown('excludeDead',$excludeDeadA, $excludeDead);
    $submitButton = form_button($submitButtonA);
    $resetButton = form_button($resetButtonA);
    $formTableA = array(array(''),
                        array('Select starting quadrat: ', $quadratNameDD1),
                        array('Select ending quadrat:', $quadratNameDD2),
                        array('Top header line: ', $firstHeaderLineTbx),
                        array('Header columns on all sheets: ', $columnHeaderRepeatDD.'<span style="color:#8C0209;">&nbsp;&nbsp;(Yes, will place Top `Field Instructions` and `Table` on cover page)</span>'),
                        array('Top field instruction: ', $table1InstructionTbx),
                        array('Top table headers(; Seperated): ', $table1HeadersTbx),
                        array('No. of rows in table: ', $table1RowNoTbx),
                        array('Page size: ', $pageSizeDD),
                        array('Page orientation: ', $pageOrientationDD),
                        array('Font size: ', $fontSizeDD),
                        array('Border: ', $borderDD),
                        array('SubQuadrat order(; Seperated): ',$subQuadratTbx),
                        array('Include all dead trees: ',$includeDeadDD),
                        array('Exclude trees dead in all of last x census: ',$excludeDeadDD),
                        array('', '<p style="text-align:Left;">' . $submitButton . '&nbsp;&nbsp;&nbsp;' . $resetButton . '</p>'));
    $this->table->set_empty("");
    $formTable = $this->table->generate($formTableA);
    return $formTable;
  }


  function oldform() {
    $plotCensusArray = $this->session->userdata('plotCensusArray');
    $plotID = $plotCensusArray['plotName'];
    $censusNumber = $plotCensusArray['censusNumber'];
    $plotActualName = $plotCensusArray['plotActualName'];
    $selectedPlotName = $this->session->userdata('selectedPlotName');
    $plotName = $this->formmodel->getPlotNameByID($plotID);
    $fileLinkJoin = "";
    $createdFileNumber = 1;
    $mainFolderName = $selectedPlotName."_".$plotName;
    $dirPath = "files/printfieldforms/";
    if (!file_exists($dirPath . $mainFolderName)) {
      mkdir($dirPath . $mainFolderName);
      chmod('./' . $dirPath . $mainFolderName, 0777);
    }
    $formType = 'oldform';
    $lastSubquadrat = "";
//used to create blank rows after a subquadrat ends
    $checkTabA = array();
    $quadratName1 = $this->input->post('quadratName1');
    $quadratName2 = $this->input->post('quadratName2');
    $firstHeaderLine = $this->input->post('firstHeaderLine');
    $columnHeaderRepeat = $this->input->post('columnHeaderRepeat');
    $table1Instruction = $this->input->post('table1Instruction');
    $table1Headings = $this->input->post('table1Headers');
    $numberRowTable1 = $this->input->post('table1RowNo');
    $pageSize = $this->input->post('pageSize');
    $pageOrientation = $this->input->post('pageOrientation');
    $fontSize = $this->input->post('fontSize');
    $border = $this->input->post('border');
    $subQuadratCustom = $this->input->post('subQuadrat');
    $includeDead = $this->input->post('includeDead');
    $excludeDead = $this->input->post('excludeDead');

    $this->session->set_userdata('columnHeaderRepeat', $columnHeaderRepeat);
    $this->session->set_userdata('fontSize', $fontSize);

    if($border == 'yes') { $tborder = 0.5;}
    else { $tborder = 0; }
    $table1HeadingA = explode(";", $table1Headings);
    $this->session->set_userdata('firstHeaderLine', $firstHeaderLine);
    $table1HeadingCount = count($table1HeadingA);
    $table1Row = array();
    for ($zz = 1; $zz <= $table1HeadingCount; $zz++) {
      $table1Row[$zz] = "";
    }
    $tmpl1 = array('table_open' => '<table border="0.5"  align="center">');
    $this->table->set_template($tmpl1);
    $this->table->set_heading($table1HeadingA);
    for ($zz = 1; $zz <= $numberRowTable1; $zz++) {
      $this->table->add_row($table1Row);
    }
    $table1 = $this->table->generate();
    $this->load->library('formlibrary');
    $fileName = base_url() . "files/configfiles/" . $formType . "_" . $selectedPlotName . "_" . $plotName . "_" . $plotID . ".txt";
    $fileName = str_replace(" ", "", $fileName);
    $formDetailResult = $this->formlibrary->readConfigFile($fileName);
    if ($formDetailResult == "Not Found") {
      $data['table'] = '<br /><br /><div class="error"> Configuration File Not Found</div>';
      $plotCensusArray = $this->session->userdata('plotCensusArray');
      $plotName = $plotCensusArray['plotName'];
      $censusNumber = $plotCensusArray['censusNumber'];
      $plotActualName = $plotCensusArray['plotActualName'];
      $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
      $data['backLink'] = "";
      $data['formOpen'] = "";
      $data['contentTitle'] = 'Create Field Form - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">' . $plotActualName . '</span></span>';
      $this->load->view('pdf/simpleform', $data);
    }
    else {
      //rest all code of this function
      $subQuadratOrder = '';
      $quadratListQ = $this->formmodel->getQuadratRange($quadratName1, $quadratName2, $plotID);
      foreach ($quadratListQ->result() as $quadratListRow) {
        $quadratName = $quadratListRow->QuadratName;
        $this->session->set_userdata('quadratName', $quadratName);
        foreach ($formDetailResult as $formDetailRow) {
          if ($formDetailRow->ColumnType == 'oldcolumn') {
            $attributes = $formDetailRow->Attributes;
            $columnNumber = $formDetailRow->ColumnNumber;
            $attributesArray = $this->_sortOldFormData($attributes);
            $columnName = $attributesArray['columnName'];
            if ($columnName == 'subquadrat') {
              $startsWith = $attributesArray['startsWith'];
              $maxX = $attributesArray['maxX'];
              $maxY = $attributesArray['maxY'];
              $orderBy = 'subquadrat';
              if($subQuadratCustom !== '') {
                $subQuadratCustomArr = explode(';', $subQuadratCustom);
                if($startsWith == 'A'){
                  foreach($subQuadratCustomArr as $key=>$val){
                    $valSplitArr = str_split($val,1);
                    $firstConv = ord(strtoupper($valSplitArr[0])) - ord('A') + 1;
                    $subQuadratCustomArr[$key] = $firstConv.$valSplitArr[1];
                  }
                }
                $subQuadratOrder = implode(',', $subQuadratCustomArr);
              }

            }
            elseif ($columnName == 'nosubTag') {
              $maxX = $attributesArray['maxX'];
              $maxY = $attributesArray['maxY'];
              $orderBy = 'treetag';
            }
          }
        }
        $subquadQuery = "SELECT QDimX as DimX, QDimY as DimY FROM Site WHERE PlotID = " . $plotID;
        $subquadReturnQuery = $this->formmodel->subquadDDQuery($subquadQuery);
        $subquadRow = $subquadReturnQuery->row();
        $dimX = $subquadRow->DimX;
        $dimY = $subquadRow->DimY;
        $lastCensusID = $censusNumber - 1;
        if ($lastCensusID == 0) {
          $data['table'] = '<br /><br /><div class="error">Old data does not exist for Census 1.</div>';
          $plotCensusArray = $this->session->userdata('plotCensusArray');
          $plotName = $plotCensusArray['plotName'];
          $censusNumber = $plotCensusArray['censusNumber'];
          $plotActualName = $plotCensusArray['plotActualName'];
          $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
          $data['backLink'] = "";
          $data['formOpen'] = "";
          $data['contentTitle'] = 'Create Field Form - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">' . $plotActualName . '</span></span>';
          $this->load->view('pdf/simpleform', $data);
        }
        else {
//Create Table
          //$this->table->clear();
          //$tmpl = array('table_open' => '<table border="0" align="center" cellpadding="0" cellspacing="0">');
          //$this->table->set_template($tmpl);
          $table = "";
          $this->load->model('formmodel');

          if($excludeDead !=2 and $includeDead == 'no'){
            $treeDeadArray = $this->formmodel->treeDeadExclude($lastCensusID,$plotID,$quadratName,$excludeDead);
          }
          else {
            if($lastCensusID > 2 and $includeDead == 'no')
            {
              $treeDeadArray = $this->formmodel->treeDead($lastCensusID,$plotID,$quadratName);
            }
            else
            {
              $treeDeadArray = array();
            }
          }


          $oldDataExtractQuery = $this->formmodel->olddataextractField($lastCensusID, $plotID, $quadratName, $maxX, $maxY, $dimX, $dimY, $orderBy, $treeDeadArray,$subQuadratOrder);
          $fileName = "FieldForm_" . $plotActualName . "_" . $quadratName . "_" . $censusNumber . ".pdf";
          $fileLoc = $dirPath . $mainFolderName . "/" . $fileName;
          if ($oldDataExtractQuery->num_rows > 0) {
            $rowNumber = 1;
            $tableHTML = "";
            foreach ($oldDataExtractQuery->result() as $oldExtractRow) {
              foreach ($formDetailResult as $formDetailRow) {
                if ($formDetailRow->ColumnType == 'oldcolumn') {
                  $attributes = $formDetailRow->Attributes;
                  $columnNumber = $formDetailRow->ColumnNumber;
                  $attributesArray = $this->_sortOldFormData($attributes);
                  $columnHeader = $attributesArray['columnHeader'];
                  $headerListA[$columnNumber] = $columnHeader;
                  $columnName = $attributesArray['columnName'];
                  $columnNameA[$columnNumber] = $columnName;
                  $columnSize = $attributesArray['columnSize'];
                  $columnSizeA[$columnNumber] = $columnSize;
                  if ($columnName == 'subquadrat') {
                    $startsWith = $attributesArray['startsWith'];
                    $maxX = $attributesArray['maxX'];
                    $maxY = $attributesArray['maxY'];
                    if ($startsWith == '0') {
                      $in = 0;
                    }
                    else {
                      $in = 1;
                    }
                    $qX = $oldExtractRow->QX;
                    $qY = $oldExtractRow->QY;
                    if ($qX != "") {
                      $qX = $in + intval(($qX - $dimX * intval($qX / $dimX)) / $maxX);
                      if($startsWith == 'A')
                        {
                          $aX = 'A';
                          for($zz=1;$zz<$qX;$zz++)
                          {
                            ++$aX;
                          }
                          $qX = $aX;
                        }
                    }
                    if ($qY != "") {
                      $qY = $in + intval(($qY - $dimY * intval($qY / $dimY)) / $maxY);
                    }
                    $subquadrat = $qX . $qY;
                    $columnListA[$columnNumber] = '<span style="align:center;">' . $subquadrat . '</span>';
                    if ($lastSubquadrat !== $subquadrat) {
                      $this->table->add_row('<br />'); //to create gap after a group of subquadrats
                      $tableHTML = $tableHTML.'<br />';

                    }
                    $lastSubquadrat = $subquadrat;
                    $checkTabA[$columnNumber] = "no";
                  }
                  /*if ($columnName == 'subquadrat') {
                    $subquadrat = $oldExtractRow->Subquadrat;
                    $columnListA[$columnNumber] = '<span style="align:center;">' . $subquadrat . '</span>';
                    if ($lastSubquadrat !== $subquadrat) {
                      $this->table->add_row('<br />'); //to create gap after a group of subquadrats
                      $tableHTML = $tableHTML.'<br />';

                    }
                    $lastSubquadrat = $subquadrat;
                    $checkTabA[$columnNumber] = "no";
                  }*/
                  elseif ($columnName == 'tag') {
                    $treeTag = $oldExtractRow->Tag;
                    $columnListA[$columnNumber] = $treeTag;
                    $checkTabA[$columnNumber] = "no";
                  }
                  elseif ($columnName == 'nosubTag') {
                    $treeTag = $oldExtractRow->Tag;
                    $columnListA[$columnNumber] = $treeTag;
                    $checkTabA[$columnNumber] = "no";
                  }
                  elseif ($columnName == 'stemTag') {
                    $readOnly = $attributesArray['readOnly'];
                    $stemTag = $oldExtractRow->StemTag;
                    if ($readOnly == "no") {
                      $columnListA[$columnNumber] = $stemTag;
                      $checkTabA[$columnNumber] = "yes";
                    }
                    else {
                      $columnListA[$columnNumber] = $stemTag;
                      $checkTabA[$columnNumber] = "no";
                    }
                  }
                  elseif ($columnName == 'species') {
                    $species = $oldExtractRow->Mnemonic;
                    $columnListA[$columnNumber] = $species;
                    $checkTabA[$columnNumber] = "no";
                  }
                  elseif ($columnName == 'olddbh') {
                    $dbh = $oldExtractRow->DBH;
                    $columnListA[$columnNumber] = $dbh;
                    $checkTabA[$columnNumber] = "no";
                  }
                  elseif ($columnName == 'oldcodes') {
                    $code = $oldExtractRow->ListOfTSM;
                    $columnListA[$columnNumber] = $code;
                    $checkTabA[$columnNumber] = "no";
                  }
                  elseif ($columnName == 'oldhom') {
                    $hom = $oldExtractRow->HOM;
                    $columnListA[$columnNumber] = $hom;
                    $checkTabA[$columnNumber] = "no";
                  }
                  elseif ($columnName == 'x') {
                    $qx = $oldExtractRow->QX;
                    $columnListA[$columnNumber] = $qx;
                    $checkTabA[$columnNumber] = "no";
                  }
                  elseif ($columnName == 'y') {
                    $qy = $oldExtractRow->QY;
                    $columnListA[$columnNumber] = $qy;
                    $checkTabA[$columnNumber] = "no";
                  }
                  else{
                   $column = $oldExtractRow->$columnName;
                   $columnListA[$columnNumber] = $column;
                   $checkTabA[$columnNumber] = "no";
                 }
                }
                elseif ($formDetailRow->ColumnType == 'text') {
                  $attributes = $formDetailRow->Attributes;
                  $columnNumber = $formDetailRow->ColumnNumber;
                  $columnDetailA = $this->_textAttributes($attributes);
                  $columnName = $columnDetailA['columnName'];
                  $columnNameA[$columnNumber] = $columnName;
                  $headerListA[$columnNumber] = $columnDetailA['columnHeader'];
                  $columnDetailA['columnType'] = $formDetailRow->ColumnType;
                  $blank = $this->_createBlank($columnDetailA['columnSize'],$border);
                  $columnSizeA[$formDetailRow->ColumnNumber] = $columnDetailA['columnSize'];
                  $columnListA[$formDetailRow->ColumnNumber] = $blank;
                  $checkTabA[$columnNumber] = "yes";
                }
                elseif ($formDetailRow->ColumnType == "limit") {
                  $attributes = $formDetailRow->Attributes;
                  $columnNumber = $formDetailRow->ColumnNumber;
                  $columnDetailA = $this->_limitAttributes($attributes);
                  $columnName = $columnDetailA['columnName'];
                  $columnNameA[$columnNumber] = $columnName;
                  $headerListA[$columnNumber] = $columnDetailA['columnHeader'];
                  $columnDetailA['columnType'] = $formDetailRow->ColumnType;
                  $blank = $this->_createBlank($columnDetailA['columnSize'],$border);
                  $columnSizeA[$formDetailRow->ColumnNumber] = $columnDetailA['columnSize'];
                  $columnListA[$formDetailRow->ColumnNumber] = $blank;
                  $checkTabA[$columnNumber] = "yes";
                }
              }
              $stemID = $oldExtractRow->StemID;
              $stemColumnName = 'stemID_' . $rowNumber;
              $stemColumnNumber = $columnNumber + 1;
              //$this->table->add_row($columnListA);
              $tableRowHTML = "";
              foreach($columnListA as $columnListName=>$columnListValue)
              {
                if(isset($columnSizeA[$columnListName]))
                {
                  $columnSize = $columnSizeA[$columnListName];
                  if ($columnSize > 10 AND $columnSize <= 15 ) {
                  $columnSize = 12;
                  }
                  else if($columnSize > 15 AND $columnSize < 20 ) {
                    $columnSize = 15;
                  }
                  else if($columnSize >= 20) {
                    $columnSize = 24;
                  }
                  /*if($columnSize >= 20)
                  {
                    $width = '175';     //25 * 7
                  }
                  else if ($columnSize > 15 AND $columnSize < 20 )
                  {
                    $width = '105';        // 15 * 7
                  }
                  else
                  {*/
                    $width = $columnSize * 7.5;
                    /*if($width < 55)
                    {
                      $width = 55;
                    }*/
                  //}
                  $tableRowHTML = $tableRowHTML.'<td width ="'.$width.'">'.$columnListValue.'</td>';
                }
                else
                {
                  $tableRowHTML = $tableRowHTML.'<td width ="50">'.$columnListValue.'</td>';
                }
              }
              $tableHTML = $tableHTML.'<tr>'.$tableRowHTML.'</tr>';
              $rowNumber++;
            }
            $headerHTML = '';
            foreach($headerListA as $headerKey=>$headerValue)
            {
              if(isset($columnSizeA[$headerKey]))
              {
                $columnSize = $columnSizeA[$headerKey];

                if ($columnSize > 10 AND $columnSize <= 15 ) {
                  $columnSize = 12;
                }
                else if($columnSize > 15 AND $columnSize < 20 ) {
                  $columnSize = 15;
                }
                else if($columnSize >= 20) {
                  $columnSize = 24;
                }

                /*if($columnSize >= 20)
                {
                  $width = '175';     //25 * 7
                }
                else if ($columnSize > 15 AND $columnSize < 20 )
                {
                  $width = '105';        // 15 * 7
                }

                else
                {*/
                  $width = $columnSize * 7.5;
                  /*if($width < 55)
                  {
                    $width = 55;
                  }*/
                //}
                $headerHTML = $headerHTML.'<th width ="'.$width.'"><b>'.$headerValue.'</b></th>';
              }
              else
              {
                $headerHTML = $headerHTML.'<th width ="50"><b>'.$headerValue.'</b></th>';
              }
            }
            $headerHTML = '<table border="'.$tborder.'" align="center" cellpadding="0" cellspacing="0" width="100%"><tr>'.$headerHTML.'</tr></table>';

            if($columnHeaderRepeat == 'yes') {
                $this->session->set_userdata('headerHTML', $headerHTML);
                $tableHTML = '<table border="'.$tborder.'" align="center" cellpadding="0" cellspacing="0" width="100%">'.$tableHTML.'</table>';
            }
            else {
              $tableHTML = '<table border="'.$tborder.'" align="center" cellpadding="0" cellspacing="0" width="100%">'.$headerHTML.$tableHTML.'</table>';
            }
            //echo $tableHTML;
            //die();
            //$this->table->set_heading($headerListA);
            //$table2 = $this->table->generate();
// create new PDF document
//PDF Page size = W:210 H:297
            $pdf = new pdflibrary(PDF_PAGE_ORIENTATION, PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false);
// set document information
            $pdf->SetCreator(PDF_CREATOR);
            $pdf->SetAuthor('Anudeep Singh');
            $pdf->SetTitle('Field Form');
            $pdf->SetSubject('Field Entry Form');
// set default header data
            //$pdf->SetHeaderData(PDF_HEADER_LOGO, PDF_HEADER_LOGO_WIDTH, PDF_HEADER_TITLE, PDF_HEADER_STRING);
// set header and footer fonts
            $pdf->setHeaderFont(Array(PDF_FONT_NAME_MAIN, '', PDF_FONT_SIZE_MAIN));
            $pdf->setFooterFont(Array(PDF_FONT_NAME_DATA, '', PDF_FONT_SIZE_DATA));
// set default monospaced font
            $pdf->SetDefaultMonospacedFont(PDF_FONT_MONOSPACED);
// set margins

            if($columnHeaderRepeat !== 'yes') {
               $pdf->SetMargins(PDF_MARGIN_LEFT, PDF_MARGIN_TOP, PDF_MARGIN_RIGHT);
            }
            else {
                $pdf->SetMargins(PDF_MARGIN_LEFT, PDF_MARGIN_TOP+5, PDF_MARGIN_RIGHT);
            }
            $pdf->SetHeaderMargin(PDF_MARGIN_HEADER);
            $pdf->SetFooterMargin(PDF_MARGIN_FOOTER);
// set auto page breaks
            $pdf->SetAutoPageBreak(TRUE, PDF_MARGIN_BOTTOM);
// set image scale factor
            $pdf->setImageScale(PDF_IMAGE_SCALE_RATIO);
// set some language-dependent strings (optional)
           // if (@ file_exists(dirname(__FILE__) . '/lang/eng.php')) {
           //   require_once (dirname(__FILE__) . '/lang/eng.php');
           //   $pdf->setLanguageArray($l);
           // }
// ---------------------------------------------------------
// set default font subsetting mode
            $pdf->setFontSubsetting(true);
// Set font
// dejavusans is a UTF-8 Unicode font, if you only need to
// print standard ASCII chars, you can use core fonts like
// helvetica or times to reduce file size.
            $pdf->SetFont('helvetica', '', $fontSize);


// Add a page
// This method has several options, check the source code documentation for more information.

// set text shadow effect
//$pdf->setTextShadow(array('enabled'=>true, 'depth_w'=>0.2, 'depth_h'=>0.2, 'color'=>array(196,196,196), 'opacity'=>1, 'blend_mode'=>'Normal'));
            if($columnHeaderRepeat == 'yes') {
              $pdf->setPrintHeader(false);
              $pdf->AddPage($pageOrientation,$pageSize);
              $firstHeaderLineHtml = '<div align="center"><h1>' . $firstHeaderLine . '</h1><br /><br /></div>';
              $quadratInfoHtml =  '<div align="center"><h2>Quadrat: ' . $quadratName . '</h2><br /><br /></div>';
              $table1InstructionHtml = '<div align="center">' . $table1Instruction . '<br /></div>';
              $pdf->writeHTML($firstHeaderLineHtml.$quadratInfoHtml, true, false, true, false, '');
              $pdf->writeHTML($table1InstructionHtml, true, false, true, false, '');
              $pdf->writeHTML($table1, true, false, false, false, '');

              $pdf->setPrintHeader(true);
              $pdf->AddPage($pageOrientation,$pageSize);
            }
            else {
              $pdf->AddPage($pageOrientation,$pageSize);
              $table1InstructionHtml = '<div align="center">' . $table1Instruction . '</div>';
              $pdf->writeHTML($table1InstructionHtml, true, false, true, false, '');
              $pdf->writeHTML($table1, true, false, false, false, '');
            }
// Set some content to print
            //$html = $table2;
            $pdf->writeHTML($tableHTML, true, false, false, false, '');
// Print text using writeHTMLCell()
// ---------------------------------------------------------
// Close and output PDF document
// This method has several options, check the source code documentation for more information.
            $pdf->Output($fileLoc, 'F');
            $filepath = base_url() . $fileLoc;
            if ($this->fileExists($filepath)) {
              chmod('./' . $fileLoc, 0777);
              $fileLink = anchor($filepath, $fileName, array('title' => 'View PDF File', 'target' => '_blank'));
            }
            else {
              $fileLink = '<span style="font-size:10pt; color:#FF0000;">Error - ' . $fileName . '</span>';
            }
          }
          else {
            $fileLink = '<span style="font-size:10pt; color:#FF0000;">Error - ' . $fileName . '</span>';
          }
          $fileLinkJoin = $fileLinkJoin . '<br />' . $createdFileNumber . '. ' . $fileLink;
          $createdFileNumber++;
        }
      }
    }
     $backLink = anchor('fieldform/selectquadrat', 'Back To Select Quadrat', array('title'=>'Back To Select Quadrat', 'class'=>'back'));
     $data['table'] = '<div class="success">List of Files Created: '.$fileLinkJoin.'</div>';

     $data['formOpen'] = "";
     $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
     $data['contentTitle'] = 'Create Field Forms - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
     $data['backLink'] = '<br />'.$backLink;
     $this->load->view('pdf/simpleform', $data);
  }


  function _sortOldFormData($attributes) {
    $attributesList = explode("\t", $attributes);
    $attributesArray['columnHeader'] = $attributesList[0];
    $attributesArray['columnName'] = $attributesList[1];
    $attributesArray['columnSize'] = $attributesList[2];
    if ($attributesArray['columnName'] == 'subquadrat') {
      $attributesArray['startsWith'] = $attributesList[3];
      $attributesArray['maxX'] = $attributesList[4];
      $attributesArray['maxY'] = $attributesList[5];
    }
    elseif ($attributesArray['columnName'] == 'nosubTag') {
      $attributesArray['maxX'] = $attributesList[3];
      $attributesArray['maxY'] = $attributesList[4];
    }
    elseif ($attributesArray['columnName'] == 'stemTag') {
      $attributesArray['readOnly'] = $attributesList[3];
    }
    return $attributesArray;
  }

  function _textAttributes($attributes) {
    $attributeA = explode("\t", $attributes);
    $array ['columnHeader'] = $attributeA[0];
    $array ['columnName'] = $attributeA[1];
    $array ['dataType'] = $attributeA[2];
    $array ['defaultValue'] = $attributeA[3];
    $array ['columnSize'] = $attributeA[4];
    $array ['allowNull'] = $attributeA[5];
    return $array;
  }

  function _limitAttributes($attributes) {
    $attributeA = explode("\t", $attributes);
    $array ['columnHeader'] = $attributeA[0];
    $array ['columnName'] = $attributeA[1];
    $array ['dataType'] = $attributeA[2];
    $array ['upperLimit'] = $attributeA[3];
    $array ['lowerLimit'] = $attributeA[4];
    $array ['defaultValue'] = $attributeA[5];
    $array ['columnSize'] = $attributeA[6];
    $array ['allowNull'] = $attributeA[7];
    return $array;
  }

  function _createBlank($columnSize, $border) {
    $blank = "_";
    if ($columnSize > 0) {
      if ($columnSize > 10 AND $columnSize <= 15 ) {
        $columnSize = 12;
      }
      else if($columnSize > 15 AND $columnSize < 20 ) {
        $columnSize = 15;
      }
      else if($columnSize >= 20) {
        $columnSize = 24;
      }
      for ($x = 1; $x <= $columnSize; $x++) {
        $blank = $blank . "_";
      }
    }
    else {
      $blank = "_______";
    }
    if($border == 'yes') { $blank = "";}
    return $blank;
  }
  function fileExists($path) {
    return (@ fopen($path, "r") == true);
  }
}