<?php

class Formtypes extends Controller {

  function Formtypes()
  {
    parent::Controller();
    if($this->session->userdata('loggedin') !== '1')
    {
      redirect('main','location');
    }
    $this->load->model('configmodel');
  }

//////////////////Simple textbox with text,integer or decimal values with no limits///////////////////
  function textform()
  {
    $data['title'] = "Configuration Form";
    $data['contentTitle'] = "Simple Text Form";
    $data['formHeading'] = "";
    $data['formOpen'] = form_open("formtypes/textformvalidate");
    $data['table'] = $this->_textFormTable();
    $data['backLink'] = anchor('forms/selectcolumntype/','Back',array('class'=>'back'));
    $this->load->view('forms/simpleform2',$data);
  }

  function textformvalidate()
  {
    $this->_validatetextform();

    if($this->form_validation->run() == FALSE)
    {
      $data['title'] = "Configuration Form";
      $data['contentTitle'] = "Simple Text Form";
      $data['formHeading'] = "";
      $data['formOpen'] = form_open("formtypes/textformvalidate");
      $data['table'] = $this->_textFormTable();
      $data['backLink'] = anchor('forms/selectcolumntype/','Back',array('class'=>'back'));
      $this->load->view('forms/simpleform2',$data);
    }
    else
    {
      //insert into database
      $plotID = $this->session->userdata('configPlotID');
      $formType = $this->session->userdata('formType');
      $columnType = "text";
      $columnNumber = $this->configmodel->getColumnNumber($plotID,$formType);

      $columnHeader = $this->input->post('columnHeader');
      $columnName = $this->input->post('columnName');
      $dataType = $this->input->post('dataType');
      $stemChange = $this->input->post('stemChange');
      $treeChange = $this->input->post('treeChange');
      $defaultValue = $this->input->post('defaultValue');
      $columnSize = $this->input->post('columnSize');
      $allowNull = $this->input->post('allowNull');
      $nextLineKey = $this->input->post('nextLineKey');

      $attributes = join("\t",array($columnHeader,$columnName,$dataType,$stemChange,$treeChange,$defaultValue,$columnSize,$allowNull,$nextLineKey));
      $this->configmodel->insertFormData($plotID,$formType,$columnNumber,$columnType,$attributes);
      redirect('forms/addcolumn');
    }
  }

  function _textFormTable()
  {
    $columnHeader = set_value('columnHeader');
    $columnName = set_value('columnName');
    $dataType = set_value('dataType');
    $stemChange = set_value('stemChange');
    $treeChange = set_value('treeChange');
    $defaultValue = set_value('defaultValue');
    $columnSize = set_value('columnSize');
    if($columnSize == "")
    {
      $columnSize = 10;
    }


    $columnHeaderA = array('name'=>'columnHeader','id'=>'columnHeader','size'=>'16','value'=>$columnHeader);
    //$columnNameA = array('name'=>'columnName','id'=>'columnName','size'=>'16','value'=>$columnName);
    $columnNameA = array('default'=>'Select',
                         'tag'=>'Tag, TreeTag',
                         'stemTag'=>'StemTag, MultiStem',
                         'quadratName'=>'QuadratName',
                         'subquadrat'=>'Subquadrat',
                         'species'=>'Species, Mnemonic',
                         'plotCensusNumber'=>'PlotCensus',
                         'primaryStem'=>'PrimaryStem',
                         'x'=>'X, QX',
                         'y'=>'Y, QY',
                         'dbh'=>'DBH, Diameter',
                         'hom'=>'HOM, Height',
                         'codes'=>'Codes',
                         'comments'=>'Comments',
                         'errors'=>'Errors',
                         'extra1'=>'Extra1',
                         'extra2'=>'Extra2',
                         'extra3'=>'Extra3',
                         'extra4'=>'Extra4',
                         'extra5'=>'Extra5');
    $dataTypeA = array('default'=>'Select', 'varchar'=>'varchar', 'integer'=>'integer','float'=>'float','decimal'=>'decimal');
    $stemChangeA = array('no'=>'No','incremented'=>'Incremented','carried'=>'Carried Over');
    $treeChangeA = array('no'=>'No','incremented'=>'Incremented','carried'=>'Carried Over');
    $defaultValueA = array('name'=>'defaultValue','id'=>'defaultValue','size'=>'16','value'=>$defaultValue);
    $columnSizeA = array('name'=>'columnSize','id'=>'columnSize','size'=>'16','value'=>$columnSize);
    $allowNullA = array('no'=>'No','yes'=>'Yes');
    $nextLineKeyA = array('no'=>'No','yes'=>'Yes');

    $submitButtonA = array('name'=>'submitButton','id'=>'button','type'=>'submit','content'=>'Submit');
    $resetButtonA = array('name'=>'resetButton','id'=>'button','type'=>'reset','content'=>'Reset');


    $columnHeaderTbx = form_input($columnHeaderA);
    //$columnNameTbx = form_input($columnNameA);
    $columnNameDD = form_dropdown('columnName',$columnNameA);
    $dataTypeDD = form_dropdown('dataType',$dataTypeA);
    $stemChangeDD = form_dropdown('stemChange',$stemChangeA);
    $treeChangeDD = form_dropdown('treeChange',$treeChangeA);
    $defaultValueTbx = form_input($defaultValueA);
    $columnSizeTbx = form_input($columnSizeA);
    $allowNullDD = form_dropdown('allowNull',$allowNullA,'yes');
    $nextLineKeyDD = form_dropdown('nextLineKey',$nextLineKeyA,'no');
    $submitButton = form_button($submitButtonA);
    $resetButton = form_button($resetButtonA);

    $columnHeaderErr = form_error('columnHeader');
    $columnNameErr = form_error('columnName');
    $dataTypeErr = form_error('dataType');
    $columnSizeErr = form_error('columnSize');

    $formTableA = array(array(),
                        array('Column Header : ',$columnHeaderTbx,$columnHeaderErr),
                        array('Column Name : ',$columnNameDD,$columnNameErr),
                        array('Data Type : ',$dataTypeDD,$dataTypeErr),
                        array('Is Value Changed with Stem : ',$stemChangeDD),
                        array('Is Value Changed with Tree : ',$treeChangeDD),
                        array('Default Value : ',$defaultValueTbx),
                        array('Column Size : ',$columnSizeTbx,$columnSizeErr),
                        array('Null Value Allowed: ',$allowNullDD),
                        array('Add Next Row Stroke: ',$nextLineKeyDD),
                        array(),
                        array('',$submitButton."\t".$resetButton)
                        );

    $this->table->set_empty("");
    $formTable = $this->table->generate($formTableA);

    return $formTable;
  }

  function _validatetextform()
  {
    $this->form_validation->set_rules('columnHeader', 'Column Header', 'trim|required' );
    $this->form_validation->set_rules('columnName', 'Column Name', 'callback_dropdown_check' );
    $this->form_validation->set_rules('dataType', 'Data Type', 'callback_dropdown_check' );
    $this->form_validation->set_rules('columnSize', 'Column Size','trim|required|integer');

    $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
  }
//////////////******************///////////////////////

//////Simple text box with interger values and a limit check//////////
  function limitform()
  {
    $data['title'] = "Configuration Form";
    $data['contentTitle'] = "Limit Form";
    $data['formHeading'] = "";
    $data['formOpen'] = form_open("formtypes/limitformvalidate");
    $data['table'] = $this->_limitFormTable();
    $data['backLink'] = anchor('forms/selectcolumntype/','Back',array('class'=>'back'));
    $this->load->view('forms/simpleform2',$data);
  }

  function limitformvalidate()
  {
    $this->_validatelimitform();

    if($this->form_validation->run() == FALSE)
    {
      $data['title'] = "Configuration Form";
      $data['contentTitle'] = "Simple Text Form";
      $data['formHeading'] = "";
      $data['formOpen'] = form_open("formtypes/limitformvalidate");
      $data['table'] = $this->_limitFormTable();
      $data['backLink'] = anchor('forms/selectcolumntype/','Back',array('class'=>'back'));
      $this->load->view('forms/simpleform2',$data);
    }
    else
    {
      //insert into database
      $plotID = $this->session->userdata('configPlotID');
      $formType = $this->session->userdata('formType');
      $columnType = "limit";
      $columnNumber = $this->configmodel->getColumnNumber($plotID,$formType);

      $columnHeader = $this->input->post('columnHeader');
      $columnName = $this->input->post('columnName');
      $dataType = $this->input->post('dataType');
      $stemChange = $this->input->post('stemChange');
      $treeChange = $this->input->post('treeChange');
      $upperLimit = $this->input->post('upperLimit');
      $lowerLimit = $this->input->post('lowerLimit');
      $defaultValue = $this->input->post('defaultValue');
      $columnSize = $this->input->post('columnSize');
      $allowNull = $this->input->post('allowNull');
      $nextLineKey = $this->input->post('nextLineKey');

      $attributes = join("\t",array($columnHeader,$columnName,$dataType,$stemChange,$treeChange,$upperLimit,$lowerLimit,$defaultValue,$columnSize,$allowNull,$nextLineKey));
      $this->configmodel->insertFormData($plotID,$formType,$columnNumber,$columnType,$attributes);
      redirect('forms/addcolumn');
    }
  }

  function _limitFormTable()
  {
    $columnHeader = set_value('columnHeader');
    $columnName = set_value('columnName');
    $dataType = set_value('dataType');
    $stemChange = set_value('stemChange');
    $treeChange = set_value('treeChange');
    $upperLimit = set_value('upperLimit');
    $lowerLimit = set_value('lowerLimit');
    $defaultValue = set_value('defaultValue');
    $columnSize = set_value('columnSize');
    if($columnSize == "")
    {
      $columnSize = 10;
    }


    $columnHeaderA = array('name'=>'columnHeader','id'=>'columnHeader','size'=>'16','value'=>$columnHeader);
    $columnNameA = array('default'=>'Select',
                         'tag'=>'Tag, TreeTag',
                         'stemTag'=>'StemTag, MultiStem',
                         'quadratName'=>'QuadratName',
                         'subquadrat'=>'Subquadrat',
                         'species'=>'Species, Mnemonic',
                         'plotCensusNumber'=>'PlotCensus',
                         'primaryStem'=>'PrimaryStem',
                         'x'=>'X, QX',
                         'y'=>'Y, QY',
                         'dbh'=>'DBH, Diameter',
                         'hom'=>'HOM, Height',
                         'codes'=>'Codes',
                         'comments'=>'Comments',
                         'errors'=>'Errors',
                         'extra1'=>'Extra1',
                         'extra2'=>'Extra2',
                         'extra3'=>'Extra3',
                         'extra4'=>'Extra4',
                         'extra5'=>'Extra5');
    $dataTypeA = array('default'=>'Select', 'integer'=>'integer','float'=>'float','decimal'=>'decimal');
    $stemChangeA = array('no'=>'No','incremented'=>'Incremented','carried'=>'Carried Over');
    $treeChangeA = array('no'=>'No','incremented'=>'Incremented','carried'=>'Carried Over');
    $upperLimitA = array('name'=>'upperLimit','id'=>'upperLimit','size'=>'16','value'=>$upperLimit);
    $lowerLimitA = array('name'=>'lowerLimit','id'=>'lowerLimit','size'=>'16','value'=>$lowerLimit);
    $defaultValueA = array('name'=>'defaultValue','id'=>'defaultValue','size'=>'16','value'=>$defaultValue);
    $columnSizeA = array('name'=>'columnSize','id'=>'columnSize','size'=>'16','value'=>$columnSize);
    $allowNullA = array('no'=>'No','yes'=>'Yes');
    $nextLineKeyA = array('no'=>'No','yes'=>'Yes');



    $submitButtonA = array('name'=>'submitButton','id'=>'button','type'=>'submit','content'=>'Submit');
    $resetButtonA = array('name'=>'resetButton','id'=>'button','type'=>'reset','content'=>'Reset');

    $columnHeaderTbx = form_input($columnHeaderA);
    $columnNameDD = form_dropdown('columnName',$columnNameA);
    $dataTypeDD = form_dropdown('dataType',$dataTypeA);
    $stemChangeDD = form_dropdown('stemChange',$stemChangeA);
    $treeChangeDD = form_dropdown('treeChange',$treeChangeA);
    $defaultValueTbx = form_input($defaultValueA);
    $upperLimitTbx = form_input($upperLimitA);
    $lowerLimitTbx = form_input($lowerLimitA);
    $columnSizeTbx = form_input($columnSizeA);
    $allowNullDD = form_dropdown('allowNull',$allowNullA,'yes');
    $nextLineKeyDD = form_dropdown('nextLineKey',$nextLineKeyA,'no');
    $submitButton = form_button($submitButtonA);
    $resetButton = form_button($resetButtonA);

    $columnHeaderErr = form_error('columnHeader');
    $columnNameErr = form_error('columnName');
    $dataTypeErr = form_error('dataType');
    $columnSizeErr = form_error('columnSize');

    $formTableA = array(array(),
                        array('Column Header : ',$columnHeaderTbx,$columnHeaderErr),
                        array('Column Name : ',$columnNameDD,$columnNameErr),
                        array('Data Type : ',$dataTypeDD,$dataTypeErr),
                        array('Is Value Changed with Stem : ',$stemChangeDD),
                        array('Is Value Changed with Tree : ',$treeChangeDD),
                        array('Upper Limit : ',$upperLimitTbx),
                        array('Lower Limit : ',$lowerLimitTbx),
                        array('Default Value : ',$defaultValueTbx),
                        array('Column Size : ',$columnSizeTbx,$columnSizeErr),
                        array('Null Value Allowed: ',$allowNullDD),
                        array('Add Next Row Stroke: ',$nextLineKeyDD),
                        array(),
                        array('',$submitButton."\t".$resetButton)
                        );

    $this->table->set_empty("");
    $formTable = $this->table->generate($formTableA);

    return $formTable;
  }

  function _validatelimitform()
  {
    $this->form_validation->set_rules('columnHeader', 'Column Header', 'trim|required' );
    $this->form_validation->set_rules('columnName', 'Column Name', 'callback_dropdown_check' );
    $this->form_validation->set_rules('dataType', 'Data Type', 'callback_dropdown_check' );
    $this->form_validation->set_rules('columnSize', 'Column Size','trim|required|integer');

    $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
  }


////////////*******************///////////////////////

////////////Quadrat Dropdown/////////////////////////
  function quadratdropdown()
  {
    $data['title'] = "Configuration Form";
    $data['contentTitle'] = "Quadrat Dropdown";
    $data['formHeading'] = "";
    $data['formOpen'] = form_open("formtypes/quadratdropdownvalidate");
    $data['table'] = $this->_quadratFormTable();
    $data['backLink'] = anchor('forms/selectcolumntype/','Back',array('class'=>'back'));
    $this->load->view('forms/simpleform2',$data);
  }

  function quadratdropdownvalidate()
  {
    $this->_validatequadratqueryform();

    if($this->form_validation->run() == FALSE)
    {
      $data['title'] = "Configuration Form";
      $data['contentTitle'] = "Quadrat Dropdown";
      $data['formHeading'] = "";
      $data['formOpen'] = form_open("formtypes/quadratdropdownvalidate");
      $data['table'] = $this->_quadratFormTable();
      $data['backLink'] = anchor('forms/selectcolumntype/','Back',array('class'=>'back'));
      $this->load->view('forms/simpleform2',$data);
    }
    else
    {
      //insert into database
      $plotID = $this->session->userdata('configPlotID');
      $formType = $this->session->userdata('formType');
      $columnType = "quadratdd";
      $columnNumber = $this->configmodel->getColumnNumber($plotID,$formType);

      $columnHeader = $this->input->post('columnHeader');
      $columnName = $this->input->post('columnName');

      $attributes = join("\t",array($columnHeader,$columnName));
      $this->configmodel->insertFormData($plotID,$formType,$columnNumber,$columnType,$attributes);
      redirect('forms/addcolumn');
    }
  }

  function _quadratFormTable()
  {
    $columnHeader = set_value('columnHeader');
    $columnName = set_value('columnName');



    $columnHeaderA = array('name'=>'columnHeader','id'=>'columnHeader','size'=>'16','value'=>$columnHeader);
    $columnNameA = array('default'=>'Select',
                         'quadratName'=>'QuadratName',
                         'extra1'=>'Extra1',
                         'extra2'=>'Extra2',
                         'extra3'=>'Extra3',
                         'extra4'=>'Extra4',
                         'extra5'=>'Extra5');


    $submitButtonA = array('name'=>'submitButton','id'=>'button','type'=>'submit','content'=>'Submit');
    $resetButtonA = array('name'=>'resetButton','id'=>'button','type'=>'reset','content'=>'Reset');

    $columnHeaderTbx = form_input($columnHeaderA);
    $columnNameDD = form_dropdown('columnName',$columnNameA);


    $submitButton = form_button($submitButtonA);
    $resetButton = form_button($resetButtonA);

    $columnHeaderErr = form_error('columnHeader');
    $columnNameErr = form_error('columnName');


    $formTableA = array(array(),
                        array('Column Header : ',$columnHeaderTbx.$columnHeaderErr),
                        array('Column Name : ',$columnNameDD.$columnNameErr),
                        array(),
                        array('',$submitButton."\t".$resetButton)
                        );

    $this->table->set_empty("");
    $formTable = $this->table->generate($formTableA);

    return $formTable;
  }

  function _validatequadratqueryform()
  {
    $this->form_validation->set_rules('columnHeader', 'Column Header', 'trim|required' );
    $this->form_validation->set_rules('columnName', 'Column Name', 'callback_dropdown_check');

    $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
  }
//////////////////////////////////////////////////////////////////////////

////////////Species Dropdown/////////////////////////
  function speciesdropdown()
  {
    //SELECT Species.SpeciesID, Species.Mnemonic FROM Species WHERE CurrentTaxonFlag =1 ORDER BY Species.Mnemonic
    $data['title'] = "Configuration Form";
    $data['contentTitle'] = "Species Dropdown";
    $data['formHeading'] = "";
    $data['formOpen'] = form_open("formtypes/speciesdropdownvalidate");
    $data['table'] = $this->_speciesFormTable();
    $data['backLink'] = anchor('forms/selectcolumntype/','Back',array('class'=>'back'));
    $this->load->view('forms/simpleform2',$data);
  }

  function speciesdropdownvalidate()
  {
    $this->_validatespeciesqueryform();

    if($this->form_validation->run() == FALSE)
    {
      $data['title'] = "Configuration Form";
      $data['contentTitle'] = "Species Dropdown";
      $data['formHeading'] = "";
      $data['formOpen'] = form_open("formtypes/speciesdropdownvalidate");
      $data['table'] = $this->_speciesFormTable();
      $data['backLink'] = anchor('forms/selectcolumntype/','Back',array('class'=>'back'));
      $this->load->view('forms/simpleform2',$data);
    }
    else
    {
      //insert into database
      $plotID = $this->session->userdata('configPlotID');
      $formType = $this->session->userdata('formType');
      $columnType = "speciesdd";
      $columnNumber = $this->configmodel->getColumnNumber($plotID,$formType);

      $columnHeader = $this->input->post('columnHeader');
      $columnName = $this->input->post('columnName');
      $stemChange = $this->input->post('stemChange');
      $speciesQuery = $this->input->post('speciesQuery');

      $attributes = join("\t",array($columnHeader,$columnName,$stemChange,$speciesQuery));
      $this->configmodel->insertFormData($plotID,$formType,$columnNumber,$columnType,$attributes);
      redirect('forms/addcolumn');
    }
  }

  function _speciesFormTable()
  {
    $columnHeader = set_value('columnHeader');
    $columnName = set_value('columnName');
    $stemChange = set_value('stemChange');
    $speciesQuery = set_value('speciesQuery');
    if($speciesQuery == "")
    {
      $speciesQuery = "SELECT Species.SpeciesID, Species.Mnemonic FROM Species WHERE CurrentTaxonFlag =1 ORDER BY Species.Mnemonic";
    }

    $columnHeaderA = array('name'=>'columnHeader','id'=>'columnHeader','size'=>'16','value'=>$columnHeader);
    $columnNameA = array('default'=>'Select',
                         'species'=>'Species, Mnemonic',
                         'extra1'=>'Extra1',
                         'extra2'=>'Extra2',
                         'extra3'=>'Extra3',
                         'extra4'=>'Extra4',
                         'extra5'=>'Extra5');
    $stemChangeA = array('no'=>'No','carried'=>'Carried Over');
    $speciesQueryA = array('name'=>'speciesQuery','id'=>'speciesQuery','value'=>$speciesQuery,'class'=>'textarea1');

    $submitButtonA = array('name'=>'submitButton','id'=>'button','type'=>'submit','content'=>'Submit');
    $resetButtonA = array('name'=>'resetButton','id'=>'button','type'=>'reset','content'=>'Reset');

    $columnHeaderTbx = form_input($columnHeaderA);
    $columnNameDD = form_dropdown('columnName',$columnNameA);
    $stemChangeDD = form_dropdown('stemChange',$stemChangeA);
    $speciesQueryTarea = form_textarea($speciesQueryA);

    $submitButton = form_button($submitButtonA);
    $resetButton = form_button($resetButtonA);

    $columnHeaderErr = form_error('columnHeader');
    $columnNameErr = form_error('columnName');
    $speciesQueryErr = form_error('speciesQuery');

    $formTableA = array(array(),
                        array('Column Header : ',$columnHeaderTbx.$columnHeaderErr),
                        array('Column Name : ',$columnNameDD.$columnNameErr),
                        array('Effect with stem increment : ',$stemChangeDD),
                        array('Species Query : ',$speciesQueryTarea),
                        array('',$speciesQueryErr),
                        array(),
                        array('',$submitButton."\t".$resetButton)
                        );

    $this->table->set_empty("");
    $formTable = $this->table->generate($formTableA);

    return $formTable;
  }

  function _validatespeciesqueryform()
  {
    $this->form_validation->set_rules('columnHeader', 'Column Header', 'trim|required' );
    $this->form_validation->set_rules('columnName', 'Column Name', 'callback_dropdown_check' );
    $this->form_validation->set_rules('speciesQuery','Species Query','required');

    $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
  }
//////////////////////////////////////////////////////////////////////////

/////////////////////////Subquadrat DropDown/////////////////////////////
function subquaddropdown()
  {
    //SELECT Species.SpeciesID, Species.Mnemonic FROM Species WHERE CurrentTaxonFlag =1 ORDER BY Species.Mnemonic
    $data['title'] = "Configuration Form";
    $data['contentTitle'] = "Subquadrat Dropdown";
    $data['formHeading'] = "";
    $data['formOpen'] = form_open("formtypes/subquaddropdownvalidate");
    $data['table'] = $this->_subquadFormTable();
    $data['backLink'] = anchor('forms/selectcolumntype/','Back',array('class'=>'back'));
    $this->load->view('forms/simpleform2',$data);
  }

  function subquaddropdownvalidate()
  {
    $this->_validatesubquadqueryform();

    if($this->form_validation->run() == FALSE)
    {
      $data['title'] = "Configuration Form";
      $data['contentTitle'] = "Subquadrat Dropdown";
      $data['formHeading'] = "";
      $data['formOpen'] = form_open("formtypes/subquaddropdownvalidate");
      $data['table'] = $this->_subquadFormTable();
      $data['backLink'] = anchor('forms/selectcolumntype/','Back',array('class'=>'back'));
      $this->load->view('forms/simpleform2',$data);
    }
    else
    {
      //insert into database
      $plotID = $this->session->userdata('configPlotID');
      $formType = $this->session->userdata('formType');
      $columnType = "subquaddd";
      $columnNumber = $this->configmodel->getColumnNumber($plotID,$formType);

      $columnHeader = $this->input->post('columnHeader');
      $columnName = $this->input->post('columnName');
      $startsWith = $this->input->post('startsWith');
      $maxX = $this->input->post('maxX');
      $maxY = $this->input->post('maxY');
      $subquadQuery = $this->input->post('subquadQuery');

      $attributes = join("\t",array($columnHeader,$columnName,$startsWith,$maxX,$maxY,$subquadQuery));
      $this->configmodel->insertFormData($plotID,$formType,$columnNumber,$columnType,$attributes);
      redirect('forms/addcolumn');
    }
  }

  function _subquadFormTable()
  {
    $plotID = $this->session->userdata('configPlotID');
    $columnHeader = set_value('columnHeader');
    $columnName = set_value('columnName');
    $maxX = set_value('maxX');
    $maxY = set_value('maxY');
    $subquadQuery = set_value('subquadQuery');
    if($subquadQuery == "")
    {
      $subquadQuery = "SELECT QDimX as DimX, QDimY as DimY FROM Site WHERE PlotID = $plotID";
    }
    if($maxX == '')
    {
      $maxX = 5;
    }
    if($maxY == '')
    {
      $maxY = 5;
    }

    $columnHeaderA = array('name'=>'columnHeader','id'=>'columnHeader','size'=>'16','value'=>$columnHeader);
    $columnNameA = array('default'=>'Select',
                         'subquadrat'=>'Subquadrat',
                         'extra1'=>'Extra1',
                         'extra2'=>'Extra2',
                         'extra3'=>'Extra3',
                         'extra4'=>'Extra4',
                         'extra5'=>'Extra5');
    $startsWithA = array('0'=>'0','1'=>'1','A'=>'A');
    $maxXA = array('name'=>'maxX','id'=>'maxX','size'=>'9','value'=>$maxX);
    $maxYA = array('name'=>'maxY','id'=>'maxY','size'=>'9','value'=>$maxY);
    $subquadQueryA = array('name'=>'subquadQuery','id'=>'subquadQuery','value'=>$subquadQuery,'class'=>'textarea1');
    $submitButtonA = array('name'=>'submitButton','id'=>'button','type'=>'submit','content'=>'Submit');
    $resetButtonA = array('name'=>'resetButton','id'=>'button','type'=>'reset','content'=>'Reset');

    $columnHeaderTbx = form_input($columnHeaderA);
    $columnNameDD = form_dropdown('columnName',$columnNameA);
    $startsWithDD = form_dropdown('startsWith',$startsWithA);
    $maxXTbx = form_input($maxXA);
    $maxYTbx = form_input($maxYA);
    $subquadQueryTarea = form_textarea($subquadQueryA);

    $submitButton = form_button($submitButtonA);
    $resetButton = form_button($resetButtonA);

    $columnHeaderErr = form_error('columnHeader');
    $columnNameErr = form_error('columnName');
    $maxXErr = form_error('maxX');
    $maxYErr = form_error('maxY');
    $subquadQueryErr = form_error('subquadQuery');

    $formTableA = array(array(),
                        array('Column Header : ',$columnHeaderTbx.$columnHeaderErr),
                        array('Column Name : ',$columnNameDD.$columnNameErr),
                        array('Starts With : ',$startsWithDD),
                        array('Max X: ','DimX / '.$maxXTbx,$maxXErr),
                        array('Max Y: ','DimY / '.$maxYTbx,$maxYErr),
                        array('Subquadrat Query : ',$subquadQueryTarea),
                        array('',$subquadQueryErr),
                        array(),
                        array('',$submitButton."\t".$resetButton)
                        );

    $this->table->set_empty("");
    $formTable = $this->table->generate($formTableA);

    return $formTable;
  }

  function _validatesubquadqueryform()
  {
    $this->form_validation->set_rules('columnHeader', 'Column Header', 'trim|required' );
    $this->form_validation->set_rules('columnName', 'Column Name', 'callback_dropdown_check');
    $this->form_validation->set_rules('maxX', 'Max X', 'trim|required' );
    $this->form_validation->set_rules('maxY', 'Max Y', 'trim|required' );
    $this->form_validation->set_rules('subquadQuery','Subquadrat Query','required');

    $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
  }
///////////////////////////////////////////////////////////////////////////////


////////////User Dropdown/////////////////////////
  function userdropdown()
  {
    $data['title'] = "Configuration Form";
    $data['contentTitle'] = "User Dropdown";
    $data['formHeading'] = "";
    $data['formOpen'] = form_open("formtypes/userdropdownvalidate");
    $data['table'] = $this->_userFormTable();
    $data['backLink'] = anchor('forms/selectcolumntype/','Back',array('class'=>'back'));
    $this->load->view('forms/simpleform2',$data);
  }

  function userdropdownvalidate()
  {
    $this->_validateuserqueryform();

    if($this->form_validation->run() == FALSE)
    {
      $data['title'] = "Configuration Form";
      $data['contentTitle'] = "User Dropdown";
      $data['formHeading'] = "";
      $data['formOpen'] = form_open("formtypes/userdropdownvalidate");
      $data['table'] = $this->_userFormTable();
      $data['backLink'] = anchor('forms/selectcolumntype/','Back',array('class'=>'back'));
      $this->load->view('forms/simpleform2',$data);
    }
    else
    {
      //insert into database
      $plotID = $this->session->userdata('configPlotID');
      $formType = $this->session->userdata('formType');
      $columnType = "userdd";
      $columnNumber = $this->configmodel->getColumnNumber($plotID,$formType);

      $columnHeader = $this->input->post('columnHeader');
      $columnName = $this->input->post('columnName');
      $userData = $this->input->post('userData');

      $attributes = join("\t",array($columnHeader,$columnName,$userData));
      $this->configmodel->insertFormData($plotID,$formType,$columnNumber,$columnType,$attributes);
      redirect('forms/addcolumn');
    }
  }

  function _userFormTable()
  {
    $columnHeader = set_value('columnHeader');
    $columnName = set_value('columnName');
    $userData = set_value('userData');
    /*if($speciesQuery == "")
    {
      $speciesQuery = "SELECT Species.SpeciesID, Species.Mnemonic FROM Species WHERE CurrentTaxonFlag =1 ORDER BY Species.Mnemonic";
    }*/

    $columnHeaderA = array('name'=>'columnHeader','id'=>'columnHeader','size'=>'16','value'=>$columnHeader);
    $columnNameA = array('default'=>'Select',
                         'tag'=>'Tag, TreeTag',
                         'stemTag'=>'StemTag, MultiStem',
                         'quadratName'=>'QuadratName',
                         'subquadrat'=>'Subquadrat',
                         'species'=>'Species, Mnemonic',
                         'plotCensusNumber'=>'PlotCensus',
                         'primaryStem'=>'PrimaryStem',
                         'x'=>'X, QX',
                         'y'=>'Y, QY',
                         'dbh'=>'DBH, Diameter',
                         'hom'=>'HOM, Height',
                         'codes'=>'Codes',
                         'comments'=>'Comments',
                         'errors'=>'Errors',
                         'extra1'=>'Extra1',
                         'extra2'=>'Extra2',
                         'extra3'=>'Extra3',
                         'extra4'=>'Extra4',
                         'extra5'=>'Extra5');
    $userDataA = array('name'=>'userData','id'=>'userData','value'=>$userData,'class'=>'textarea1');

    $submitButtonA = array('name'=>'submitButton','id'=>'button','type'=>'submit','content'=>'Submit');
    $resetButtonA = array('name'=>'resetButton','id'=>'button','type'=>'reset','content'=>'Reset');

    $columnHeaderTbx = form_input($columnHeaderA);
    $columnNameDD = form_dropdown('columnName',$columnNameA);
    $userDataTarea = form_textarea($userDataA);

    $submitButton = form_button($submitButtonA);
    $resetButton = form_button($resetButtonA);

    $columnHeaderErr = form_error('columnHeader');
    $columnNameErr = form_error('columnName');
    $userDataErr = form_error('userData');

    $formTableA = array(array(),
                        array('Column Header : ',$columnHeaderTbx.$columnHeaderErr),
                        array('Column Name : ',$columnNameDD.$columnNameErr),
                        array('User Data : ',$userDataTarea),
                        array('',"Enter Dropdown options, seperated by ;"),
                        array('',$userDataErr),
                        array(),
                        array('',$submitButton."\t".$resetButton)
                        );

    $this->table->set_empty("");
    $formTable = $this->table->generate($formTableA);

    return $formTable;
  }

  function _validateuserqueryform()
  {
    $this->form_validation->set_rules('columnHeader', 'Column Header', 'trim|required' );
    $this->form_validation->set_rules('columnName', 'Column Name', 'callback_dropdown_check');
    $this->form_validation->set_rules('userData','User Data','required');

    $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
  }
//////////////////////////////////////////////////////////////////////////


/////////////////twotextform////////////////////////////

function twotextform()
  {
    $data['title'] = "Configuration Form";
    $data['contentTitle'] = "Two Text Form";
    $data['formHeading'] = "";
    $data['formOpen'] = form_open("formtypes/twotextformvalidate");
    $data['table'] = $this->_twotextFormTable();
    $data['backLink'] = anchor('forms/selectcolumntype/','Back',array('class'=>'back'));
    $this->load->view('forms/simpleform2',$data);
  }

  function twotextformvalidate()
  {
    $this->_validatetwotextform();

    if($this->form_validation->run() == FALSE)
    {
      $data['title'] = "Configuration Form";
      $data['contentTitle'] = "Two Text Form";
      $data['formHeading'] = "";
      $data['formOpen'] = form_open("formtypes/twotextformvalidate");
      $data['table'] = $this->_twotextFormTable();
      $data['backLink'] = anchor('forms/selectcolumntype/','Back',array('class'=>'back'));
      $this->load->view('forms/simpleform2',$data);
    }
    else
    {
      //insert into database
      $plotID = $this->session->userdata('configPlotID');
      $formType = $this->session->userdata('formType');
      $columnType = "twotext";
      $columnNumber = $this->configmodel->getColumnNumber($plotID,$formType);

      $columnHeader = $this->input->post('columnHeader');
      $columnName = $this->input->post('columnName');
      $dataType = $this->input->post('dataType');
      $stemChange = $this->input->post('stemChange');
      $treeChange = $this->input->post('treeChange');
      $prefix = $this->input->post('prefix');
      $defaultValue = $this->input->post('defaultValue');
      $columnSize = $this->input->post('columnSize');
      $allowNull = $this->input->post('allowNull');
      $nextLineKey = $this->input->post('nextLineKey');

      $attributes = join("\t",array($columnHeader,$columnName,$dataType,$stemChange,$treeChange,$prefix,$defaultValue,$columnSize,$allowNull,$nextLineKey));
      $this->configmodel->insertFormData($plotID,$formType,$columnNumber,$columnType,$attributes);
      redirect('forms/addcolumn');
    }
  }

  function _twotextFormTable()
  {
    $columnHeader = set_value('columnHeader');
    $columnName = set_value('columnName');
    $dataType = set_value('dataType');
    $stemChange = set_value('stemChange');
    $treeChange = set_value('treeChange');
    $prefix = set_value('prefix');
    $defaultValue = set_value('defaultValue');
    $columnSize = set_value('columnSize');
    if($columnSize == "")
    {
      $columnSize = 10;
    }


    $columnHeaderA = array('name'=>'columnHeader','id'=>'columnHeader','size'=>'16','value'=>$columnHeader);
    $columnNameA = array('default'=>'Select',
                         'tag'=>'Tag, TreeTag',
                         'stemTag'=>'StemTag, MultiStem',
                         'quadratName'=>'QuadratName',
                         'subquadrat'=>'Subquadrat',
                         'species'=>'Species, Mnemonic',
                         'plotCensusNumber'=>'PlotCensus',
                         'primaryStem'=>'PrimaryStem',
                         'x'=>'X, QX',
                         'y'=>'Y, QY',
                         'dbh'=>'DBH, Diameter',
                         'hom'=>'HOM, Height',
                         'codes'=>'Codes',
                         'comments'=>'Comments',
                         'errors'=>'Errors',
                         'extra1'=>'Extra1',
                         'extra2'=>'Extra2',
                         'extra3'=>'Extra3',
                         'extra4'=>'Extra4',
                         'extra5'=>'Extra5');
    $dataTypeA = array('default'=>'Select', 'varchar'=>'varchar', 'integer'=>'integer','float'=>'float','decimal'=>'decimal');
    $stemChangeA = array('no'=>'No','incremented'=>'Incremented','carried'=>'Carried Over');
    $treeChangeA = array('no'=>'No','incremented'=>'Incremented','carried'=>'Carried Over');
    $prefixA = array('name'=>'prefix','id'=>'prefix','size'=>'16','value'=>$prefix);
    $defaultValueA = array('name'=>'defaultValue','id'=>'defaultValue','size'=>'16','value'=>$defaultValue);
    $columnSizeA = array('name'=>'columnSize','id'=>'columnSize','size'=>'16','value'=>$columnSize);
    $allowNullA = array('no'=>'No','yes'=>'Yes');
    $nextLineKeyA = array('no'=>'No','yes'=>'Yes');

    $submitButtonA = array('name'=>'submitButton','id'=>'button','type'=>'submit','content'=>'Submit');
    $resetButtonA = array('name'=>'resetButton','id'=>'button','type'=>'reset','content'=>'Reset');


    $columnHeaderTbx = form_input($columnHeaderA);
    $columnNameDD = form_dropdown('columnName',$columnNameA);
    $dataTypeDD = form_dropdown('dataType',$dataTypeA);
    $stemChangeDD = form_dropdown('stemChange',$stemChangeA);
    $treeChangeDD = form_dropdown('treeChange',$treeChangeA);
    $prefixTbx = form_input($prefixA);
    $defaultValueTbx = form_input($defaultValueA);
    $columnSizeTbx = form_input($columnSizeA);
    $allowNullDD = form_dropdown('allowNull',$allowNullA,'yes');
    $nextLineKeyDD = form_dropdown('nextLineKey',$nextLineKeyA,'no');
    $submitButton = form_button($submitButtonA);
    $resetButton = form_button($resetButtonA);

    $columnHeaderErr = form_error('columnHeader');
    $columnNameErr = form_error('columnName');
    $dataTypeErr = form_error('dataType');
    $columnSizeErr = form_error('columnSize');
    $prefixErr = form_error('prefix');

    $formTableA = array(array(),
                        array('Column Header : ',$columnHeaderTbx,$columnHeaderErr),
                        array('Column Name : ',$columnNameDD,$columnNameErr),
                        array('Data Type : ',$dataTypeDD,$dataTypeErr),
                        array('Is Value Changed with Stem : ',$stemChangeDD),
                        array('Is Value Changed with Tree : ',$treeChangeDD),
                        array('Prefix : ',$prefixTbx,$prefixErr),
                        array('Default Value : ',$defaultValueTbx),
                        array('Column Size : ',$columnSizeTbx,$columnSizeErr),
                        array('Null Value Allowed: ',$allowNullDD),
                        array('Add Next Row Stroke: ',$nextLineKeyDD),
                        array(),
                        array('',$submitButton."\t".$resetButton)
                        );

    $this->table->set_empty("");
    $formTable = $this->table->generate($formTableA);

    return $formTable;
  }

  function _validatetwotextform()
  {
    $this->form_validation->set_rules('columnHeader', 'Column Header', 'trim|required' );
    $this->form_validation->set_rules('columnName', 'Column Name', 'callback_dropdown_check');
    $this->form_validation->set_rules('dataType', 'Data Type', 'callback_dropdown_check' );
    $this->form_validation->set_rules('columnSize', 'Column Size','trim|required|integer');
    $this->form_validation->set_rules('prefix','Prefix','trim|required');

    $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
  }


/////////////////////////////////////////////////////////////////////////

/////////////////////////////tagstemform////////////////////////////////

function tagstemform()
  {
    $data['title'] = "Configuration Form";
    $data['contentTitle'] = "Tree Tag For Consecutive Stem Tag Form";
    $data['formHeading'] = "";
    $data['formOpen'] = form_open("formtypes/tagstemformvalidate");
    $data['table'] = $this->_tagstemFormTable();
    $data['backLink'] = anchor('forms/selectcolumntype/','Back',array('class'=>'back'));
    $this->load->view('forms/simpleform2',$data);
  }

  function tagstemformvalidate()
  {
    $this->_validatetagstemform();

    if($this->form_validation->run() == FALSE)
    {
      $data['title'] = "Configuration Form";
      $data['contentTitle'] = "Tree Tag For Consecutive Stem Tag Form";
      $data['formHeading'] = "";
      $data['formOpen'] = form_open("formtypes/tagstemformvalidate");
      $data['table'] = $this->_tagstemFormTable();
      $data['backLink'] = anchor('forms/selectcolumntype/','Back',array('class'=>'back'));
      $this->load->view('forms/simpleform2',$data);
    }
    else
    {
      //insert into database
      $plotID = $this->session->userdata('configPlotID');
      $formType = $this->session->userdata('formType');
      $columnType = "tagstem";
      $columnNumber = $this->configmodel->getColumnNumber($plotID,$formType);

      $columnHeader = $this->input->post('columnHeader');
      $columnName = $this->input->post('columnName');
      $dataType = $this->input->post('dataType');
      $stemChange = $this->input->post('stemChange');
      //$treeChange = $this->input->post('treeChange');
      $defaultValue = $this->input->post('defaultValue');
      $columnSize = $this->input->post('columnSize');
      $allowNull = $this->input->post('allowNull');
      $nextLineKey = $this->input->post('nextLineKey');

      $attributes = join("\t",array($columnHeader,$columnName,$dataType,$stemChange,$defaultValue,$columnSize,$allowNull,$nextLineKey));
      $this->configmodel->insertFormData($plotID,$formType,$columnNumber,$columnType,$attributes);
      redirect('forms/addcolumn');
    }
  }

  function _tagstemFormTable()
  {
    $columnHeader = set_value('columnHeader');
    $columnName = set_value('columnName');
    $dataType = set_value('dataType');
    $stemChange = set_value('stemChange');
    //$treeChange = set_value('treeChange');
    $defaultValue = set_value('defaultValue');
    $columnSize = set_value('columnSize');
    if($columnSize == "")
    {
      $columnSize = 10;
    }


    $columnHeaderA = array('name'=>'columnHeader','id'=>'columnHeader','size'=>'16','value'=>$columnHeader);
    $columnNameA = array('default'=>'Select',
                         'tag'=>'Tag, TreeTag',
                         'extra1'=>'Extra1',
                         'extra2'=>'Extra2',
                         'extra3'=>'Extra3',
                         'extra4'=>'Extra4',
                         'extra5'=>'Extra5');
    $dataTypeA = array('default'=>'Select', 'varchar'=>'varchar', 'integer'=>'integer','float'=>'float','decimal'=>'decimal');
    $stemChangeA = array('no'=>'No','incremented'=>'Incremented','carried'=>'Carried Over');
    //$treeChangeA = array('no'=>'No','incremented'=>'Incremented','carried'=>'Carried Over');
    $defaultValueA = array('name'=>'defaultValue','id'=>'defaultValue','size'=>'16','value'=>$defaultValue);
    $columnSizeA = array('name'=>'columnSize','id'=>'columnSize','size'=>'16','value'=>$columnSize);
    $allowNullA = array('no'=>'No','yes'=>'Yes');
    $nextLineKeyA = array('no'=>'No','yes'=>'Yes');

    $submitButtonA = array('name'=>'submitButton','id'=>'button','type'=>'submit','content'=>'Submit');
    $resetButtonA = array('name'=>'resetButton','id'=>'button','type'=>'reset','content'=>'Reset');


    $columnHeaderTbx = form_input($columnHeaderA);
    $columnNameDD = form_dropdown('columnName',$columnNameA);
    $dataTypeDD = form_dropdown('dataType',$dataTypeA);
    $stemChangeDD = form_dropdown('stemChange',$stemChangeA);
    //$treeChangeDD = form_dropdown('treeChange',$treeChangeA);
    $defaultValueTbx = form_input($defaultValueA);
    $columnSizeTbx = form_input($columnSizeA);
    $allowNullDD = form_dropdown('allowNull',$allowNullA,'yes');
    $nextLineKeyDD = form_dropdown('nextLineKey',$nextLineKeyA,'no');
    $submitButton = form_button($submitButtonA);
    $resetButton = form_button($resetButtonA);

    $columnHeaderErr = form_error('columnHeader');
    $columnNameErr = form_error('columnName');
    $dataTypeErr = form_error('dataType');
    $columnSizeErr = form_error('columnSize');

    $formTableA = array(array(),
                        array('Column Header : ',$columnHeaderTbx,$columnHeaderErr),
                        array('Column Name : ',$columnNameDD,$columnNameErr),
                        array('Data Type : ',$dataTypeDD,$dataTypeErr),
                        array('Is Value Changed with Stem : ',$stemChangeDD),
                        //array('Is Value Changed with Tree : ',$treeChangeDD),
                        array('Default Value : ',$defaultValueTbx),
                        array('Column Size : ',$columnSizeTbx,$columnSizeErr),
                        array('Null Value Allowed: ',$allowNullDD),
                        array('Add Next Row Stroke: ',$nextLineKeyDD),
                        array(),
                        array('',$submitButton."\t".$resetButton)
                        );

    $this->table->set_empty("");
    $formTable = $this->table->generate($formTableA);

    return $formTable;
  }

  function _validatetagstemform()
  {
    $this->form_validation->set_rules('columnHeader', 'Column Header', 'trim|required' );
    $this->form_validation->set_rules('columnName', 'Column Name', 'callback_dropdown_check' );
    $this->form_validation->set_rules('dataType', 'Data Type', 'callback_dropdown_check' );
    $this->form_validation->set_rules('columnSize', 'Column Size','trim|required|integer');

    $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
  }
///////////////////////////////******************////////////////////////////////////




///////////////Helper Functions///////////////////////
  function dropdown_check($str)
  {
     if($str == 'default')
     {
        $this->form_validation->set_message('dropdown_check', '%s need to be Selected');
        return FALSE;
     }
     else
     {
        return True;
     }
  }

///////////////////////////////////////////////////////

}