<?php
function uploadoldtrees()
    {
      $plotCensusArray = $this->session->userdata('plotCensusArray');
      $plotName = $plotCensusArray['plotName'];
      $censusNumber = $plotCensusArray['censusNumber'];
      $plotActualName = $plotCensusArray['plotActualName'];

      $mainStem = 'main';
      $secondaryStem = 'secondary';
      $bigdescription = 'Buttressed tree';
      $stemLost =  'stem lost';
      $deadStem = 'dead';
      $tempOldTrees = 'TempOldTrees';
      $tempNewPlants = 'TempNewPlants';
      $tempMultiStems = 'TempMultiStems';
      $tempAllTrees = 'TempAllTrees';
      $tempTrees1 = 'TempTrees1';
      $tempTrees2 = 'TempTrees2';
      $tempTrees = 'TempTrees';

      //Start Transaction
      $this->datauploadmodel->startTransaction();

    $list['step'] = '1';
    $list['detail'] = 'Creating, Updating Temp Tables';
    $this->session->set_userdata('progressList',$list);
    session_write_close();

      //createStemNumberTable - Create StemNumber table with largest StemNumber (old StemID)
        //Get maximum StemNumber from Stem table and insert into TempStemNumber
      $this->datauploadmodel->createStemNumberTable();

      //createtempAllTrees
      $this->datauploadmodel->createTempAllTrees();

      //Get TreeIDs and StemIDs for tempOldTrees where TreeID is null
      //Update tempOldTrees
      $this->datauploadmodel->updateTempOldTrees();

      // Erase all StemIDs from previous attempts from Multiple Stems form
      //Get TreeIDs and SpeciesIDs into Multiple Stem For
      if($this->datauploadmodel->ifTableExist($tempMultiStems))
      {
       $this->datauploadmodel->updateTempMultiStem();
      }
      //Check if TempNewPlants Exist
      if($this->datauploadmodel->ifTableExist($tempNewPlants))
      {
        // Get Old Trees from New Plants Form
           //Set OldTrees field to "n"
           //Set OldTrees field to "y" if old tag
        // Erase all StemIDs in TempNewPlants from previous attempts
        $this->datauploadmodel->updateTempNewPlants();

        //Count Old Trees in TempNewPlants
          //If yes - set variable
        $countOldInNew =  $this->datauploadmodel->oldTreesInTempNewPlants();
        if($countOldInNew > 0)
        {
          $oldTreesInNewPlants = "y";
        }
        else
        {
          $oldTreesInNewPlants = "n";
        }
      }
      else
      {
        $oldTreesInNewPlants = "n";
      }

      //Check if TempBigTrees Exist  (Don't exist now for future use)
      if($this->datauploadmodel->ifTableExist('TempBigTrees'))
      {
         $bigCode = $this->datauploadmodel->getCodes($bigdescription);
         //Set BigTrees field to "n"
         //Set BigTrees field to "y" if code has big tree code
         $this->datauploadmodel->updateTempTreesForBigTrees($tempOldTrees,$bigCode,'Both'); //second parameter is for selecting queries
      }
      else
      {
        $bigCode = $this->datauploadmodel->getCodes($bigdescription);
        //Set BigTrees field to "n"
        $this->datauploadmodel->updateTempTreesForBigTrees($tempOldTrees,$bigCode,'Single'); //second parameter is for selecting queries
      }

//////...
    $list['step'] = '2';
    $list['detail'] = 'Inserting Into TempAllTrees from TempOldTrees';
    $this->session->set_userdata('progressList',$list);
    session_write_close();

      //Append into TempAllTrees from Old Trees - all records except where data is in Big Trees form
      $getOldTreesQuery = $this->datauploadmodel->getOldTreesNoBigTrees();

      if($getOldTreesQuery->num_rows() > 0)
      {
        foreach($getOldTreesQuery->result_array() as $getOldTreesRow)
        {
          $this->datauploadmodel->insertRowIntoTable($tempAllTrees,$getOldTreesRow);
        }
      }
      $getOldTreesQuery->free_result(); //Free Result
//////...
    $list['step'] = '3';
    $list['detail'] = 'Checking, Updating Stem Data in TempAllTrees';
    $this->session->set_userdata('progressList',$list);
    session_write_close();

      //Check to see if site uses Stem Tags

      $checkIfStemTagsUsed = $this->datauploadmodel->checkIfStemTagsUsed($mainStem); //will return count of DBHID

      if($checkIfStemTagsUsed > 0)
      {
//////...
    $list['step'] = '4';
    $list['detail'] = 'Inserting Into TempAllTrees from TempMultiStems';
    $this->session->set_userdata('progressList',$list);
    session_write_close();

        if($this->datauploadmodel->ifTableExist($tempMultiStems))
        {
          //Get StemIDs into TempMultiStem
          $this->datauploadmodel->updateStemIDFromStemTable($tempMultiStems);

          //Append into TempAllTrees table from TempMultiStems
          $getMultiStemsQuery = $this->datauploadmodel->getDataForTempAllTrees($tempMultiStems);
          if($getMultiStemsQuery->num_rows() > 0)
          {
            foreach($getMultiStemsQuery->result_array() as $getMultiStemsRow)
            {
              $this->datauploadmodel->insertRowIntoTable($tempAllTrees,$getMultiStemsRow);
            }
          }
          $getMultiStemsQuery->free_result(); //Free Result
        }
//////...
    $list['step'] = '5';
    $list['detail'] = 'Inserting Into TempAllTrees from TempNewPlants, If Any';
    $this->session->set_userdata('progressList',$list);
    session_write_close();

        if($oldTreesInNewPlants == "y")
        {
          //If Old trees in TempNewPlants - update StemIDs in TempNewPlants from Stem Table
          $this->datauploadmodel->updateStemIDFromStemTable($tempNewPlants);

          //Append into TempAllTrees from TempNewPlants
          $getNewPlantsQuery = $this->datauploadmodel->getOldTreesInTempNewPlants();
          if($getNewPlantsQuery->num_rows() > 0)
          {
            foreach($getNewPlantsQuery->result_array() as $getNewPlantsRow)
            {
              $this->datauploadmodel->insertRowIntoTable($tempAllTrees,$getNewPlantsRow);
            }
          }
          $getNewPlantsQuery->free_result(); //Free Result
        }
      }
      else //if not StemTag is used
      {
//////...
    $list['step'] = '4';
    $list['detail'] = 'Inserting Into TempAllTrees from TempMultiStems';
    $this->session->set_userdata('progressList',$list);
    session_write_close();

        //Append tempMultStems into tempAllTrees table
        $getMultiStemsQuery = $this->datauploadmodel->getDataForTempAllTrees($tempMultiStems);
        if($getMultiStemsQuery->num_rows() > 0)
        {
          foreach($getMultiStemsQuery->result_array() as $getMultiStemsRow)
          {
            $this->datauploadmodel->insertRowIntoTable($tempAllTrees,$getMultiStemsRow);
          }
        }
        $getMultiStemsQuery->free_result(); //Free Result
        // Erase all StemIDs in TempAllPlants from previous attempts
        $this->datauploadmodel->setStemIDsToNull($tempAllTrees);

        // Replace all stems with same StemIDs from previous census if tree only has one stem in both censuses and and no resprout code in this census
        $prevCensusNumber = $censusNumber - 1;
        $prevCensusID = $this->datauploadmodel->getCensusID($plotName,$prevCensusNumber);


        //Create Both Temp Trees
        $this->datauploadmodel->createTempTree1($tempTrees1);
        $this->datauploadmodel->createTempTree2($tempTrees2);
        //Get one-stemmed trees from previous census into TempTrees1 from ViewFullTable
        $this->datauploadmodel->insertOneStemIntoTempTree1($tempTrees1,$prevCensusID);

        // Get resprout codes
        $resproutArr = $this->datauploadmodel->getCodes($stemLost);
        $deadArr = $this->datauploadmodel->getCodes($deadStem);

        $this->datauploadmodel->updTempAllTreesTagged($tempAllTrees,'n');
        //Get one-stemmed trees from TempAllTrees into TempTrees2
        $this->datauploadmodel->insertOneStemIntoTempTree2($tempTrees2.$tempAllTrees);
        //Delete Records with code 'stem lost
        $this->datauploadmodel->deleteRecordsWithCode($tempTrees2,$resproutArr);

        //Update TempAllTrees with TempTrees2 - Set Tagged = 'y' comparing TreeID
        //Update TempAllTrees Join TempTrees1 - Update StemID where Tagged = 'y'
        $this->datauploadmodel->updTempAllTreesTaggedCompare($tempAllTrees,$tempTrees2,'y');
        $this->datauploadmodel->updTempAllTreesTaggedJoin($tempAllTrees,$tempTrees1,'y');


        /////Create TempTrees and If Tree Died take StemID of main Stem/////
        $this->datauploadmodel->getMainStem($tempTrees,$prevCensusID);

        $this->datauploadmodel->updTempAllTreesTagged($tempAllTrees,'n');
        $this->datauploadmodel->createTempTree2($tempTrees2);

        $this->datauploadmodel->insertTempTree2Dead($tempTrees2,$tempAllTrees,$deadArr);

        //Update TempAllTrees with TempTrees2 - Set Tagged = 'y' comparing TreeID
        //Update TempAllTrees Join TempTrees - Update StemID where Tagged = 'y'
        $this->datauploadmodel->updTempAllTreesTagged($tempAllTrees,$tempTrees2,'y');
        $this->datauploadmodel->updTempAllTreesTaggedJoin($tempAllTrees,$tempTrees,'y');
//////...
    $list['step'] = '5';
    $list['detail'] = 'Inserting Into TempAllTrees from TempNewPlants, If Any';
    $this->session->set_userdata('progressList',$list);
    session_write_close();

        ////// Do the same with old trees in New Plants form/////
        if($oldTreesInNewPlants == "y")
        {
          // Work only with single-stemmed trees
          $getSingleStemQuery = $this->datauploadmodel->getTempNewPlantsSingleStem($tempNewPlants);
          foreach($getSingleStemQuery->result() as $getSingleStemRow)
          {
            //Check to see if there is a resprout code
            $resprout = 'n';
            $treeID = $getSingleStemRow->TreeID;
            $tempID = $getSingleStemRow->TempID;
            $getCodesQuery = $this->datauploadmodel->getTempNewPlantsCodes($tempNewPlants,$tempID);
            if($getCodesQuery->num_rows() > 0)
            {
              $getCodesRow = $getCodesQuery->row_array();
              $noCodes = SUBSTR_COUNT($getCodesRow["Codes"],';');
              $arrCodes = explode(";", $getCodesRow["Codes"]);
              for ($i = 0; $i <= $noCodes; $i++)
              {
                if (in_array($arrCodes[$i], $resproutArr))
                {
                   $resprout = 'y';
                }
              } // end for
            }//end if
            if ($resprout == 'n')
            {
             //Check how many stems there were when tree was last measured - may be several censuses ago

             $stop='n';
             // Look at data from 2 censuses ago, assume that tree was not measured in previous census
             $k = 2;
             $prevCensusNumber = $censusNumber - $k;

             while ($stop == 'n' && $prevCensusNumber >= 1)
             {
               $prevCensusID = $this->datauploadmodel->getCensusID($plotName,$prevCensusNumber);

               $getListOfTSMQuery = $this->datauploadmodel->getListOfTSM($prevCensusID,$treeID);
               //$q4 = 'select TreeID, StemID, DBH, ListOfTSM from DFtemp where censusID = '.$prevcensusid.' and TreeID = '.$onestem["TreeID"].' group by TreeID,StemID';
              //$r4 = mysql_query($q4, $connect) or die('Getting Stems from DFtemp failed: ' .mysql_error());
               $dead = 'n';
               $respr2 = 'n';

               //If there were more than one stem, then stop, get new StemIDs
               if ($getListOfTSMQuery->num_rows() > 1)
               {
                 $stop = 'y';
               }

               if ($getListOfTSMQuery->num_rows() == 1)
               {
                 $row = $getListOfTSMQuery->row_array();

                 $noCodes = SUBSTR_COUNT($row["ListOfTSM"],",");
                 $arrCodes = explode(",", $row["ListOfTSM"]);
                 for ($i = 0; $i <= $noCodes; $i++)
                 {
                   if (in_array($arrCodes[$i], $deadArr))
                   {
                     $dead = 'y';
                   }
                   if (in_array($arrCodes[$i], $resproutArr))
                   {
                     $respr2 = 'y';
                   }
                 }  // end for
                 // If not dead and (dbh>=10 or resprout)
                 If ($dead == 'n')
                 {
                   If ($row["DBH"]>=10 || $respr2 == 'y')
                   {
                     $this->datauploadmodel->updateTempNewPlantStemID($tempNewPlants,$row['StemID'],$tempID);
                     $stop = 'y';
                   }
                 }  // End if ($dead == 'n')

               } //End if (mysql_num_rows($r4) == 1)
               $k = $k+1;    //Go to next census to find if tree measured
               $prevCensusNumber = $censusNumber - $k;
             }//End While ($stop == 'n' && $prevcensus >= 1)
            }  // End if (resprout == 'n')
          }//end forech
          //Append into TempAllTrees from TempNewPlants
          $getNewPlantsQuery = $this->datauploadmodel->getOldTreesInTempNewPlants();
          if($getNewPlantsQuery->num_rows() > 0)
          {
            foreach($getNewPlantsQuery->result_array() as $getNewPlantsRow)
            {
              $this->datauploadmodel->insertRowIntoTable($tempAllTrees,$getNewPlantsRow);
            }
          }
        }//end if $oldTreesInNewPlants == "y"
        //Free Result
        $getSingleStemQuery->free_result();
        $getCodesQuery->free_result();
        $getListOfTSMQuery->free_result();
        $getNewPlantsQuery->free_result();
      }//end else - if not StemTag is used

      //Drop Temp Tables
      $this->datauploadmodel->dropTableIfExist($tempTrees);
      $this->datauploadmodel->dropTableIfExist($tempTrees1);
      $this->datauploadmodel->dropTableIfExist($tempTrees2);
//////...
    $list['step'] = '6';
    $list['detail'] = 'Update TempAllTrees for Quadrat, Species, DBH, PrimaryStem';
    $this->session->set_userdata('progressList',$list);
    session_write_close();

      //Update Quadrat in TempAllTrees
      $this->datauploadmodel->updQuadratTempTrees($tempAllTrees);
      //Update Species in TempAllTrees
      $this->datauploadmodel->updSpeciesTempTrees($tempAllTrees);
      //Update DBH to NULL where its is O in TempAllTrees
      $this->datauploadmodel->updDBHNullTempTrees($tempAllTrees);

      //Update PrimaryStem in TempAllTrees
      $getMainStemQuery = $this->datauploadmodel->getTsmCodeDesc($mainStem);
      if($getMainStemQuery->num_rows() > 0)
      {
        $getMainStemRow = $getMainStemQuery->row_array();
        $mainCode = $getMainStemRow['TSMCode'];
        $mainDescription = $getMainStemRow['Description'];
        $this->datauploadmodel->updPrimaryTempTrees($tempAllTrees,$mainCode,$mainDescription);
      }
      $getSecondStemQuery = $this->datauploadmodel->getTsmCodeDesc($secondaryStem);
      if($getSecondStemQuery->num_rows() > 0)
      {
        $getSecondStemRow = $getSecondStemQuery->row_array();
        $secondCode = $getSecondStemRow['TSMCode'];
        $secondDescription = $getSecondStemRow['Description'];
        $this->datauploadmodel->updPrimaryTempTrees($tempAllTrees,$secondCode,$secondDescription);
      }
      //Free Result
      $getMainStemQuery->free_result();
      $getSecondStemQuery->free_result();
////....Checking for error If errors stop Script and return value.
      //Check to see if any of the required fields have errors
      $checkNullQuery = $this->datauploadmodel->getNullTreeID($tempAllTrees);
      $checkNullRow = $checkNullQuery->row_array();
      if($checkNullRow['Cnt'] > 0)
      {
//////...
    $list['step'] = 'error';
    $list['detail'] = 'Some records from Old Trees cannot be loaded into production tables. Contact Administrator.';
    $this->session->set_userdata('progressList',$list);
    session_write_close();
        /*echo 'Some records from Old Trees cannot be loaded into production tables. Please ask the Administrator to check them in the tempAllTrees table
         by using the following SQL:<br /><br />
         TreeID IS NULL OR StemID IS NULL<br /><br />';*/
         die();
      }

      else
      {
///...Loading in Production
//////...
    $list['step'] = '7';
    $list['detail'] = 'Loading In Production Tables';
    $this->session->set_userdata('progressList',$list);
    session_write_close();

        //Upload New Stems into Stem table and update StemTag if available
        $stemDataQuery = $this->datauploadmodel->getTempAllTreesStemData($tempAllTrees);
        foreach($stemDataQuery->result() as $stemDataRow)
        {
          //
          $tempTreeID = $stemDataRow->TreeID;
          $tempStemID = $stemDataRow->StemID;
          $tempStemTag = $stemDataRow->StemTag;
          $tempQuadratID = $stemDataRow->QuadratID;
          $getStemDataQuery = $this->datauploadmodel->getStemData($tempStemID);
          if($getStemDataQuery->num_rows() == 1)
          {
            if (!is_null($tempStemTag) and $tempStemTag<>"" and $tempStemTag<>"0")
            {
              $this->datauploadmodel->updateStemStemTag($tempStemID,$tempStemTag);
            }

          }
          else //Insert into Stems table if not found
          {
            $this->datauploadmodel->insertIntoStemTreeIDStemID($tempTreeID,$tempQuadratID,$tempStemTag);
          }
        }
        //Free Results
        $stemDataQuery->free_result();
        $getStemDataQuery->free->result();


        //Upload measurements and codes into DBH and DBHAttributes tables

        //Upload into DBH Table
        $dbhDataQuery = $this->datauploadmodel->getTempAllTreesDBHData($tempAllTrees);
        foreach($dbhDataQuery->result_array() as $dbhDataRow)
        {
          if(is_null($dbhDataRow['DBH']))
          {
            $dbhDataRow['DBH'] = 'NULL';
          }
          if(is_null($dbhDataRow['HOM']))
          {
            $dbhDataRow['HOM'] = 'NULL';
          }
          $insertDBH = array('CensusID'=>$dbhDataRow['CensusID'],'StemID'=>$dbhDataRow['StemID'],'DBH'=>$dbhDataRow['DBH'],'HOM'=>$dbhDataRow['HOM'],'PrimaryStem'=>$dbhDataRow['PrimaryStem'],'ExactDate'=>$dbhDataRow['ExactDate']);
          $this->datauploadmodel->insertRowIntoTable('DBH',$insertDBH);
          $insertedDBHID = $this->datauploadmodel->getLastInsertedID();  //get the DBHID where the record is inserted

          //insert into DBHAttributes
          $tempCodes = $dbhDataRow['Codes'];
          if(!is_null($tempCodes) AND $tempCodes<>'*' AND $tempCodes<>'')
          {
            $arrcodes = explode(";", $tempCodes);

            //Get unique values - avoid duplicate codes
            $arrCodes = array_unique($arrCodes);
            $noCodes = count($arrCodes);

            for ($i = 0; $i < $noCodes; $i++)
            {
              if ($arrCodes[$i]<>$mainStem && $arrCodes[$i]<>$secondaryStem)
              {
                $tsmIDQuery = $this->datauploadmodel->getTSMID($arrCodes[$i]);
                $tsmIDRow = $tsmIDQuery->row();
                $tsmID = $tsmIDRow->TSMID;

                $insertDBHAtt = array('DBHID'=>$insertedDBHID,'CensusID'=>$dbhDataRow['CensusID'],'TSMID'=>$tsmID);
                $this->datauploadmodel->insertRowIntoTable('DBHAttributes',$insertDBHAtt);
                  $tsm = mysql_fetch_row($r2);
               } //End if
            }
          }
        }
        //Free Results
        $dbhDataQuery->free_result();
        $tsmIDQuery->free_result();
      }
//////...Complete
    $list['step'] = '8';
    $list['detail'] = 'Uploading Process Completed';
    $this->session->set_userdata('progressList',$list);
    session_write_close();
     echo 'Done';
      //Complete Transaction
      $this->datauploadmodel->completeTransaction();
    }
?>