<?php

class Plotdatareport extends Controller{

    function Plotdatareport()
    {
      parent::Controller();
      if($this->session->userdata('loggedin') !== '1')
      {
        redirect('main','location');
      }
      $this->load->library(array('table','pagination'));
      global $databaseVersion;
      $databaseVersion = $this->session->userdata('databaseVersion');
      if($databaseVersion == 'new')
      {
        $this->load->model('plotdatareportmodel_new','plotdatareportmodel');

      }
      elseif($databaseVersion == 'old')
      {
        $this->load->model('plotdatareportmodel','plotdatareportmodel');
      }
      global $databaseName;
      $databaseName = $this->session->userdata('databaseName');

      set_time_limit(0);
      ini_set('memory_limit', '-1');
    }
    function selectplot()
    {
      global $databaseName;
      if(isset($this->session->userdata[$databaseName.'plotReport']))
      {
        $this->session->unset_userdata($databaseName.'plotReport');
      }
      if(isset($this->session->userdata[$databaseName.'totalPlotDataRowCount']))
      {
        $this->session->unset_userdata($databaseName.'totalPlotDataRowCount');
      }
      if(isset($this->session->userdata[$databaseName.'selectPlot']))
      {
        $this->session->unset_userdata($databaseName.'selectPlot');
      }
      $data['formTable'] = $this->_generateselectplotform($databaseName);
      $data['formOpen'] = form_open('plotdatareport/selectplotform');

      $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
      $data['contentTitle'] = 'Plot Data Report';
      $this->load->view('user/plotdataform',$data);
    }
    function selectplotform()
    {
      global $databaseName;
      $this->_validateselectplotform();
      if($this->form_validation->run() == FALSE)
      {
        $data['formTable'] = $this->_generateselectplotform($databaseName);
        $data['formOpen'] = form_open('plotdatareport/selectplotform');

        $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
        $data['contentTitle'] = 'Plot Data Report';
        $this->load->view('user/plotdataform',$data);
      }
      else
      {
        $selectPlot = $this->input->post('plotName');
        $this->session->set_userdata($databaseName.'selectPlot',$selectPlot);
        redirect('plotdatareport/plotdata');
      }
    }
    function _generateselectplotform($databaseName)
    {
      $plotName = set_value('plotName');

      $plotNameA = $this->plotdatareportmodel->getPlotNames();

      $submitButtonA = array('name'=>'submitButton','id'=>'button','type'=>'submit','content'=>'Submit');

      $plotNameDD = form_dropdown('plotName',$plotNameA,$plotName);
      $submitButton = form_button($submitButtonA);

      $plotNameErr = form_error('plotName');

      $formTableA = array(array(),
                         array('Plot Name<b><span style="color:#FF0000; font-size:medium;">*</span></b> : ',$plotNameDD,$plotNameErr),
                         array('','<p style="text-align:center;">'.$submitButton.'</p>')
                         );
       $this->table->set_empty("");
       $formTable = $this->table->generate($formTableA);

       return $formTable;


    }
    function _validateselectplotform()
    {
       $this->form_validation->set_rules('plotName', 'Plot Name', 'callback_dropdown_check');

       $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    function plotdata()
    {
      global $databaseName;

      if(!isset($this->session->userdata[$databaseName.'selectPlot']))
      {
        redirect('plotdatareport/selectplot');
      }
      if(isset($this->session->userdata[$databaseName.'plotReport']))
      {
        $this->session->unset_userdata($databaseName.'plotReport');
      }
      if(isset($this->session->userdata[$databaseName.'totalPlotDataRowCount']))
      {
        $this->session->unset_userdata($databaseName.'totalPlotDataRowCount');
      }
      $data['formTable'] = $this->_generateplotdataform($databaseName);
      $data['formOpen'] = form_open('plotdatareport/plotdataform');

      $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
      $data['contentTitle'] = 'Plot Data Report';
      $this->load->view('user/plotdataform',$data);
    }
    function plotdataform($offset = 0)
    {
      global $databaseName;
      $this->_validateplotdataform();
      if(($this->form_validation->run() == FALSE) && (!isset($this->session->userdata[$databaseName.'plotReport'])))
      {
        $data['formTable'] = $this->_generateplotdataform($databaseName);
        $data['formOpen'] = form_open('plotdatareport/plotdataform');

        $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
        $data['contentTitle'] = 'Plot Data Report';
        $this->load->view('user/plotdataform',$data);
      }
      else
      {
        if(isset($this->session->userdata[$databaseName.'plotReport']))
        {
          $plotReportArray = $this->session->userdata($databaseName.'plotReport');
          $plotID = $this->session->userdata($databaseName.'selectPlot');
          $plotName = $this->plotdatareportmodel->getPlotNameByID($plotID);
          $censusNumber = $plotReportArray['censusNumber'];
          $genus = $plotReportArray['genus'];
          $species = $plotReportArray['species'];
          $quadrat = $plotReportArray['quadrat'];
          $maxX = $plotReportArray['maxX'];
          $minX = $plotReportArray['minX'];
          $maxY = $plotReportArray['maxY'];
          $minY = $plotReportArray['minY'];
          $maxDBH = $plotReportArray['maxDBH'];
          $minDBH = $plotReportArray['minDBH'];
          $includeDT = $plotReportArray['includeDT'];
          $stemRadio = $plotReportArray['stemRadio'];
        }
        else
        {
          $plotID = $this->session->userdata($databaseName.'selectPlot');
          $plotName = $this->plotdatareportmodel->getPlotNameByID($plotID);
          $censusNumber = $this->input->post('censusNumber');
          $genus = $this->input->post('genus');
          $species = $this->input->post('species');
          $quadrat = $this->input->post('quadrat');
          $maxX = $this->input->post('maxX');
          $minX = $this->input->post('minX');
          $maxY = $this->input->post('maxY');
          $minY = $this->input->post('minY');
          $maxDBH = $this->input->post('maxDBH');
          $minDBH = $this->input->post('minDBH');
          $includeDT = $this->input->post('includeDT');
          $stemRadio = $this->input->post('stemRadio');

          $plotReportArray = array('plotID'=>$plotID,'censusNumber'=>$censusNumber,'genus'=>$genus,'species'=>$species,'quadrat'=>$quadrat,'maxX'=>$maxX,'minX'=>$minX,'maxY'=>$maxY,'minY'=>$minY,'maxDBH'=>$maxDBH,'minDBH'=>$minDBH,'includeDT'=>$includeDT,'stemRadio'=>$stemRadio);
          $this->session->set_userdata($databaseName.'plotReport',$plotReportArray);
        }
        $this-> _viewplotdata($plotID,$censusNumber,$genus,$species,$quadrat,$maxX,$minX,$maxY,$minY,$maxDBH,$minDBH,$includeDT,$stemRadio,$offset);
      }
    }

    function _generateplotdataform($databaseName)
    {
      //$plotName = $this->session->userdata('initialPlot');
      $plotID = $this->session->userdata($databaseName.'selectPlot');
      $plotName = $this->plotdatareportmodel->getPlotNameByID($plotID);

      //$plotName = set_value('plotName');
      $censusNumber = set_value('censusNumber');
      $genus = set_value('genus');
      $species = set_value('species');
      $quadrat = set_value('quadrat');
      $maxX = set_value('maxX');
      $minX = set_value('minX');
      $maxY = set_value('maxY');
      $minY = set_value('minY');
      $maxDBH = set_value('maxDBH');
      $minDBH = set_value('minDBH');

      /////Re-populate the Checkbox
      if(isset($_POST) AND !empty($_POST))
      {
        if($this->input->post('includeDT') !== 'Yes')
        {
          echo $this->input->post('includeDT');
          $includeDTC = FALSE;
        }
        else
        {
          $includeDTC = TRUE;
        }
      }
      else
      {
        $includeDTC = TRUE;
      }
      ////////////////////////////////

      //Re-populate Radio Buttons
      if(isset($_POST) AND !empty($_POST))
      {
        $mainCheck = FALSE;
        $secondaryCheck = FALSE;
        $allCheck = FALSE;
        $measurementCheck = FALSE;
        if($this->input->post('stemRadio') == 'secondary')
        {
          $secondaryCheck = TRUE;
        }
        elseif($this->input->post('stemRadio') == 'all')
        {
          $allCheck = TRUE;
        }
        elseif($this->input->post('stemRadio') == 'measurement')
        {
          $measurementCheck = TRUE;
        }
        else
        {
          $mainCheck = TRUE;
        }
      }
      else
      {
        $mainCheck = FALSE;
        $secondaryCheck = FALSE;
        $allCheck = FALSE;
        $measurementCheck = TRUE;
      }
      //////////////////////////////////

      $genusA = array('name'=>'genus','id'=>'genus','size'=>'16','value'=>$genus);
      $speciesA = array('name'=>'species','id'=>'species','size'=>'16','value'=>$species);
      $quadratA =  array('name' =>'quadrat','id'=>'quadrat','size'=>'16','value'=>$quadrat);
      $maxXA = array('name' =>'maxX','id'=>'maxX','size'=>'16','value'=>$maxX);
      $minXA = array('name' =>'minX','id'=>'minX','size'=>'16','value'=>$minX);
      $maxYA = array('name' =>'maxY','id'=>'maxY','size'=>'16','value'=>$maxY);
      $minYA = array('name' =>'minY','id'=>'minY','size'=>'16','value'=>$minY);
      $maxDBHA = array('name' =>'maxDBH','id'=>'maxDBH','size'=>'16','value'=>$maxDBH);
      $minDBHA = array('name' =>'minDBH','id'=>'minDBH','size'=>'16','value'=>$minDBH);
      $includeDTA = array('name'=>'includeDT','id'=>'includeDT','value'=>'Yes','checked'=>$includeDTC);
      //Radio Buttons
      $mainStemA = array('name'=>'stemRadio','id'=>'stemRadio','value'=>'main','checked'=>$mainCheck);
      $secondaryStemA = array('name'=>'stemRadio','id'=>'stemRadio','value'=>'secondary','checked'=>$secondaryCheck);
      $allStemA = array('name'=>'stemRadio','id'=>'stemRadio','value'=>'all','checked'=>$allCheck);
      $measurementA = array('name'=>'stemRadio','id'=>'stemRadio','value'=>'measurement','checked'=>$measurementCheck);
      /////////
      $submitButtonA = array('name'=>'submitButton','id'=>'button','type'=>'submit','content'=>'Submit');
      $resetButtonA = array('name'=>'resetButton','id'=>'button','type'=>'reset','content'=>'Reset');

      //$plotNameA = $this->plotdatareportmodel->getPlotNames();

      $censusNumberA = $this->plotdatareportmodel->getCensusList($plotID);

      //$plotNameDD = form_dropdown('plotName',$plotNameA,$plotName);
      $censusNumberDD = form_dropdown('censusNumber',$censusNumberA,$censusNumber);
      $genusTbx = form_input($genusA);
      $speciesTbx = form_input($speciesA);
      $quadratTbx = form_input($quadratA);
      $maxXTbx = form_input($maxXA);
      $minXTbx = form_input($minXA);
      $maxYTbx = form_input($maxYA);
      $minYTbx = form_input($minYA);
      $maxDBHTbx = form_input($maxDBHA);
      $minDBHTbx = form_input($minDBHA);
      $includeDTCbx = form_checkbox($includeDTA);
      $mainStemRB = form_radio($mainStemA);
      $secondaryStemRB = form_radio($secondaryStemA);
      $allStemRB = form_radio($allStemA);
      $measurementRB = form_radio($measurementA);
      $submitButton = form_button($submitButtonA);
      $resetButton = form_button($resetButtonA);

      //$plotNameErr = form_error('plotName');
      $censusNumberErr = form_error('censusNumber');
      $genusErr = form_error('genus');
      $speciesErr = form_error('species');
      $quadratErr = form_error('quadrat');
      $maxXErr = form_error('maxX');
      $minXErr = form_error('minX');
      $maxYErr = form_error('maxY');
      $minYErr = form_error('minY');
      $maxDBHErr = form_error('maxDBH');
      $minDBHErr = form_error('minDBH');

      $formTableA = array(array(),
                         array('Plot Name<b><span style="color:#FF0000; font-size:medium;">*</span></b> : ',$plotName),
                         array('Census Number<b><span style="color:#FF0000; font-size:medium;">*</span></b> : ',$censusNumberDD,$censusNumberErr),
                         array('Genus : ',$genusTbx,$genusErr),
                         array('Species : ',$speciesTbx,$speciesErr),
                         array('Quadrat : ',$quadratTbx,$quadratErr),
                         array('Max X : ',$maxXTbx,$maxXErr),
                         array('Min X : ',$minXTbx,$minXErr),
                         array('Max Y : ',$maxYTbx,$maxYErr),
                         array('Min Y : ',$minYTbx,$minYErr),
                         array('Max DBH : ',$maxDBHTbx,$maxDBHErr),
                         array('Min DBH : ',$minDBHTbx,$minDBHErr),
                         array('Include Dead Trees :',$includeDTCbx.'YES'),
                         array($mainStemRB.'Main Stems Only',$secondaryStemRB.'Secondary Stems Only'),
                         array($allStemRB.'All Stems',$measurementRB.'All Measurements'),
                         array('<p style="text-align:center;">'.$submitButton."\t".$resetButton.'</p>')
                         );
       $this->table->set_empty("");
       $formTable = $this->table->generate($formTableA);

       return $formTable;
    }

    function _validateplotdataform()
    {
       //$this->form_validation->set_rules('plotName', 'Plot Name', 'callback_dropdown_check');
       $this->form_validation->set_rules('censusNumber', 'Census Number', 'callback_dropdown_check' );
       $this->form_validation->set_rules('genus', 'Genus', 'max_length[50]');
       $this->form_validation->set_rules('species', 'Species', 'max_length[50]');
       $this->form_validation->set_rules('quadrat', 'Quadrat', 'max_length[12]');
       $this->form_validation->set_rules('maxX', 'Maximum X Value', 'max_length[8]|numeric');
	   $this->form_validation->set_rules('minX', 'Minimum X Value', 'max_length[5]|numeric');
	   $this->form_validation->set_rules('maxY', 'Maximum Y Value', 'max_length[8]|numeric');
	   $this->form_validation->set_rules('minY', 'Minimum Y Value', 'max_length[5]|numeric');
	   $this->form_validation->set_rules('maxDBH', 'Minimum DBH Value', 'max_length[8]|numeric');
	   $this->form_validation->set_rules('minDBH', 'Minimum DBH Value', 'max_length[5]|numeric');

       $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    function dropdown_check($str)
    {
      if($str == 'default')
      {
          $this->form_validation->set_message('dropdown_check', '%s need to be Selected');
          return FALSE;
      }
      else
      {
          return True;
      }
    }

   function _viewplotdata($plotID,$censusNumber,$genus,$species,$quadrat,$maxX,$minX,$maxY,$minY,$maxDBH,$minDBH,$includeDT,$stemRadio,$offset)
   {
      global $databaseName;
      global $databaseVersion;
      //echo $censusNumber."</br>".$genus."</br>".$species."</br>".$quadrat."</br>".$maxX."</br>".$minX."</br>".$maxY."</br>".$minY."</br>".$maxDBH."</br>".$minDBH."</br>".$includeDT."</br>".$stemRadio."</br>".$offset;
      $limit = 30;

      $plotDataA['plotID'] = $plotID;
      $plotDataA['censusNumber'] = $censusNumber;
      $plotDataA['genus'] = $genus;
      $plotDataA['species'] = $species;
      $plotDataA['quadrat'] = $quadrat;
      $plotDataA['maxX'] = $maxX;
      $plotDataA['minX'] = $minX;
      $plotDataA['maxY'] = $maxY;
      $plotDataA['minY'] = $minY;
      $plotDataA['maxDBH'] = $maxDBH;
      $plotDataA['minDBH'] = $minDBH;
      $plotDataA['includeDT'] = $includeDT;
      $plotDataA['stemRadio'] = $stemRadio;
      $plotDataA['limit'] = $limit;
      $plotDataA['offset'] = $offset;

      $plotDataQuery = $this->plotdatareportmodel->GetPlotDataLimits($plotDataA);
      $plotDataCount = $plotDataQuery->num_rows();
      $plotDataResult = $plotDataQuery->result();

      if($plotDataCount > 0)
      {
        if(!isset($this->session->userdata[$databaseName.'totalPlotDataRowCount']))
        {
          $totalQuery = $this->plotdatareportmodel->GetPlotData($plotDataA);
          $countall = $totalQuery->num_rows();
          $this->session->set_userdata($databaseName.'totalPlotDataRowCount',$countall);
        }
        else
        {
          $countall = $this->session->userdata($databaseName.'totalPlotDataRowCount');
        }

        //offset - starting point for the current page
  		$uri_segment = 3;
  		$offset = $this->uri->segment($uri_segment);


  		//generate pagination
  		$config['base_url'] = site_url('plotdatareport/plotdataform');
  		$config['total_rows'] = $countall;
  		$config['per_page'] = $limit;
  		$config['uri_segment'] = $uri_segment;
        if($countall > 0 AND $limit > 0)
        {
         $pageCount = $countall / $limit;
         $pageCount = ceil($pageCount);
         $config['last_link'] = "Last(".$pageCount.")>";
        }
  		$this->pagination->initialize($config);
  		$dataTable['pagination'] = $this->pagination->create_links();

  		//generate table data
  		$this->table->set_empty("&nbsp;");
        if($databaseVersion == 'new')
        {
           $this->table->set_heading('No.', 'Latin', 'SubSpecies', 'Quadrat', 'PX', 'PY', 'TreeID','Tag', 'StemID', 'StemTag', 'Census','DBH','HOM','Date','Codes','Stem','Status');
        }
        else
        {
           $this->table->set_heading('No.', 'Latin', 'SubSpecies','Quadrat', 'gx', 'gy', 'TreeID','Tag', 'StemID', 'StemTag', 'Census','DBH','HOM','Date','Codes','Stem','Status');
        }
          $i = 0 + $offset;
          foreach($plotDataResult as $plotDataRow)
          {
            if($databaseVersion == 'new')
            {
               $this->table->add_row(++$i, $plotDataRow->Latin, $plotDataRow->SubSpecies, $plotDataRow->Quadrat, $plotDataRow->PX, $plotDataRow->PY, $plotDataRow->TreeID, $plotDataRow->Tag, $plotDataRow->StemID, $plotDataRow->StemTag, $plotDataRow->Census, $plotDataRow->DBH, $plotDataRow->HOM, $plotDataRow->Date, $plotDataRow->Codes, $plotDataRow->Stem, $plotDataRow->Status);
            }
            else
            {
               $this->table->add_row(++$i, $plotDataRow->Latin, $plotDataRow->SubSpecies, $plotDataRow->Quadrat, $plotDataRow->gx, $plotDataRow->gy, $plotDataRow->TreeID, $plotDataRow->Tag, $plotDataRow->StemID, $plotDataRow->StemTag, $plotDataRow->Census, $plotDataRow->DBH, $plotDataRow->HOM, $plotDataRow->Date, $plotDataRow->Codes, $plotDataRow->Stem, $plotDataRow->Status);
            }
          }

          $dataTable['table'] = $this->table->generate();
          $dataTable['downloadcsv'] = anchor('plotdatareport/downloadcsv', 'Download Data to File', array('class'=>'download'));
          $dataTable['tsmcodeLink'] =  anchor('plotdatareport/tsmcode', 'TSM Codes', array('class'=>'view', 'target'=>"_blank"));

        }
        else
        {
          $dataTable['table'] = "<h2>No Record Found!!</h2>";
          $dataTable['downloadcsv'] = "";
          $dataTable['pagination'] = "";
          $dataTable['tsmcodeLink'] = "";
          $countall = "0";
        }
        $dataTable['title'] = 'CTFS/SIGEO Forest Plot Census Data';
        //$plotName = $this->session->userdata('initialPlot');
        $plotID = $this->session->userdata($databaseName.'selectPlot');
        $plotName = $this->plotdatareportmodel->getPlotNameByID($plotID);
        $dataTable['contentTitle'] = 'Plot Data Report - '.$plotName."<h5 align=right>Total Records: ".$countall."</h5>";
        $dataTable['backLink'] = anchor('/plotdatareport/plotdata', 'Back', array('title'=>'Back to View Form', 'class'=>'back'));


		// load view
		$this->load->view('user/plotdata', $dataTable);
   }

   function downloadcsv()
   {
      error_reporting(E_ALL ^ E_WARNING); 
      global $databaseName;
      global $databaseVersion;

      $plotDataA = $this->session->userdata($databaseName.'plotReport');
      /*$plotDataA['censusNumber'] = $plotReportArray['censusNumber'];
      $plotDataA['genus'] = $plotReportArray['genus'];
      $plotDataA['species'] = $plotReportArray['species'];
      $plotDataA['quadrat'] = $plotReportArray['quadrat'];
      $plotDataA['maxX'] = $plotReportArray['maxX'];
      $plotDataA['minX'] = $plotReportArray['minX'];
      $plotDataA['maxY'] = $plotReportArray['maxY'];
      $plotDataA['minY'] = $plotReportArray['minY'];
      $plotDataA['maxDBH'] = $plotReportArray['maxDBH'];
      $plotDataA['minDBH'] = $plotReportArray['minDBH'];
      $plotDataA['includeDT'] = $plotReportArray['includeDT'];
      $plotDataA['stemRadio'] = $plotReportArray['stemRadio'];*/

      $this->load->helper('date');
      $datestring = "%m-%d-%Y";
      $date = mdate($datestring);
      $random = rand();
      $filename = join('',array('PlotDataReport',$date,'_',$random));

      $plotDataQuery = $this->plotdatareportmodel->GetPlotData($plotDataA);
      $plotDataResult = $plotDataQuery->result();

      $this->load->helper('file');
      $i = 0;
      //$x = 0;
      if($databaseVersion == 'new')
      {
        $dataJoin = join("\t", array('No.', 'Latin', 'SubSpecies', 'Quadrat', 'PX', 'PY', 'TreeID','Tag', 'StemID', 'StemTag', 'Census','DBH','HOM','Date','Codes','Stem','Status'));
        write_file('./download/'.$filename.'.txt', $dataJoin,'a');
        $nextline = "\r\n";
        write_file('./download/'.$filename.'.txt', $nextline,'a');
      }
      else
      {
        $dataJoin = join("\t", array('No.', 'Latin', 'SubSpecies', 'Quadrat', 'gx', 'gy', 'TreeID','Tag', 'StemID', 'StemTag', 'Census','DBH','HOM','Date','Codes','Stem','Status'));
        write_file('./download/'.$filename.'.txt', $dataJoin,'a');
        $nextline = "\r\n";
        write_file('./download/'.$filename.'.txt', $nextline,'a');
      }
      foreach($plotDataResult as $plotDataRow)
      {
        if($databaseVersion == 'new')
        {
          $dataJoin = join("\t",array(++$i, $plotDataRow->Latin, $plotDataRow->SubSpecies, $plotDataRow->Quadrat, $plotDataRow->PX, $plotDataRow->PY, $plotDataRow->TreeID, $plotDataRow->Tag, $plotDataRow->StemID, $plotDataRow->StemTag, $plotDataRow->Census, $plotDataRow->DBH, $plotDataRow->HOM, $plotDataRow->Date, $plotDataRow->Codes, $plotDataRow->Stem, $plotDataRow->Status));
          write_file('./download/'.$filename.'.txt', $dataJoin,'a');
          $nextline = "\r\n";
          write_file('./download/'.$filename.'.txt', $nextline,'a');
        }
        else
        {
          $dataJoin = join("\t",array(++$i, $plotDataRow->Latin, $plotDataRow->SubSpecies, $plotDataRow->Quadrat, $plotDataRow->gx, $plotDataRow->gy, $plotDataRow->TreeID, $plotDataRow->Tag, $plotDataRow->StemID, $plotDataRow->StemTag, $plotDataRow->Census, $plotDataRow->DBH, $plotDataRow->HOM, $plotDataRow->Date, $plotDataRow->Codes, $plotDataRow->Stem, $plotDataRow->Status));
          write_file('./download/'.$filename.'.txt', $dataJoin,'a');
          $nextline = "\r\n";
          write_file('./download/'.$filename.'.txt', $nextline,'a');
        }
      }
      //$dataArray = join("\r\n",$dataJoin);

     /* $this->load->helper('file');
      if (! write_file('./download/'.$filename.'.txt', $dataArray))
      {
        echo 'Unable to write the file';
      }
      else
      {*/
        /*$this->load->helper('download');
        $dataGet = file_get_contents("./download/".$filename.".txt"); // Read the file's contents
        force_download($filename.'.txt', $dataGet);*/
      //}
      //////////Download as Zip File///////////
      $this->load->library('zip');
      $filePath = "./download/".$filename.".txt";

      $this->zip->read_file($filePath);

      unlink($filePath); //Delete the Txt file created

      // Download the file to your desktop
      $this->zip->download($filename.'.zip');
      ////////////////////////////////



      /*header('Content-Type: text/plain');
      header('Content-Disposition: attachment;filename='.$filename.'.txt');
      $fp=fopen("./download/".$filename.".txt",'r');
      fpassthru($fp);
      fclose($fp);*/
   }

   function tsmcode()
   {
     $tsmQuery = $this->plotdatareportmodel->getTsmCode();

     if($tsmQuery->num_rows() > 0)
     {
       $tsmResult = $tsmQuery->result();
     	//generate table data
  		$this->table->set_empty("&nbsp;");

        $this->table->set_heading('TSMCode', 'Description');

        foreach($tsmResult as $tsmRow)
        {
          $this->table->add_row($tsmRow->TSMCode, $tsmRow->Description);
        }

        $dataTable['table'] = $this->table->generate();

     }
     else
     {
       $dataTable['table'] = "<h2>No Code Found!!</h2>";
     }
      $dataTable['title'] = 'CTFS/SIGEO Forest Plot Census Data';
      //$plotName = $this->session->userdata('initialPlot');
      //$plotID = $this->session->userdata($databaseName.'selectPlot');
      //$plotName = $this->plotdatareportmodel->getPlotNameByID($plotID);
      $dataTable['contentTitle'] = 'Legend for Codes';
      //$dataTable['backLink'] = anchor('/plotdatareport/plotdata', 'Back', array('title'=>'Back to View Form', 'class'=>'back'));


      // load view
      $this->load->view('user/tsmcode', $dataTable);

   }
}