<?php

class Postscreening extends Controller{

    function Postscreening()
    {
      parent::Controller();
      if($this->session->userdata('loggedin') !== '1')
      {
        redirect('main','location');
      }
      $this->load->model('postscreeningmodel');
      global $databaseName;
      $databaseName = $this->session->userdata('databaseName');

      set_time_limit(0);
      ini_set('memory_limit', '-1');
      ini_set('max_execution_time', 600);
    }

    function screen()
    {
      $plotCensusArray = $this->session->userdata('plotCensusArray');
      $plotID = $plotCensusArray['plotName'];
      $censusNumber = $plotCensusArray['censusNumber'];
      $plotActualName = $plotCensusArray['plotActualName'];

      $html = "";

//Site Information
      //Check to see if the Site table has missing information: Shape, Area, QDimX, QdimY. Join with the Coordinates table and make sure that there are global (GX and GY) coordinates for the plot.
       $siteQuery = $this->postscreeningmodel->checkSiteInfo();
       $html = $html.'<center><h3>Site Information</h3></center>
                      <table border = "1" align = "center">
                      <tr><th>PlotID</th>  <th>PlotName</th>  <th>ShapeOfSite</th>  <th>Area</th>  <th>QDimX</th>  <th>QDimY</th>  <th>GX</th>  <th>GY</th></tr>';
       foreach($siteQuery->result() as $siteRow)
       {
         $html = $html."<tr><td>".$siteRow->PlotID."</td><td>".$this->markEmpty($siteRow->PlotName)."</td><td>".$this->markEmpty($siteRow->ShapeOfSite)."</td><td>".$this->markEmptyZero($siteRow->Area)."</td><td>".$this->markEmptyZero($siteRow->QDimX)."</td><td>".$this->markEmptyZero($siteRow->QDimY)."</td><td>".$this->markEmpty($siteRow->GX)."</td><td>".$this->markEmpty($siteRow->GY)."</td></tr>";
       }
       $html = $html."</table></br>";
       $siteQuery->free_result();    //free the memory associated with query


//Quadrats Per Census
       //Check whether the number of quadrats per census per plot look fine
       $quadratQuery1 = $this->postscreeningmodel->quadratPerCensus();
       $quadratQuery2 = $this->postscreeningmodel->quadratPerPlot();
       foreach($quadratQuery2->result() as $quadratRow2)
       {
         $totalCountArray[$quadratRow2->PlotID] = $quadratRow2->QuadratCount;
       }
       $html = $html.'<center><h3>Quadrat Per Census</h3></center>
                      <table border = "1" align = "center">
                      <tr><th>PlotID</th>  <th>PlotName</th>  <th>CensusNumber</th>  <th>QuadratCount</th>  <th>TotalQuadrats</th></tr>';
       foreach($quadratQuery1->result() as $quadratRow1)
       {
         $plotID = $quadratRow1->PlotID;
         $quadratCount = $quadratRow1->QuadratCount;
         $totalCount = $totalCountArray[$plotID];
         if($quadratCount !== $totalCount)
         {
           $quadratCount = $this->markRed($quadratCount);
         }

         $html = $html."<tr><td>".$plotID."</td><td>".$quadratRow1->PlotName."</td><td>".$this->markEmpty($quadratRow1->PlotCensusNumber)."</td><td>".$quadratCount."</td><td>".$this->markEmptyZero($totalCount)."</td></tr>";
       }
       $html = $html."</table></br>";
       $quadratQuery1->free_result();    //free the memory associated with query
       $quadratQuery2->free_result();    //free the memory associated with query


//Trees Per Quadrat
       //Check the range (minimum and maximum) of number of trees per quadrat
       $quadratQuery = $this->postscreeningmodel->treesPerQuadrat();
       $html = $html.'<center><h3>Trees Per Quadrat</h3></center>
                      <table border = "1" align = "center">
                      <tr><th>PlotID</th>  <th>PlotName</th>  <th>Minimum No. Of Trees</th>  <th>Maximum No. Of Trees</th>  <th>Total No. Of Quadrats</th></tr>';
       foreach($quadratQuery->result() as $quadratRow)
       {
         $html = $html."<tr><td>".$quadratRow->PlotID."</td><td>".$quadratRow->PlotName."</td><td>".$quadratRow->MinTreeCount."</td><td>".$quadratRow->MaxTreeCount."</td><td>".$this->markEmptyZero($quadratRow->TotalCount)."</td></tr>";
       }
       $html = $html."</table></br>";
       $quadratQuery->free_result();    //free the memory associated with query


//Check TSM Codes
       //Display list of the TSMAttributes  user should check whether the dead, lost_stem and main codes exist. Count number of records with codes main, dead and stem lost.
       $tsmQuery1 = $this->postscreeningmodel->getTSMCodes();
       $html = $html."<center><h3>TSM Code - Main, Dead and Stem Lost</h3></center>";
       if($tsmQuery1->num_rows == 0)     // No records found
       {
         $html = $html.'<table border = "1">
                        <tr><td><span style="color:#FF3300;">No records in TSMAttributes with codes = Main, Dead, or Stem Lost</span></td></tr>
                        </table></br>';
       }
       else
       {
         $html = $html.'<table border = "1" align = "center">
                        <tr><th>TSMID</th>  <th>TSMCode</th>  <th>Description</th></tr>';
         foreach($tsmQuery1->result() as $tsmRow1)
         {
           $html = $html."<tr><td>".$tsmRow1->TSMID."</td><td>".$tsmRow1->TSMCode."</td><td>".$tsmRow1->Description."</td></tr>";
         }
         $html = $html."</table></br>";

         $tsmQuery2 = $this->postscreeningmodel->tsmRecords();

         $html = $html.'<center><h3>Records with codes "main", "dead" and "stem lost"</h3></center><table border = "1" align = "center">
                        <tr><th>TSMCode</th>  <th>Description</th>  <th>PlotID</th>  <th>PlotName</th>  <th>CensusNumber</th>  <th>No. Of Records</th></tr>';
         foreach($tsmQuery2->result() as $tsmRow2)
         {
            $html = $html."<tr><td>".$tsmRow2->TSMCode."</td><td>".$tsmRow2->Description."</td><td>".$tsmRow2->PlotID."</td><td>".$tsmRow2->PlotName."</td><td>".$tsmRow2->PlotCensusNumber."</td><td>".$tsmRow2->RecordCount."</td></tr>";
         }
         $html = $html."</table></br>";
         $tsmQuery2->free_result();    //free the memory associated with query
       }
       $tsmQuery1->free_result();    //free the memory associated with query


//Missing or Duplicate Species Code
      //Check to see if there are any missing or duplicate species codes.
       $speciesQuery1 = $this->postscreeningmodel->duplicateMnemonic();
       $html = $html."<center><h3>Duplicate Species Code</h3></center>";
       if($speciesQuery1->num_rows == 0)     // No records found
       {
         $html = $html.'<table border = "1" align = "center">
                        <tr><td><span style="color:#73943D;">All Species Codes are unique.</span></td></tr>
                        </table></br>';
       }
       else
       {
         $html = $html.'<table border = "1" align = "center">
                        <tr><th>Species Code</th>  <th>Records</th></tr>';
         foreach($speciesQuery1->result() as $speciesRow1)
         {
           $html = $html."<tr><td>".$speciesRow1->Mnemonic."</td><td>".$speciesRow1->RecordCount."</td><tr>";
         }
         $html = $html."</table></br>";
       }
       $speciesQuery1->free_result();

       $speciesQuery2 = $this->postscreeningmodel->missingMnemonic();
       $speciesRow2 = $speciesQuery2->row();
       $recordCount = $speciesRow2->RecordCount;
       if($recordCount == 0)
       {
         $msg =  '<span style="color:#73943D;">No missing Species Code.</span>';
       }
       else
       {
         $msg =  '<span style="color:#FF3300;">No. of records with missing Species Code: '.$recordCount.'</span>';
       }
       $html = $html.'<center><h3>Missing Species Code</h3></center>';
       $html = $html.'<table border = "1" align = "center">
                      <tr><td>'.$msg.'</td></tr>
                      </table></br>';
       $speciesQuery2->free_result();

//Species ID Level
       //Check to see if the species id levels are correctly assigned
       $levelQuery = $this->postscreeningmodel->idLevel();
       $html = $html.'<center><h3>Species ID Levels</h3></center>
                      <table border = "1" align = "center">
                      <tr><th>ID Level</th>  <th>No. of Records</th></tr>';
       foreach($levelQuery->result() as $levelRow)
       {
         $html = $html."<tr><td>".$levelRow->IDLevel."</td><td>".$levelRow->RecordCount."</td></tr>";
       }
       $html = $html."</table></br>";
       $levelQuery->free_result();    //free the memory associated with query


//Missing Authority
       //Check to see if there are any missing authorities from the Species table
       $authQuery = $this->postscreeningmodel->missingAuthority();
       $authRow = $authQuery->row();
       $recordCount = $authRow->RecordCount;
       if($recordCount == 0)
       {
         $msg =  '<span style="color:#73943D;">No missing Authorities in Species Table.</span>';
       }
       else
       {
         $msg =  '<span style="color:#FF3300;">No. of records with missing Authority in Species Table: '.$recordCount.'</span>';
       }
       $html = $html."<center><h3>Missing Authority for Species</h3></center>";
       $html = $html.'<table border = "1" align = "center">
                      <tr><td>'.$msg.'</td></tr>
                      </table></br>';
       $authQuery->free_result();

//Check Tree Coordinates
       //List the minimum and maximum QX, QY, PX and PY coordinates per plot. They should not go over the limits of the dimension of the quadrat and plot. Make a note if any of the coordinates go over QDimX or QDimY from the Site table
       $treeQuery = $this->postscreeningmodel->treeCoordinates();
       $html = $html.'<center><h3>Trees Coordinates</h3></center>
                      <table border = "1" align = "center">
                      <tr><th>PlotID</th>  <th>PlotName</th>  <th>QDimX</th>  <th>QDimY</th>  <th>Minimum PX</th>  <th>Minimum PY</th>  <th>Maximum PX</th>  <th>Maximum PY</th>  <th>Minimum QX</th>  <th>Minimum QY</th>  <th>Maximum QX</th>  <th>Maximum QY</th></tr>';
       foreach($treeQuery->result() as $treeRow)
       {
         $siteQDimX = $treeRow->QDimX;
         $siteQDimY = $treeRow->QDimY;
         $maxQX = $treeRow->MaxQX;
         $maxQY = $treeRow->MaxQY;
         if($maxQX > $siteQDimX)
         {
           $maxQX = $this->markRed($maxQX);
         }
         if($maxQY > $siteQDimY)
         {
           $maxQY = $this->markRed($maxQY);
         }
         $html = $html."<tr><td>".$treeRow->PlotID."</td><td>".$treeRow->PlotName."</td><td>".$this->markEmptyZero($siteQDimX)."</td><td>".$this->markEmptyZero($siteQDimY)."</td><td>".$treeRow->MinPX."</td><td>".$treeRow->MinPY."</td><td>".$treeRow->MaxPX."</td><td>".$treeRow->MaxPY."</td><td>".$treeRow->MinQX."</td><td>".$treeRow->MinQY."</td><td>".$maxQX."</td><td>".$maxQY."</td></tr>";
       }
       $html = $html."</table></br>";
       $treeQuery->free_result();    //free the memory associated with query

//Check unique Stem Tags
       //Check to see that all stem tags are unique (stem tags may be a combination of tree and stemtag to be unique). Make a note if there are any duplicate stemtags (put a red asterisk beside table?)
       $stemQuery = $this->postscreeningmodel->uniqueStemTag();
       $rowCount = $stemQuery->num_rows();
       $html = $html."<center><h3>Duplicate Stem Tags</h3></center>";
       if($rowCount == 0)
       {
         $html = $html.'<table border = "1" align = "center">
                      <tr><td><span style="color:#73943D;">No duplicate Stem Tags.</span></td></tr>
                      </table></br>';
       }
       elseif($rowCount > 100)
       {
         $msg =  '<span style="color:#FF3300;">No. of records with duplicate Stem Tags(Not listed if > 100): '.$rowCount.'</span>';
         $html = $html.'<table border = "1" align = "center">
                      <tr><td><span style="color:#FF3300;">No. of records with duplicate Stem Tags(Not listed if > 100): '.$rowCount.'</span></td></tr>
                      </table></br>';
       }
       else
       {
         $html = $html.'<table border = "1" align = "center">
                        <tr><th>PlotID</th>  <th>PlotName</th>  <th>TreeID</th>  <th>TreeTag</th>  <th>StemTag</th>  <th>Duplicate Count</th></tr>';
         foreach($stemQuery->result() as $stemRow)
         {
            $html = $html."<tr><td>".$stemRow->PlotID."</td><td>".$stemRow->PlotName."</td><td>".$stemRow->TreeID."</td><td>".$stemRow->TreeTag."</td><td>".$stemRow->StemTag."</td><td>".$stemRow->DplCnt."</td></tr>";
         }
         $html = $html."</table></br>";
         $stemQuery->free_result();    //free the memory associated with query
       }

//Stem per tree
       //Count number of stems per tree to make sure that it isnt too high.
       $stemCountQuery = $this->postscreeningmodel->stemCount();
       $stemCountRow = $stemCountQuery->row();
       $html = $html.'<center><h3>Stem Count for Trees</h3></center>
                      <table border = "1" align = "center">
                      <tr><th>Minimum Stem Count</th>  <th>Maximum Stem Count</th>  <th>Total Trees</th></tr>
                      <tr><td>'.$stemCountRow->MinSC.'</td><td>'.$stemCountRow->MaxSC.'</td><td>'.$stemCountRow->TotalCount.'</td></tr>
                      </table></br>';
       $stemCountQuery->free_result();

//Check Dates
      //Check the range of ExactDate in the DBH table. Mark any of the missing dates

       $dateQuery = $this->postscreeningmodel->checkDateRange();
       $html = $html.'<center><h3>Date Range From DBH</h3></center>
                      <table border = "1" align = "center">
                      <tr><th>CensusID</th>  <th>Minimum Date</th>  <th>Maximum Data</th></tr>';
       foreach($dateQuery->result() as $dateRow)
       {
         $minDate = $dateRow->min;
         $maxDate = $dateRow->max;
         if($minDate == '0000-00-00')
         {
           $minDate = $this->markRed($minDate);
         }
         if($maxDate == '0000-00-00')
         {
           $maxDate = $this->markRed($maxDate);
         }
         $html = $html."<tr><td>".$dateRow->CensusID."</td><td>".$minDate."</td><td>".$maxDate."</td></tr>";
       }
       $html = $html."</table></br>";
       $dateQuery->free_result();    //free the memory associated with query

//Unique DBH measurement for each stem per census.
       //Check that there should only be one dbh measurement for each stem for each tree for each census for each hom. Make a note if there are more than one dbh per stem per tree per census per hom
       $dbhQuery = $this->postscreeningmodel->uniqueDBH();
       $html = $html."<center><h3>Unique DBH Measurement per Census</h3></center>";
       if($dbhQuery->num_rows == 0)     // No records found
       {
         $html = $html.'<table border = "1" align = "center">
                        <tr><td><span style="color:#73943D;">All DBH measurements are unique for each stem per census.</span></td></tr>
                        </table></br>';
       }
       else
       {
         $html = $html.'<table border = "1" align = "center">
                        <tr><th>CensusID</th>  <th>StemID</th>  <th>HOM</th>  <th>No. Of Records</th></tr>';
         foreach($dbhQuery->result() as $dbhRow)
         {
           $html = $html."<tr><td>".$dbhRow->CensusID."</td><td>".$dbhRow->StemID."</td><td>".$dbhRow->HOM."</td><td>".$dbhRow->RecordCount."</td></tr>";
         }
         $html = $html."</table></br>";
       }
       $dbhQuery->free_result();    //free the memory associated with query

//Minimum and Maximum DBH
       //Check the minimum and maximum dbh per species. Errors include a dbh that is too large for certain species.
       $maxDBHQuery = $this->postscreeningmodel->dbhSpecies();
       $html = $html.'<center><h3>Maximum and Minimum DBH Per Species</h3></center>
                      <table border = "1" align = "center">
                      <tr><th>SpeciesID</th>  <th>Species Code</th>  <th>Genus</th>  <th>Species</th>  <th>Minimum DBH</th>  <th>Maximum DBH</th>  <th>No. Of Records</th></tr>';
       foreach($maxDBHQuery->result() as $maxDBHRow)
       {
          $html = $html."<tr><td>".$maxDBHRow->SpeciesID."</td><td>".$maxDBHRow->Mnemonic."</td><td>".$maxDBHRow->Genus."</td><td>".$maxDBHRow->SpeciesName."</td><td>".$maxDBHRow->MinDBH."</td><td>".$maxDBHRow->MaxDBH."</td><td>".$maxDBHRow->RecordCount."</td></tr>";
       }
       $html = $html."</table></br>";
       $maxDBHQuery->free_result();     //free the memory associated with query

//HOM Range
       //Check range of hom.
       $homQuery = $this->postscreeningmodel->homRange();
       $html = $html.'<center><h3>HOM Range</h3></center>
                      <table border = "1" align = "center">
                      <tr><th>PlotID</th>  <th>Plot</th>  <th>CensusID</th>  <th>Census Number</th>  <th>Minimum HOM</th>  <th>Maximum HOM</th></tr>';
       foreach($homQuery->result() as $homRow)
       {
          $html = $html."<tr><td>".$homRow->PlotID."</td><td>".$homRow->PlotName."</td><td>".$homRow->CensusID."</td><td>".$homRow->PlotCensusNumber."</td><td>".$homRow->MinHOM."</td><td>".$homRow->MaxHOM."</td></tr>";
       }
       $html = $html."</table></br>";
       $homQuery->free_result();     //free the memory associated with query

//DBH Range and Number of TSM Code
       //Check dbh range and number of records for each TSM code.
       $tsmQuery = $this->postscreeningmodel->tsmDBHRange();
       $html = $html.'<center><h3>TSM Codes</h3></center>
                      <table border = "1" align = "center">
                      <tr><th>CensusID</th>  <th>Census Number</th>  <th>Plot</th>  <th>TSMCode</th>  <th>Description</th>  <th>Minimum DBH</th> <th>Maximum DBH</th> <th>No. Of Records</th></tr>';
       foreach($tsmQuery->result() as $tsmRow)
       {
          $html = $html."<tr><td>".$tsmRow->CensusID."</td><td>".$tsmRow->PlotCensusNumber."</td><td>".$tsmRow->PlotName."</td><td>".$tsmRow->TSMCode."</td><td>".$tsmRow->TSMDesc."</td><td>".$tsmRow->MinDBH."</td><td>".$tsmRow->MaxDBH."</td><td>".$tsmRow->RecordCount."</td></tr>";
       }
       $html = $html."</table></br>";
       $tsmQuery->free_result();

//One Main Stem
       //Check that there is only one main stem per tree.
       $mainStemQuery = $this->postscreeningmodel->mainStem();
       $html = $html."<center><h3>One Main Stem Per Tree</h3></center>";
       if($mainStemQuery->num_rows == 0)     // No records found
       {
         $html = $html.'<table border = "1" align = "center">
                        <tr><td><span style="color:#73943D;">All Trees Have Only One Main Stem.</span></td></tr>
                        </table></br>';
       }
       else
       {
         $html = $html.'<table border = "1" align = "center">
                        <tr><th>CensusID</th>  <th>Census Number</th>  <th>Tree Tag</th>  <th>HOM</th>  <th>No. Of Records</th></tr>';
         foreach($mainStemQuery->result() as $mainStemRow)
         {
           $html = $html."<tr><td>".$mainStemRow->CensusID."</td><td>".$mainStemRow->PlotCensusNumber."</td><td>".$mainStemRow->Tag."</td><td>".$mainStemRow->HOM."</td><td>".$mainStemRow->RecordCount."</td><tr>";
         }
         $html = $html."</table></br>";
       }
       $mainStemQuery->free_result();

//Status
       //Check number of records per status from the ViewFullTable table
       $statusQuery = $this->postscreeningmodel->statusCount();
       $html = $html.'<center><h3>Status Count</h3></center>
                      <table border = "1" align = "center">
                      <tr><th>CensusID</th>  <th>Census Number</th>  <th>Plot</th>  <th>Status</th>  <th>No. Of Records</th></tr>';
       foreach($statusQuery->result() as $statusRow)
       {
          $html = $html."<tr><td>".$statusRow->CensusID."</td><td>".$statusRow->PlotCensusNumber."</td><td>".$statusRow->Plot."</td><td>".$statusRow->Status."</td><td>".$statusRow->RecordCount."</td></tr>";
       }
       $html = $html."</table></br>";
       $statusQuery->free_result();

//Tree Both Dead and Alive in a Census
       //Check to see if any tree has both a dead and alive status in one census.
       $treeStatusQuery = $this->postscreeningmodel->treeStatus();
       $html = $html."<center><h3>Trees Both Dead and Alive in a Census</h3></center>";
       if($treeStatusQuery->num_rows == 0)     // No records found
       {
         $html = $html.'<table border = "1" align = "center">
                        <tr><td><span style="color:#73943D;">No tree has both dead and alive status in one census.</span></td></tr>
                        </table></br>';
       }
       else
       {
         $html = $html.'<table border = "1" align = "center">
                        <tr><th>CensusID</th>  <th>Census Number</th>  <th>Plot</th>  <th>TreeID</th>  <th>No. Of Records</th></tr>';
         foreach($treeStatusQuery->result() as $treeStatusRow)
         {
           $html = $html."<tr><td>".$treeStatusRow->CensusID."</td><td>".$treeStatusRow->PlotCensusNumber."</td><td>".$treeStatusRow->Plot."</td><td>".$treeStatusRow->TreeID."</td><td>".$treeStatusRow->RecordCount."</td><tr>";
         }
         $html = $html."</table></br>";
       }
       $treeStatusQuery->free_result();

//Dead Stem In First Census
       //Check to see if there are any dead stems in the first census (according to the standard methodology there shouldnt be any).
       $deadQuery = $this->postscreeningmodel->deadFirst();
       $deadRow = $deadQuery->row();
       $recordCount = $deadRow->RecordCount;
       if($recordCount == 0)
       {
         $msg =  '<span style="color:#73943D;">No dead stems in first census.</span>';
       }
       else
       {
         $msg =  '<span style="color:#FF3300;">No. of dead stems in first census: '.$recordCount.'</span>';
       }
       $html = $html."<center><h3>Tree Dead in First Census</h3></center>";
       $html = $html.'<table border = "1" align = "center">
                      <tr><td>'.$msg.'</td></tr>
                      </table></br>';
       $deadQuery->free_result();


//For the site/plots with more than one census
       $plotListQuery = $this->postscreeningmodel->plotList();
       if($plotListQuery->num_rows() > 0)
       {
//------For each census, count the number of stems that are not accounted for in the next census.  - Table1
//------For each recensus, count the number of recruits - Table2
//------For each census, check how many stems changed from dead in one census to alive in the next census  - Table3
          $table1 = '<center><h3>Stems not accounted for in the Next Census</h3></center>
                     <table border = "1" align = "center">
                     <tr><th>PlotID</th>  <th>Plot</th>  <th>Census1</th>  <th>Census2</th>  <th>No. of trees not in Census2</th></tr>';
          $table2 = '<center><h3>Stems newly recruited</h3></center>
                     <table border = "1" align = "center">
                     <tr><th>PlotID</th>  <th>Plot</th>  <th>Census1</th>  <th>Census2</th>  <th>No. of new recruits</th></tr>';
          $table3 = '<center><h3>Stems changed from dead in one to alive in the Next Census</h3></center>
                     <table border = "1" align = "center">
                     <tr><th>PlotID</th>  <th>Plot</th>  <th>Census1</th>  <th>Census2</th>  <th>No. of Records</th></tr>';
          foreach($plotListQuery->result() as $plotListRow)
          {
            $plotID = $plotListRow->PlotID;
            $censusIDListQuery = $this->postscreeningmodel->censusIDList($plotID);
            $recordCount = $censusIDListQuery->num_rows();
            $i=0;
            foreach($censusIDListQuery->result() as $censusIDListRow)
            {
              $i++;
              $censusID[$i] = $censusIDListRow->CensusID;
              $plotCensusNumber[$i] = $censusIDListRow->PlotCensusNumber;
              $plotName = $censusIDListRow->PlotName;
            }
            for($x=1;$x<$i;$x++)
            {
              $currentCensus = $censusID[$x];
              $currentPlotCensusNumber = $plotCensusNumber[$x];
              $nextCensus = $censusID[$x+1];
              $nextPlotCensusNumber = $plotCensusNumber[$x+1];

              $diffQuery1 = $this->postscreeningmodel->diffCount($currentCensus,$nextCensus); // Count no. of trees not accounted in next census
              $diffRow1 = $diffQuery1->row();
              $diffCount1 = $diffRow1->RecordCount;
              $table1 = $table1."<tr><td>".$plotID."</td><td>".$plotName."</td><td>".$currentPlotCensusNumber."</td><td>".$nextPlotCensusNumber."</td><td>".$diffCount1."</td><tr>";

              $diffQuery2 = $this->postscreeningmodel->recruitCount($nextCensus,$currentCensus); // Count no. of new recruits
              $diffRow2 = $diffQuery2->row();
              $diffCount2 = $diffRow2->RecordCount;
              $table2 = $table2."<tr><td>".$plotID."</td><td>".$plotName."</td><td>".$currentPlotCensusNumber."</td><td>".$nextPlotCensusNumber."</td><td>".$diffCount2."</td><tr>";

              $diffQuery3 = $this->postscreeningmodel->diffStatusCount($currentCensus,$nextCensus); // Count no. of stems changed from dead in one census to alive in the next census
              if($diffQuery3->num_rows() == 0)
              {
                $diffCount3 = 0;
              }
              else
              {
                $diffRow3 = $diffQuery3->row();
                $diffCount3 = $diffRow3->RecordCount;
              }
              $table3 = $table3."<tr><td>".$plotID."</td><td>".$plotName."</td><td>".$currentPlotCensusNumber."</td><td>".$nextPlotCensusNumber."</td><td>".$diffCount3."</td><tr>";
            }
          }
          $table1 = $table1."</table></br>";
          $table2 = $table2."</table></br>";
          $table3 = $table3."</table></br>";
          $html = $html.$table1.$table2.$table3;
          $censusIDListQuery->free_result();

//------List trees with extreme growth rates: growth rate too large - stems where absolute annual growth >65 mm, growth rate too negative - annual relative growth <= -0.05 in stems where previous dbh>=50mm.
          $censusTable1 = 'TempPSCensus1';
          $censusTable2 = 'TempPSCensus2';
          $this->postscreeningmodel->createTempTable($censusTable1);      // Create temp post screening table
          $this->postscreeningmodel->createTempTable($censusTable2);
          foreach($plotListQuery->result() as $plotListRow)
          {
            $plotID = $plotListRow->PlotID;
            $censusIDListQuery = $this->postscreeningmodel->censusIDList($plotID);
            $recordCount = $censusIDListQuery->num_rows();
            $i=0;
            foreach($censusIDListQuery->result() as $censusIDListRow)
            {
              $i++;
              $censusID[$i] = $censusIDListRow->CensusID;
              $plotCensusNumber[$i] = $censusIDListRow->PlotCensusNumber;
              $plotName = $censusIDListRow->PlotName;
            }
            for($x=1;$x<$i;$x++)
            {
              $currentCensus = $censusID[$x];
              $currentPlotCensusNumber = $plotCensusNumber[$x];
              $nextCensus = $censusID[$x+1];
              $nextPlotCensusNumber = $plotCensusNumber[$x+1];

              $this->postscreeningmodel->deleteData($censusTable1);
              $this->postscreeningmodel->deleteData($censusTable2);
              $this->postscreeningmodel->insertCensusData1($censusTable1, $currentCensus, $nextCensus);
              $this->postscreeningmodel->insertCensusData2($censusTable2, $currentCensus, $nextCensus);

              //Grew too much
              $grewQuery = $this->postscreeningmodel->grewMuch($censusTable1,$censusTable2);
              $grewQueryCount = $grewQuery->num_rows();
              if($grewQueryCount > 0)
              {
                 $html = $html.'<center><h3>No. of records with growth rates that increased more than 65 mm per year for '.$plotName.' from Census '.$currentPlotCensusNumber.' to '.$nextPlotCensusNumber.' : '.$grewQueryCount.'</h3></center>
                                <table border = "1" align = "center">
                                <tr><th>Plot</th><th>Species</th><th>Tag</th><th>StemID</th><th>StemTag</th><th>PrimaryStem</th><th>Census1</th><th>DBH1</th><th>HOM1</th><th>Codes1</th><th>Census2</th><th>DBH2</th><th>HOM2</th><th>Codes2</th></tr>';
                 foreach($grewQuery->result() as $grewRow)
                 {
                   $html = $html."<tr><td>".$grewRow->Plot."</td><td>".$grewRow->Mnemonic."</td><td>".$grewRow->Tag."</td><td>".$grewRow->StemID."</td><td>".$grewRow->StemTag."</td><td>".$grewRow->PrimaryStem."</td><td>".$grewRow->Census1."</td><td>".$grewRow->DBH1."</td><td>".$grewRow->HOM1."</td><td>".$grewRow->Codes1."</td><td>".$grewRow->Census2."</td><td>".$grewRow->DBH2."</td><td>".$grewRow->HOM2."</td><td>".$grewRow->Codes2."</td></tr>";
                 }
                 $html = $html."</table></br>";
              }
              else
              {
                 $html = $html.'<center><h3>No. of records with growth rates that increased more than 65 mm per year for '.$plotName.' from Census '.$currentPlotCensusNumber.' to '.$nextPlotCensusNumber.' : <span style="color:#73943D;">'.$grewQueryCount.'</span></h3></center>';
              }
              $grewQuery->free_result();


              //Growth rate too negative
              $growthNegQuery = $this->postscreeningmodel->growthNegative($censusTable1,$censusTable2);
              $growthNegQueryCount = $growthNegQuery->num_rows();
              if($growthNegQueryCount > 0)
              {
                 $html = $html.'<center><h3>No. of records with growth rates that decreased more than 5% for '.$plotName.' from Census '.$currentPlotCensusNumber.' to '.$nextPlotCensusNumber.' : '.$growthNegQueryCount.'</h3></center>
                                <table border = "1" align = "center">
                                <tr><th>Plot</th><th>Species</th><th>Tag</th><th>StemID</th><th>StemTag</th><th>PrimaryStem</th><th>Census1</th><th>DBH1</th><th>HOM1</th><th>Codes1</th><th>Census2</th><th>DBH2</th><th>HOM2</th><th>Codes2</th></tr>';
                 foreach($growthNegQuery->result() as $grewNegRow)
                 {
                   $html = $html."<tr><td>".$grewNegRow->Plot."</td><td>".$grewNegRow->Mnemonic."</td><td>".$grewNegRow->Tag."</td><td>".$grewNegRow->StemID."</td><td>".$grewNegRow->StemTag."</td><td>".$grewNegRow->PrimaryStem."</td><td>".$grewNegRow->Census1."</td><td>".$grewNegRow->DBH1."</td><td>".$grewNegRow->HOM1."</td><td>".$grewNegRow->Codes1."</td><td>".$grewNegRow->Census2."</td><td>".$grewNegRow->DBH2."</td><td>".$grewNegRow->HOM2."</td><td>".$grewNegRow->Codes2."</td></tr>";
                 }
                 $html = $html."</table></br>";
              }
              else
              {
                 $html = $html.'<center><h3>No. of records with growth rates that decreased more than 5% for '.$plotName.' from Census '.$currentPlotCensusNumber.' to '.$nextPlotCensusNumber.' : <span style="color:#73943D;">'.$growthNegQueryCount.'</span></h3></center>';
              }
              $growthNegQuery->free_result();
            }

          }

       }     // end if
       $plotListQuery->free_result();

       $data['title'] = "Data Entry";
       $data['contentTitle'] = 'Postscreening Report - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>';
       $data['backLink'] = anchor('/dataentry/postscreening','Back',array('class'=>'back'));
       $data['html'] = $html;
       $createFile = $this->_createHTMLFile($html,$plotActualName);
       if($createFile !== "")
       {
         $data['download'] = '<a href="'.base_url().'/download/'.$createFile.'" download target="_blank" class="download">Download Report</a>';
       }
       else
       {
         $data['download'] = '<a href="#" download class="download">Download Report</a><br /><span style="font:8px; color:#CC3300;">(Check Download Folder Write Permission)';
       }

       $this->load->view('treeforms/printhtml',$data);
       /*$tableHTML = $html;

       $this->load->library('pdflibrary');
       // create new PDF document
       //PDF Page size = W:210 H:297
       $pdf = new pdflibrary(PDF_PAGE_ORIENTATION, PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false);
       // set document information
       $pdf->SetCreator(PDF_CREATOR);
       $pdf->SetAuthor('Anudeep Singh');
       $pdf->SetTitle('Field Form');
       $pdf->SetSubject('Field Entry Form');
       // set default header data
       $pdf->SetHeaderData(PDF_HEADER_LOGO, PDF_HEADER_LOGO_WIDTH, PDF_HEADER_TITLE, PDF_HEADER_STRING);
       // set header and footer fonts
       $pdf->setHeaderFont(Array(PDF_FONT_NAME_MAIN, '', PDF_FONT_SIZE_MAIN));
       $pdf->setFooterFont(Array(PDF_FONT_NAME_DATA, '', PDF_FONT_SIZE_DATA));
       // set default monospaced font
       $pdf->SetDefaultMonospacedFont(PDF_FONT_MONOSPACED);
       // set margins
       $pdf->SetMargins(PDF_MARGIN_LEFT, PDF_MARGIN_TOP, PDF_MARGIN_RIGHT);
       $pdf->SetHeaderMargin(PDF_MARGIN_HEADER);
       $pdf->SetFooterMargin(PDF_MARGIN_FOOTER);
       // set auto page breaks
       $pdf->SetAutoPageBreak(TRUE, PDF_MARGIN_BOTTOM);
       // set image scale factor
       $pdf->setImageScale(PDF_IMAGE_SCALE_RATIO);
       // set some language-dependent strings (optional)
       // if (@ file_exists(dirname(__FILE__) . '/lang/eng.php')) {
       //   require_once (dirname(__FILE__) . '/lang/eng.php');
       //   $pdf->setLanguageArray($l);
       // }
       // ---------------------------------------------------------
       // set default font subsetting mode
       $pdf->setFontSubsetting(true);
       // Set font
       // dejavusans is a UTF-8 Unicode font, if you only need to
       // print standard ASCII chars, you can use core fonts like
       // helvetica or times to reduce file size.
       $pdf->SetFont('times', '', 8);
       // Add a page
       // This method has several options, check the source code documentation for more information.
       $pdf->AddPage('P','A4');
       // set text shadow effect
       //$pdf->setTextShadow(array('enabled'=>true, 'depth_w'=>0.2, 'depth_h'=>0.2, 'color'=>array(196,196,196), 'opacity'=>1, 'blend_mode'=>'Normal'));
       ////$table1InstructionHtml = '<div align="center">' . $table1Instruction . '</div>';
      //// $pdf->writeHTML($table1InstructionHtml, true, false, true, false, '');
      //// $pdf->writeHTML($table1, true, false, false, false, '');
       // Set some content to print
       //$html = $table2;
       $pdf->writeHTML($tableHTML, true, false, false, false, '');
       // Print text using writeHTMLCell()
       // ---------------------------------------------------------
       // Close and output PDF document
       // This method has several options, check the source code documentation for more information.

       $filepath = base_url() . 'download/';
       $fileName =  "test.pdf";
       $fileLoc = "download/". $fileName;
       $pdf->Output($fileLoc, 'F');
       if ($this->fileExists($filepath)) {
        chmod('./' . $fileLoc, 0777);
        $fileLink = anchor($filepath, $fileName, array('title' => 'View PDF File', 'target' => '_blank'));
       }
       else {
         $fileLink = '<span style="font-size:10pt; color:#FF0000;">Error - ' . $fileName . '.txt</span>';
       }
       echo $html. '<br />' .$fileLink; */

    }

    function _createHTMLFile($html,$plotActualName)
    {
      $this->load->helper('file');

      $this->load->helper('date');
      $datestring = "%m-%d-%Y";
      $date = mdate($datestring);
      //$random = rand(1,999);
      $filename = 'PostScreeningReport_'.$plotActualName.'_'.$date.'.html';

      $fileHtml = $this->_htmlTemplate($html,$plotActualName);

      write_file('./download/'.$filename, $fileHtml,'w'); //use w to start a new file rather than appending in existing

      $filepath = base_url().'download/'.$filename;
      if($this->fileExists($filepath))
      {
        chmod('./download/'.$filename, 0777);
        $fileCreated = $filename;
      }
      else
      {
        $fileCreated = FALSE;
      }
      return $fileCreated;
    }

    function _htmlTemplate($html,$plotActualName)
    {
       $fileHtml = '<!DOCTYPE html>
                   <html>
                   <head><style>
                     body
                      {
                      background-color:#475E26;
                      }
                      h1
                      {
                      color:#ACAC62;
                      text-align:center;
                      padding-top: 20px;
                      }
                      .topb
                      {
                        background-color:#000000;
                        width: 100%;
                        min-width:1000px;
                        height: 100px;
                        margin-top: -20px;
                      }
                      .report
                      {
                      background-color:#EBEBEB;
                      min-width:960px;
                      min-height:600px;
                      margin: 0px 20px 0px 20px;
                      }
                      .cssTable {
                      	margin:0px;padding:0px;
                      	width:100%;

                      }.cssTable table{
                          border-spacing:0;
                          max-width:940px;
                      	height:100%;
                      	margin:0px;padding:0px;
                         	box-shadow: 5px 5px 3px #888888;
                      	border:1px solid #000000;

                      	-moz-border-radius-bottomleft:3px;
                      	-webkit-border-bottom-left-radius:3px;
                      	border-bottom-left-radius:3px;

                      	-moz-border-radius-bottomright:3px;
                      	-webkit-border-bottom-right-radius:3px;
                      	border-bottom-right-radius:3px;

                      	-moz-border-radius-topright:3px;
                      	-webkit-border-top-right-radius:3px;
                      	border-top-right-radius:3px;

                      	-moz-border-radius-topleft:3px;
                      	-webkit-border-top-left-radius:3px;
                      	border-top-left-radius:3px;
                      }.cssTable tr:last-child td:last-child {
                      	-moz-border-radius-bottomright:3px;
                      	-webkit-border-bottom-right-radius:3px;
                      	border-bottom-right-radius:3px;
                      }
                      .cssTable table tr:first-child th:first-child {
                      	-moz-border-radius-topleft:3px;
                      	-webkit-border-top-left-radius:3px;
                      	border-top-left-radius:3px;
                      }
                      .cssTable table tr:first-child td:last-child {
                      	-moz-border-radius-topright:3px;
                      	-webkit-border-top-right-radius:3px;
                      	border-top-right-radius:3px;
                      }.cssTable tr:last-child th:first-child{
                      	-moz-border-radius-bottomleft:3px;
                      	-webkit-border-bottom-left-radius:3px;
                      	border-bottom-left-radius:3px;
                      }.cssTable tr:hover td{
                      	background-color:#ffffff;
                      }
                      .cssTable td{
                      	vertical-align:middle;
                      		background:-o-linear-gradient(bottom, #e0ead0 5%, #ffffff 100%);	background:-webkit-gradient( linear, left top, left bottom, color-stop(0.05, #e0ead0), color-stop(1, #ffffff) );
                      	background:-moz-linear-gradient( center top, #e0ead0 5%, #ffffff 100% );
                      	filter:progid:DXImageTransform.Microsoft.gradient(startColorstr="#e0ead0", endColorstr="#ffffff");	background: -o-linear-gradient(top,#e0ead0,ffffff);
                      	background-color:#e0ead0;
                      	border:1px solid #000000;
                      	border-width:0px 1px 1px 0px;
                      	text-align:center;
                      	padding:8px;
                      	font-size:10px;
                      	font-family:Arial;
                      	font-weight:normal;
                      	color:#000000;
                      }.cssTable tr:last-child td{
                      	border-width:0px 1px 0px 0px;
                      }.cssTable tr td:last-child{
                      	border-width:0px 0px 1px 0px;
                      }.cssTable tr:last-child td:last-child{
                      	border-width:0px 0px 0px 0px;
                      }
                      .cssTable tr:first-child th{
                      		background:-o-linear-gradient(bottom, #8ea56b 5%, #475e26 100%);	background:-webkit-gradient( linear, left top, left bottom, color-stop(0.05, #8ea56b), color-stop(1, #475e26) );
                      	background:-moz-linear-gradient( center top, #8ea56b 5%, #475e26 100% );
                      	filter:progid:DXImageTransform.Microsoft.gradient(startColorstr="#8ea56b", endColorstr="#475e26");	background: -o-linear-gradient(top,#8ea56b,475e26);

                      	background-color:#8ea56b;
                      	border:0px solid #000000;
                      	text-align:center;
                      	border-width:0px 0px 1px 1px;
                      	font-size:14px;
                      	font-family:Arial;
                      	font-weight:bold;
                      	color:#ffffff;
                      }
                      .cssTable tr:first-child:hover th{
                      	background:-o-linear-gradient(bottom, #8ea56b 5%, #475e26 100%);	background:-webkit-gradient( linear, left top, left bottom, color-stop(0.05, #8ea56b), color-stop(1, #475e26) );
                      	background:-moz-linear-gradient( center top, #8ea56b 5%, #475e26 100% );
                      	filter:progid:DXImageTransform.Microsoft.gradient(startColorstr="#8ea56b", endColorstr="#475e26");	background: -o-linear-gradient(top,#8ea56b,475e26);
                      	background-color:#8ea56b;
                      }
                      .cssTable tr:first-child th:first-child{
                      	border-width:0px 0px 1px 0px;
                      }
                      .cssTable tr:first-child td:last-child{
                      	border-width:0px 0px 1px 1px;
                      }
                      </style>
                      </head>
                      <body>
                      <div class = "topb"><h1>Postscreening Report - '.$plotActualName.' </h1></div>
                      <div class = "report">
                        <div class = "cssTable" align = "center"><br />'
                        .$html.
                        '</div>
                         </div>
                        </body></html>';
       return $fileHtml;
    }

    function markEmpty($field)
    {
      if($field == "" || $field == NULL)
      {
        $field =  '<span style="color:#FF3300;">*Missing*</span>';
      }
      return $field;
    }

    function markEmptyZero($field)
    {
      if($field == "" || $field == NULL)
      {
        $field =  '<span style="color:#FF3300;">*Missing*</span>';
      }
      elseif($field == 0)
      {
        $field =  '<span style="color:#FF3300;">0</span>';
      }
      return $field;
    }

    function markRed($field)
    {
      $field =  '<span style="color:#FF3300;">'.$field.'*</span>';
      return $field;
    }

    function fileExists($path)
    {
      return (@fopen($path,"r")==true);
    }
}