<?php

class Screening extends Controller{

    function Screening()
    {
      parent::Controller();
      if($this->session->userdata('loggedin') !== '1')
      {
        redirect('main','location');
      }
      $this->load->model('screeningmodel');
      
      set_time_limit(0);
      ini_set('memory_limit', '-1');
    }

    function screencheck()
    {
      if(!isset($this->session->userdata['plotCensusArray']))
      {
         $this->plotcensus();
      }
      $plotCensusArray = $this->session->userdata('plotCensusArray');

      $data['formOpen'] = form_open('screening/screencheckform');
      $data['formTable'] = $this->_generatescreencheckform();

      $plotName = $plotCensusArray['plotName'];
      $censusNumber = $plotCensusArray['censusNumber'];
      $plotActualName = $plotCensusArray['plotActualName'];
      $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
      $data['contentTitle'] = 'Data Screening - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
      $data['backLink'] = anchor('/dataentry/selectentrytype', 'Back', array('title'=>'Back to Screening Menu', 'class'=>'back'));

      $this->load->view('user/dataentry/simpleform',$data);
    }

    function screencheckform()
    {
      $this->_validatescreencheckform();
      if($this->form_validation->run() == FALSE)
      {
        if(!isset($this->session->userdata['plotCensusArray']))
        {
           $this->plotcensus();
        }
        $plotCensusArray = $this->session->userdata('plotCensusArray');

        $data['formOpen'] = form_open('screening/screencheckform');
        $data['formTable'] = $this->_generatescreencheckform();

        $plotName = $plotCensusArray['plotName'];
        $censusNumber = $plotCensusArray['censusNumber'];
        $plotActualName = $plotCensusArray['plotActualName'];
        $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
        $data['contentTitle'] = 'Data Screening - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
        $data['backLink'] = anchor('/dataentry/selectentrytype', 'Back', array('title'=>'Back to Screening Menu', 'class'=>'back'));

        $this->load->view('user/dataentry/simpleform',$data);
      }
      else
      {
        global $minDBH;
        global $maxDBH;

        $minDBH = $this->input->post('minDBH');
        $maxDBH = $this->input->post('maxDBH');

        $this->_screentemp();
      }
    }

    function _generatescreencheckform()
    {
      $minDBH = set_value('minDBH');
      $maxDBH  = set_value('maxDBH');

      $minDBHA = array('name'=>'minDBH','id'=>'minDBH','size'=>'10','value'=>$minDBH);
      $maxDBHA = array('name'=>'maxDBH','id'=>'maxDBH','size'=>'10','value'=>$maxDBH);

      $minDBHTbx = form_input($minDBHA);
      $maxDBHTbx = form_input($maxDBHA);

      $minDBHErr = form_error('minDBH');
      $maxDBHErr = form_error('maxDBH');

      $submitButtonA = array('name'=>'submitButton','id'=>'button','type'=>'submit','content'=>'Submit');
      $resetButtonA = array('name'=>'resetButton','id'=>'button','type'=>'reset','content'=>'Reset');
      $submitButton = form_button($submitButtonA);
      $resetButton = form_button($resetButtonA);

      $formTableA = array(array('',''),
                         array('Min DBH Allowed: ',$minDBHTbx,$minDBHErr),
                         array('Max DBH Allowed: ',$maxDBHTbx,$maxDBHErr),
                         array('',''),
                         array($submitButton."\t".$resetButton)
                         );
      $this->table->set_empty("");
      $formTable = $this->table->generate($formTableA);

      return $formTable;
    }

    function _validatescreencheckform()
    {
      $this->form_validation->set_rules('minDBH', 'Min DBH', 'trim|required');
      $this->form_validation->set_rules('maxDBH', 'Max DBH', 'trim|required');

      $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    function _screentemp()
    {
      $plotCensusArray = $this->session->userdata('plotCensusArray');
      $plotID = $plotCensusArray['plotName'];
      $censusNumber = $plotCensusArray['censusNumber'];
      $plotActualName = $plotCensusArray['plotActualName'];

      global $minDBH;
      global $maxDBH;

      $this->table->set_heading('');

      $tempNewTable = 'TempNewPlants';
      $tempNewExist = $this->screeningmodel->ifTableExist($tempNewTable);
      $tempOldTable = 'TempOldTrees';
      $tempOldExist = $this->screeningmodel->ifTableExist($tempOldTable);
      $tempMultiTable = 'TempMultiStems';
      $tempMultiExist = $this->screeningmodel->ifTableExist($tempMultiTable);
      $tempLocationTable = 'TempLocations';
      $tempLocationExist = $this->screeningmodel->ifTableExist($tempLocationTable);

      //Other temptables
      $tempQuadratDates = 'TempQuadratDates';
      $tempQuadratExist = $this->screeningmodel->ifTableExist($tempQuadratDates);

      $this->screeningmodel->startTransaction(); // Start Transaction

      if($censusNumber > 1)
      {
        if($tempOldExist == 'yes')
        {
          //Screening Old Plants//
          $color = 'blue'; //for old plants
          $tempTableName = 'TempOldTrees';
          $this->screeningmodel->makeErrorBlank($tempTableName);
          $this->screeningmodel->checkDuplStemin($tempTableName);
          $this->table->add_row('Duplicate StemTags for <font color="'.$color.'">'.$tempTableName.'</font> checked');
          $this->screeningmodel->screenDiam($tempTableName,$maxDBH,$minDBH);
          $this->table->add_row('Diameter range for <font color="'.$color.'">'.$tempTableName.'</font> checked');
          $this->screeningmodel->screenCodes($tempTableName);
          if($tempQuadratExist == 'yes')
          {
            //Check for extreme growth - for Old Trees form
            //Tags stems where absolute annual growth > 65 mm
            $annualGrowth = '65';

            //Check for shrinkage in recensuses - only for Old Trees form
            //Tags records with annual relative growth <= -0.05 in stems with previous dbh>=50mm and no current stem lost code
            $dbhCheck2 = '50';
            $annualShrink = '-0.05';
            $this->screeningmodel->checkGrowth($tempTableName,$minDBH,$annualGrowth,$dbhCheck2,$annualShrink);
            $this->table->add_row('Growth and shrinkage for <font color="'.$color.'">'.$tempTableName.'</font> screened');
          }

          $this->screeningmodel->checkSpecies($tempTableName, 'Species');
          $this->table->add_row('Species codes in <font color="'.$color.'">'.$tempTableName.'</font> checked');

          $this->screeningmodel->checkQuadName($tempTableName, 'Quadrat', $plotID);
          $this->table->add_row('Quadrat names in <font color="'.$color.'">'.$tempTableName.'</font> checked');

          $this->screeningmodel->screenDuplQuad($tempTableName);
          $this->table->add_row('More than one Quadrat name in <font color="'.$color.'">'.$tempTableName.'</font> checked');

          $this->screeningmodel->screenDuplSpec($tempTableName);
          $this->table->add_row('More than one Species in <font color="'.$color.'">'.$tempTableName.'</font> checked');
        }
        if($tempMultiExist == 'yes')
        {
          //Screen Multiple Stems
          $tempTableName = 'TempMultiStems';
          $color = 'orange';
          $this->screeningmodel->makeErrorBlank($tempTableName);

          $this->screeningmodel->checkDuplStemin($tempTableName);
          $this->table->add_row('Duplicate StemTags for <font color="'.$color.'">'.$tempTableName.'</font> checked');

          //Check that all Tree tags in Multiple Stem file appears in tempOldTrees
          $this->screeningmodel->checkTagInOldTrees ($tempMultiTable,$tempOldTable);
          $this->table->add_row('Comparing tags from <font color="'.$color.'">Multiple Stems</font> to Old Trees forms done');

          $this->screeningmodel->checkDuplTagout ($tempTableName,$tempNewTable, $plotID);
          $this->table->add_row('Duplicate Tags for <font color="'.$color.'">'.$tempTableName.'</font> in '.$tempNewTable.' checked');

          $this->screeningmodel->checkDuplStemout ($tempTableName,$tempOldTable, $plotID);
          $this->table->add_row('Duplicate tags for <font color="'.$color.'">'.$tempTableName.'</font> in '.$tempOldTable.' checked');

          //This should be checked, but takes way too long - how to shorten???
          //checkDuplStemout ('TempMultStems','DFTemp', $plotid, 'orange');

          $this->screeningmodel->screenDiam($tempTableName,$maxDBH,$minDBH);
          $this->table->add_row('Diameter range for <font color="'.$color.'">'.$tempTableName.'</font> checked');

          $this->screeningmodel->screenCodes($tempTableName);
          $this->table->add_row('Invalid codes for <font color="'.$color.'">'.$tempTableName.'</font> checked');

          $this->screeningmodel->checkQuadName($tempTableName, 'Quadrat', $plotID);
          $this->table->add_row('Quadrat names in <font color="'.$color.'">'.$tempTableName.'</font> checked');

          $this->screeningmodel->screenDuplQuad($tempTableName);
          $this->table->add_row('More than one Quadrat name in <font color="'.$color.'">'.$tempTableName.'</font> checked');
        }

        if($tempMultiExist == 'yes' AND $tempOldExist == 'yes')
        {
          //Screen Old Trees and Multiple Stems for main stem code
          $this->screeningmodel->screenMainStems2 ($tempOldTable,$tempMultiTable);
          $this->table->add_row('Primary and secondary stems screened for <font color="'.$color.'">'.$tempOldTable.'</font> and <font color="'.$color.'">'.$tempMultiTable.'</font>');
        }
      }
   
      if($tempNewExist == 'yes')
      {
        $continuescreening = 'y';
        if($censusNumber == 1)
        {
          if($this->screeningmodel->ifTableExist('TempSpecies') == 'no')
          {
            $this->screeningmodel->createTempSpecies();
          }
          //Screen temporary species file
          $this->screeningmodel->makeErrorBlank ('TempSpecies');
          $continuescreening = $this->screeningmodel->screenSpecies ();
          if($continuescreening == 'error1')
          {
            $screenSpeciesErr1 = 'Errors found in <font color="dark blue">Species list</font> - please EDIT, then SCREEN again<br />
                               (<i>Note that a missing or unknown Genus should say: <b>Unidentified</b></i>)<br /><br />
                               Do not edit the other forms until the Species list is clean.<br /><br />';
            $this->table->add_row($screenSpeciesErr1);
            $continuescreening = 'n'; //stop further screening
          }
          elseif($continuescreening == 'error2')
          {
            $screenSpeciesErr2 = 'You have not loaded a species table yet... Please load before continuing.<br /><br />';
            $this->table->add_row($screenSpeciesErr2);
            $continuescreening = 'n'; //stop further screening
          }
        }

        //Continue screening only after no errors found in Species file and data uploaded into Species table (1st census)
        if ($continuescreening == 'y')
        {
          //Screen New Plants
          $tempTableName = 'TempNewPlants';
          $color = 'green';
          $this->screeningmodel->makeErrorBlank ($tempTableName);
          if ($censusNumber > 1)
          {
            $this->screeningmodel->checkDuplTagout($tempTableName,'ViewFullTable',$plotID);
            $this->table->add_row('Duplicate Tags for <font color="'.$color.'">'.$tempTableName.'</font> in Tree checked');
          }

          $this->screeningmodel->checkDuplStemin($tempTableName);
          $this->table->add_row('Duplicate StemTags for <font color="'.$color.'">'.$tempTableName.'</font> checked');

          $this->screeningmodel->screenDiam($tempTableName,$maxDBH,$minDBH);
          $this->table->add_row('Diameter range for <font color="'.$color.'">'.$tempTableName.'</font> checked');

          $this->screeningmodel->screenCodes($tempTableName);
          $this->table->add_row('Invalid codes for <font color="'.$color.'">'.$tempTableName.'</font> checked');

          $this->screeningmodel->screenMainStems($tempTableName);
          $this->table->add_row('Primary and secondary stems screened for <font color="'.$color.'">'.$tempTableName.'</font>');

          $this->screeningmodel->checkSpecies($tempTableName, 'Species');
          $this->table->add_row('Species codes in <font color="'.$color.'">'.$tempTableName.'</font> checked');

          $this->screeningmodel->checkQuadName($tempTableName, 'Quadrat', $plotID);
          $this->table->add_row('Quadrat names in <font color="'.$color.'">'.$tempTableName.'</font> checked');

          $this->screeningmodel->screenDuplQuad($tempTableName);
          $this->table->add_row('More than one Quadrat name in <font color="'.$color.'">'.$tempTableName.'</font> checked');

          $this->screeningmodel->screenDuplSpec($tempTableName);
          $this->table->add_row('More than one Species in <font color="'.$color.'">'.$tempTableName.'</font> checked');

          //Screen tempPersonnelInfo
          $this->screeningmodel->makeErrorBlank('TempPersonnelInfo');
          //Duplicate records
          $this->screeningmodel->screenDuplQuadratInfo ();
          $this->table->add_row('Duplicate records for Quadrat table checked');

          //Screen Dates
          //Get date of beginning of census from Census table
          $startDate = $this->screeningmodel->censusStartDate($plotID,$censusNumber);
          $enddate = date("Y-m-d");

          $this->screeningmodel->screenQuadratInfo($startDate,$enddate);
          $this->table->add_row('Date ranges for Quadrat Info checked');
        }
      }

      if($tempLocationExist == 'yes')
      {
         //Screen Locations
         $tempTableName = 'TempLocations';
         $color = 'purple';
         $this->screeningmodel->makeErrorBlank($tempTableName);
         //makeErrorBlank ($connect,'tempLocations');
         //$this->screeningmodel->checkDuplTagin($tempTableName);
         
         $this->table->add_row('Duplicate tags in <font color="'.$color.'">'.$tempTableName.'</font> checked');
         if ($censusNumber > 1)
         {
           $this->screeningmodel->checkDuplTagout($tempTableName,'ViewFullTable',$plotID);
           $this->table->add_row('Duplicate Tags for <font color="'.$color.'">'.$tempTableName.'</font> in Tree checked');
           //checkDuplTagout ($connect,'tempLocations','Tree',$plotid, 'purple');
         }
         $this->screeningmodel->checkDuplStemin($tempTableName);
         $this->table->add_row('Duplicate StemTags for <font color="'.$color.'">'.$tempTableName.'</font> checked');

         $this->screeningmodel->screenXY ($tempTableName,$plotID);
         $this->table->add_row('X,Y coordinate ranges for <font color="'.$color.'">'.$tempTableName.'</font> table checked');

         if($tempNewExist == 'yes')
         {
           $this->screeningmodel->checkQuadrat ($tempTableName, $tempNewTable, $plotID);
           $this->table->add_row('Screening for Quadrat mismatches in <font color="'.$color.'">'.$tempTableName.' and <font color="'.$color.'">'.$tempNewTable.'</font> done<br />');

           $this->screeningmodel->checkTagnotout ($tempTableName, $tempNewTable, $plotID);
           $this->table->add_row('Tags in <font color="'.$color.'">'.$tempTableName.'</font> not found in <font color="'.$color.'">'.$tempNewTable.'</font> checked<br />');
         }
      }

      $this->screeningmodel->endTransaction(); //end transaction
      $table = $this->table->generate();

      $plotCensusArray = $this->session->userdata('plotCensusArray');

      $data['formOpen'] = "";
      $data['formTable'] = $table;

      $plotName = $plotCensusArray['plotName'];
      $censusNumber = $plotCensusArray['censusNumber'];
      $plotActualName = $plotCensusArray['plotActualName'];
      $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
      $data['contentTitle'] = 'Single Data Screening - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
      $data['backLink'] = anchor('/dataentry/selectentrytype', 'Back', array('title'=>'Back to Screening Menu', 'class'=>'back'));

      $this->load->view('user/dataentry/simpleform',$data);
    }

}