<?php
class Selectmergefile extends Controller{

    function Selectmergefile()
    {
      parent::Controller();
      if($this->session->userdata('loggedin') !== '1')
      {
        redirect('main','location');
      }
      $this->load->model('dataentrymodel');
      global $databaseName;
      $databaseName = $this->session->userdata('databaseName');
    }

    function selectformtype()
    {
      if(isset($this->session->userdata['formType']))
      {
        $this->session->unset_userdata('formType');
      }

      $data['formOpen'] = form_open("selectmergefile/selectformtypevalidate");
      $data['formTable'] = $this->_selectFormTypeTable();

      $plotCensusArray = $this->session->userdata('plotCensusArray');
      $plotName = $plotCensusArray['plotName'];
      $censusNumber = $plotCensusArray['censusNumber'];
      $plotActualName = $plotCensusArray['plotActualName'];
      $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
      $data['contentTitle'] = 'Select Merge File - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
      $data['backLink'] = anchor('/dataentry/mainmenu', 'Back', array('title'=>'Back to Data Entry', 'class'=>'back'));
      $this->load->view('user/dataentry/simpleform',$data);
    }

    function selectformtypevalidate()
    {
      $this->_validateselectformtype();

      if($this->form_validation->run() == FALSE)
      {
        $data['formOpen'] = form_open("selectmergefile/selectformtypevalidate");
        $data['formTable'] = $this->_selectFormTypeTable();

        $plotCensusArray = $this->session->userdata('plotCensusArray');
        $plotName = $plotCensusArray['plotName'];
        $censusNumber = $plotCensusArray['censusNumber'];
        $plotActualName = $plotCensusArray['plotActualName'];
        $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
        $data['contentTitle'] = 'Select Merge File - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
        $data['backLink'] = anchor('/dataentry/mainmenu', 'Back', array('title'=>'Back to Data Entry', 'class'=>'back'));
        $this->load->view('user/dataentry/simpleform',$data);
      }
      else
      {
        $formType = $this->input->post('formType');
        //$this->session->set_userdata('formType',$formType);

        if($formType == 'newform')
        {
          $dir = "./files/datafiles/newplant/";
        }
        elseif($formType == 'multiform')
        {
          $dir = "./files/datafiles/multistem/";
        }
        elseif($formType == 'bigform')
        {
          $dir = "./files/datafiles/bigtree/";
        }


        $plotCensusArray = $this->session->userdata('plotCensusArray');
        $plotName = $plotCensusArray['plotName'];
        $censusNumber = $plotCensusArray['censusNumber'];
        $plotActualName = $plotCensusArray['plotActualName'];
        $plotActualNameNoSpace = str_replace(" ","",$plotActualName);

        //form with drop down - listing files in the selected form type folder
        if(is_dir($dir))
        {
          if ($dh = opendir($dir))
          {
            $fileNameArray = array();
            //$fileNameArray['default'] = 'No Files In Folder';
            while (($file = readdir($dh)) !== false)
            {
              if($file !== "." && $file !== "..")
              {
                $fileSplit = explode(".",$file);
                $file = $fileSplit[0]; // Remove .txt from the end - need to remove for dropdown
                $fileSplit1 = explode("_",$file);
                if($fileSplit1[1] == $plotActualNameNoSpace)
                {
                  $fileNameArray[$file] = $file;
                }
                $fileNameArray['default'] = 'Select';
              }
            }
            natcasesort($fileNameArray);
            $defaultArray = array('default'=>'Select');
            $fileNameArray = array_merge($defaultArray,$fileNameArray);
            closedir($dh);
          }
        }

        $data['formTable'] = $this->_selectFileTable($fileNameArray,$formType);
        $data['formOpen'] = form_open("selectmergefile/selectfile");

        $plotCensusArray = $this->session->userdata('plotCensusArray');
        $plotName = $plotCensusArray['plotName'];
        $censusNumber = $plotCensusArray['censusNumber'];
        $plotActualName = $plotCensusArray['plotActualName'];
        $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
        $data['contentTitle'] = 'Select Merge File - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
        $data['backLink'] = anchor('/selectmergefile/selectformtype', 'Back', array('title'=>'Back to Select Form Type', 'class'=>'back'));
        $this->load->view('user/dataentry/simpleform',$data);
      }
    }

    function _selectFormTypeTable()
    {
      $formType = set_value('formType');

      $formTypeA = array('default'=>'Select','newform'=>'New Plants','multiform'=>'Multi Stem','bigform'=>'Big Trees');
      $formTypeDD = form_dropdown('formType',$formTypeA);

      $formTypeErr = form_error('formType');

      $submitButtonA = array('name'=>'submitButton','id'=>'button','type'=>'submit','content'=>'Submit');
      $submitButton = form_button($submitButtonA);

      $formTableA = array(array(),
                          array('Form Type : ',$formTypeDD,$formTypeErr),
                          array('',$submitButton)
                          );

      $this->table->set_empty("");
      $formTable = $this->table->generate($formTableA);

      return $formTable;
    }

    function _validateselectformtype()
    {
      $this->form_validation->set_rules('formType', 'Form Type', 'callback_dropdown_check');

      $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    function _selectFileTable($fileNameArray,$formType)
    {
      $fileName = set_value('fileName');

      $fileNameDD = form_dropdown('fileName',$fileNameArray);
      $fileNameHd = form_hidden('fileNameArray',$fileNameArray);
      $formTypeHd = form_hidden('formType',$formType);

      $fileNameErr = form_error('fileName');

      $submitButtonA = array('name'=>'submitButton','id'=>'button','type'=>'submit','content'=>'Submit');
      $submitButton = form_button($submitButtonA);

      $formTableA = array(array(),
                          array('Select File : ',$fileNameDD,$fileNameErr),
                          array('',$fileNameHd.$formTypeHd),
                          array('',$submitButton)
                          );

      $this->table->set_empty("");
      $formTable = $this->table->generate($formTableA);

      return $formTable;
    }

    function selectfile()
    {
      $this->_validateselectfile();
      $fileNameArray = $this->input->post('fileNameArray');
      $formType = $this->input->post('formType');

      if($this->form_validation->run() == FALSE)
      {
        $data['formTable'] = $this->_selectFileTable($fileNameArray,$formType);
        $data['formOpen'] = form_open("selectmergefile/selectfile");

        $plotCensusArray = $this->session->userdata('plotCensusArray');
        $plotName = $plotCensusArray['plotName'];
        $censusNumber = $plotCensusArray['censusNumber'];
        $plotActualName = $plotCensusArray['plotActualName'];
        $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
        $data['contentTitle'] = 'Select Merge File - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
        $data['backLink'] = anchor('/selectmergefile/selectformtype', 'Back', array('title'=>'Back to Select Form Type', 'class'=>'back'));
        $this->load->view('user/dataentry/simpleform',$data);
      }
      else
      {
        $fileName = $this->input->post('fileName');

        $this->session->set_userdata('mergefilename',$fileName);

        if($formType == 'newform')
        {
          redirect('newplantform/createform/merge');
        }
        elseif($formType == 'multiform')
        {
          redirect('multistemform/createform/merge');
        }
        elseif($formType == 'bigform')
        {
          redirect('bigtreeform/createform/merge');
        }
      }
    }

    function _validateselectfile()
    {
      $this->form_validation->set_rules('fileName', 'File', 'callback_dropdown_check');

      $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    function dropdown_check($str)
    {
      if($str == 'default')
      {
          $this->form_validation->set_message('dropdown_check', '%s need to be Selected');
          return FALSE;
      }
      else
      {
          return True;
      }
    }

}