<?php

class Singledataentry extends Controller{

    function Singledataentry()
    {
      parent::Controller();
      if($this->session->userdata('loggedin') !== '1')
      {
        redirect('main','location');
      }
      $this->load->model('dataentrymodel');
      global $databaseName;
      $databaseName = $this->session->userdata('databaseName');

      set_time_limit(0);
      ini_set('memory_limit', '-1');
    }

    function selectformtype()
    {
      if(isset($this->session->userdata['formType']))
      {
        $this->session->unset_userdata('formType');
      }

      $data['formOpen'] = form_open("singledataentry/selectformtypevalidate");
      $data['formTable'] = $this->_selectFormTypeTable();

      $plotCensusArray = $this->session->userdata('plotCensusArray');
      $plotName = $plotCensusArray['plotName'];
      $censusNumber = $plotCensusArray['censusNumber'];
      $plotActualName = $plotCensusArray['plotActualName'];
      $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
      $data['contentTitle'] = 'Single Data Entry - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
      $data['backLink'] = anchor('/dataentry/singledataentry', 'Back', array('title'=>'Back to Select Entry Type', 'class'=>'back'));
      $this->load->view('user/dataentry/simpleform',$data);
    }

    function selectformtypevalidate()
    {
      $this->_validateselectformtype();

      if($this->form_validation->run() == FALSE)
      {
        $data['formOpen'] = form_open("singledataentry/selectformtypevalidate");
        $data['formTable'] = $this->_selectFormTypeTable();

        $plotCensusArray = $this->session->userdata('plotCensusArray');
        $plotName = $plotCensusArray['plotName'];
        $censusNumber = $plotCensusArray['censusNumber'];
        $plotActualName = $plotCensusArray['plotActualName'];
        $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
        $data['contentTitle'] = 'Single Data Entry - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
        $data['backLink'] = anchor('/dataentry/singledataentry', 'Back', array('title'=>'Back to Select Entry Type', 'class'=>'back'));
        $this->load->view('user/dataentry/simpleform',$data);
      }
      else
      {
        $formType = $this->input->post('formType');
        $allFiles = $this->input->post('allFilesCB');
        //$this->session->set_userdata('formType',$formType);

        if($formType == 'newform')
        {
          $dir = "./files/datafiles/newplant/";
        }
        elseif($formType == 'multiform')
        {
          $dir = "./files/datafiles/multistem/";
        }
        elseif($formType == 'oldform')
        {
          $dir = "./files/datafiles/oldtree/";
        }
        elseif($formType == 'bigform')
        {
          $dir = "./files/datafiles/bigtree/";
        }

        if($allFiles == 'allFiles')
        {
          $this->dataentrymodel->startTransaction(); // Transaction Starts Here

          $plotCensusArray = $this->session->userdata('plotCensusArray');
          $plotActualName = $plotCensusArray['plotActualName'];
          $plotActualNameNoSpace = str_replace(" ","",$plotActualName);

          //upload all the files from selected form type folder
          if(is_dir($dir))
          {
            if ($dh = opendir($dir))
            {
              while (($file = readdir($dh)) !== false)
              {
                if($file !== "." && $file !== "..")
                {
                  //Read the file content and upload to the temp table.
                  $fileSplit = explode(".",$file);
                  $file = $fileSplit[0];  // Remove .txt from the end - need to remove for dropdown
                  $fileSplit1 = explode("_",$file);
                  if($fileSplit1[1] == $plotActualNameNoSpace)
                  {
                    $this->_uploadFile($formType,$file);
                    $this->_moveuploadedfile($formType,$file);
                  }
                }
              }
              closedir($dh);
            }
          }
          $transactionStatus = $this->dataentrymodel->completeTransaction(); // Transaction Ends Here

          if($transactionStatus == 'Success')
          {
            $data['formTable'] = '<div class="success">The Data Uploaded Successfully.</div>';
          }
          else
          {
            $data['formTable'] = '<div class="error">Error Occured while uploading.</div>';
          }

          $data['formOpen'] = form_open("singledataentry/onefileupload");

          $plotCensusArray = $this->session->userdata('plotCensusArray');
          $plotName = $plotCensusArray['plotName'];
          $censusNumber = $plotCensusArray['censusNumber'];
          $plotActualName = $plotCensusArray['plotActualName'];
          $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
          $data['contentTitle'] = 'Single Data Entry - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
          $data['backLink'] = anchor('/singledataentry/selectformtype', 'Back', array('title'=>'Back to Select Form Type', 'class'=>'back'));
          $this->load->view('user/dataentry/simpleform',$data);
        }
        else
        {
          $plotCensusArray = $this->session->userdata('plotCensusArray');
          $plotName = $plotCensusArray['plotName'];
          $censusNumber = $plotCensusArray['censusNumber'];
          $plotActualName = $plotCensusArray['plotActualName'];

          $plotActualNameNoSpace = str_replace(" ","",$plotActualName);
          //form with drop down - listing files in the selected form type folder
          if(is_dir($dir))
          {
            if ($dh = opendir($dir))
            {
              $fileNameArray = array();
              //$fileNameArray['default'] = 'No Files In Folder';
              while (($file = readdir($dh)) !== false)
              {
                if($file !== "." && $file !== "..")
                {
                  $fileSplit = explode(".",$file);
                  $file = $fileSplit[0]; // Remove .txt from the end - need to remove for dropdown
                  $fileSplit1 = explode("_",$file);
                  if($fileSplit1[1] == $plotActualNameNoSpace)
                  {
                    $fileNameArray[$file] = $file;
                  }
                  $fileNameArray['default'] = 'Select';
                }
              }
              natcasesort($fileNameArray);
              $defaultArray = array('default'=>'Select');
              $fileNameArray = array_merge($defaultArray,$fileNameArray);
              closedir($dh);
            }
          }

          $data['formTable'] = $this->_selectFileTable($fileNameArray,$formType);
          $data['formOpen'] = form_open("singledataentry/onefileupload");

          $plotCensusArray = $this->session->userdata('plotCensusArray');
          $plotName = $plotCensusArray['plotName'];
          $censusNumber = $plotCensusArray['censusNumber'];
          $plotActualName = $plotCensusArray['plotActualName'];
          $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
          $data['contentTitle'] = 'Single Data Entry - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
          $data['backLink'] = anchor('/singledataentry/selectformtype', 'Back', array('title'=>'Back to Select Form Type', 'class'=>'back'));
          $this->load->view('user/dataentry/simpleform',$data);
        }
      }
    }

    function _selectFormTypeTable()
    {
      $formType = set_value('formType');

      $formTypeA = array('default'=>'Select','newform'=>'New Plants','oldform'=>'Old Trees','multiform'=>'Multi Stem','bigform'=>'Big Trees');
      //$formTypeA = array('default'=>'Select','newform'=>'New Plants','oldform'=>'Old Trees','multiform'=>'Multi Stem');
      $formTypeDD = form_dropdown('formType',$formTypeA);

      $checkBox = form_checkbox('allFilesCB', 'allFiles', FALSE);

      $formTypeErr = form_error('formType');

      $submitButtonA = array('name'=>'submitButton','id'=>'button','type'=>'submit','content'=>'Submit');
      $submitButton = form_button($submitButtonA);

      $formTableA = array(array(),
                          array('Form Type : ',$formTypeDD,$formTypeErr),
                          array('',$checkBox.' Upload all files in folder '),
                          array('',$submitButton)
                          );

      $this->table->set_empty("");
      $formTable = $this->table->generate($formTableA);

      return $formTable;
    }

    function _validateselectformtype()
    {
      $this->form_validation->set_rules('formType', 'Form Type', 'callback_dropdown_check');

      $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    function _selectFileTable($fileNameArray,$formType)
    {
      $fileName = set_value('fileName');

      $fileNameDD = form_dropdown('fileName',$fileNameArray);
      $fileNameHd = form_hidden('fileNameArray',$fileNameArray);
      $formTypeHd = form_hidden('formType',$formType);

      $fileNameErr = form_error('fileName');

      $submitButtonA = array('name'=>'submitButton','id'=>'button','type'=>'submit','content'=>'Submit');
      $submitButton = form_button($submitButtonA);

      $formTableA = array(array(),
                          array('Select File : ',$fileNameDD,$fileNameErr),
                          array('',$fileNameHd.$formTypeHd),
                          array('',$submitButton)
                          );

      $this->table->set_empty("");
      $formTable = $this->table->generate($formTableA);

      return $formTable;
    }

    function onefileupload()
    {
      $this->_validateonefileupload();
      $fileNameArray = $this->input->post('fileNameArray');
      $formType = $this->input->post('formType');

      if($this->form_validation->run() == FALSE)
      {
        $data['formTable'] = $this->_selectFileTable($fileNameArray,$formType);
        $data['formOpen'] = form_open("singledataentry/onefileupload");

        $plotCensusArray = $this->session->userdata('plotCensusArray');
        $plotName = $plotCensusArray['plotName'];
        $censusNumber = $plotCensusArray['censusNumber'];
        $plotActualName = $plotCensusArray['plotActualName'];
        $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
        $data['contentTitle'] = 'Single Data Entry - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
        $data['backLink'] = anchor('/singledataentry/selectformtype', 'Back', array('title'=>'Back to Select Form Type', 'class'=>'back'));
        $this->load->view('user/dataentry/simpleform',$data);
      }

      else
      {
        //upload the file into temp table.
        $this->dataentrymodel->startTransaction(); // Transaction Starts Here

        $fileName = $this->input->post('fileName');
        $this->_uploadFile($formType,$fileName);

        $transactionStatus = $this->dataentrymodel->completeTransaction(); // Transaction Ends Here
        if($transactionStatus == 'Success')
        {
          //if Success move file to different folder;
           if($formType == 'newform')
          {
            $dir = "./files/datafiles/newplant/";
            $dirMove = "./files/datafiles/uploaded/newplant/";
          }
          elseif($formType == 'multiform')
          {
            $dir = "./files/datafiles/multistem/";
            $dirMove = "./files/datafiles/uploaded/multistem/";
          }
          elseif($formType == 'oldform')
          {
            $dir = "./files/datafiles/oldtree/";
            $dirMove = "./files/datafiles/uploaded/oldtree/";
          }
          elseif($formType == 'bigform')
          {
            $dir = "./files/datafiles/bigtree/";
            $dirMove = "./files/datafiles/uploaded/bigtree/";
          }
          $fileNameMove = $fileName;
          $fileName = $dir.$fileName.".txt";  //complete path to file
          $fileNameMove = $dirMove.$fileNameMove.".txt";
          copy($fileName,$fileNameMove); //copy file

          $this->fileExists($fileNameMove); //to make sure file is copied to other folder
          {
            unlink($fileName);//delete file
          }

          //Display that file Uploaded
          $data['formTable'] = '<div class="success">The Data Uploaded Successfully.</div>';
        }
        else
        {
          $data['formTable'] = '<div class="error">Error Occured while uploading.</div>';
        }

        $data['formOpen'] = form_open("singledataentry/onefileupload");

        $plotCensusArray = $this->session->userdata('plotCensusArray');
        $plotName = $plotCensusArray['plotName'];
        $censusNumber = $plotCensusArray['censusNumber'];
        $plotActualName = $plotCensusArray['plotActualName'];
        $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
        $data['contentTitle'] = 'Single Data Entry - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
        $data['backLink'] = anchor('/singledataentry/selectformtype', 'Back', array('title'=>'Back to Select Form Type', 'class'=>'back'));
        $this->load->view('user/dataentry/simpleform',$data);


      }

    }

    function _validateonefileupload()
    {
      $this->form_validation->set_rules('fileName', 'File', 'callback_dropdown_check');

      $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    function dropdown_check($str)
    {
      if($str == 'default')
      {
          $this->form_validation->set_message('dropdown_check', '%s need to be Selected');
          return FALSE;
      }
      else
      {
          return True;
      }
    }

    function _uploadFile($formType,$fileName)
    {
      if($formType == 'newform')
      {
        $dir = "./files/datafiles/newplant/";
        $tempTableName = 'TempNewPlants';
        $tempTableNameErr = 'TempNewPlantsError';
      }
      elseif($formType == 'multiform')
      {
        $dir = "./files/datafiles/multistem/";
        $tempTableName = 'TempMultiStems';
        $tempTableNameErr = 'TempMultiStemsError';
      }
      elseif($formType == 'oldform')
      {
        $dir = "./files/datafiles/oldtree/";
        $tempTableName = 'TempOldTrees';
        $tempTableNameErr = 'TempOldTreesError';
      }
      elseif($formType == 'bigform')
      {
        $dir = "./files/datafiles/bigtree/";
        $tempTableName = 'TempBigTrees';
        $tempTableNameErr = 'TempBigTreesError';
      }

      $fileName = $dir.$fileName.".txt";  //complete path to file

      $this->load->library('formlibrary');

      if($formType == 'bigform')
      {
        $fileContent = $this->formlibrary->readDataFileBig($fileName);

        $fileInfoA = $fileContent['fileInfo'];
        //$quadratName = $fileInfoA['quadratName'];
        $censusNumber = $fileInfoA['censusNumber'];
        $plotName = $fileInfoA['plotName'];
        $collectedA = $fileContent['collected'];
        $checkedA = $fileContent['checked'];
        $enteredA = $fileContent['entered'];
        $contentA = $fileContent['content'];

        $plotCensusArray = $this->session->userdata('plotCensusArray');
        $plotID = $plotCensusArray['plotName'];

        $censusID = $this->dataentrymodel->getCensusIDByCensusNumber($censusNumber,$plotID);

        //Create personnel temp table and form temp table
        $createTempPersonnel = $this->dataentrymodel->createPersonnelTempTable();

        $createTempForm = $this->dataentrymodel->createFormTempTable($tempTableName);
        $createTempFormErr = $this->dataentrymodel->createFormTempTable($tempTableNameErr);

        //upload form data into form temp table
        $tempTableColumns = $this->_tempTableColumnArray();
        $contentInsertArray = array();

        $quadratNameArray = array();

        foreach($contentA as $contentRow)
        {
          //$contentInsertArray['QuadratName'] = $quadratName;
          $contentInsertArray['PlotCensusNumber'] = $censusNumber;
          $contentInsertArray['CensusID'] = $censusID;
          $contentInsertArray['PlotID'] = $plotID;

          $collectedCount = count($collectedA) - 1; //Last record is date
          $dateWorked = $collectedA[$collectedCount]; //array starts from 0
          $exactDate = $dateWorked; //This is ExactDate for collection column in Temp Tables

          $contentInsertArray['ExactDate'] = $exactDate;

          foreach($tempTableColumns as $key => $value)
          {
            if(isset($contentRow->$value))
            {
              $contentInsertArray[$key] = $contentRow->$value;

              //If Quadrat column exists in the big form
              if($key == 'QuadratName')
              {
                $quadratName = $contentRow->$value;
                if(!in_array($quadratName,$quadratNameArray))      //Do not enter Personnel information again if already entered once for a quadrat
                {
                  $quadratNameArray[$quadratName] = $quadratName;
                  //upload personnel info into personnel temp table
                  //Enter Collected Data
                      //////$exactDate Moved out of the loop...
                  for($i=0;$i<$collectedCount;$i++)
                  {
                    $personnelID = $collectedA[$i];
                    $role = "field technician";
                    $roleID = $this->dataentrymodel->getRoleID($role);
                    $personnelInsertArray = array('QuadratName'=>$quadratName,'PersonnelID'=>$personnelID,'Form'=>$formType,'PlotID'=>$plotID,'CensusID'=>$censusID,'PlotCensusNumber'=>$censusNumber,'Role'=>$role,'RoleID'=>$roleID,'DateWorked'=>$dateWorked);
                    $tableName = 'TempPersonnelInfo';
                    $personnelInsert = $this->dataentrymodel->insertRowIntoTable($tableName,$personnelInsertArray);
                  }
                  //Enter Checked Data
                  $checkedCount = count($checkedA) - 1; //Last record is date
                  $dateWorked = $checkedA[$checkedCount]; //array starts from 0
                  for($i=0;$i<$checkedCount;$i++)
                  {
                    $personnelID = $checkedA[$i];
                    $role = "field supervisor";
                    $roleID = $this->dataentrymodel->getRoleID($role);
                    $personnelInsertArray = array('QuadratName'=>$quadratName,'PersonnelID'=>$personnelID,'Form'=>$formType,'PlotID'=>$plotID,'CensusID'=>$censusID,'PlotCensusNumber'=>$censusNumber,'Role'=>$role,'RoleID'=>$roleID,'DateWorked'=>$dateWorked);
                    $tableName = 'TempPersonnelInfo';
                    $personnelInsert = $this->dataentrymodel->insertRowIntoTable($tableName,$personnelInsertArray);
                  }
                  //Enter Entered Data
                  $enteredCount = count($enteredA) - 1; //Last record is date
                  $dateWorked = $enteredA[$enteredCount]; //array starts from 0
                  for($i=0;$i<$enteredCount;$i++)
                  {
                    $personnelID = $enteredA[$i];
                    $role = "data entry technician";
                    $roleID = $this->dataentrymodel->getRoleID($role);
                    $personnelInsertArray = array('QuadratName'=>$quadratName,'PersonnelID'=>$personnelID,'Form'=>$formType,'PlotID'=>$plotID,'CensusID'=>$censusID,'PlotCensusNumber'=>$censusNumber,'Role'=>$role,'RoleID'=>$roleID,'DateWorked'=>$dateWorked);
                    $tableName = 'TempPersonnelInfo';
                    $personnelInsert = $this->dataentrymodel->insertRowIntoTable($tableName,$personnelInsertArray);
                  }
                }
              } //END if $key = quadratName
            }
          }

          $this->dataentrymodel->insertRowIntoTable($tempTableName,$contentInsertArray);
        }
      }

      else  //For NewPlants, MultiStem and OldTrees
      {
        $fileContent = $this->formlibrary->readDataFile($fileName);

        $fileInfoA = $fileContent['fileInfo'];
        $quadratName = $fileInfoA['quadratName'];
        $censusNumber = $fileInfoA['censusNumber'];
        $plotName = $fileInfoA['plotName'];
        $collectedA = $fileContent['collected'];
        $checkedA = $fileContent['checked'];
        $enteredA = $fileContent['entered'];
        $contentA = $fileContent['content'];

        //print_r($contentA);
        //die();

        $plotCensusArray = $this->session->userdata('plotCensusArray');
        $plotID = $plotCensusArray['plotName'];

        $censusID = $this->dataentrymodel->getCensusIDByCensusNumber($censusNumber,$plotID);

        //Create personnel temp table and form temp table
        $createTempPersonnel = $this->dataentrymodel->createPersonnelTempTable();

        $createTempForm = $this->dataentrymodel->createFormTempTable($tempTableName);
        $createTempFormErr = $this->dataentrymodel->createFormTempTable($tempTableNameErr);

        //upload personnel info into personnel temp table

        //Enter Collected Data
        $collectedCount = count($collectedA) - 1; //Last record is date
        $dateWorked = $collectedA[$collectedCount]; //array starts from 0
        $exactDate = $dateWorked; //This is ExactDate for collection column in Temp Tables
        for($i=0;$i<$collectedCount;$i++)
        {
          $personnelID = $collectedA[$i];
          $role = "field technician";
          $roleID = $this->dataentrymodel->getRoleID($role);
          $personnelInsertArray = array('QuadratName'=>$quadratName,'PersonnelID'=>$personnelID,'Form'=>$formType,'PlotID'=>$plotID,'CensusID'=>$censusID,'PlotCensusNumber'=>$censusNumber,'Role'=>$role,'RoleID'=>$roleID,'DateWorked'=>$dateWorked);
          $tableName = 'TempPersonnelInfo';
          $personnelInsert = $this->dataentrymodel->insertRowIntoTable($tableName,$personnelInsertArray);
        }
        //Enter Checked Data
        $checkedCount = count($checkedA) - 1; //Last record is date
        $dateWorked = $checkedA[$checkedCount]; //array starts from 0
        for($i=0;$i<$checkedCount;$i++)
        {
          $personnelID = $checkedA[$i];
          $role = "field supervisor";
          $roleID = $this->dataentrymodel->getRoleID($role);
          $personnelInsertArray = array('QuadratName'=>$quadratName,'PersonnelID'=>$personnelID,'Form'=>$formType,'PlotID'=>$plotID,'CensusID'=>$censusID,'PlotCensusNumber'=>$censusNumber,'Role'=>$role,'RoleID'=>$roleID,'DateWorked'=>$dateWorked);
          $tableName = 'TempPersonnelInfo';
          $personnelInsert = $this->dataentrymodel->insertRowIntoTable($tableName,$personnelInsertArray);
        }
        //Enter Entered Data
        $enteredCount = count($enteredA) - 1; //Last record is date
        $dateWorked = $enteredA[$enteredCount]; //array starts from 0
        for($i=0;$i<$enteredCount;$i++)
        {
          $personnelID = $enteredA[$i];
          $role = "data entry technician";
          $roleID = $this->dataentrymodel->getRoleID($role);
          $personnelInsertArray = array('QuadratName'=>$quadratName,'PersonnelID'=>$personnelID,'Form'=>$formType,'PlotID'=>$plotID,'CensusID'=>$censusID,'PlotCensusNumber'=>$censusNumber,'Role'=>$role,'RoleID'=>$roleID,'DateWorked'=>$dateWorked);
          $tableName = 'TempPersonnelInfo';
          $personnelInsert = $this->dataentrymodel->insertRowIntoTable($tableName,$personnelInsertArray);
        }

        //upload form data into form temp table
        $tempTableColumns = $this->_tempTableColumnArray();
        $contentInsertArray = array();
        foreach($contentA as $contentRow)
        {
          $contentInsertArray['QuadratName'] = $quadratName;
          $contentInsertArray['PlotCensusNumber'] = $censusNumber;
          $contentInsertArray['CensusID'] = $censusID;
          $contentInsertArray['PlotID'] = $plotID;
          $contentInsertArray['ExactDate'] = $exactDate;

          foreach($tempTableColumns as $key => $value)
          {
            if(isset($contentRow->$value))
            {
              $insertValue = $contentRow->$value;
              if($insertValue == '')
              {
                $insertValue = NULL;     //set the value Null if the column is left blank
              }
              if($value == 'nosubTag')
              {
                $contentInsertArray['Tag'] = $insertValue;       // as tag and nosubTag ColumnName both goes to 'Tag' in temp table
              }
              else
              {
                $contentInsertArray[$key] = $insertValue;
              }
            }
          }

          $this->dataentrymodel->insertRowIntoTable($tempTableName,$contentInsertArray);
        }
      }
    }

    function _tempTableColumnArray()
    {
      $tempTableArray['TreeID'] = 'treeID';
      $tempTableArray['Tag'] = 'tag';
      $tempTableArray['nosubTag'] = 'nosubTag';  // will be changed to 'Tag' while inserting records.
      $tempTableArray['StemID'] = 'stemID';
      $tempTableArray['StemTag'] = 'stemTag';
      $tempTableArray['QuadratID'] = 'quadratID';
      $tempTableArray['QuadratName'] = 'quadratName';
      $tempTableArray['Subquad'] = 'subquadrat';
      $tempTableArray['SpeciesID'] = 'speciesID';
      $tempTableArray['Mnemonic'] = 'species';
      $tempTableArray['SubSpeciesID'] = 'subSpeciesID';
      $tempTableArray['PlotID'] = 'plotID';
      $tempTableArray['CensusID'] = 'censusID';
      $tempTableArray['PlotCensusNumber'] = 'plotCensusNumber';
      $tempTableArray['PrimaryStem'] = 'primaryStem';
      $tempTableArray['X'] = 'x';
      $tempTableArray['Y'] = 'y';
      $tempTableArray['DBH'] = 'dbh';
      $tempTableArray['OldDBH'] = 'olddbh';
      $tempTableArray['HOM'] = 'hom';
      $tempTableArray['OldHOM'] = 'oldhom';
      $tempTableArray['Codes'] = 'codes';
      $tempTableArray['OldCodes'] = 'oldcodes';
      $tempTableArray['Comments'] = 'comments';
      $tempTableArray['ExactDate'] = 'exactDate';
      $tempTableArray['Errors'] = 'errors';
      $tempTableArray['OldTrees'] = 'oldtrees';
      $tempTableArray['BigTrees'] = 'bigtrees';
      $tempTableArray['Extra1'] = 'extra1';
      $tempTableArray['Extra2'] = 'extra2';
      $tempTableArray['Extra3'] = 'extra3';
      $tempTableArray['Extra4'] = 'extra4';
      $tempTableArray['Extra5'] = 'extra5';

      return $tempTableArray;
    }

    function _moveuploadedfile($formType,$fileName)
    {
       //if Success move file to different folder;
       if($formType == 'newform')
       {
        $dir = "./files/datafiles/newplant/";
        $dirMove = "./files/datafiles/uploaded/newplant/";
       }
       elseif($formType == 'multiform')
       {
         $dir = "./files/datafiles/multistem/";
         $dirMove = "./files/datafiles/uploaded/multistem/";
       }
       elseif($formType == 'oldform')
       {
         $dir = "./files/datafiles/oldtree/";
         $dirMove = "./files/datafiles/uploaded/oldtree/";
       }
       elseif($formType == 'bigform')
       {
         $dir = "./files/datafiles/bigtree/";
         $dirMove = "./files/datafiles/uploaded/bigtree/";
       }
       $fileNameMove = $fileName;
       $fileName = $dir.$fileName.".txt";  //complete path to file
       $fileNameMove = $dirMove.$fileNameMove.".txt";
       copy($fileName,$fileNameMove); //copy file

       $this->fileExists($fileNameMove); //to make sure file is copied to other folder
       {
         unlink($fileName);//delete file
       }
    }

    function fileExists($path)
    {
      return (@fopen($path,"r")==true);
    }
}