<?php

class Taxonomyreport extends Controller{

    function Taxonomyreport()
    {
      parent::Controller();
      if($this->session->userdata('loggedin') !== '1')
      {
        redirect('main','location');
      }
      $this->load->library(array('table','pagination'));
      $this->load->model('taxonomyreportmodel');
      global $databaseName;
      $databaseName = $this->session->userdata('databaseName');

      set_time_limit(0);
      ini_set('memory_limit', '-1');
    }

    function taxonomy()
    {
      global $databaseName;

      if(isset($this->session->userdata[$databaseName.'taxonomyReport']))
      {
        $this->session->unset_userdata($databaseName.'taxonomyReport');
      }
      if(isset($this->session->userdata[$databaseName.'totalTaxonomyRowCount']))
      {
        $this->session->unset_userdata($databaseName.'totalTaxonomyRowCount');
      }

      $data['formTable'] = $this->_generatetaxonomyform($databaseName);
      $data['formOpen'] = form_open('taxonomyreport/taxonomyform');

      $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
      $data['contentTitle'] = 'Taxonomy Report';
      $this->load->view('user/taxonomyform',$data);
    }

    function taxonomyform($offset = 0)
    {
      global $databaseName;
      $this->_validatetaxonomyform();
      if(($this->form_validation->run() == FALSE) && (!isset($this->session->userdata[$databaseName.'taxonomyReport'])))
      {
        $data['formTable'] = $this->_generatetaxonomyform($databaseName);
        $data['formOpen'] = form_open('taxonomyreport/taxonomyform');

        $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
        $data['contentTitle'] = 'Taxonomy Report';
        $this->load->view('user/taxonomyform',$data);
      }
      else
      {
        if(isset($this->session->userdata[$databaseName.'taxonomyReport']))
        {
          $taxonomyReportArray = $this->session->userdata($databaseName.'taxonomyReport');
          $plotID = $taxonomyReportArray['plotID'];
          $sortBy = $taxonomyReportArray['sortBy'];
          $family = $taxonomyReportArray['family'];
          $genus = $taxonomyReportArray['genus'];
          $species = $taxonomyReportArray['species'];
        }
        else
        {
          $plotID = $this->input->post('plotName');
          $sortBy = $this->input->post('sortBy');
          $family = $this->input->post('family');
          $genus = $this->input->post('genus');
          $species = $this->input->post('species');

          $taxonomyReportArray = array('plotID'=>$plotID,'sortBy'=>$sortBy,'family'=>$family,'genus'=>$genus,'species'=>$species);
          $this->session->set_userdata($databaseName.'taxonomyReport',$taxonomyReportArray);
        }
        $this-> _viewplotdata($plotID,$sortBy,$family,$genus,$species,$offset);
      }
    }

    function _generatetaxonomyform($databaseName)
    {
      //$plotName = $this->session->userdata('initialPlot');

      $plotName = set_value('plotName');
      $sortBy = set_value('sortBy');
      $family = set_value('family');
      $genus = set_value('genus');
      $species = set_value('species');

      $familyA = array('name'=>'family','id'=>'family','size'=>'16','value'=>$family);
      $genusA = array('name'=>'genus','id'=>'genus','size'=>'16','value'=>$genus);
      $speciesA = array('name'=>'species','id'=>'species','size'=>'16','value'=>$species);

      $submitButtonA = array('name'=>'submitButton','id'=>'button','type'=>'submit','content'=>'Submit');
      $resetButtonA = array('name'=>'resetButton','id'=>'button','type'=>'reset','content'=>'Reset');

      $plotNameA = $this->taxonomyreportmodel->getPlotNames();
      $sortByA = array('Family'=>'Family','GenusSpecies'=>'Genus-Species');

      $plotNameDD = form_dropdown('plotName',$plotNameA,$plotName);
      $sortByDD = form_dropdown('sortBy',$sortByA,$sortBy);
      $familyTbx = form_input($familyA);
      $genusTbx = form_input($genusA);
      $speciesTbx = form_input($speciesA);

      $submitButton = form_button($submitButtonA);
      $resetButton = form_button($resetButtonA);

      $plotNameErr = form_error('plotName');
      //$sortByErr = form_error('sortBy');
      $familyErr = form_error('family');
      $genusErr = form_error('genus');
      $speciesErr = form_error('species');

      $formTableA = array(array(),
                         array('Plot Name : ',$plotNameDD,$plotNameErr),
                         array('Sort By : ',$sortByDD),
                         array('Family : ',$familyTbx,$familyErr),
                         array('Genus : ',$genusTbx,$genusErr),
                         array('Species : ',$speciesTbx,$speciesErr),
                         array('','<p style="text-align:center;">'.$submitButton."\t".$resetButton.'</p>')
                         );
       $this->table->set_empty("");
       $formTable = $this->table->generate($formTableA);

       return $formTable;
    }

    function _validatetaxonomyform()
    {
       $this->form_validation->set_rules('plotName', 'Plot Name', 'callback_dropdown_check');
       $this->form_validation->set_rules('family', 'Family', 'max_length[50]');
       $this->form_validation->set_rules('genus', 'Genus', 'max_length[50]|alpha');
       $this->form_validation->set_rules('species', 'Species', 'max_length[50]|alpha');

       $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    function dropdown_check($str)
    {
      if($str == 'default')
      {
          $this->form_validation->set_message('dropdown_check', '%s need to be Selected');
          return FALSE;
      }
      else
      {
          return True;
      }
    }

    function _viewplotdata($plotID,$sortBy,$family,$genus,$species,$offset)
   {
      global $databaseName;
      $limit = 30;

      $taxonomyDataA['plotID'] = $plotID;
      $taxonomyDataA['sortBy'] = $sortBy;
      $taxonomyDataA['family'] = $family;
      $taxonomyDataA['genus'] = $genus;
      $taxonomyDataA['species'] = $species;

      $taxonomyDataA['limit'] = $limit;
      $taxonomyDataA['offset'] = $offset;

      $taxonomyDataQuery = $this->taxonomyreportmodel->JoinTaxDataLimits($taxonomyDataA);
      $taxonomyDataCount = $taxonomyDataQuery->num_rows();
      $taxonomyDataResult = $taxonomyDataQuery->result();

      if($taxonomyDataCount > 0)
      {
        if(!isset($this->session->userdata[$databaseName.'totalTaxonomyRowCount']))
        {
          $totalQuery = $this->taxonomyreportmodel->JoinTaxData($taxonomyDataA);
          $countall = $totalQuery->num_rows();
          $this->session->set_userdata($databaseName.'totalTaxonomyRowCount',$countall);
        }
        else
        {
          $countall = $this->session->userdata($databaseName.'totalTaxonomyRowCount');
        }

        //offset - starting point for the current page
  		$uri_segment = 3;
  		$offset = $this->uri->segment($uri_segment);


  		//generate pagination
  		$config['base_url'] = site_url('taxonomyreport/taxonomyform/');
  		$config['total_rows'] = $countall;
  		$config['per_page'] = $limit;
  		$config['uri_segment'] = $uri_segment;
        if($countall > 0 AND $limit > 0)
        {
         $pageCount = $countall / $limit;
         $pageCount = ceil($pageCount);
         $config['last_link'] = "Last(".$pageCount.")>";
        }
  		$this->pagination->initialize($config);
  		$dataTable['pagination'] = $this->pagination->create_links();

  		//generate table data
  		$this->table->set_empty("&nbsp;");
  		$this->table->set_heading('No.', 'Family', 'Genus', 'Species', 'Subspecies', 'Mnemonic', 'IDlevel', 'Authority', 'PriorNames', 'SpeciesID', 'Action');
          $i = 0 + $offset;
          foreach($taxonomyDataResult as $taxonomyDataRow)
          {
             if($taxonomyDataRow->IDLevel == NULL)
             {
               $idLevel = "Not Defined";
             }
             else
             {
               $idLevel = $taxonomyDataRow->IDLevel;
             }
             $this->table->add_row(++$i, $taxonomyDataRow->Family, $taxonomyDataRow->Genus, $taxonomyDataRow->SpeciesName, $taxonomyDataRow->Subspecies,$taxonomyDataRow->Mnemonic, $taxonomyDataRow->IDLevel, $taxonomyDataRow->Authority, $taxonomyDataRow->ListOfOldNames, $taxonomyDataRow->SpeciesID,
             anchor('taxonomyreport/viewdetail/'.$taxonomyDataRow->SpeciesID.'/'.$taxonomyDataRow->Family.'/'.$taxonomyDataRow->Genus.'/'.$taxonomyDataRow->SpeciesName.'/'.$idLevel,'Detail',array('class'=>'view','target'=>'_blank')));
          }

          $dataTable['table'] = $this->table->generate();
          $dataTable['downloadcsv'] = anchor('taxonomyreport/downloadcsv', 'Download Data to File', array('class'=>'download'));

        }
        else
        {
          $dataTable['table'] = "<h2>No Record Found!!</h2>";
          $dataTable['downloadcsv'] = "";
          $dataTable['pagination'] = "";
          $countall = "0";
        }

        $dataTable['title'] = 'CTFS/SIGEO Forest Plot Census Data';
        //$plotName = $this->session->userdata('initialPlot');
        $plotName = $this->taxonomyreportmodel->getPlotNameByID($plotID);
        $dataTable['contentTitle'] = 'Taxonomy Report - '.$plotName."<h5 align=right>Total Records: ".$countall."</h5>";
        $dataTable['backLink'] = anchor('/taxonomyreport/taxonomy', 'Back', array('title'=>'Back to View Form', 'class'=>'back'));

		// load view
		$this->load->view('user/taxonomy', $dataTable);
   }

   function viewdetail($speciesID,$family,$genus,$speciesName,$idLevel = "Not Defined")
   {
      $getDetailData = $this->taxonomyreportmodel->getDetailData($speciesID);
      $authority = $getDetailData['authority'];
      $mnemonic = $getDetailData['mnemonic'];
      $description = $getDetailData['description'];
      $listOfHerbarium = $getDetailData['listOfHerbarium'];

      if($authority==NULL || $authority=='')
      {
      $authority='None available';
      }

      $detailTableA = array(array('',''),
                            array('<b>Mnemonic: </b>',$mnemonic),
                            array('<b>Authority: </b>',$authority),
                            array('<b>Deepest Level of Identification: </b>',$idLevel),
                            array('<b>List of Herbarium: </b>',$listOfHerbarium)
                            );
      $this->table->set_empty("");
      $data['detailTable'] = $this->table->generate($detailTableA);
      $this->table->clear();

      $obsoleteQuery = $this->taxonomyreportmodel->getObsolete($family,$genus,$speciesName);
      if($obsoleteQuery->num_rows() > '0')
      {
        $i = 0;
        $obsoleteResult = $obsoleteQuery->result();
        $this->table->set_empty("&nbsp;");
		$this->table->set_heading('No.','ObsoleteGenusName', 'ObsoleteSpeciesName', 'ChangeDate', 'Description');
        foreach($obsoleteResult as $obsoleteRow)
        {
          $this->table->add_row(++$i,$obsoleteRow->ObsoleteGenusName, $obsoleteRow->ObsoleteSpeciesName, $obsoleteRow->ChangeDate, $obsoleteRow->Description);
        }
        $data['obsoleteTable'] = $this->table->generate();
      }
      else
      {
        $data['obsoleteTable'] = "No Obsolete Names For This Species.";
      }

        $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
        $data['contentTitle'] = $family."&nbsp;".$genus."&nbsp;".$speciesName;
		// load view
		$this->load->view('user/taxonomydetail', $data);
   }

   function downloadcsv()
   {
      error_reporting(E_ALL ^ E_WARNING); 
      global $databaseName;
      $taxonomyReportArray = $this->session->userdata($databaseName.'taxonomyReport');

      $this->load->helper('file');

      $this->load->helper('date');
      $datestring = "%m-%d-%Y";
      $date = mdate($datestring);
      $random = rand();
      $filename = join('',array('TaxonomyReport',$date,'_',$random));

      $taxonomyDataQuery = $this->taxonomyreportmodel->JoinTaxData($taxonomyReportArray);
      $taxonomyDataResult = $taxonomyDataQuery->result();

      $i = 0;
      //$x = 0;
      $dataJoin = join("\t", array('No.', 'Family', 'Genus', 'Species', 'Subspecies', 'Mnemonic', 'IDlevel', 'Authority', 'PriorNames', 'SpeciesID'));
      write_file('./download/'.$filename.'.txt', $dataJoin,'a');
      $nextline = "\r\n";
      write_file('./download/'.$filename.'.txt', $nextline,'a');

      foreach($taxonomyDataResult as $taxonomyDataRow)
      {
        $dataJoin = join("\t",array(++$i, $taxonomyDataRow->Family, $taxonomyDataRow->Genus, $taxonomyDataRow->SpeciesName, $taxonomyDataRow->Subspecies,$taxonomyDataRow->Mnemonic, $taxonomyDataRow->IDlevel, $taxonomyDataRow->Authority, $taxonomyDataRow->ListOfOldNames, $taxonomyDataRow->SpeciesID));
        write_file('./download/'.$filename.'.txt', $dataJoin,'a');
        $nextline = "\r\n";
        write_file('./download/'.$filename.'.txt', $nextline,'a');
      }
      //$dataArray = join("\r\n",$dataJoin);

      //////////Download as Zip File///////////
      $this->load->library('zip');
      $filePath = "./download/".$filename.".txt";

      $this->zip->read_file($filePath);

      unlink($filePath); //Delete the Txt file created

      // Download the file to your desktop
      $this->zip->download($filename.'.zip');
      ////////////////////////////////


      /////Download as Txt file////////
      /*header('Content-Type: text/plain');
      header('Content-Disposition: attachment;filename='.$filename.'.txt');
      $fp=fopen("./download/".$filename.".txt",'r');
      fpassthru($fp);
      fclose($fp);*/
      ////////////////////////


      /*if (! write_file('./download/'.$filename.'.txt', $dataArray))
      {
        echo 'Unable to write the file';
      }
      else
      {
        $this->load->helper('download');
        $dataGet = file_get_contents("./download/".$filename.".txt"); // Read the file's contents
        force_download($filename.'.txt', $dataGet);
      }*/
   }


}