<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

require_once dirname(__FILE__) . '/excel_reader2.php';

class Filereader
{
    function csvReader($filePath, $hasHeader, $delimiter, $columns) {
        $maxRowSize = 0;
        $content = array();
        $file = fopen($filePath, 'r');
        //print_r($columns);
        //die();
        if($hasHeader == 'yes') {
            $fields = fgetcsv($file, $maxRowSize, $delimiter);
        }
        while( ($row = fgetcsv($file, $maxRowSize, $delimiter)) !== FALSE ) {
           $items = array();
           // Fill the array with values of defined fields
           foreach( $columns as $tableColumn => $fileColumn ) {
               if($fileColumn !== 'keepDefault') {
                  if( isset($row[$fileColumn]) ) {
                       $items[$tableColumn] = $row[$fileColumn];
                  }
               }
           }
           $content[] = $items;
        }
        fclose($file);
        return $content;
    }

    function csvHeader($filePath, $hasHeader, $delimiter) {
        $maxRowSize = 0;
        $headers = array();
        $file = fopen($filePath, 'r');
        if($hasHeader == 'yes') {
            $fields = fgetcsv($file, $maxRowSize, $delimiter);
            foreach($fields as $key => $value) {
              //$key = $key+1;
              $headers[$key] = $value;
            }
        }
        else {
           $row = fgetcsv($file, $maxRowSize, $delimiter);
           $numCol = count($row);
           for($i = 0; $i < $numCol; $i++) {
              $j = $i + 1;
              $headers[$i]  = 'Column_'.$j;
           }
        }
        fclose($file);
        return $headers;
    }

    function xlsReader($filePath, $hasHeader, $columns, $sheet) {
        $data = new Spreadsheet_Excel_Reader($filePath, false);
        $sheetsData = $data->sheets;
        $numSheets = count($sheetsData);
        if ($sheet == 'All') {
            for ($x = 0; $x < $numSheets; $x++) {
                //loop all sheets
                $rowCount = 0;
                foreach ($sheetsData[$x]['cells'] as $row) {
                    $rowCount++;
                    if ($hasHeader == 'yes' && $rowCount == 1) {
                        continue;
                    }
                    $items = array();
                    // Fill the array with values of defined fields
                    foreach ($columns as $tableColumn => $fileColumn) {
                        if ($fileColumn !== 'keepDefault') {
                            if (isset ($row[$fileColumn])) {
                                $items[$tableColumn] = $row[$fileColumn];
                            }
                        }
                    }
                    $content[] = $items;
                }
            }
        }
        else {
            // read single sheet
            $sheet = $sheet - 1;
            $rowCount = 0;
            foreach ($sheetsData[$sheet]['cells'] as $row) {
                $rowCount++;
                if ($hasHeader == 'yes' && $rowCount == 1) {
                    continue;
                }
                $items = array();
                // Fill the array with values of defined fields
                foreach ($columns as $tableColumn => $fileColumn) {
                    if ($fileColumn !== 'keepDefault') {
                        if (isset ($row[$fileColumn])) {
                            $items[$tableColumn] = $row[$fileColumn];
                        }
                    }
                }
                $content[] = $items;
            }
        }
        return $content;
    }

    function xlsHeader($filePath, $hasHeader, $sheet) {
        if ($sheet == 'All') {
            $sheet = 0;
        }
        else {
            $sheet = $sheet - 1;
        }
        $data = new Spreadsheet_Excel_Reader($filePath, false);
        $sheetsData = $data->sheets;
        //Get headers from first sheet
        if (count($sheetsData[$sheet]['cells']) > 0) {
            //checking sheet is not empty
            $numCols = $sheetsData[$sheet]['numCols'];
            if ($hasHeader == 'yes') {
                for ($x = 1; $x <= $numCols; $x++) {
                    $headers[$x] = $sheetsData[$sheet]['cells'][1][$x];
                }
            }
            else {
                for ($x = 1; $x <= $numCols; $x++) {
                    $headers[$x] = 'Column_'.$x;
                }
            }
        }
        return $headers;
    }


}