<?php

class Createviewmodel extends Model{

    function Createviewmodel()
    {
      parent::Model();
      $database = $this->session->userdata('databaseName');
      $this->cvdb = $this->load->database($database,TRUE);
    }

    function PopPXPY1()
    {
      // zero the quadrat QX,QY fields in the Coordinates table
      $q1 = 'SELECT CoorID FROM Coordinates WHERE FeatureID IS NULL AND QuadratID IS NOT NULL AND (PX IS NOT NULL AND PY IS NOT NULL) AND (QX IS NULL OR QY IS NULL)';
      $runQ1 = $this->cvdb->query($q1);
      if ($runQ1->num_rows() > 0)
      {
        foreach($runQ1->result() as $row)
        {
          $q2 = 'UPDATE Coordinates SET QX=0,QY=0 WHERE CoorID='.$row->CoorID;
          $runQ2 = $this->cvdb->query($q2);
        }
      }

      // zero the plot PX,PY fields in the Coordinates table
      $q1 = 'SELECT CoorID FROM Coordinates WHERE FeatureID IS NULL AND QuadratID IS NULL AND (GX IS NOT NULL AND GY IS NOT NULL) AND (PX IS NULL OR PY IS NULL)';
      $runQ1 = $this->cvdb->query($q1);
      if ($runQ1->num_rows() > 0)
      {
        foreach($runQ1->result() as $row)
        {
          $q2 = 'UPDATE Coordinates SET PX=0,PY=0 WHERE CoorID='.$row->CoorID;
          $runQ2 = $this->cvdb->query($q2);
        }
      }
    }

    function PopPXPY2()
    {
      // calculating plot-local points (in Stem table) from quadrat points (in Coordinates table)
      $q1 = 'SELECT StemID, Coordinates.PX, Coordinates.PY FROM Stem, Coordinates WHERE Stem.QuadratID=Coordinates.QuadratID AND Coordinates.QX=0 AND Coordinates.QY=0 AND ((Stem.PX IS NULL AND Stem.QX IS NOT NULL) OR (Stem.PY IS NULL AND Stem.QY IS NOT NULL))';
      $runQ1 = $this->cvdb->query($q1);
      if ($runQ1->num_rows() > 0)
      {
        foreach($runQ1->result() as $row)
        {
          $q2 = 'UPDATE Stem SET PX='.$row->PX.'+QX, PY='.$row->PY.'+QY WHERE StemID='.$row->StemID;
          $runQ2 = $this->cvdb->query($q2);
        }
      }

      // calculating plot-local points for features (in Coordinates table) from quadrat points (in Coordinates table)
      $q1 = 'SELECT C1.CoorID, C2.PX, C2.PY FROM Coordinates C1, Coordinates C2 WHERE C1.FeatureID IS NOT NULL AND C1.QuadratID=C2.QuadratID AND ((C1.PX IS NULL AND C1.QX IS NOT NULL) OR (C1.PY IS NULL AND C1.QY IS NOT NULL))';
      $runQ1 = $this->cvdb->query($q1);
      if ($runQ1->num_rows() > 0)
      {
        foreach($runQ1->result() as $row)
        {
          $q2 = 'UPDATE Coordinates SET PX='.$row->PX.'+QX, PY='.$row->PY.'+QY WHERE CoorID='.$row->CoorID;
          $runQ2 = $this->cvdb->query($q2);
        }
      }
    }


    function SGFtemp()
    {
      $q1 = $this->cvdb->query("DROP TABLE IF EXISTS SGFtemp");

      $q2 = $this->cvdb->query("CREATE TABLE SGFtemp(SGFtempID INT unsigned NOT NULL auto_increment,
                                                    Family CHAR(32),
                                                  	Genus CHAR(32),
                                                  	SpeciesName CHAR(64),
                                                  	SubSpeciesName CHAR(64),
                                                    SpeciesID INT UNSIGNED,
                                                  	Mnemonic CHAR(10),
                                                  	TreeID  INT NOT NULL,
                                                    StemID INT NOT NULL,
                                                  	QuadratID  INT NOT NULL,
                                                  	PlotID  INT NOT NULL,
                                                    PRIMARY KEY (SGFtempID),
                                                    KEY (TreeID),
                                                    KEY (StemID)
                                                    )ENGINE=MyISAM");

      $q3 = $this->cvdb->query("INSERT INTO SGFtemp (Family, Genus, SpeciesName, SpeciesID, Mnemonic, TreeID, StemID, QuadratID, PlotID)
                                                     SELECT DISTINCT Family.Family, Genus.Genus, Species.SpeciesName, Species.SpeciesID, Species.Mnemonic,
                                                     Tree.TreeID, Stem.StemID, Stem.QuadratID, Quadrat.PlotID
                                                     FROM Species, Genus, Family, Tree, Stem, Quadrat
                                                     WHERE Species.SpeciesID = Tree.SpeciesID  AND
                                                     Species.GenusID = Genus.GenusID AND
                                                     Genus.FamilyID = Family.FamilyID AND
                                              	     Stem.TreeID = Tree.TreeID AND
                                  	                 Quadrat.QuadratID = Stem.QuadratID AND
                                                     Tree.SubSpeciesID IS NULL");

      $q4 = $this->cvdb->query("INSERT INTO SGFtemp (Family, Genus, SpeciesName, SubSpeciesName, SpeciesID, Mnemonic, TreeID, StemID, QuadratID, PlotID)
                                                     SELECT DISTINCT Family.Family, Genus.Genus, Species.SpeciesName, SubSpecies.SubSpeciesName, Species.SpeciesID, SubSpecies.Mnemonic,
                                                     Tree.TreeID, Stem.StemID, Stem.QuadratID, Quadrat.PlotID
                                                     FROM Species, Genus, Family, Tree, Stem, Quadrat, SubSpecies
                                                     WHERE Species.SpeciesID = Tree.SpeciesID  AND
                                                     Species.GenusID = Genus.GenusID AND
                                                     Genus.FamilyID = Family.FamilyID AND
                                                     Stem.TreeID = Tree.TreeID AND
                                  	                 Quadrat.QuadratID = Stem.QuadratID AND
                                  	                 Tree.SubSpeciesID = SubSpecies.SubSpeciesID
                                                     AND Tree.SubSpeciesID IS NOT NULL");
    }

    function MPQTtemp()
    {
      $q1 = $this->cvdb->query("DROP TABLE IF EXISTS MPQTtemp");

      $q2 = $this->cvdb->query("CREATE TABLE MPQTtemp (DBHID INT NOT NULL,
                                                    	PlotID INT NOT NULL,
                                                    	PlotName CHAR(64),
                                                    	QuadratID INT NOT NULL,
                                                    	QuadratName CHAR(12),
                                                    	QX FLOAT(8),
                                                    	QY FLOAT(8),
                                                    	PX FLOAT(8),
                                                    	PY FLOAT(8),
                                                    	TreeID  INT  NOT NULL,
                                                    	Tag char(10),
                                                    	StemID  INT  NOT NULL,
                                                    	StemNumber INT NOT NULL,
                                                    	StemTag VARCHAR(32),
                                                        Moved enum('Y','N') NOT NULL,
                                                    	PrimaryStem CHAR(20),
                                                    	CensusID INT  NOT NULL,
                                                    	PlotCensusNumber INT,
                                                    	DBH FLOAT(8),
                                                    	HOM FLOAT(8),
                                                    	ExactDate date,
                                                    	ListOfTSM VARCHAR(256),
                                                        PRIMARY KEY (DBHID),
                                                        KEY (TreeID),
                                                        KEY (StemID)
                                                        ) ENGINE=MyISAM");

      $q3 = $this->cvdb->query("INSERT INTO MPQTtemp (DBHID, PlotID, PlotName, QuadratID, QuadratName, QX, QY, PX, PY, TreeID, Tag,
                                                      StemID, StemNumber, StemTag, Moved, PrimaryStem, CensusID, PlotCensusNumber, DBH, HOM, ExactDate)
                                                      SELECT DISTINCT
                                                      DBH.DBHID, Quadrat.PlotID, Site.PlotName, Quadrat.QuadratID, Quadrat.QuadratName,
                                                      Stem.QX, Stem.QY, Stem.PX, Stem.PY, Tree.TreeID, Tree.Tag, DBH.StemID, Stem.StemNumber, Stem.StemTag, Stem.Moved,
                                                      DBH.PrimaryStem, DBH.CensusID, Census.PlotCensusNumber,
                                                      DBH.DBH, DBH.HOM, DBH.ExactDate
                                                      FROM DBH, Quadrat, Stem, Tree, Census, Site
                                                      WHERE Tree.TreeID = Stem.TreeID AND
                                                      Stem.StemID = DBH.StemID AND
                                                      Stem.TreeID = Tree.TreeID AND
                                                      DBH.CensusID = Census.CensusID AND
                                                      Quadrat.PlotID = Site.PlotID AND
                                                	  Quadrat.QuadratID = Stem.QuadratID");
    }

    function viewFullTable()
    {
      $q1 = $this->cvdb->query("DROP TABLE IF EXISTS ViewFullTable");

      $q2 = $this->cvdb->query("CREATE TABLE ViewFullTable (DBHID INT NOT NULL,
                                                            PlotID INT NOT NULL,
                                                        	Plot VARCHAR(35),
                                                        	Family CHAR(32),
                                                        	GenusSpecies CHAR(64),
                                                        	Genus CHAR(32),
                                                        	SpeciesName CHAR(64),
                                                            SubSpeciesName CHAR(64),
                                                            SpeciesID INT UNSIGNED,
                                                            Mnemonic CHAR(10),
                                                        	QuadratID INT NOT NULL,
                                                        	QuadratName VARCHAR(12),
                                                        	QX decimal(16,5),
                                                        	QY decimal(16,5),
                                                        	PX decimal(16,5),
                                                        	PY decimal(16,5),
                                                        	TreeID  INT  NOT NULL,
                                                        	Tag char(10),
                                                        	StemID  INT  NOT NULL,
                                                        	StemNumber INT NOT NULL,
                                                        	StemTag VARCHAR(32),
                                                            Moved enum('Y','N') NOT NULL,
                                                        	PrimaryStem CHAR(20),
                                                        	CensusID INT  NOT NULL,
                                                            PlotCensusNumber INT,
                                                        	DBH FLOAT(8),
                                                        	HOM FLOAT(8),
                                                        	ExactDate date,
                                                        	ListOfTSM VARCHAR(256),
                                                            HighHOM bool,
                                                            MainStem bool,
                                                            Status VARCHAR(25),
                                                            PRIMARY KEY (DBHID),
                                                            KEY(Genus(5)),
                                                            KEY(SpeciesName(5)),
                                                          	KEY(SpeciesID),
                                                            KEY(QuadratName(4)),
                                                            KEY(PlotCensusNumber),
                                                            KEY(DBH)
                                                        ) ENGINE=MYISAM");

      $q3 = $this->cvdb->query("ALTER TABLE `ViewFullTable` ADD INDEX `ForDataEntry` (TreeID, StemID, CensusID, DBHID)");

      $q4 = $this->cvdb->query("ALTER TABLE `ViewFullTable` ADD INDEX `ForDataScreening` (Tag, StemTag, PlotID)");

      $q5 = $this->cvdb->query("INSERT INTO ViewFullTable(DBHID, PlotID, Plot, Family, GenusSpecies, Genus, SpeciesName, SubSpeciesName, SpeciesID, Mnemonic,
                                                         QuadratID, QuadratName, QX, QY, PX, PY, TreeID, Tag, StemID, StemNumber, StemTag, Moved,
                                                         PrimaryStem, CensusID, PlotCensusNumber, DBH, HOM, ExactDate, ListOfTSM, Status)
                                                         SELECT MPQTtemp.DBHID, MPQTtemp.PlotID, MPQTtemp.PlotName, SGFtemp.Family,
                                                         concat(SGFtemp.Genus, ' ', SGFtemp.SpeciesName), SGFtemp.Genus,
                                                         SGFtemp.SpeciesName, SGFtemp.SubSpeciesName, SGFtemp.SpeciesID, SGFtemp.Mnemonic, MPQTtemp.QuadratID,
                                                         MPQTtemp.QuadratName, MPQTtemp.QX, MPQTtemp.QY,
                                                         MPQTtemp.PX, MPQTtemp.PY, MPQTtemp.TreeID,
                                                         MPQTtemp.Tag, MPQTtemp.StemID, MPQTtemp.StemNumber,
                                                  	     MPQTtemp.StemTag, MPQTtemp.Moved, MPQTtemp.PrimaryStem,
                                                         MPQTtemp.CensusID, MPQTtemp.PlotCensusNumber,
                                                         MPQTtemp.DBH, MPQTtemp.HOM, MPQTtemp.ExactDate, MPQTtemp.ListOfTSM, 'alive'
                                                        FROM MPQTtemp, SGFtemp
                                                        WHERE MPQTtemp.StemID = SGFtemp.StemID");
      $q6 = $this->cvdb->query("DROP TABLE IF EXISTS MPQTtemp");
      $q7 = $this->cvdb->query("DROP TABLE IF EXISTS SGFtemp");
    }

    function getDBHData()
    {
      $q1 = $this->cvdb->query("SELECT DBHID FROM ViewFullTable");

      return $q1;
    }

    function getTSMData($dbhID)
    {
      $q1 = $this->cvdb->query("SELECT TSMAttributes.TSMCode AS TSMCode
                                FROM DBHAttributes JOIN TSMAttributes USING (TSMID)
                                WHERE ".$dbhID." = DBHAttributes.DBHID");
      return $q1;
    }

    function updVFTListOfTSM($dbhID,$listOfTSM)
    {
      $q1 = $this->cvdb->query("UPDATE ViewFullTable SET ListOfTSM = '".$listOfTSM."'
                                                     WHERE DBHID = ".$dbhID);
    }

    function updStatus()
    {
      //Get the dead and lost stem TSMcodes from the table
	  $deadcode=$this->getCodes('%dead%');
	  $loststemcode=$this->getCodes('%stem%lost%');
	  if(empty($loststemcode[0]))
      {
        $loststemcode=$this->getCodes('%lost%stem%');
      }
      if(empty($loststemcode[0]))
      {
        $loststemcode=$this->getCodes('resprout');
      }

      foreach($deadcode as $dead)
      {

        $deadLike1=$dead.',%';
    	$deadLike2='%,'.$dead;
    	$deadLike3='%,'.$dead.',%';

        $deadQ = $this->cvdb->query("UPDATE ViewFullTable SET Status='dead' WHERE
                                     ListOfTSM LIKE '".$deadLike1."' OR ListOfTSM LIKE '".$deadLike2."' OR ListOfTSM LIKE '".$deadLike3."' OR ListOfTSM='".$dead."' ");
      }
      foreach($loststemcode as $lost)
      {
        $lostLike1=$lost.',%';
  	    $lostLike2='%,'.$lost;
  	    $lostLike3='%,'.$lost.',%';

        $lostQ = $this->cvdb->query("UPDATE ViewFullTable SET Status='lost_stem' WHERE
                                     ListOfTSM LIKE '".$lostLike1."' OR ListOfTSM LIKE '".$lostLike2."' OR ListOfTSM LIKE '".$lostLike3."' OR ListOfTSM='".$lost."' ");
      }

      $missingQ = $this->cvdb->query("UPDATE ViewFullTable SET Status='missing' WHERE ListOfTSM IS NULL AND DBH IS NULL");
    }

    function getCodes($description)
    {
      $query = $this->cvdb->query("SELECT TSMCode FROM TSMAttributes WHERE Description LIKE '" . $description . "'");

      $codesarr = array();

      if($query->num_rows() > 0)
      {
        $j = 0;
        foreach($query->result() as $row)
        $codesarr[$j++] = $row->TSMCode;
      }
      else
      {
        $codesarr[0] = '';
      }

      return $codesarr;
    }
/////////////////ViewFullTable Status Update - Read directly from TSMAttribute table/////////////////////////////////////
     function updStatus2() {
      //Get the dead and lost stem TSMcodes from the table
	  $deadcode=$this->getCodes2('dead');
	  $brokenBelowCode=$this->getCodes2('broken below');
	  $notFoundCode = $this->getCodes2('not found');
      $notMeasuredCode = $this->getCodes2('alive-not measured');


      foreach($notMeasuredCode as $notMeasured)
      {
        $notMeasuredLike1=$notMeasured.',%';
  	    $notMeasuredLike2='%,'.$notMeasured;
  	    $notMeasuredLike3='%,'.$notMeasured.',%';

        $lostQ = $this->cvdb->query("UPDATE ViewFullTable2015 SET Status='alive-not measured' WHERE
                                     ListOfTSM LIKE '".$notMeasuredLike1."' OR ListOfTSM LIKE '".$notMeasuredLike2."' OR ListOfTSM LIKE '".$notMeasuredLike3."' OR ListOfTSM='".$notMeasured."' ");
      }

      foreach($notFoundCode as $notFound)
      {
        $notFoundLike1=$notFound.',%';
  	    $notFoundLike2='%,'.$notFound;
  	    $notFoundLike3='%,'.$notFound.',%';

        $lostQ = $this->cvdb->query("UPDATE ViewFullTable2015 SET Status='not found' WHERE
                                     ListOfTSM LIKE '".$notFoundLike1."' OR ListOfTSM LIKE '".$notFoundLike2."' OR ListOfTSM LIKE '".$notFoundLike3."' OR ListOfTSM='".$notFound."' ");
      }

      foreach($brokenBelowCode as $broken)
      {
        $brokenLike1=$broken.',%';
  	    $brokenLike2='%,'.$broken;
  	    $brokenLike3='%,'.$broken.',%';

        $lostQ = $this->cvdb->query("UPDATE ViewFullTable2015 SET Status='broken below' WHERE
                                     ListOfTSM LIKE '".$brokenLike1."' OR ListOfTSM LIKE '".$brokenLike2."' OR ListOfTSM LIKE '".$brokenLike3."' OR ListOfTSM='".$broken."' ");
      }

      foreach($deadcode as $dead)
      {

        $deadLike1=$dead.',%';
    	$deadLike2='%,'.$dead;
    	$deadLike3='%,'.$dead.',%';

        $deadQ = $this->cvdb->query("UPDATE ViewFullTable2015 SET Status='dead' WHERE
                                     ListOfTSM LIKE '".$deadLike1."' OR ListOfTSM LIKE '".$deadLike2."' OR ListOfTSM LIKE '".$deadLike3."' OR ListOfTSM='".$dead."' ");
      }

      $missingQ = $this->cvdb->query("UPDATE ViewFullTable2015 SET Status='not found' WHERE ListOfTSM IS NULL AND DBH IS NULL");

    }

    function getCodes2($status) {
      $query = $this->cvdb->query("SELECT TSMCode FROM TSMAttributes WHERE Status = '".$status."'");

      $codesarr = array();

      if($query->num_rows() > 0)
      {
        $j = 0;
        foreach($query->result() as $row)
        $codesarr[$j++] = $row->TSMCode;
      }
      else
      {
        $codesarr[0] = '';
      }

      return $codesarr;
    }
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////

    function tax1temp()
    {
      $q1 = $this->cvdb->query("DROP TABLE IF EXISTS ViewTaxonomy");

      $q2 = $this->cvdb->query("CREATE TABLE ViewTaxonomy (
                            	SpeciesID INT NOT NULL,
                            	SubspeciesID INT,
                            	Family CHAR(32),
                            	Genus CHAR(32),
                            	Mnemonic CHAR(10),
                            	SpeciesName CHAR(64),
                            	SubspeciesName CHAR(64),
                            	IDLevel  CHAR(32),
                            	Authority CHAR(124),
                            	ListOfOldNames VARCHAR(255),
                            	NumberOfHerbarium INT,
                            	ListOfHerbarium VARCHAR(255),
                            	Description VARCHAR(128),
                                LocalName varchar(128) default NULL,
                                ReferenceID char(15) default NULL,
                                FieldFamily char(32) default NULL,
                                Lifeform char(32) default NULL,
                                PRIMARY KEY (SpeciesID, SubspeciesID)
                                ) ENGINE=MyISAM");

      $q3 = $this->cvdb->query("INSERT INTO ViewTaxonomy(SpeciesID, Family, Genus, Mnemonic, SpeciesName, IDLevel, Authority, Description, LocalName, ReferenceID, FieldFamily, Lifeform)
                                SELECT distinct(Species.SpeciesID),Family.Family, Genus.Genus,
                                  Species.Mnemonic, Species.SpeciesName,
                                  Species.IDLevel, Species.Authority, Species.Description, Species.LocalName, Species.ReferenceID, Species.FieldFamily, Species.Lifeform
                                  FROM   Species, Genus, Family
                                  WHERE  Species.CurrentTaxonFlag = 1 AND
                                  Family.FamilyID = Genus.FamilyID AND
                                  Genus.GenusID = Species.GenusID
                                  ORDER BY Species.SpeciesID");

      $q4 = $this->cvdb->query("DELETE FROM ViewTaxonomy USING ViewTaxonomy, SubSpecies
                                WHERE ViewTaxonomy.SpeciesID = SubSpecies.SpeciesID");

      $q5 = $this->cvdb->query("INSERT INTO ViewTaxonomy(SpeciesID, SubspeciesID, Family, Genus, SpeciesName, SubspeciesName, IDLevel, Authority, Description,LocalName, ReferenceID, FieldFamily, Lifeform)
                                SELECT SubSpecies.SpeciesID, SubSpecies.SubspeciesID, F.Family, G.Genus,
                                Species.SpeciesName, SubSpecies.SubspeciesName,
                                Species.IDLevel, Species.Authority, Species.Description, Species.LocalName, Species.ReferenceID, Species.FieldFamily, Species.Lifeform
                                FROM Species, Genus G, Family F, SubSpecies
                                WHERE Species.CurrentTaxonFlag = 1 AND
                                       SubSpecies.CurrentTaxonFlag = 1 AND
                                       F.FamilyID = G.FamilyID AND
                                       G.GenusID = Species.GenusID AND
                                       Species.SpeciesID = SubSpecies.SpeciesID
                                ORDER BY Species.SpeciesID");

    }

    function tax2temp()
    {
      $q1 = $this->cvdb->query("DROP TABLE IF EXISTS TAX2temp");
      $q2 = $this->cvdb->query("CREATE TABLE TAX2temp (SpeciesID INT NOT NULL,
                                                       ObsoleteSpeciesID INT NOT NULL,
                                                       ObsoleteGenusName CHAR(32),
                                                       ObsoleteSpeciesName CHAR(64),
                                                       ObsoleteGenSpeName CHAR(128),
                                                       Description CHAR(128),
                                                       ChangeDate DATE,
                                                       Family CHAR(32),
                                                       Genus CHAR(32),
                                                       SpeciesName CHAR(64),
                                                       Authority CHAR(128),
                                                       IDLevel  CHAR(8),
                                                       PRIMARY KEY (SpeciesID, ObsoleteSpeciesID, ChangeDate)
                                                       )ENGINE=MyISAM");
      $q3 = $this->cvdb->query("INSERT INTO TAX2temp (SpeciesID, ObsoleteSpeciesID, ObsoleteSpeciesName, Description, ChangeDate, Family, Genus, SpeciesName, Authority, IDLevel)
                                                      SELECT CO.SpeciesID, CO.ObsoleteSpeciesID, S2.SpeciesName,
                                                             TTC.Description, CO.ChangeDate, F.Family, G.Genus,
                                                             S1.SpeciesName, S1.Authority, S1.IDLevel
                                                      FROM Species S1, CurrentObsolete CO, TreeTaxChange TTC,
                                                           Genus G, Family F, Species S2
                                                      WHERE
                                                            S1.SpeciesID = CO.SpeciesID AND
                                                            S2.SpeciesID = CO.ObsoleteSpeciesID AND
                                                            S2.ObsoleteTaxonFlag = 1 AND
                                                            S1.GenusID = G.GenusID AND
                                                            G.FamilyID = F.FamilyID AND
                                                            CO.ChangeCodeID = TTC.ChangeCodeID
                                                      ORDER BY S1.SpeciesID");
    }

    function tax3temp()
    {
      $q1 = $this->cvdb->query("DROP TABLE IF EXISTS TAX3temp");

      $q2 = $this->cvdb->query("CREATE TABLE TAX3temp (PlotSpeciesID INT AUTO_INCREMENT,
                                                  	   PlotID INT NOT NULL,
                                                  	   SpeciesID INT NOT NULL,
                                                  	   SubSpeciesID INT,
                                                       PRIMARY KEY (PlotSpeciesID)
                                                       )ENGINE=MyISAM");
      $q3 = $this->cvdb->query("INSERT INTO TAX3temp (PlotID, SpeciesID, SubSpeciesID)
                                                      SELECT DISTINCT Quadrat.PlotID, Tree.SpeciesID, Tree.SubSpeciesID
                                                      FROM Tree, Stem, Quadrat
                                                      WHERE Quadrat.QuadratID = Stem.QuadratID AND
                                                		    Stem.TreeID = Tree.TreeID");
      $q4 = $this->cvdb->query("INSERT INTO TAX3temp (PlotID, SpeciesID, SubspeciesID)
                                                      SELECT DISTINCT PlotID, SpeciesID, SubSpeciesID
                                                      FROM SpeciesInventory");

      $q5 = $this->cvdb->query("ALTER TABLE `TAX3temp` ADD INDEX `TAX3Plot` (PlotID, SpeciesID, SubspeciesID)");
    }

    function getSpeciesIDs()
    {
      $q1 = $this->cvdb->query("SELECT SpeciesID FROM Species");
      return $q1;
    }

    function getHerbarium($speciesID)
    {
      $q1 = $this->cvdb->query("SELECT Herbarium FROM Species S, Specimen
                                WHERE S.SpeciesID = Specimen.SpeciesID
                                AND S.SpeciesID = ".$speciesID);
      return $q1;
    }

    function updListOfHerbarium($speciesID,$numberOfHerbarium,$listOfHerbarium)
    {
      $q1 = $this->cvdb->query("UPDATE ViewTaxonomy SET
                                ListOfHerbarium = '".$listOfHerbarium."',
				                NumberOfHerbarium = ".$numberOfHerbarium."
      				            WHERE SpeciesID = ".$speciesID);
    }

    function getSpeciesData($speciesID)
    {
      $q1 = $this->cvdb->query("SELECT S2.SpeciesName AS SpeciesName, S2.GenusID AS GenusID, CO.ObsoleteSpeciesID AS ObsoleteSpeciesID
                                FROM CurrentObsolete CO, Species S1, Species S2
                                WHERE ".$speciesID." = S1.SpeciesID AND
			                    S1.SpeciesID = CO.SpeciesID AND
                                CO.ObsoleteSpeciesID = S2.SpeciesID");
      return $q1;
    }

    function getGenus($genusID)
    {
      $q1 = $this->cvdb->query("SELECT Genus FROM Genus
                                WHERE GenusID = ".$genusID);
      return $q1;
    }

    function updTax1temp($listOfOldNames,$startingSpeciesID)
    {
      $q1 = $this->cvdb->query("UPDATE ViewTaxonomy SET ListOfOldNames = '".$listOfOldNames."'
      				            WHERE SpeciesID = ".$startingSpeciesID);
    }

    function getTAX2temp()
    {
      $q1 = $this->cvdb->query("SELECT SpeciesID, ObsoleteSpeciesID, ObsoleteSpeciesName FROM TAX2temp");
      return $q1;
    }

    function getGenusName($obsoleteSpeciesID)
    {
      $q1 = $this->cvdb->query("SELECT G.Genus As Genus FROM Genus G, Species S
                                WHERE S.SpeciesID = ".$obsoleteSpeciesID." AND
			                    S.ObsoleteTaxonFlag = 1 AND
			                    S.GenusID = G.GenusID");
      return $q1;
    }

    function updTax2temp($oldGenusName,$obsoleteSpeciesName,$speciesID,$obsoleteSpeciesID)
    {
      $q1 = $this->cvdb->query("UPDATE TAX2temp
	                            SET ObsoleteGenusName = '".$oldGenusName."',
                                ObsoleteGenSpeName = concat('".$oldGenusName."',' ','".$obsoleteSpeciesName."')
      		                    WHERE SpeciesID = ".$speciesID." AND
                                ObsoleteSpeciesID = ".$obsoleteSpeciesID);
    }
    //$q4 = $this->cvdb->query("");
}