<?php

class Dataentrymodel extends Model{

    function Dataentrymodel()
    {
      parent::Model();
      $database = $this->session->userdata('databaseName');
      $this->db5 = $this->load->database($database,TRUE);
    }

    function getPlotName()
    {
      //$this->db5->distinct();
      $this->db5->select('PlotID,PlotName');
      $query = $this->db5->get('Site');
      $plotNameA['default'] = 'Select';
      foreach($query->result() as $row)
      {
        $plotNameA[$row->PlotID] = $row->PlotName;
      }
      return $plotNameA;
    }

    function getCensusList($plotID)
    {
      $this->db5->distinct();
      $this->db5->select('PlotCensusNumber');
      $this->db5->where('PlotID',$plotID);
      $query = $this->db5->get('Census');
      $censusNumberA['default'] = 'Select';
      foreach($query->result() as $row)
      {
        $censusNumberA[$row->PlotCensusNumber] = $row->PlotCensusNumber;
      }
      return $censusNumberA;
    }

    function getCensusIDByCensusNumber($censusNumber,$plotID)
    {
      $this->db5->select('CensusID');
      $this->db5->where('PlotID',$plotID);
      $this->db5->where('PlotCensusNumber',$censusNumber);
      $query = $this->db5->get('Census');
      $row = $query->row();
      $censusID = $row->CensusID;
      return $censusID;
    }

    function getPlotByID($plotID)
    {
      $this->db5->select('*');
      $this->db5->where('PlotID',$plotID);
      $query = $this->db5->get('Site');
      return $query;
    }

    function getQuadratList($plotID,$censusNumber)
    {
      $this->db5->distinct();
      $this->db5->select('QuadratName');
      $this->db5->where('PlotID',$plotID);
      $this->db5->where('PlotCensusNumber',$censusNumber);
      $this->db5->order_by('QuadratName');
      $query = $this->db5->get('TempPersonnelInfo');
      if($query->num_rows() > 0)
      {
        $quadratListA['default'] = 'Select';
        foreach($query->result() as $row)
        {
          $quadratListA[$row->QuadratName] = $row->QuadratName;
        }
      }
      else
      {
        $quadratListA['default'] = 'No Record Found';
      }
      return $quadratListA;
    }

    function getRecordByID($recordID,$keyName,$tableName)
    {
      $this->db5->select('*');
      $this->db5->where($keyName,$recordID);
      $query = $this->db5->get($tableName);
      return $query;
    }

    function deleteRecordByID($recordID,$keyName,$tableName)
    {
      $this->db5->where($keyName,$recordID);
      $this->db5->delete($tableName);
    }

///////////////      Old Tree     ///////////////////////////
    function listQuadratOldTree($quadratName,$plotName,$censusNumber,$limit,$offset)
    {
      $this->db5->select('QuadratName,Subquad,Tag,StemTag,Mnemonic,OldDBH,OldCodes,DBH,HOM,Codes,ExactDate,Comments,Errors,TempID');
      $this->db5->where('QuadratName',$quadratName);
      //$this->db5->where('PlotID',$plotName);
      $this->db5->where('PlotCensusNumber',$censusNumber);
      $this->db5->order_by('QuadratName,Subquad,Tag,StemTag');
      $this->db5->limit($limit,$offset);
      $query = $this->db5->get('TempOldTrees');
      return $query;
    }

    function listQuadratOldTreeCount($quadratName,$plotName,$censusNumber)
    {
      $this->db5->select('QuadratName,Subquad,Tag,StemTag,Mnemonic,OldDBH,OldCodes,DBH,HOM,Codes,ExactDate,Comments,Errors,TempID');
      $this->db5->where('QuadratName',$quadratName);
      //$this->db5->where('PlotID',$plotName);
      $this->db5->where('PlotCensusNumber',$censusNumber);
      $this->db5->order_by('QuadratName,Subquad,Tag,StemTag');
      $query = $this->db5->get('TempOldTrees');
      $count = $query->num_rows();
      return $count;
    }

    function oldTreeRecordUpdate($tempID,$updateData)
    {
      $this->db5->trans_start();
      $this->db5->where('TempID',$tempID);
      $this->db5->update('TempOldTrees',$updateData);
      $this->db5->trans_complete();
      if ($this->db5->trans_status() === TRUE)
      {
        $updateStatus = "OK";
      }
      else
      {
        $updateStatus = "Error";
      }
      return $updateStatus;
    }
    //For Download Function
    function listAllQuadratOldTree($quadratName,$plotName,$censusNumber)
    {
      $this->db5->select('QuadratName,Subquad,Tag,StemTag,Mnemonic,OldDBH,OldCodes,DBH,HOM,Codes,ExactDate,Comments,Errors,TempID');
      $this->db5->where('QuadratName',$quadratName);
      //$this->db5->where('PlotID',$plotName);
      $this->db5->where('PlotCensusNumber',$censusNumber);
      $this->db5->order_by('QuadratName,Subquad,Tag,StemTag');
      $query = $this->db5->get('TempOldTrees');
      return $query;
    }

    function listAllCommentOldTree($plotName,$censusNumber,$limit,$offset)
    {
      $this->db5->select('QuadratName,Subquad,Tag,StemTag,Mnemonic,OldDBH,OldCodes,DBH,HOM,Codes,ExactDate,Comments,Errors,TempID');
      //$this->db5->where('QuadratName',$quadratName);
      //$this->db5->where('PlotID',$plotName);
      $this->db5->where('PlotCensusNumber',$censusNumber);
      $this->db5->where('Comments !=','');
      $this->db5->order_by('QuadratName,Subquad,Tag,StemTag');
      $this->db5->limit($limit,$offset);
      $query = $this->db5->get('TempOldTrees');
      return $query;
    }

    function listAllCommentOldTreeCount($plotName,$censusNumber)
    {
      $this->db5->select('QuadratName,Subquad,Tag,StemTag,Mnemonic,OldDBH,OldCodes,DBH,HOM,Codes,ExactDate,Comments,Errors,TempID');
      //$this->db5->where('QuadratName',$quadratName);
      //$this->db5->where('PlotID',$plotName);
      $this->db5->where('PlotCensusNumber',$censusNumber);
      $this->db5->where('Comments !=','');
      $this->db5->order_by('QuadratName,Subquad,Tag,StemTag');
      $query = $this->db5->get('TempOldTrees');
      $count = $query->num_rows();
      return $count;
    }

    function listCommentOldTree($quadratName,$plotName,$censusNumber,$limit,$offset)
    {
      $this->db5->select('QuadratName,Subquad,Tag,StemTag,Mnemonic,OldDBH,OldCodes,DBH,HOM,Codes,ExactDate,Comments,Errors,TempID');
      $this->db5->where('QuadratName',$quadratName);
      //$this->db5->where('PlotID',$plotName);
      $this->db5->where('PlotCensusNumber',$censusNumber);
      $this->db5->where('Comments !=','');
      $this->db5->order_by('QuadratName,Subquad,Tag,StemTag');
      $this->db5->limit($limit,$offset);
      $query = $this->db5->get('TempOldTrees');
      return $query;
    }

    function listCommentOldTreeCount($quadratName,$plotName,$censusNumber)
    {
      $this->db5->select('QuadratName,Subquad,Tag,StemTag,Mnemonic,OldDBH,OldCodes,DBH,HOM,Codes,ExactDate,Comments,Errors,TempID');
      $this->db5->where('QuadratName',$quadratName);
      //$this->db5->where('PlotID',$plotName);
      $this->db5->where('PlotCensusNumber',$censusNumber);
      $this->db5->where('Comments !=','');
      $this->db5->order_by('QuadratName,Subquad,Tag,StemTag');
      $query = $this->db5->get('TempOldTrees');
      $count = $query->num_rows();
      return $count;
    }

    function createPersonnelTempTable()
    {
      $query = $this->db5->query("CREATE TABLE IF NOT EXISTS `TempPersonnelInfo`
                                (`TempID` int(10) unsigned NOT NULL auto_increment,
                                `QuadratName` varchar(12) default NULL,
                                `QuadratID` int(10) unsigned default NULL,
                                `PersonnelID` smallint(5) unsigned default NULL,
                                `Form` varchar(32) default NULL,
                                `PlotID` int(10) unsigned default NULL,
                                `CensusID` int(10) unsigned default NULL,
                                `PlotCensusNumber` int(10) unsigned default NULL,
                                `Role` varchar(128) default NULL,
                                `RoleID` smallint(5) unsigned default NULL,
                                `DateWorked` date default NULL,
                                `Errors` varchar(256) default NULL,
                                PRIMARY KEY  (`TempID`),
                                KEY `indexQuadratName` (`QuadratName`)
                                )ENGINE=MyISAM DEFAULT CHARSET=latin1");
      return $query; //will return true or false
    }

    function createFormTempTable($tempTableName)
    {
      $query = $this->db5->query("CREATE TABLE IF NOT EXISTS $tempTableName
                                (`TempID` int(10) unsigned NOT NULL auto_increment,
                                `TreeID` int(10) unsigned default NULL,
                                `Tag` varchar(10) default NULL,
                                `StemID` int(10) unsigned default NULL,
                                `StemTag` varchar(32) default NULL,
                                `QuadratID` int(10) unsigned default NULL,
                                `QuadratName` varchar(12) default NULL,
                                `Subquad` int(10) unsigned default NULL,
                                `SpeciesID` int(10) unsigned default NULL,
                                `Mnemonic` varchar(10) default NULL,
                                `SubSpeciesID` int(10) unsigned default NULL,
                                `PlotID` int(10) unsigned default NULL,
                                `CensusID` int(10) unsigned default NULL,
                                `PlotCensusNumber` int(10) unsigned default NULL,
                                `PrimaryStem` varchar(20) default NULL,
                                `X` float default NULL,
                                `Y` float default NULL,
                                `DBH` float default NULL,
                                `OldDBH` float default NULL,
                                `HOM` float default NULL,
                                `OldHOM` float default NULL,
                                `Codes` varchar(50) default NULL,
                                `OldCodes` varchar(50) default NULL,
                                `Comments` varchar(256) default NULL,
                                `ExactDate` date default NULL,
                                `Errors` varchar(256) default NULL,
                                `OldTrees` varchar(10) default NULL,
                                `BigTrees` varchar(10) default NULL,
                                `Extra1` varchar(80) default NULL,
                                `Extra2` varchar(80) default NULL,
                                `Extra3` varchar(80) default NULL,
                                `Extra4` varchar(80) default NULL,
                                `Extra5` varchar(80) default NULL,
                                PRIMARY KEY  (`TempID`),
                                KEY `indexTagStemTag` (`Tag`,`StemTag`),
                                KEY `indexTreeIDStemID` (`TreeID`,`StemID`),
                                KEY `indexQuadratNamePlotID` (`QuadratName`,`PlotID`),
                                KEY `indexMnemonic` (`Mnemonic`)
                                ) ENGINE=MyISAM  DEFAULT CHARSET=latin1");
       return $query; //will return true or false
    }

    function createSpeciesTempTable()
    {
      $query = $this->db5->query("CREATE TABLE IF NOT EXISTS TempSpecies(
                                 TempSpeciesID    INT UNSIGNED AUTO_INCREMENT,
                                 Mnemonic         VARCHAR(10),
                                 Genus            VARCHAR(32),
                                 SpeciesName      VARCHAR(64),
                                 FieldFamily      VARCHAR(32),
                                 Authority        VARCHAR(128),
                                 IDLevel          VARCHAR(8),
                                 GenusID          INT(10),
                                 SpeciesID        INT(10),
                                 Family           VARCHAR(32),
                                 Errors           VARCHAR(256),
                                 PRIMARY KEY (TempSpeciesID),
                                 KEY indexGenus (Genus)
                                 )ENGINE=MyISAM DEFAULT CHARSET=latin1");
      return $query; //will return true or false
    }

    function createQuadratTempTable()
    {
      $query = $this->db5->query("CREATE TABLE IF NOT EXISTS TempQuadratDates(
                                 TempQuadID       INT UNSIGNED  AUTO_INCREMENT,
                                 QuadratName      VARCHAR(12),
                                 PrevDate         Date,
                                 PRIMARY KEY (TempQuadID)
                                )ENGINE=MyISAM DEFAULT CHARSET=latin1");
      return $query; //will return true or false
    }

    function createLocationTempTable()
    {
      $query = $this->db5->query("CREATE TABLE IF NOT EXISTS TempLocations(
                                  TempLocationID   INT UNSIGNED  AUTO_INCREMENT,
                                  QuadratName      VARCHAR(12),
                                  Tag              VARCHAR(10),
                                  X                FLOAT(8),
                                  Y                FLOAT(8),
                                  Comments         VARCHAR(256) DEFAULT NULL,
                                  TreeID           INT UNSIGNED,
                                  PlotCensusNumber INT UNSIGNED,
                                  CensusID         INT UNSIGNED,
                                  PlotID           INT UNSIGNED,
                                  Errors           VARCHAR(256),
                                  OldTrees         VARCHAR(10),
                                  PRIMARY KEY (TempLocationID),
                                  KEY indexTag (Tag),
                                  KEY indexTreeID (TreeID),
                                  KEY indexQuadratName (QuadratName)
                                  )ENGINE=MyISAM DEFAULT CHARSET=latin1");
      return $query; //will return true or false
    }

    function getRoleID($role)
    {
      $this->db5->select('RoleID');
      $this->db5->where('Description',$role);
      $query = $this->db5->get('RoleReference');
      $row = $query->row();
      $roleID = $row->RoleID;
      return $roleID;
    }

    function insertRowIntoTable($tableName,$insertArray)
    {
      $query = $this->db5->insert($tableName,$insertArray);
      return $query;
    }

    function startTransaction()
    {
      $this->db5->trans_start();
    }

    function completeTransaction()
    {
      $this->db5->trans_complete();
      $status = 'Success';
      if ($this->db5->trans_status() === FALSE)
      {
        $status = 'Error';
      }
      return $status;
    }

}