<?php
class Formmodel extends Model{

    function Formmodel()
    {
      parent::Model();
      $database = $this->session->userdata('databaseName');
      $this->formdb = $this->load->database($database,TRUE);
    }

    function speciesDDQuery($query)
    {
      $dbQuery = $this->formdb->query($query);
      if($dbQuery->num_rows() > 0)
      {
        foreach($dbQuery->result() as $dbRow)
        {
          $ddArray[$dbRow->Mnemonic] = $dbRow->Mnemonic;
        }
      }
      else
      {
        $ddArray['error'] = 'Insert Species';
      }
      return $ddArray;
    }

    function getCensusList($plotID)
    {
      $this->formdb->distinct();
      $this->formdb->select('PlotCensusNumber');
      $this->formdb->where('PlotID',$plotID);
      $query = $this->formdb->get('Census');
      $censusNumberA['default'] = 'Select';
      foreach($query->result() as $row)
      {
        $censusNumberA[$row->PlotCensusNumber] = $row->PlotCensusNumber;
      }
      return $censusNumberA;
    }

    function getAllQuadratNames($plotID)
    {
      $this->formdb->select('QuadratName');
      $this->formdb->where('PlotID',$plotID);
      $query = $this->formdb->get('Quadrat');
      return $query;
    }

    function getQuadratNames($plotID)
    {
      $this->formdb->select('QuadratName');
      $this->formdb->where('PlotID',$plotID);
      $query = $this->formdb->get('Quadrat');
      if($query->num_rows() > 0)
      {
        foreach($query->result() as $row)
        {
          $array[$row->QuadratName] = $row->QuadratName;
        }
      }
      else
      {
        $array['error'] = 'Quadrat List Empty';
      }
      return $array;
    }

    function getPersonnelNames()
    {
      $this->formdb->select('PersonnelID,FirstName,LastName');
      $this->formdb->from('Personnel');
      $this->formdb->order_by('LastName asc');
      $query = $this->formdb->get();
      if($query->num_rows() > 0)
      {
        foreach($query->result() as $row)
        {
          $array[$row->PersonnelID] = $row->FirstName.' '.$row->LastName;
        }
      }
      else
      {
        $array['error'] = 'Personnel List Empty';
      }
      return $array;
    }

    function getPersonnelNameByID($id)
    {
      $this->formdb->select('FirstName,LastName');
      $this->formdb->from('Personnel');
      $this->formdb->where('PersonnelID',$id);
      $query = $this->formdb->get();

      $row = $query->row();
      $firstName = trim($row->FirstName);
      $lastName = trim($row->LastName);
      $name = $firstName.$lastName;
      return $name;
    }

    function subquadDDQuery($query)
    {
      $dbQuery = $this->formdb->query($query);
      return $dbQuery;
    }

    function olddataextract($lastCensusID,$plotID,$quadratName,$maxX,$maxY,$dimX,$dimY,$orderBy,$treeDeadArray)
    {
      $treeDeadCount = count($treeDeadArray);
      $this->formdb->select('*, TreeID, StemID, QuadratName, QX, QY,(1 + floor((QX-'.$dimX.'*floor(QX/'.$dimX.'))/'.$maxX.')) AS X, (1 + floor((QY-'.$dimY.'*floor(QY/'.$dimY.'))/'.$maxY.')) AS Y, Mnemonic, Tag, StemTag, ListOfTSM, DBH, HOM');
      $this->formdb->from('ViewFullTable');
      $this->formdb->where('PlotCensusNumber',$lastCensusID);
      $this->formdb->where('PlotID',$plotID);
      $this->formdb->where('QuadratName',$quadratName);
      if($lastCensusID > 2 AND $treeDeadCount > 0)
      {
       $this->formdb->where_not_in('TreeID',$treeDeadArray);
      }
      if($orderBy == 'treetag')
      {
        $this->formdb->order_by('Tag asc, StemTag asc, DBH desc');
      }
      else if($orderBy == 'subquadrat')
      {
        $this->formdb->order_by('X asc, Y asc, Tag asc, StemTag asc, DBH desc');
      }
      else
      {
        $this->formdb->order_by('X asc, Y asc, TreeID asc, StemID asc, DBH desc');
      }
      $query = $this->formdb->get();
      //$str = $this->formdb->last_query();
      //echo $str;
      //die();
      return $query;
    }

    function olddataextractField($lastCensusID,$plotID,$quadratName,$maxX,$maxY,$dimX,$dimY,$orderBy,$treeDeadArray,$subQuadratOrder)
    {
      $treeDeadCount = count($treeDeadArray);
      $query = 'SELECT * FROM (SELECT *, CONCAT("",(1 + floor((QX-'.$dimX.'*floor(QX/'.$dimX.'))/'.$maxX.')), (1 + floor((QY-'.$dimY.'*floor(QY/'.$dimY.'))/'.$maxY.'))) AS Subquadrat
                FROM ViewFullTable
                WHERE PlotCensusNumber = '.$lastCensusID.'
                AND PlotID = '.$plotID.'
                AND QuadratName = "'.$quadratName.'"';
      if($lastCensusID > 2 AND $treeDeadCount > 0)
      {
        $treeDeadList = implode(',',$treeDeadArray);
        $query = $query.' AND TreeID NOT IN ('.$treeDeadList.')';
      }
      $query = $query.') AS A';
      if($orderBy == 'treetag')
      {
        $query = $query.' ORDER BY Tag asc, StemTag asc, DBH desc';
      }
      else if($orderBy == 'subquadrat')
      {
        if($subQuadratOrder == '') {
          $query = $query.' ORDER BY Subquadrat asc, Tag asc, StemTag asc, DBH desc';
        }
        else {
          $query = $query.' ORDER BY FIELD(Subquadrat,'.$subQuadratOrder.'), Tag asc, StemTag asc, DBH desc';
        }
      }
      else
      {
        $query = $query.' ORDER BY Subquadrat asc, TreeID asc, StemID asc, DBH desc';
      }

      $runQuery = $this->formdb->query($query);
      return $runQuery;
    }

    function treeDead($lastCensusID,$plotID,$quadratName)
    {
      $twoCensusBack = $lastCensusID - 1;
      $treeIDArray = array();
      /*$this->formdb->select('TreeID');
      $this->formdb->from('ViewFullTable');
      $this->formdb->where('PlotCensusNumber',$twoCensusBack);
      $this->formdb->where('PlotID',$plotID);
      $this->formdb->where('QuadratName',$quadratName);
      $this->formdb->where('Status','dead');
      $query1 = $this->formdb->get();*/
      $query1 = $this->formdb->query("SELECT `TreeID` FROM `ViewFullTable` WHERE `PlotCensusNumber` = ".$twoCensusBack." AND `PlotID` = '".$plotID."' AND `QuadratName` = '".$quadratName."' AND `Status` = 'dead' AND `TreeID` NOT IN (SELECT `TreeID` FROM `ViewFullTable` WHERE `PlotCensusNumber` = ".$lastCensusID." AND `PlotID` = '".$plotID."' AND `QuadratName` = '".$quadratName."' AND `Status` != 'dead')");
      //$str = $this->formdb->last_query();
      //echo $str;
      //die();

      foreach ($query1->result_array() as $row1)
      {
        $treeIDArray[] = $row1['TreeID'];
      }
      //die($this->formdb->last_query());
      return $treeIDArray;
    }

    function treeDeadExclude($lastCensusID,$plotID,$quadratName,$excludeDead) {
      $treeIDArray = array();
      for($i=0;$i<$excludeDead;$i++){
        $excludeDeadA[$i] = $lastCensusID - $i;
      }
      //$excludeDeadCount = count($excludeDeadA);
      $excludeDeadList = implode(',', $excludeDeadA);
      $query1 = $this->formdb->query("SELECT `TreeID` FROM `ViewFullTable` WHERE `PlotID` = '".$plotID."' AND `QuadratName` = '".$quadratName."' AND `Status` = 'dead' AND `PlotCensusNumber` IN (".$excludeDeadList.") AND `TreeID` NOT IN (SELECT `TreeID` FROM `ViewFullTable` WHERE `PlotID`  = '".$plotID."' AND `QuadratName` = '".$quadratName."' AND `Status` != 'dead' AND `PlotCensusNumber` IN (".$excludeDeadList."))");

      foreach ($query1->result_array() as $row1)
      {
        $treeIDArray[] = $row1['TreeID'];
      }
      //die($this->formdb->last_query());
      return $treeIDArray;
    }

    function getPlotNameByID($plotID)
    {
      $this->formdb->select('PlotName');
      $this->formdb->where('PlotID',$plotID);
      $query = $this->formdb->get('Site');
      $row = $query->row();
      $plotName = $row->PlotName;
      return $plotName;
    }

    function getPlotName()
    {
      //$this->db5->distinct();
      $this->formdb->select('PlotID,PlotName');
      $query = $this->formdb->get('Site');
      $plotNameA['default'] = 'Select';
      foreach($query->result() as $row)
      {
        $plotNameA[$row->PlotID] = $row->PlotName;
      }
      return $plotNameA;
    }

    function getQuadratRange($quadratName1,$quadratName2,$plotID)
    {
      $this->formdb->select('QuadratID, QuadratName');
      $this->formdb->where('QuadratName >=',$quadratName1);
      $this->formdb->where('QuadratName <=',$quadratName2);
      $this->formdb->where('PlotID',$plotID);
      $query = $this->formdb->get('Quadrat');
      return $query;
    }

    function getTableColumns($tableName) {
        $runQ = $this->formdb->query('SHOW COLUMNS FROM '.$tableName);
        $list['default'] = 'Select';
        foreach ($runQ->result_array() as $row) {
            $fieldName = $row['Field'];
            $list[$fieldName] = $fieldName;
        }
        return $list;
    }
}