<?php

class Plotdatareportmodel_new extends Model{

    function Plotdatareportmodel_new()
    {
      parent::Model();
      $database = $this->session->userdata('databaseName');
      $this->db3 = $this->load->database($database,TRUE);
    }

    function getPlotNames()
    {
      $this->db3->select('PlotID,PlotName');
      $query = $this->db3->get('Site');
      if($query->num_rows() > 1)
      {
      $plotNameA ['default'] = 'Select';
      }
      foreach($query->result() as $row)
      {
        $plotNameA[$row->PlotID] = $row->PlotName;
      }
      return $plotNameA;

    }

    function getPlotNameByID($plotID)
    {
      $this->db3->select('PlotName');
      $this->db3->where('PlotID',$plotID);
      $query = $this->db3->get('Site');
      $row = $query->row();
      $plotName = $row->PlotName;
      return $plotName;
    }

    function getCensusList($plotID)
    {
      $this->db3->distinct();
      $this->db3->select('PlotCensusNumber');
      $this->db3->where('PlotID',$plotID);
      $query = $this->db3->get('Census');
      $censusNumberA['default'] = 'Select';
      foreach($query->result() as $row)
      {
        $censusNumberA[$row->PlotCensusNumber] = $row->PlotCensusNumber;
      }
      return $censusNumberA;
    }

    function GetPlotDataLimits($plotDataA)
    {
        $plotID = $plotDataA['plotID'];
        $censusNumber = $plotDataA['censusNumber'] ;
        $genus = $plotDataA['genus'];
        $species = $plotDataA['species'];
        $quadrat = $plotDataA['quadrat'];
        $maxX = $plotDataA['maxX'];
        $minX = $plotDataA['minX'];
        $maxY = $plotDataA['maxY'];
        $minY = $plotDataA['minY'];
        $maxDBH = $plotDataA['maxDBH'];
        $minDBH = $plotDataA['minDBH'];
        $includeDT = $plotDataA['includeDT'];
        $stemRadio = $plotDataA['stemRadio'];
        $limit = $plotDataA['limit'];
        $offset = $plotDataA['offset'];

    	$selectpart="SELECT PlotName as Plot, CONCAT(Genus, ' ', SpeciesName) AS Latin, Mnemonic, SubSpecies AS SubSpecies, QuadratName AS Quadrat, PX, PY, TreeID, Tag, StemID, StemTag,
            			PlotCensusNumber AS Census, DBH, HOM, ExactDate AS Date, ListOfTSM AS Codes, PrimaryStem AS Stem, Status
    				FROM ViewFullTable ";

    	// Subquery to get the highest HOM of each stem; if only main or secondary stems are requested, must inlude a stem query
    	// To get matching HOM, must use ABS(maxHOM-HOM), and this could return more than one measurement!
    	$subqry="JOIN (SELECT treeID, stemID, max(HOM) AS maxHOM FROM ViewFullTable WHERE PlotCensusNumber = '$censusNumber' ";
    	if($stemRadio=='main')
        {
          $subqry .= "AND PrimaryStem = 'main' ";
        }
        else if($stemRadio=='secondary')
        {
          $subqry .= "AND PrimaryStem != 'main' ";
        }
    	//if($plot!='%')
        $subqry .= "AND PlotID='$plotID' ";
    	$subqry .= "GROUP BY treeID,stemID) AS highHOM USING (treeID,stemID) ";
        $subqry .= "WHERE (ABS(maxHOM-HOM)<.02 OR (HOM IS NULL AND maxHOM IS NULL)) AND ";

    	// If every measurements is requested, the above subquery is not used
        if($stemRadio=='measurement')
        {
          $subqry="WHERE ";
        }

        // mainpart has all the conditions; at least has census number, all others are optional
    	$mainpart = " PlotCensusNumber = '$censusNumber' ";
    	//if($plot!='%')
        $mainpart .= "AND PlotID='$plotID' ";

    	//include quadrat condition if quadrat was selected
    	if($quadrat !== '')		$mainpart .= "AND  QuadratName LIKE '$quadrat' ";

    	//include genus condition if genus was selected (including wild card)
    	if($genus !== '')		$mainpart .= "AND Genus LIKE '$genus' ";

    	//include species condition if speciesname was selected (including wild card)
    	if($species !== '')		$mainpart .= "AND SpeciesName LIKE '$species' ";

    	//include dbh conditions if any were set
     	if($minDBH !== '')		$mainpart .= " AND DBH >= '$minDBH' ";
     	if($maxDBH !== '')		$mainpart .= " AND DBH <= '$maxDBH' ";

    	//if x and y ranges are set, include them in the WHERE clause
    	if($minX !== '')		$mainpart .= "AND PX >= '$minX' ";
    	if($maxX !== '') 		$mainpart .= "AND PX <= '$maxX' ";
    	if($minY !== '') 		$mainpart .= "AND PY >= '$minY' ";
    	if($maxY !== '') 		$mainpart .= "AND PY <= '$maxY' ";

        //if the dead trees are not included
        if($includeDT !== 'Yes')
        {
           $mainpart .= "AND Status LIKE 'alive' ";
        }

    	//the ORDER BY clause
    	$orderpart = " ORDER BY Latin, Plot, Quadrat, TreeID, DBH DESC, HOM";

    	// if Limits and offset
    	$limitpart = " LIMIT $offset, $limit";

    	$qryfinal=$selectpart.$subqry.$mainpart.$orderpart.$limitpart;

    	//  echo " limit is  ". $limit . "<Br>";// if($limit!=0) { echo $qryfinal; exit(); }
    	//return mysql_query($qryfinal);
        //echo $qryfinal;
        //die();
        $finalQuery = $this->db3->query($qryfinal);
        return $finalQuery;
    }

    function GetPlotData($plotDataA)
    {
        $plotID = $plotDataA['plotID'];    //controller - plotID is passed as plotName
        $censusNumber = $plotDataA['censusNumber'] ;
        $genus = $plotDataA['genus'];
        $species = $plotDataA['species'];
        $quadrat = $plotDataA['quadrat'];
        $maxX = $plotDataA['maxX'];
        $minX = $plotDataA['minX'];
        $maxY = $plotDataA['maxY'];
        $minY = $plotDataA['minY'];
        $maxDBH = $plotDataA['maxDBH'];
        $minDBH = $plotDataA['minDBH'];
        $includeDT = $plotDataA['includeDT'];
        $stemRadio = $plotDataA['stemRadio'];

    	$selectpart="SELECT PlotName as Plot, Concat(Genus, ' ', SpeciesName) AS Latin, Mnemonic, SubSpecies AS SubSpecies, QuadratName AS Quadrat, PX, PY, TreeID, Tag, StemID, StemTag,
            			PlotCensusNumber AS Census, DBH, HOM, ExactDate AS Date, ListOfTSM AS Codes, PrimaryStem AS Stem, Status
    				FROM ViewFullTable ";

    	// Subquery to get the highest HOM of each stem; if only main or secondary stems are requested, must inlude a stem query
    	// To get matching HOM, must use ABS(maxHOM-HOM), and this could return more than one measurement!
    	$subqry="JOIN (SELECT treeID, stemID, max(HOM) AS maxHOM FROM ViewFullTable WHERE PlotCensusNumber = '$censusNumber' ";
    	if($stemRadio=='main')		$subqry .= "AND PrimaryStem = 'main' ";
    	else if($stemRadio=='secondary')	$subqry .= "AND PrimaryStem != 'main' ";
    	//if($plot!='%')
        $subqry .= "AND PlotID='$plotID' ";
    	$subqry .= "GROUP BY treeID,stemID) AS highHOM USING (treeID,stemID) ";
        $subqry .= "WHERE (ABS(maxHOM-HOM)<.02 OR (HOM IS NULL AND maxHOM IS NULL)) AND ";

    	// If every measurements is requested, the above subquery is not used
            if($stemRadio=='measurement') $subqry="WHERE ";

    	// mainpart has all the conditions; at least has census number, all others are optional
    	$mainpart = " PlotCensusNumber = '$censusNumber' ";
    	//if($plot!='%')
        $mainpart .= "AND PlotID='$plotID' ";

    	//include quadrat condition if quadrat was selected
    	if($quadrat !== '')		$mainpart .= "AND  QuadratName LIKE '$quadrat' ";

    	//include genus condition if genus was selected (including wild card)
    	if($genus !== '')		$mainpart .= "AND Genus LIKE '$genus' ";

    	//include species condition if speciesname was selected (including wild card)
    	if($species !== '')		$mainpart .= "AND SpeciesName LIKE '$species' ";

    	//include dbh conditions if any were set
     	if($minDBH !== '')		$mainpart .= " AND DBH >= '$minDBH' ";
     	if($maxDBH !== '')		$mainpart .= " AND DBH <= '$maxDBH' ";

    	//if x and y ranges are set, include them in the WHERE clause
    	if($minX !== '')		$mainpart .= "AND PX >= '$minX' ";
    	if($maxX !== '') 		$mainpart .= "AND PX <= '$maxX' ";
    	if($minY !== '') 		$mainpart .= "AND PY >= '$minY' ";
    	if($maxY !== '') 		$mainpart .= "AND PY <= '$maxY' ";

        //if the dead trees are not included
        if($includeDT !== 'Yes')
        {
           $mainpart .= "AND Status LIKE 'alive' ";
        }

    	//the ORDER BY clause
    	$orderpart = " ORDER BY Latin, Plot, Quadrat, TreeID, DBH DESC, HOM";

    	// if Limits and offset
    	//$limitpart .= " LIMIT $offset, $limit";

    	$qryfinal=$selectpart.$subqry.$mainpart.$orderpart;

        $finalQuery = $this->db3->query($qryfinal);
        return $finalQuery;
    }

    function getTsmCode()
    {
      $this->db3->select('TSMCode,Description');
      $this->db3->order_by('TSMCode asc');
      $query = $this->db3->get('TSMAttributes');
      return $query;
    }
}