<?php

class Postscreeningmodel extends Model{

    function Postscreeningmodel()
    {
      parent::Model();
      $database = $this->session->userdata('databaseName');
      $this->postscreeningdb = $this->load->database($database,TRUE);
    }

    function checkSiteInfo()
    {
      $query = "SELECT Site.PlotID, PlotName, ShapeOfSite, Area, QDimX, QDimY, GX, GY FROM Site,Coordinates WHERE Site.PlotID = Coordinates.PlotID AND Coordinates.QuadratID IS NULL";
      $runQuery = $this->postscreeningdb->query($query);
      return $runQuery;
    }

    function quadratPerCensus()
    {
      $query = "SELECT Census.PlotID, PlotName, PlotCensusNumber,count(*) as QuadratCount FROM CensusQuadrat, Census, Site
                WHERE CensusQuadrat.CensusID = Census.CensusID AND Census.PlotID = Site.PlotID
                GROUP BY PlotID,PlotCensusNumber
                ORDER BY PlotID,PlotCensusNumber";
      $runQuery = $this->postscreeningdb->query($query);
      return $runQuery;
    }

    function quadratPerPlot()
    {
      $query = "SELECT PlotID, COUNT(*) as QuadratCount FROM Quadrat GROUP BY PlotID ORDER BY PlotID";
      $runQuery = $this->postscreeningdb->query($query);
      return $runQuery;
    }

    function treesPerQuadrat()
    {
      $query = "SELECT Temp.PlotID, PlotName, MIN( TreeCount ) AS MinTreeCount, Max( TreeCount ) AS MaxTreeCount, COUNT( TreeCount ) AS TotalCount
                FROM (SELECT COUNT( DISTINCT (TreeID) ) AS TreeCount, PlotID, Stem.QuadratID FROM Stem, Quadrat WHERE Stem.QuadratID = Quadrat.QuadratID GROUP BY Stem.QuadratID)AS Temp, Site
                WHERE Temp.PlotID = Site.PlotID
                GROUP BY PlotID";
      $runQuery = $this->postscreeningdb->query($query);
      return $runQuery;
    }

    function getTSMCodes()
    {
      $query = "SELECT * FROM TSMAttributes WHERE LOWER(Description) LIKE 'main%' OR LOWER(Description) LIKE 'dead%' OR LOWER(Description) LIKE 'stem lost%'";
      $runQuery = $this->postscreeningdb->query($query);
      return $runQuery;
    }

    function tsmRecords()
    {
      $query = "SELECT TSMCode, TSMAttributes.Description AS Description, Census.PlotID, PlotName, PlotCensusNumber, count( * ) AS RecordCount
                FROM DBHAttributes, TSMAttributes, DBH, Census, Site
                WHERE TSMAttributes.TSMID = DBHAttributes.TSMID
                AND DBHAttributes.DBHID = DBH.DBHID
                AND DBH.CensusID = Census.CensusID
                AND Census.PlotID = Site.PlotID
                AND DBH.PrimaryStem LIKE 'main%'
                AND (TSMAttributes.Status = 'dead'
                    OR TSMAttributes.Status = 'not found'
                )
                GROUP BY TSMCode, PlotCensusNumber
                ORDER BY PlotID, TSMCode, PlotCensusNumber";
      $runQuery = $this->postscreeningdb->query($query);
      return $runQuery;
    }

    function duplicateMnemonic()
    {
      $query = "SELECT Mnemonic, COUNT(*) AS RecordCount FROM Species WHERE CurrentTaxonFlag=1 GROUP BY Mnemonic HAVING RecordCount > 1";
      $runQuery = $this->postscreeningdb->query($query);
      return $runQuery;
    }

    function missingMnemonic()
    {
      $query = "SELECT COUNT(*) as RecordCount FROM Species WHERE Mnemonic IS NULL";
      $runQuery = $this->postscreeningdb->query($query);
      return $runQuery;
    }

    function idLevel()
    {
      $query = "SELECT IDLevel,COUNT(*) AS RecordCount FROM Species GROUP BY IDLevel";
      $runQuery = $this->postscreeningdb->query($query);
      return $runQuery;
    }

    function missingAuthority()
    {
      $query = "SELECT COUNT(*) AS RecordCount FROM `Species` WHERE `Authority` = '' OR `Authority` IS NULL";
      $runQuery = $this->postscreeningdb->query($query);
      return $runQuery;
    }

    function treeCoordinates()
    {
      $query = "SELECT Quadrat.PlotID, PlotName, QDimX, QDimY, MIN( PX ) AS MinPX , Min( PY ) AS MinPY , MAX( PX ) AS MaxPX , MAX( PY ) AS MaxPY , MIN( QX ) AS MinQX , Min( QY ) AS MinQY, MAX( QX ) AS MaxQX , MAX( QY ) as MaxQY FROM Quadrat, Site, Stem
                WHERE Quadrat.QuadratID = Stem.QuadratID AND Site.PlotID = Quadrat.PlotID
                GROUP BY PlotID";
      $runQuery = $this->postscreeningdb->query($query);
      return $runQuery;
    }

    function uniqueStemTag()
    {
      $query = "SELECT Site.PlotID, PlotName, Tree.TreeID, Tree.Tag, Stem.StemTag, COUNT( * ) AS DplCnt FROM Tree, Stem, Quadrat, Site
                WHERE Tree.TreeID = Stem.TreeID
                AND Quadrat.QuadratID = Stem.QuadratID
                AND Site.PlotID = Quadrat.PlotID
                GROUP BY Tree.TreeID, StemTag
                HAVING DplCnt >1";
      $runQuery = $this->postscreeningdb->query($query);
      return $runQuery;
    }

    function stemCount()
    {
      $query = "SELECT MIN(StemCount) as MinSC, MAX(StemCount) as MaxSC, COUNT(StemCount) as TotalCount FROM (SELECT TreeID,COUNT(*) AS StemCount FROM Stem GROUP BY TreeID) AS Tmp";
      $runQuery = $this->postscreeningdb->query($query);
      return $runQuery;
    }

    function checkDateRange()
    {
      $query = "SELECT CensusID, MIN(ExactDate) as min, MAX(ExactDate) as max FROM DBH GROUP BY CensusID";
      $runQuery = $this->postscreeningdb->query($query);
      return $runQuery;
    }

    function uniqueDBH()
    {
      $query = "SELECT CensusID, StemID, HOM, COUNT( DBH ) AS RecordCount FROM `DBH` GROUP BY CensusID, StemID, HOM HAVING RecordCount > 1";
      $runQuery = $this->postscreeningdb->query($query);
      return $runQuery;
    }

    function dbhSpecies()
    {
      $query = "SELECT Tree.SpeciesID, Mnemonic, Genus, SpeciesName, MIN( DBH ) as MinDBH , MAX( DBH ) as MaxDBH , COUNT( * ) as RecordCount FROM Tree, Species, Genus, Stem, DBH
                WHERE Species.SpeciesID = Tree.SpeciesID AND Genus.GenusID = Species.GenusID AND Tree.TreeID = Stem.TreeID AND Stem.StemID = DBH.StemID
                GROUP BY Tree.SpeciesID
                ORDER BY Genus, SpeciesName";
      $runQuery = $this->postscreeningdb->query($query);
      return $runQuery;
    }

    function homRange()
    {
      $query = "SELECT DBH.CensusID, PlotCensusNumber, Site.PlotID, PlotName, MIN( HOM ) AS MinHOM, MAX( HOM ) AS MaxHOM FROM DBH, Census, Site
                WHERE Census.CensusID = DBH.CensusID AND Site.PlotID = Census.PlotID
                GROUP BY CensusID
                ORDER BY PlotID, PlotCensusNumber";
      $runQuery = $this->postscreeningdb->query($query);
      return $runQuery;
    }

    function tsmDBHRange()
    {
      $query = "SELECT DBH.CensusID, PlotCensusNumber, PlotName, TSMCode, TSMAttributes.Description AS TSMDesc, MIN( DBH ) AS MinDBH, MAX( DBH ) AS MaxDBH, COUNT( * ) AS RecordCount
                FROM DBH, DBHAttributes, TSMAttributes, Census, Site
                WHERE DBH.DBHID = DBHAttributes.DBHID AND TSMAttributes.TSMID = DBHAttributes.TSMID AND Census.CensusID = DBH.CensusID AND Site.PlotID = Census.PlotID
                GROUP BY DBH.CensusID, TSMCode
                ORDER BY DBH.CensusID, TSMCode";
      $runQuery = $this->postscreeningdb->query($query);
      return $runQuery;
    }

    function mainStem()
    {
      $query = "SELECT CensusID, PlotCensusNumber, Tag, HOM, COUNT(*) as RecordCount FROM ViewFullTable WHERE PrimaryStem = 'main' GROUP BY CensusID,Tag,HOM HAVING RecordCount > 1";
      $runQuery = $this->postscreeningdb->query($query);
      return $runQuery;
    }

    function statusCount()
    {
      $query = "SELECT CensusID,PlotCensusNumber,Plot,Status,COUNT(*) as RecordCount FROM ViewFullTable GROUP BY CensusID, Status";
      $runQuery = $this->postscreeningdb->query($query);
      return $runQuery;
    }

    function treeStatus()
    {
      $query = "SELECT CensusID, PlotCensusNumber, Plot, TreeID, COUNT( * ) AS RecordCount
                FROM (SELECT DISTINCT CensusID, PlotCensusNumber, Plot, TreeID, STATUS FROM ViewFullTable WHERE STATUS = 'dead' OR STATUS = 'alive') AS tmp
                GROUP BY CensusID, PlotCensusNumber, TreeID
                HAVING RecordCount > 1";
      $runQuery = $this->postscreeningdb->query($query);
      return $runQuery;
    }

    function deadFirst()
    {
      $query = "SELECT COUNT(*) as RecordCount FROM ViewFullTable WHERE status='dead' AND PlotCensusNumber=1";
      $runQuery = $this->postscreeningdb->query($query);
      return $runQuery;
    }

    function plotList() //with more than one census
    {
      $query = "SELECT PlotID, count( PlotCensusNumber ) AS RecordCount FROM Census GROUP BY PlotID HAVING RecordCount > 1";
      $runQuery = $this->postscreeningdb->query($query);
      return $runQuery;
    }

    function censusIDList($plotID)
    {
      $query = "SELECT CensusID, Census.PlotID, PlotName, PlotCensusNumber FROM Census, Site WHERE Site.PlotID = Census.PlotID AND Census.PlotID = ".$plotID." ORDER BY PlotCensusNumber";
      $runQuery = $this->postscreeningdb->query($query);
      return $runQuery;
    }

    function diffCount($census1,$census2)
    {
      $query = "SELECT COUNT( DISTINCT TreeID ) AS RecordCount FROM ViewFullTable
                WHERE CensusID = ".$census1 ." AND STATUS <> 'dead' AND TreeID NOT IN (SELECT DISTINCT TreeID FROM ViewFullTable WHERE CensusID =".$census2.")";
      $runQuery = $this->postscreeningdb->query($query);
      return $runQuery;
    }

    function recruitCount($census1,$census2)
    {
      $query = "SELECT COUNT( DISTINCT TreeID ) AS RecordCount FROM ViewFullTable
                WHERE CensusID = ".$census1 ." AND TreeID NOT IN (SELECT DISTINCT TreeID FROM ViewFullTable WHERE CensusID =".$census2.")";
      $runQuery = $this->postscreeningdb->query($query);
      return $runQuery;
    }

    function diffStatusCount($census1,$census2)
    {
      $query = "SELECT PlotCensusNumber,COUNT(*) as RecordCount FROM ViewFullTable WHERE (TreeID,StemID) = ANY (SELECT TreeID,StemID FROM ViewFullTable WHERE CensusID=".$census1." AND Status='dead') AND CensusID=".$census2." AND Status='alive' GROUP BY PlotCensusNumber";
      $runQuery = $this->postscreeningdb->query($query);
      return $runQuery;
    }

    function createTempTable($tableName)
    {
      $query = "CREATE TABLE IF NOT EXISTS ".$tableName." (
                `DBHID` int(11) NOT NULL,
                `PlotID` int(11) NOT NULL,
                `Plot` varchar(35) default NULL,
                `Family` char(32) default NULL,
                `GenusSpecies` char(64) default NULL,
                `Genus` char(32) default NULL,
                `SpeciesName` char(64) default NULL,
                `SubSpeciesName` char(64) default NULL,
                `SpeciesID` int(10) unsigned default NULL,
                `Mnemonic` char(10) default NULL,
                `QuadratID` int(11) NOT NULL,
                `QuadratName` varchar(12) default NULL,
                `QX` float default NULL,
                `QY` float default NULL,
                `PX` float default NULL,
                `PY` float default NULL,
                `TreeID` int(11) NOT NULL,
                `Tag` char(10) default NULL,
                `StemID` int(11) NOT NULL,
                `StemNumber` int(11) NOT NULL,
                `StemTag` varchar(32) default NULL,
                `Moved` enum('Y','N') NOT NULL,
                `PrimaryStem` char(20) default NULL,
                `CensusID` int(11) NOT NULL,
                `PlotCensusNumber` int(11) default NULL,
                `DBH` float default NULL,
                `HOM` float default NULL,
                `ExactDate` date default NULL,
                `ListOfTSM` varchar(256) default NULL,
                `Status` varchar(15) default NULL,
                PRIMARY KEY  (`DBHID`,`CensusID`),
                KEY(PlotID,TreeID,StemID)
              ) ENGINE=MyISAM";
      $runQuery = $this->postscreeningdb->query($query);
      return $runQuery;
    }

    function deleteData($tableName)
    {
      $query = "DELETE FROM ".$tableName;
      $runQuery = $this->postscreeningdb->query($query);
      return $runQuery;
    }

    function insertCensusData1($tableName, $census1, $census2)
    {
      $query = "INSERT INTO ".$tableName." SELECT `DBHID`, `PlotID`, `Plot`, `Family`, `GenusSpecies`, `Genus`, `SpeciesName`, `SubSpeciesName`, `SpeciesID`, `Mnemonic`, `QuadratID`, `QuadratName`, `QX`, `QY`, `PX`, `PY`, `TreeID`, `Tag`, `StemID`, `StemNumber`, `StemTag`, `Moved`, `PrimaryStem`, `CensusID`, `PlotCensusNumber`, `DBH`, `HOM`, `ExactDate`, `ListOfTSM`, `Status`
                                             FROM ViewFullTable WHERE CensusID=".$census1."
                AND (TreeID,StemID) IN (SELECT TreeID,StemID FROM ViewFullTable WHERE CensusID=".$census2."
                                        AND (TreeID,StemID) IN (SELECT TreeID,StemID FROM ViewFullTable WHERE CensusID=".$census1." AND dbh>=10 AND status='alive')
                AND DBH>=10 AND status='alive')
                ORDER BY TreeID,StemID";
      $runQuery = $this->postscreeningdb->query($query);
      return $runQuery;
    }

    function insertCensusData2($tableName, $census1, $census2)
    {
      $query = "INSERT INTO ".$tableName." SELECT `DBHID`, `PlotID`, `Plot`, `Family`, `GenusSpecies`, `Genus`, `SpeciesName`, `SubSpeciesName`, `SpeciesID`, `Mnemonic`, `QuadratID`, `QuadratName`, `QX`, `QY`, `PX`, `PY`, `TreeID`, `Tag`, `StemID`, `StemNumber`, `StemTag`, `Moved`, `PrimaryStem`, `CensusID`, `PlotCensusNumber`, `DBH`, `HOM`, `ExactDate`, `ListOfTSM`, `Status`
                                             FROM ViewFullTable WHERE CensusID=".$census2." AND (TreeID,StemID) IN
                (SELECT TreeID,StemID FROM ViewFullTable WHERE CensusID=".$census2."
                AND (TreeID,StemID) IN (SELECT TreeID,StemID FROM ViewFullTable WHERE CensusID=".$census1." AND dbh>=10 AND status='alive')
                AND DBH>=10 AND status='alive')
                ORDER BY TreeID,StemID";
      $runQuery = $this->postscreeningdb->query($query);
      return $runQuery;
    }

    function grewMuch($tableName1, $tableName2)
    {
      $query = "SELECT A.Plot,A.PlotCensusNumber AS Census1,A.Mnemonic,A.Tag,A.StemID,A.StemTag,A.PrimaryStem,A.DBH AS DBH1,A.HOM AS HOM1,A.ListOfTSM AS Codes1,B.PlotCensusNumber AS Census2,B.DBH AS DBH2,B.HOM AS HOM2,B.ListOfTSM AS Codes2 FROM ".$tableName1." AS A JOIN ".$tableName2." AS B USING (PlotID,TreeID,StemID) WHERE A.HOM=B.HOM AND (B.DBH-A.DBH)/((to_days(B.ExactDate)-to_days(A.ExactDate))/365.25) > 65";
      $runQuery = $this->postscreeningdb->query($query);
      return $runQuery;
    }

    function growthNegative($tableName1, $tableName2)
    {
      $query = "SELECT A.Plot,A.PlotCensusNumber AS Census1,A.Mnemonic,A.Tag,A.StemID,A.StemTag,A.PrimaryStem,A.DBH AS DBH1,A.HOM AS HOM1,A.ListOfTSM AS Codes1,B.PlotCensusNumber AS Census2,B.DBH AS DBH2,B.HOM AS HOM2,B.ListOfTSM AS Codes2 FROM ".$tableName1." AS A JOIN ".$tableName2." AS B USING (PlotID,TreeID,StemID) WHERE A.HOM=B.HOM AND A.DBH>=50 AND ((B.DBH-A.DBH)/A.DBH)/((to_days(B.ExactDate)-to_days(A.ExactDate))/365.25) <=-0.05";
      $runQuery = $this->postscreeningdb->query($query);
      return $runQuery;
    }
}