<?php

class Taxonomyreportmodel extends Model{

    function Taxonomyreportmodel()
    {
      parent::Model();
      $database = $this->session->userdata('databaseName');
      $this->db4 = $this->load->database($database,TRUE);
    }

    function getPlotNames()
    {
      $this->db4->select('PlotID,PlotName');
      $query = $this->db4->get('Site');
      if($query->num_rows() > 1)
      {
      $plotNameA ['default'] = 'Select';
      }
      foreach($query->result() as $row)
      {
        $plotNameA[$row->PlotID] = $row->PlotName;
      }
      return $plotNameA;

    }

    function getPlotNameByID($plotID)
    {
      $this->db4->select('PlotName');
      $this->db4->where('PlotID',$plotID);
      $query = $this->db4->get('Site');
      $row = $query->row();
      $plotName = $row->PlotName;
      return $plotName;
    }

    function JoinTaxDataLimits($taxonomyDataA)
    {
        $plotID = $taxonomyDataA['plotID'];
        $sortBy = $taxonomyDataA['sortBy'];
        $family = $taxonomyDataA['family'];
        $genus = $taxonomyDataA['genus'];
        $species = $taxonomyDataA['species'];
        $limit = $taxonomyDataA['limit'];
        $offset = $taxonomyDataA['offset'];

        $this->db4->distinct();
        $this->db4->select('Family');
        $this->db4->select('Genus, SpeciesName, Subspecies, Mnemonic, IDLevel, Authority, ListOfOldNames, t1.SpeciesID');
        $this->db4->from('ViewTaxonomy t1');
        $this->db4->join('TAX3temp t2','t1.SpeciesID=t2.SpeciesID');
        ///Where Clause//
        if($family !== '')
        {
          $this->db4->like('Family',$family);
        }
        if($genus !== '')
        {
           $this->db4->like('Genus',$genus);
        }
        if($species !== '')
        {
          $this->db4->like('SpeciesName',$species);
        }
        $this->db4->where('t2.PlotID',$plotID);       ////Added this where clause because there are other plot data in BCI database
                                                  ////Which should not be there. This clause need to be removed, after data correction
        //****************//
        //OrderBy Clause//
        if($sortBy == 'GenusSpecies')
        {
          $this->db4->order_by('Genus,SpeciesName,Subspecies');
        }
        elseif($sortBy == 'Family')
        {
          $this->db4->order_by('Family,Genus,SpeciesName,Subspecies');
        }
        //***************//
        $this->db4->limit($limit,$offset);

        $query = $this->db4->get();

    	return $query;
    }

    function JoinTaxData($taxonomyDataA)
    {
        $plotID = $taxonomyDataA['plotID'];
        $sortBy = $taxonomyDataA['sortBy'];
        $family = $taxonomyDataA['family'];
        $genus = $taxonomyDataA['genus'];
        $species = $taxonomyDataA['species'];

        $this->db4->distinct();
        $this->db4->select('Family');
        $this->db4->select('Genus, SpeciesName, Subspecies, Mnemonic, IDlevel, Authority, ListOfOldNames, t1.SpeciesID');
        $this->db4->from('ViewTaxonomy t1');
        $this->db4->join('TAX3temp t2','t1.SpeciesID=t2.SpeciesID');
        ///Where Clause//
        if($family !== '')
        {
          $this->db4->like('Family',$family);
        }
        if($genus !== '')
        {
           $this->db4->like('Genus',$genus);
        }
        if($species !== '')
        {
          $this->db4->like('SpeciesName',$species);
        }
        $this->db4->where('t2.PlotID',$plotID); ////Added this where clause because there are other plot data in BCI database
                                            ////Which should not be there. This clause need to be removed, after data correction
        //****************//
        //OrderBy Clause//
        if($sortBy == 'GenusSpecies')
        {
          $this->db4->order_by('Genus,SpeciesName,Subspecies');
        }
        elseif($sortBy == 'Family')
        {
          $this->db4->order_by('Family,Genus,SpeciesName,Subspecies');
        }
        //***************//

        $query = $this->db4->get();

    	return $query;
    }

    function getDetailData ($speciesID)
    {
       $this->db4->select('Authority, Mnemonic, Description,ListOfHerbarium');
       $this->db4->where('SpeciesID',$speciesID);
       $query = $this->db4->get('ViewTaxonomy');

       $row = $query->row();
       $getDetailData['authority'] = $row->Authority;
       $getDetailData['mnemonic'] = $row->Mnemonic;
       $getDetailData['description'] = $row->Description;
       $getDetailData['listOfHerbarium'] = $row->ListOfHerbarium;
       return $getDetailData;
    }

    function getObsolete ($family, $genus, $speciesName)
    {
    	$this->db4->select('ObsoleteGenusName, ObsoleteSpeciesName, ChangeDate, Description');
        $this->db4->where('Family',$family);
        $this->db4->where('Genus',$genus);
        $this->db4->where('SpeciesName',$speciesName);
        $query = $this->db4->get('TAX2temp');

    	return $query;
    }

}