<?php

class Usermodel_new extends Model{

    function Usermodel_new()
    {
      parent::Model();
      $database = $this->session->userdata('databaseName');
      $this->db2 = $this->load->database($database,TRUE);
    }

    function getPersonnelInfo($personnelData)
    {
      $limit = $personnelData['limit'];
      $offset = $personnelData['offset'];

      $this->db2->select('PersonnelID,FirstName,LastName');
      $this->db2->order_by('LastName asc');
      $this->db2->limit($limit, $offset);
      $returnData['query'] = $this->db2->get('Personnel');
      $returnData['count_all'] = $this->_countAllPersonnelInfo();

      return $returnData;
    }

    function _countAllPersonnelInfo()
    {
      $this->db2->select('PersonnelID,FirstName,LastName');
      $query = $this->db2->get('Personnel');
      $count_all = $query->num_rows();
      return $count_all;
    }

    /////////For New Database/////////////
    function getRoles($personnelID)
    {
      $this->db2->distinct();
      $this->db2->select('Description');
      $this->db2->from('PersonnelRole');
      $this->db2->join('RoleReference','PersonnelRole.RoleID=RoleReference.RoleID');
      $this->db2->where('PersonnelID',$personnelID);
      $query = $this->db2->get();
      if($query->num_rows() > 1)
      {
        $roleArray = array();
        foreach($query->result() as $row)
        {
          $roleArray[] = $row->Description;
        }
        $roles = join(', ',$roleArray);
      }
      elseif($query->num_rows() == 1)
      {
        $row = $query->row();
        $roles = $row->Description;
      }
      else
      {
        $roles = '';
      }
      return $roles;
    }

    //////////////////////////////////////

    function getQuadratData($quadratData)
    {
      $personnelID = $quadratData['personnelID'];
      $limit = $quadratData['limit'];
      $offset = $quadratData['offset'];
      $this->db2->select('DataCollection.StartDate,DataCollection.EndDate,Quadrat.QuadratID,Quadrat.QuadratName,Coordinates.PX StartX,Coordinates.PY StartY,Site.QDimX DimX,Site.QDimY DimY,Site.PlotName,PersonnelRole.PersonnelID');
      $this->db2->from('DataCollection');
      $this->db2->join('PersonnelRole','DataCollection.PersonnelRoleID = PersonnelRole.PersonnelRoleID');
      $this->db2->join('Quadrat','DataCollection.QuadratID = Quadrat.QuadratID');
      $this->db2->join('Coordinates','DataCollection.QuadratID = Coordinates.QuadratID');
      $this->db2->join('Site','Quadrat.PlotID = Site.PlotID');
      $this->db2->where('PersonnelRole.PersonnelID',$personnelID);
      $this->db2->order_by('QuadratName asc');
      $this->db2->limit($limit, $offset);
      $quadratQuery = $this->db2->get();
      return $quadratQuery;
    }

    function getQuadratCount($personnelID)
    {
      $this->db2->select('DataCollection.StartDate,DataCollection.EndDate,Quadrat.QuadratID,Quadrat.QuadratName,Coordinates.PX StartX,Coordinates.PY StartY,Site.QDimX DimX,Site.QDimY DimY,Site.PlotName,PersonnelRole.PersonnelID');
      $this->db2->from('DataCollection');
      $this->db2->join('PersonnelRole','DataCollection.PersonnelRoleID = PersonnelRole.PersonnelRoleID');
      $this->db2->join('Quadrat','DataCollection.QuadratID = Quadrat.QuadratID');
      $this->db2->join('Coordinates','DataCollection.QuadratID = Coordinates.QuadratID');
      $this->db2->join('Site','Quadrat.PlotID = Site.PlotID');
      $this->db2->where('PersonnelRole.PersonnelID',$personnelID);
      $quadratQuery = $this->db2->get();
      return $quadratQuery->num_rows();
    }

    function quadratTreeMeasured($data)
    {
      $personnelID = $data['personnelID'];
      $quadratID = $data['quadratID'];
      $this->db2->distinct();
      $this->db2->select('TreeID,ViewFullTable.CensusID');
      $this->db2->from('ViewFullTable');
      $this->db2->join('DataCollection','ViewFullTable.CensusID = DataCollection.CensusID AND ViewFullTable.QuadratID = DataCollection.QuadratID');
      $this->db2->join('PersonnelRole','PersonnelRole.PersonnelRoleID = DataCollection.PersonnelRoleID');
      $this->db2->where('PersonnelRole.PersonnelID',$personnelID);
      $this->db2->where('ViewFullTable.QuadratID',$quadratID);
      $query = $this->db2->get();
      return $query;
    }

    function quadratStemMeasured($data)
    {
      $personnelID = $data['personnelID'];
      $quadratID = $data['quadratID'];
      $this->db2->distinct();
      $this->db2->select('TreeID,StemID,ViewFullTable.CensusID');
      $this->db2->from('ViewFullTable');
      $this->db2->join('DataCollection','ViewFullTable.CensusID = DataCollection.CensusID AND ViewFullTable.QuadratID = DataCollection.QuadratID');
      $this->db2->join('PersonnelRole','PersonnelRole.PersonnelRoleID = DataCollection.PersonnelRoleID');
      $this->db2->where('PersonnelRole.PersonnelID',$personnelID);
      $this->db2->where('ViewFullTable.QuadratID',$quadratID);
      $query = $this->db2->get();
      return $query;
    }

    function quadratSpeciesMeasured($data)
    {
      $personnelID = $data['personnelID'];
      $quadratID = $data['quadratID'];
      $this->db2->distinct();
      $this->db2->select('SpeciesID');
      $this->db2->from('ViewFullTable');
      $this->db2->join('DataCollection','ViewFullTable.CensusID = DataCollection.CensusID AND ViewFullTable.QuadratID = DataCollection.QuadratID');
      $this->db2->join('PersonnelRole','PersonnelRole.PersonnelRoleID = DataCollection.PersonnelRoleID');
      $this->db2->where('PersonnelRole.PersonnelID',$personnelID);
      $this->db2->where('ViewFullTable.QuadratID',$quadratID);
      $query = $this->db2->get();
      return $query;
    }

    function getPersonName($personnelID)
    {
      $this->db2->select('FirstName, LastName');
      $this->db2->where('PersonnelID',$personnelID);
      $query = $this->db2->get('Personnel');
      $row = $query->row();
      $personName = $row->FirstName.' '.$row->LastName;
      return $personName;
    }

    function getStartDate($personnelID)
    {
      $this->db2->select_min('StartDate');
      $this->db2->from('DataCollection');
      $this->db2->join('PersonnelRole','PersonnelRole.PersonnelRoleID = DataCollection.PersonnelRoleID');
      $this->db2->where('PersonnelRole.PersonnelID',$personnelID);
      $query = $this->db2->get();
      $row = $query->row();
      $startDate = $row->StartDate;
      return $startDate;
    }

    function getEndDate($personnelID)
    {
      $this->db2->select_max('EndDate');
      $this->db2->from('DataCollection');
      $this->db2->join('PersonnelRole','PersonnelRole.PersonnelRoleID = DataCollection.PersonnelRoleID');
      $this->db2->where('PersonnelRole.PersonnelID',$personnelID);
      $query = $this->db2->get();
      $row = $query->row();
      $endDate = $row->EndDate;
      return $endDate;
    }

    function getNoOfHectares($personnelID)
    {
      $quadratCount = $this->getQuadratCount($personnelID);
      if($quadratCount > 0)
      {
        $avgDimXY = $this->_avgDimXY($personnelID);
        $avgDimX = $avgDimXY['avgDimX'];
        $avgDimY = $avgDimXY['avgDimY'];

        $hectares = (($avgDimX*$avgDimY)/10000) * $quadratCount;
      }
      else
      {
        $hectares = 0;
      }
      return $hectares;
      /*$this->db2->select('QuadratID');
      $this->db2->where('PersonnelID',$personnelID);
      $quadratQuery = $this->db2->get('DataCollection');
      if($quadratQuery->num_rows() > 0)
      {
        foreach($quadratQuery->result() as $quadratRow)
        {
          $quadratID = $quadratRow->quardratID;
        }
      }*/
    }

    function _avgDimXY($personnelID)
    {
      $this->db2->select_avg('QDimX','AvgDimX');
      $this->db2->select_avg('QDimY','AvgDimY');
      $this->db2->from('Site');
      $this->db2->join('Quadrat','Site.PlotID = Quadrat.PlotID');
      $this->db2->join('DataCollection','Quadrat.QuadratID = DataCollection.QuadratID');
      $this->db2->join('PersonnelRole','PersonnelRole.PersonnelRoleID = DataCollection.PersonnelRoleID');
      $this->db2->where('PersonnelRole.PersonnelID',$personnelID);
      $query = $this->db2->get();

      if ($query->num_rows() > 0)
      {
        $row = $query->row();
        $avgDimXY['avgDimX'] = $row->AvgDimX;
        $avgDimXY['avgDimY'] = $row->AvgDimY;
      }
      else
      {
        $avgDimXY['avgDimX'] = 0;
        $avgDimXY['avgDimY'] = 0;
      }
      return $avgDimXY;
    }

    function treeMeasured($personnelID)
    {
      $this->db2->distinct();
      $this->db2->select('TreeID,ViewFullTable.CensusID');
      $this->db2->from('ViewFullTable');
      $this->db2->join('DataCollection','ViewFullTable.CensusID = DataCollection.CensusID AND ViewFullTable.QuadratID = DataCollection.QuadratID');
      $this->db2->join('PersonnelRole','PersonnelRole.PersonnelRoleID = DataCollection.PersonnelRoleID');
      $this->db2->where('PersonnelRole.PersonnelID',$personnelID);
      $query = $this->db2->get();
      return $query;
    }

    function stemMeasured($personnelID)
    {
      $this->db2->distinct();
      $this->db2->select('TreeID,StemID,ViewFullTable.CensusID');
      $this->db2->from('ViewFullTable');
      $this->db2->join('DataCollection','ViewFullTable.CensusID = DataCollection.CensusID AND ViewFullTable.QuadratID = DataCollection.QuadratID');
      $this->db2->join('PersonnelRole','PersonnelRole.PersonnelRoleID = DataCollection.PersonnelRoleID');
      $this->db2->where('PersonnelRole.PersonnelID',$personnelID);
      $query = $this->db2->get();
      return $query;
    }

    function speciesMeasured($personnelID)
    {
      $this->db2->distinct();
      $this->db2->select('SpeciesID');
      $this->db2->from('ViewFullTable');
      $this->db2->join('DataCollection','ViewFullTable.CensusID = DataCollection.CensusID AND ViewFullTable.QuadratID = DataCollection.QuadratID');
      $this->db2->join('PersonnelRole','PersonnelRole.PersonnelRoleID = DataCollection.PersonnelRoleID');
      $this->db2->where('PersonnelRole.PersonnelID',$personnelID);
      $query = $this->db2->get();
      return $query;
    }

    function censusList($personnelID)
    {
      $this->db2->distinct();
      $this->db2->select('DataCollection.CensusID,Census.PlotCensusNumber, Census.StartDate,Census.EndDate');
      $this->db2->from('DataCollection');
      $this->db2->join('Census','DataCollection.CensusID=Census.CensusID');
      $this->db2->join('PersonnelRole','PersonnelRole.PersonnelRoleID = DataCollection.PersonnelRoleID');
      $this->db2->where('PersonnelRole.PersonnelID',$personnelID);
      $query = $this->db2->get();
      return $query;
    }

    function getTreeData($treeData)
    {
      $personnelID = $treeData['personnelID'];
      $limit = $treeData['limit'];
      $offset = $treeData['offset'];
      $this->db2->distinct();
      $this->db2->select('TreeID,StemID,ViewFullTable.CensusID,ViewFullTable.Tag,ViewFullTable.StemTag,ViewFullTable.SpeciesName,ViewFullTable.PlotCensusNumber,ViewFullTable.GenusSpecies,ViewFullTable.DBH,ViewFullTable.Status');
      $this->db2->from('ViewFullTable');
      $this->db2->join('DataCollection','ViewFullTable.CensusID = DataCollection.CensusID AND ViewFullTable.QuadratID = DataCollection.QuadratID');
      $this->db2->join('PersonnelRole','PersonnelRole.PersonnelRoleID = DataCollection.PersonnelRoleID');
      $this->db2->where('PersonnelRole.PersonnelID',$personnelID);
      $this->db2->order_by('Tag asc');
      $this->db2->order_by('PlotCensusNumber desc');
      $this->db2->limit($limit, $offset);
      $treeQuery = $this->db2->get();
      return $treeQuery;
    }

    function getTreeCount($personnelID)
    {
      $query = $this->stemMeasured($personnelID);
      return $query->num_rows();
    }



    //Census Based Information Functions

    function getCensusInfo($censusID)
    {
      $this->db2->select('*');
      $this->db2->where('CensusID',$censusID);
      $query = $this->db2->get('Census');
      if($query->num_rows() > 0)
      {
        $row = $query->row();
        $data['plotCensusNumber'] = $row->PlotCensusNumber;
        $data['startDate'] = $row->StartDate;
        $data['endDate'] = $row->EndDate;
      }
      else
      {
        $data['plotCensusNumber'] = '';
        $data['startDate'] = '';
        $data['endDate'] = '';
      }
      return $data;
    }


    function getCensusQuadratCount($censusData)
    {
      $personnelID = $censusData['personnelID'];
      $censusID = $censusData['censusID'];
      $this->db2->select('DataCollection.StartDate,DataCollection.EndDate,Quadrat.QuadratID,Quadrat.QuadratName,Coordinates.PX StartX,Coordinates.PY StartY,Site.QDimX DimX,Site.QDimY DimY,Site.PlotName,PersonnelRole.PersonnelID');
      $this->db2->from('DataCollection');
      $this->db2->join('PersonnelRole','DataCollection.PersonnelRoleID = PersonnelRole.PersonnelRoleID');
      $this->db2->join('Quadrat','DataCollection.QuadratID = Quadrat.QuadratID');
      $this->db2->join('Coordinates','DataCollection.QuadratID = Coordinates.QuadratID');
      $this->db2->join('Site','Quadrat.PlotID = Site.PlotID');
      $this->db2->where('PersonnelRole.PersonnelID',$personnelID);
      $this->db2->where('CensusID',$censusID);
      $quadratQuery = $this->db2->get();
      return $quadratQuery->num_rows();
    }

    function getCensusNoOfHectares($censusData)
    {
      $personnelID = $censusData['personnelID'];
      $censusID = $censusData['censusID'];

      $quadratCount = $this->getCensusQuadratCount($censusData);
      if($quadratCount > 0)
      {
        $avgDimXY = $this->_censusAvgDimXY($censusData);
        $avgDimX = $avgDimXY['avgDimX'];
        $avgDimY = $avgDimXY['avgDimY'];

        $hectares = (($avgDimX*$avgDimY)/10000) * $quadratCount;
      }
      else
      {
        $hectares = 0;
      }
      return $hectares;
    }

    function _censusAvgDimXY($censusData)
    {
      $personnelID = $censusData['personnelID'];
      $censusID = $censusData['censusID'];

      $this->db2->select_avg('QDimX','AvgDimX');
      $this->db2->select_avg('QDimY','AvgDimY');
      $this->db2->from('Site');
      $this->db2->join('Quadrat','Site.PlotID = Quadrat.PlotID');
      $this->db2->join('DataCollection','Quadrat.QuadratID = DataCollection.QuadratID');
      $this->db2->join('PersonnelRole','PersonnelRole.PersonnelRoleID = DataCollection.PersonnelRoleID');
      $this->db2->where('PersonnelRole.PersonnelID',$personnelID);
      $this->db2->where('CensusID',$censusID);
      $query = $this->db2->get();

      if ($query->num_rows() > 0)
      {
        $row = $query->row();
        $avgDimXY['avgDimX'] = $row->AvgDimX;
        $avgDimXY['avgDimY'] = $row->AvgDimY;
      }
      else
      {
        $avgDimXY['avgDimX'] = 0;
        $avgDimXY['avgDimY'] = 0;
      }
      return $avgDimXY;
    }

    function censusTreeMeasured($censusData)
    {
      $personnelID = $censusData['personnelID'];
      $censusID = $censusData['censusID'];

      $this->db2->distinct();
      $this->db2->select('TreeID,ViewFullTable.CensusID');
      $this->db2->from('ViewFullTable');
      $this->db2->join('DataCollection','ViewFullTable.CensusID = DataCollection.CensusID AND ViewFullTable.QuadratID = DataCollection.QuadratID');
      $this->db2->join('PersonnelRole','PersonnelRole.PersonnelRoleID = DataCollection.PersonnelRoleID');
      $this->db2->where('PersonnelRole.PersonnelID',$personnelID);
      $this->db2->where('ViewFullTable.CensusID',$censusID);
      $query = $this->db2->get();
      return $query;
    }

    function censusStemMeasured($censusData)
    {
      $personnelID = $censusData['personnelID'];
      $censusID = $censusData['censusID'];

      $this->db2->distinct();
      $this->db2->select('TreeID,StemID,ViewFullTable.CensusID');
      $this->db2->from('ViewFullTable');
      $this->db2->join('DataCollection','ViewFullTable.CensusID = DataCollection.CensusID AND ViewFullTable.QuadratID = DataCollection.QuadratID');
      $this->db2->join('PersonnelRole','PersonnelRole.PersonnelRoleID = DataCollection.PersonnelRoleID');
      $this->db2->where('PersonnelRole.PersonnelID',$personnelID);
      $this->db2->where('ViewFullTable.CensusID',$censusID);
      $query = $this->db2->get();
      return $query;
    }

    function censusSpeciesMeasured($censusData)
    {
      $personnelID = $censusData['personnelID'];
      $censusID = $censusData['censusID'];

      $this->db2->distinct();
      $this->db2->select('SpeciesID');
      $this->db2->from('ViewFullTable');
      $this->db2->join('DataCollection','ViewFullTable.CensusID = DataCollection.CensusID AND ViewFullTable.QuadratID = DataCollection.QuadratID');
      $this->db2->join('PersonnelRole','PersonnelRole.PersonnelRoleID = DataCollection.PersonnelRoleID');
      $this->db2->where('PersonnelRole.PersonnelID',$personnelID);
      $this->db2->where('ViewFullTable.CensusID',$censusID);
      $query = $this->db2->get();
      return $query;
    }

    function getCensusQuadratData($quadratData)
    {
      $personnelID = $quadratData['personnelID'];
      $censusID = $quadratData['censusID'];
      $limit = $quadratData['limit'];
      $offset = $quadratData['offset'];
      $this->db2->select('DataCollection.StartDate,DataCollection.EndDate,Quadrat.QuadratID,Quadrat.QuadratName,Quadrat.StartX,Quadrat.StartY,Quadrat.DimX,Quadrat.DimY,Site.PlotName');
      $this->db2->from('DataCollection');
      $this->db2->join('Quadrat','DataCollection.QuadratID = Quadrat.QuadratID AND DataCollection.PlotID = Quadrat.PlotID');
      $this->db2->join('Site','DataCollection.PlotID = Site.PlotID');
      $this->db2->where('PersonnelID',$personnelID);
      $this->db2->where('CensusID',$censusID);
      $this->db2->order_by('QuadratName asc');
      $this->db2->limit($limit, $offset);
      $quadratQuery = $this->db2->get();
      return $quadratQuery;
    }

    function censusQuadratTreeMeasured($data)
    {
      $personnelID = $data['personnelID'];
      $quadratID = $data['quadratID'];
      $censusID = $data['censusID'];
      $this->db2->distinct();
      $this->db2->select('TreeID,ViewFullTable.CensusID');
      $this->db2->from('ViewFullTable');
      $this->db2->join('DataCollection','ViewFullTable.CensusID = DataCollection.CensusID AND ViewFullTable.QuadratID = DataCollection.QuadratID');
      $this->db2->where('PersonnelID',$personnelID);
      $this->db2->where('ViewFullTable.QuadratID',$quadratID);
      $this->db2->where('ViewFullTable.CensusID',$censusID);
      $query = $this->db2->get();
      return $query;
    }

    function censusQuadratStemMeasured($data)
    {
      $personnelID = $data['personnelID'];
      $quadratID = $data['quadratID'];
      $censusID = $data['censusID'];
      $this->db2->distinct();
      $this->db2->select('TreeID,StemID,ViewFullTable.CensusID');
      $this->db2->from('ViewFullTable');
      $this->db2->join('DataCollection','ViewFullTable.CensusID = DataCollection.CensusID AND ViewFullTable.QuadratID = DataCollection.QuadratID');
      $this->db2->where('PersonnelID',$personnelID);
      $this->db2->where('ViewFullTable.QuadratID',$quadratID);
      $this->db2->where('ViewFullTable.censusID',$censusID);
      $query = $this->db2->get();
      return $query;
    }

    function censusQuadratSpeciesMeasured($data)
    {
      $personnelID = $data['personnelID'];
      $quadratID = $data['quadratID'];
      $censusID = $data['censusID'];
      $this->db2->distinct();
      $this->db2->select('SpeciesID');
      $this->db2->from('ViewFullTable');
      $this->db2->join('DataCollection','ViewFullTable.CensusID = DataCollection.CensusID AND ViewFullTable.QuadratID = DataCollection.QuadratID');
      $this->db2->where('PersonnelID',$personnelID);
      $this->db2->where('ViewFullTable.QuadratID',$quadratID);
      $this->db2->where('ViewFullTable.CensusID',$censusID);
      $query = $this->db2->get();
      return $query;
    }

    function getCensusTreeData($treeData)
    {
      $personnelID = $treeData['personnelID'];
      $censusID = $treeData['censusID'];
      $limit = $treeData['limit'];
      $offset = $treeData['offset'];
      $this->db2->distinct();
      $this->db2->select('TreeID,StemID,ViewFullTable.CensusID,ViewFullTable.Tag,ViewFullTable.StemTag,ViewFullTable.SpeciesName,ViewFullTable.PlotCensusNumber,ViewFullTable.GenusSpecies,ViewFullTable.DBH,ViewFullTable.Status');
      $this->db2->from('ViewFullTable');
      $this->db2->join('DataCollection','ViewFullTable.CensusID = DataCollection.CensusID AND ViewFullTable.QuadratID = DataCollection.QuadratID');
      $this->db2->where('PersonnelID',$personnelID);
      $this->db2->where('ViewFullTable.CensusID',$censusID);
      $this->db2->order_by('Tag asc');
      $this->db2->order_by('PlotCensusNumber desc');
      $this->db2->limit($limit, $offset);
      $treeQuery = $this->db2->get();
      return $treeQuery;
    }

    function getCensusTreeCount($treeData)
    {
      $query = $this->censusStemMeasured($treeData);
      return $query->num_rows();
    }


    //Total Plot's Trees Stems Species

    function totalPlotTrees()
    {
      $this->db2->distinct();
      $this->db2->select('TreeID');
      $this->db2->from('ViewFullTable');
      $query = $this->db2->get();
      $totalPlotTrees = $query->num_rows();
      return $totalPlotTrees;
    }

    function totalPlotStems()
    {
      $this->db2->distinct();
      $this->db2->select('TreeID,StemID');
      $this->db2->from('ViewFullTable');
      $query = $this->db2->get();
      $totalPlotStems = $query->num_rows();
      return $totalPlotStems;
    }

    function totalPlotSpecies()
    {
      $this->db2->distinct();
      $this->db2->select('SpeciesID');
      $this->db2->from('ViewFullTable');
      $query = $this->db2->get();
      $totalPlotSpecies = $query->num_rows;
      return $totalPlotSpecies;
    }

    function plotNoOfHectares()
    {
      $this->db2->distinct();
      $this->db2->select('QuadratID');
      $query1 = $this->db2->get('ViewFullTable');

      $quadratCount = $query1->num_rows();
      if($quadratCount > 0)
      {
        $sumDimX = 0;
        $sumDimY = 0;
        foreach($query1->result() as $row1)
        {
          $quadratID = $row1->QuadratID;
          $dimXY = $this->_plotDimXY($quadratID);
          $dimX = $dimXY['dimX'];
          $dimY = $dimXY['dimY'];
          $sumDimX = $sumDimX + $dimX;
          $sumDimY = $sumDimY + $dimY;
        }
        $avgDimX = $sumDimX/$quadratCount;
        $avgDimY = $sumDimY/$quadratCount;

        $hectares = (($avgDimX*$avgDimY)/10000) * $quadratCount;
      }
      else
      {
        $hectares = 0;
      }

      return $hectares;
      /*$quadratCount = $this->plotQuadratCount();
      if($quadratCount > 0)
      {
        $avgDimXY = $this->_plotAvgDimXY();
        $avgDimX = $avgDimXY['avgDimX'];
        $avgDimY = $avgDimXY['avgDimY'];

        $hectares = (($avgDimX*$avgDimY)/10000) * $quadratCount;
      }
      else
      {
        $hectares = 0;
      }*/

      /*$this->db2->select('QuadratID');
      $this->db2->where('PersonnelID',$personnelID);
      $quadratQuery = $this->db2->get('DataCollection');
      if($quadratQuery->num_rows() > 0)
      {
        foreach($quadratQuery->result() as $quadratRow)
        {
          $quadratID = $quadratRow->quardratID;
        }
      }*/
    }

    function _plotDimXY($quadratID)
    {
      $this->db2->select('QDimX DimX,QDimY DimY');
      $this->db2->from('Site');
      $this->db2->join('Quadrat','Quadrat.PlotID = Site.PlotID');
      $this->db2->where('QuadratID',$quadratID);
      $query = $this->db2->get();

      if ($query->num_rows() > 0)
      {
        $row = $query->row();
        $dimXY['dimX'] = $row->DimX;
        $dimXY['dimY'] = $row->DimY;
      }
      else
      {
        $dimXY['dimX'] = 0;
        $dimXY['dimY'] = 0;
      }
      return $dimXY;
    }

    function plotQuadratCount()
    {
      $this->db2->distinct();
      $this->db2->select('QuadratID');
      $this->db2->from('ViewFullTable');
      $quadratQuery = $this->db2->get();
      return $quadratQuery->num_rows();
    }

    //////////////////Only for Raymond Johnson's Data Correction/////////////

    function insertraydata($data)
    {
      $this->db2->insert('DataCollection',$data);
    }
    ////////////////////////////////////////////////////////////////////////

}